# This file was automatically generated by SWIG (http://www.swig.org).
# Version 2.0.8
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.


"""

PyTrilinos.Amesos is the python interface to the Trilinos direct
linear solver package Amesos:

    http://trilinos.sandia.gov/packages/amesos

The purpose of Amesos is to provide a common interface to a variety of
third-party direct solvers, made compatible with PyTrilinos.Epetra.
Note that the C++ version of Amesos uses the prefix 'Amesos_', which
has been stripped from the python implementation.

The most important classes of the Amesos module are:

    * Factory      - Factory class
    * Lapack       - LAPACK interface
    * Klu          - KLU interface
    * Umfpack      - UMFPACK interface
    * Scalapack    - SCALAPACK interface
    * Superlu      - SuperLU interface
    * Superludist  - SuperLU_DIST interface
    * Dscpack      - DSCPACK interface
    * Mumps        - MUMPS interface

Use dir(Amesos) to see what specific interfaces have been enabled on
your platform.  For examples of usage, please consult the examples
subdirectory of the PyTrilinos package, scripts exAmesos_Simple.py and
exAmesos_Factory.py.

"""


from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_Amesos', [dirname(__file__)])
        except ImportError:
            import _Amesos
            return _Amesos
        if fp is not None:
            try:
                _mod = imp.load_module('_Amesos', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _Amesos = swig_import_helper()
    del swig_import_helper
else:
    import _Amesos
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


class SwigPyIterator(_object):
    """Proxy of C++ swig::SwigPyIterator class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Amesos.delete_SwigPyIterator
    def value(self):
        """value(SwigPyIterator self) -> PyObject *"""
        return _Amesos.SwigPyIterator_value(self)

    def incr(self, n=1):
        """
        incr(SwigPyIterator self, size_t n=1) -> SwigPyIterator
        incr(SwigPyIterator self) -> SwigPyIterator
        """
        return _Amesos.SwigPyIterator_incr(self, n)

    def decr(self, n=1):
        """
        decr(SwigPyIterator self, size_t n=1) -> SwigPyIterator
        decr(SwigPyIterator self) -> SwigPyIterator
        """
        return _Amesos.SwigPyIterator_decr(self, n)

    def distance(self, *args):
        """distance(SwigPyIterator self, SwigPyIterator x) -> ptrdiff_t"""
        return _Amesos.SwigPyIterator_distance(self, *args)

    def equal(self, *args):
        """equal(SwigPyIterator self, SwigPyIterator x) -> bool"""
        return _Amesos.SwigPyIterator_equal(self, *args)

    def copy(self):
        """copy(SwigPyIterator self) -> SwigPyIterator"""
        return _Amesos.SwigPyIterator_copy(self)

    def next(self):
        """next(SwigPyIterator self) -> PyObject *"""
        return _Amesos.SwigPyIterator_next(self)

    def __next__(self):
        """__next__(SwigPyIterator self) -> PyObject *"""
        return _Amesos.SwigPyIterator___next__(self)

    def previous(self):
        """previous(SwigPyIterator self) -> PyObject *"""
        return _Amesos.SwigPyIterator_previous(self)

    def advance(self, *args):
        """advance(SwigPyIterator self, ptrdiff_t n) -> SwigPyIterator"""
        return _Amesos.SwigPyIterator_advance(self, *args)

    def __eq__(self, *args):
        """__eq__(SwigPyIterator self, SwigPyIterator x) -> bool"""
        return _Amesos.SwigPyIterator___eq__(self, *args)

    def __ne__(self, *args):
        """__ne__(SwigPyIterator self, SwigPyIterator x) -> bool"""
        return _Amesos.SwigPyIterator___ne__(self, *args)

    def __iadd__(self, *args):
        """__iadd__(SwigPyIterator self, ptrdiff_t n) -> SwigPyIterator"""
        return _Amesos.SwigPyIterator___iadd__(self, *args)

    def __isub__(self, *args):
        """__isub__(SwigPyIterator self, ptrdiff_t n) -> SwigPyIterator"""
        return _Amesos.SwigPyIterator___isub__(self, *args)

    def __add__(self, *args):
        """__add__(SwigPyIterator self, ptrdiff_t n) -> SwigPyIterator"""
        return _Amesos.SwigPyIterator___add__(self, *args)

    def __sub__(self, *args):
        """
        __sub__(SwigPyIterator self, ptrdiff_t n) -> SwigPyIterator
        __sub__(SwigPyIterator self, SwigPyIterator x) -> ptrdiff_t
        """
        return _Amesos.SwigPyIterator___sub__(self, *args)

    def __iter__(self): return self
SwigPyIterator_swigregister = _Amesos.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)

import Teuchos
import Epetra
class Factory(_object):
    """Proxy of C++ Amesos class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Factory, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Factory, name)
    __repr__ = _swig_repr
    def Create(self, *args):
        """
        Create(Factory self, char const * ClassType, LinearProblem LinearProblem) -> BaseSolver
        Create(Factory self, std::string const CT, LinearProblem LinearProblem) -> BaseSolver
        """
        return _Amesos.Factory_Create(self, *args)

    def Query(self, *args):
        """
        Query(Factory self, char const * ClassType) -> bool
        Query(Factory self, std::string const CT) -> bool
        """
        return _Amesos.Factory_Query(self, *args)

    def GetValidParameters(*args):
        """GetValidParameters() -> ParameterList"""
        return _Amesos.Factory_GetValidParameters(*args)

    if _newclass:GetValidParameters = staticmethod(GetValidParameters)
    __swig_getmethods__["GetValidParameters"] = lambda x: GetValidParameters
    def __init__(self, *args): 
        """__init__(Amesos self) -> Factory"""
        this = _Amesos.new_Factory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Factory
Factory_swigregister = _Amesos.Factory_swigregister
Factory_swigregister(Factory)

def Factory_GetValidParameters(*args):
  """Factory_GetValidParameters() -> ParameterList"""
  return _Amesos.Factory_GetValidParameters(*args)

class BaseSolver(Teuchos.ParameterListAcceptor):
    """
    Amesos_BaseSolver: A pure virtual class for direct solution of real-
    valued double- precision operators.

    Pure virtual class for all Amesos concrete implementions.

    The Amesos_BaseSolver class is a pure virtual class (that is, it
    specifies interface only) that enables the use of real-valued double-
    precision direct sparse solvers. Every Amesos class named Amesos_
    SolverName derives from Amesos_BaseSolver.

    Usage Examples

    Basic calling sequence

    The basic calling sequence solves A x = b or AT x = b without
    specifying how A has changed between each call to Solve().

    Re-using the symbolic factorization

    The following calling sequence performs multiple solves of A x = b or
    AT x = b in cases where the non-zero structure of A remains unchanged
    between each call to Solve().

    Re-using the numeric factorization

    The following calling sequence performs multiple solves of A x = b or
    AT x = b provided that A remains unchanged between each call to
    Solve().

    Constructor requirements

    Every Amesos_SolverName class should accept an Epetra_LinearProblem

    Mathematical methods

    Four mathematical methods are defined in the base class
    Amesos_BaseSolver: SymbolicFactorization(), NumericFactorization(),
    and Solve().

    Switching concrete classes

    Different concrete classes, each based on a different third party
    solver, will have different performance characteristics and will
    accept different parameters.

    Changing the values of the underlying matrix operator.

    Any changes to the values of a matrix must be accompanied by a call to
    NumericFactorization() before the next call to Solve() or the behavior
    of Solve() is undefined. Any changes to the numerical structure of the
    matrix must be followed by a call to SymbolicFactorization() and
    NumericalFactorization() before the next call to Solve().

    Once SymbolicFactorization() has been called, classes implementing
    this interface may assume that any change made to the non-zero
    structure of the underlying matrix will be accompanied by a call to
    SymbolicFactorization() prior to a subsequent call to
    NumericFactorization or Solve().

    Named Parameters

    Parameters can be changed or added at any time by calling
    SetParameters(ParamList) with the new parameters specified in
    ParamList.

    It is left to the user to be sure that changes made to the parameters
    are appropriate for the concrete class that they are using.

    Examples of appropriate changes in parameters include:  Changing
    iterative refinement rules between calls to Solve()

    Changing drop tolerance rules between calls to NumericFactorization()

    Examples of inappropriate changes in parameters include:  Changing
    drop tolerance rules between solve steps.
    Solver.NumericFactorization();
    Solver.getList()->set("DropTolerance",.001); Solver.Solve();
    Results of making inappropriate changes in parameters is unpredictable
    and could include an error return, a bogus result or ignoring the
    parameter change.

    Transpose solve

    Any class implementing Amesos_BaseSolver should handle calls to
    SetUseTranspose() at any point. However, the result of a call to
    SetUseTranspose() which is not followed by a call to
    SymbolicFactorization() and NumericFactorization() is implementation
    dependent. Some third party libraries are able to solve AT x = b and
    Ax = b using the same factorization. Others will require a new
    factorization anytime that a call to SetUseTranspose() changes the
    intended solve from AT x = b to Ax = b or vice-versa.

    Performance expectations

    The following is a list of performance guidelines that classes which
    implement the Amesos_BaseSolver class are expected to maintain.

    Memory usage:

    For serial codes, no more than one extra copy of the original matrix
    should be required. Except that some codes require matrix transpostion
    which requires additional copies of the input matrix.

    For distributed memory codes, no serial copies of the original matrix
    should be required.

    Robustness requirements

    Failures should be caught by AMESOS_CHK_ERR(). The following error
    codes should be used: 1: Singular matrix

    2: Non-symmetric matrix

    3: Matrix is not positive definite

    4: Insufficient memory

    Because we do not check to see if a matrix has changed between the
    call to SymbolicFactorization() and the call to
    NumericFactorization(), it is possible that a change to the matrix
    will cause a potentially catastrophic error.

    C++ includes: Amesos_BaseSolver.h 
    """
    __swig_setmethods__ = {}
    for _s in [Teuchos.ParameterListAcceptor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BaseSolver, name, value)
    __swig_getmethods__ = {}
    for _s in [Teuchos.ParameterListAcceptor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BaseSolver, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def getParameterList(self, *args):
        """
        getParameterList(BaseSolver self) -> Teuchos::RCP< Teuchos::ParameterList const >

        Teuchos::RCP< const
        Teuchos::ParameterList >
        Teuchos::ParameterListAcceptor::getParameterList() const

        Get const version of the parameter list that was set using
        setParameterList().

        The default implementation returns: 
        """
        return _Amesos.BaseSolver_getParameterList(self, *args)

    __swig_destroy__ = _Amesos.delete_BaseSolver
    def SymbolicFactorization(self, *args):
        """
        SymbolicFactorization(BaseSolver self) -> int

        virtual int Amesos_BaseSolver::SymbolicFactorization()=0

        Performs SymbolicFactorization on the matrix A.

        In addition to performing symbolic factorization on the matrix A, the
        call to SymbolicFactorization() implies that no change will be made to
        the non-zero structure of the underlying matrix without a subsequent
        call to SymbolicFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        <br >Postconditions: Symbolic Factorization will be performed (or
        marked to be performed) allowing NumericFactorization() and Solve() to
        be called.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.BaseSolver_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """
        NumericFactorization(BaseSolver self) -> int

        virtual int Amesos_BaseSolver::NumericFactorization()=0

        Performs NumericFactorization on the matrix A.

        In addition to performing numeric factorization on the matrix A, the
        call to NumericFactorization() implies that no change will be made to
        the underlying matrix without a subsequent call to
        NumericFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization(). (return -2 if the number of non-
        zeros changes) Other changes can have arbitrary consequences.

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should be indexed from 0 to n-1, unless the parameter
        "Reindex" was set to "true" prior to the call to
        SymbolicFactorization(). (return -3 - if caught)

        The paremeter "Reindex" should not be set to "true" except on
        CrsMatrices. (return -4)

        The paremeter "Reindex" should not be set to "true" unless Amesos
        was built with EpetraExt, i.e. with --enable-epetraext on the
        configure line. (return -4)

        Internal errors retur -5.

        <br >Postconditions: Numeric Factorization will be performed (or
        marked to be performed) allowing Solve() to be performed correctly
        despite a potential change in in the matrix values (though not in the
        non-zero structure).

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.BaseSolver_NumericFactorization(self, *args)

    def Solve(self, *args):
        """
        Solve(BaseSolver self) -> int

        virtual int
        Amesos_BaseSolver::Solve()=0

        Solves A X = B (or AT x = B)

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        GetProblem()->CheckInput (see Epetra_LinearProblem::CheckInput() for
        return values)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization().

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should not have changed since the last call to
        NumericFactorization().

        <br >Postconditions: X will be set such that A X = B (or AT X = B),
        within the limits of the accuracy of the underlying solver.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.BaseSolver_Solve(self, *args)

    def SetUseTranspose(self, *args):
        """
        SetUseTranspose(BaseSolver self, bool UseTranspose) -> int

        virtual
        int Amesos_BaseSolver::SetUseTranspose(bool UseTranspose)=0

        If set true, X will be set to the solution of AT X = B (not A X = B)

        If the implementation of this interface does not support transpose
        use, this method should return a value of -1.

        <br >Preconditions:  SetUseTranspose() should be called prior to the
        call to SymbolicFactorization() If NumericFactorization() or Solve()
        is called after SetUseTranspose() without an intervening call to
        SymbolicFactorization() the result is implementation dependent.

        <br >Postconditions: The next factorization and solve will be
        performed with the new value of UseTranspose.

        Parameters:
        -----------

        UseTranspose:  -- (In) If true, solve AT X = B, otherwise solve A X =
        B.

        Integer error code, set to 0 if successful. Set to -1 if this
        implementation does not support transpose. 
        """
        return _Amesos.BaseSolver_SetUseTranspose(self, *args)

    def UseTranspose(self, *args):
        """
        UseTranspose(BaseSolver self) -> bool

        virtual bool
        Amesos_BaseSolver::UseTranspose() const =0

        Returns the current UseTranspose setting. 
        """
        return _Amesos.BaseSolver_UseTranspose(self, *args)

    def SetParameters(self, *args):
        """
        SetParameters(BaseSolver self, ParameterList ParameterList) -> int

        virtual int
        Amesos_BaseSolver::SetParameters(Teuchos::ParameterList
        &ParameterList)=0

        Updates internal variables.

        <br >Preconditions: None.

        <br >Postconditions: Internal variables controlling the factorization
        and solve will be updated and take effect on all subseuent calls to
        NumericFactorization() and Solve().

        All parameters whose value are to differ from the default values must
        be included in ParameterList. Parameters not specified in
        ParameterList revert to their default values.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.BaseSolver_SetParameters(self, *args)

    def GetProblem(self, *args):
        """
        GetProblem(BaseSolver self) -> LinearProblem

        virtual const
        Epetra_LinearProblem* Amesos_BaseSolver::GetProblem() const =0

        Returns the Epetra_LinearProblem.

        Warning! Do not call return->SetOperator(...) to attempt to change the
        Epetra_Operator object (even if the new matrix has the same
        structure). This new operator matrix will be ignored! 
        """
        return _Amesos.BaseSolver_GetProblem(self, *args)

    def MatrixShapeOK(self, *args):
        """
        MatrixShapeOK(BaseSolver self) -> bool

        virtual bool
        Amesos_BaseSolver::MatrixShapeOK() const =0

        Returns true if the solver can handle this matrix shape.

        Returns true if the matrix shape is one that the underlying sparse
        direct solver can handle. Classes that work only on square matrices
        should return false for rectangular matrices. Classes that work only
        on symmetric matrices whould return false for non-symmetric matrices.

        """
        return _Amesos.BaseSolver_MatrixShapeOK(self, *args)

    def Comm(self, *args):
        """
        Comm(BaseSolver self) -> Comm

        virtual const
        Epetra_Comm& Amesos_BaseSolver::Comm() const =0

        Returns a pointer to the Epetra_Comm communicator associated with this
        operator. 
        """
        return _Amesos.BaseSolver_Comm(self, *args)

    def NumSymbolicFact(self, *args):
        """
        NumSymbolicFact(BaseSolver self) -> int

        virtual
        int Amesos_BaseSolver::NumSymbolicFact() const =0

        Returns the number of symbolic factorizations performed by this
        object. 
        """
        return _Amesos.BaseSolver_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """
        NumNumericFact(BaseSolver self) -> int

        virtual int
        Amesos_BaseSolver::NumNumericFact() const =0

        Returns the number of numeric factorizations performed by this object.

        """
        return _Amesos.BaseSolver_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """
        NumSolve(BaseSolver self) -> int

        virtual int
        Amesos_BaseSolver::NumSolve() const =0

        Returns the number of solves performed by this object. 
        """
        return _Amesos.BaseSolver_NumSolve(self, *args)

    def PrintStatus(self, *args):
        """
        PrintStatus(BaseSolver self)

        virtual void
        Amesos_BaseSolver::PrintStatus() const =0

        Prints status information about the current solver. 
        """
        return _Amesos.BaseSolver_PrintStatus(self, *args)

    def PrintTiming(self, *args):
        """
        PrintTiming(BaseSolver self)

        virtual void
        Amesos_BaseSolver::PrintTiming() const =0

        Prints timing information about the current solver. 
        """
        return _Amesos.BaseSolver_PrintTiming(self, *args)

    def setParameterList(self, *args):
        """
        setParameterList(BaseSolver self, Teuchos::RCP< Teuchos::ParameterList > const & paramList)

        virtual
        void Amesos_BaseSolver::setParameterList(Teuchos::RCP<
        Teuchos::ParameterList > const &paramList)

        Redefined from Teuchos::ParameterListAcceptor. 
        """
        return _Amesos.BaseSolver_setParameterList(self, *args)

    def getNonconstParameterList(self, *args):
        """
        getNonconstParameterList(BaseSolver self) -> Teuchos::RCP< Teuchos::ParameterList >

        virtual Teuchos::RCP<Teuchos::ParameterList>
        Amesos_BaseSolver::getNonconstParameterList()

        This is an empty stub. 
        """
        return _Amesos.BaseSolver_getNonconstParameterList(self, *args)

    def unsetParameterList(self, *args):
        """
        unsetParameterList(BaseSolver self) -> Teuchos::RCP< Teuchos::ParameterList >

        virtual
        Teuchos::RCP<Teuchos::ParameterList>
        Amesos_BaseSolver::unsetParameterList()

        This is an empty stub. 
        """
        return _Amesos.BaseSolver_unsetParameterList(self, *args)

    def GetTiming(self, *args):
        """
        GetTiming(BaseSolver self, ParameterList TimingParameterList)

        virtual void
        Amesos_BaseSolver::GetTiming(Teuchos::ParameterList
        &TimingParameterList) const

        Extracts timing information from the current solver and places it in
        the parameter list. 
        """
        return _Amesos.BaseSolver_GetTiming(self, *args)

BaseSolver_swigregister = _Amesos.BaseSolver_swigregister
BaseSolver_swigregister(BaseSolver)
cvar = _Amesos.cvar
StructurallySingularMatrixError = cvar.StructurallySingularMatrixError
NumericallySingularMatrixError = cvar.NumericallySingularMatrixError

class Lapack(BaseSolver):
    """
    Amesos_Lapack: an interface to LAPACK.

    Class Amesos_Lapack enables the solution of the distributed linear
    system, defined by an Epetra_LinearProblem, using LAPACK.

    Amesos_Lapack stores the lineaar system matrix as an
    Epetra_SerialDensMatrix. The linear problem is an
    Epetra_SerialDenseProblem. Amesos_Lapack factorizes the matrix using
    DGETRF().

    Marzio Sala, 9214.

    C++ includes: Amesos_Lapack.h 
    """
    __swig_setmethods__ = {}
    for _s in [BaseSolver]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Lapack, name, value)
    __swig_getmethods__ = {}
    for _s in [BaseSolver]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Lapack, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Amesos_Lapack self, LinearProblem LinearProblem) -> Lapack

        Amesos_Lapack::Amesos_Lapack(const Epetra_LinearProblem
        &LinearProblem)

        Amesos_Lapack Constructor.

        Creates an Amesos_Lapack instance, using an Epetra_LinearProblem,
        passing in an already- defined Epetra_LinearProblem object.

        Note: The operator in LinearProblem must be an Epetra_RowMatrix. 
        """
        this = _Amesos.new_Lapack(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Lapack
    def SymbolicFactorization(self, *args):
        """
        SymbolicFactorization(Lapack self) -> int

        int
        Amesos_Lapack::SymbolicFactorization()

        Performs SymbolicFactorization on the matrix A.

        In addition to performing symbolic factorization on the matrix A, the
        call to SymbolicFactorization() implies that no change will be made to
        the non-zero structure of the underlying matrix without a subsequent
        call to SymbolicFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        <br >Postconditions: Symbolic Factorization will be performed (or
        marked to be performed) allowing NumericFactorization() and Solve() to
        be called.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Lapack_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """
        NumericFactorization(Lapack self) -> int

        int
        Amesos_Lapack::NumericFactorization()

        Performs NumericFactorization on the matrix A.

        In addition to performing numeric factorization on the matrix A, the
        call to NumericFactorization() implies that no change will be made to
        the underlying matrix without a subsequent call to
        NumericFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization(). (return -2 if the number of non-
        zeros changes) Other changes can have arbitrary consequences.

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should be indexed from 0 to n-1, unless the parameter
        "Reindex" was set to "true" prior to the call to
        SymbolicFactorization(). (return -3 - if caught)

        The paremeter "Reindex" should not be set to "true" except on
        CrsMatrices. (return -4)

        The paremeter "Reindex" should not be set to "true" unless Amesos
        was built with EpetraExt, i.e. with --enable-epetraext on the
        configure line. (return -4)

        Internal errors retur -5.

        <br >Postconditions: Numeric Factorization will be performed (or
        marked to be performed) allowing Solve() to be performed correctly
        despite a potential change in in the matrix values (though not in the
        non-zero structure).

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Lapack_NumericFactorization(self, *args)

    def Solve(self, *args):
        """
        Solve(Lapack self) -> int

        int
        Amesos_Lapack::Solve()

        Solves A X = B (or AT x = B)

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        GetProblem()->CheckInput (see Epetra_LinearProblem::CheckInput() for
        return values)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization().

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should not have changed since the last call to
        NumericFactorization().

        <br >Postconditions: X will be set such that A X = B (or AT X = B),
        within the limits of the accuracy of the underlying solver.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Lapack_Solve(self, *args)

    def GetProblem(self, *args):
        """
        GetProblem(Lapack self) -> LinearProblem

        const
        Epetra_LinearProblem* Amesos_Lapack::GetProblem() const

        Returns the Epetra_LinearProblem.

        Warning! Do not call return->SetOperator(...) to attempt to change the
        Epetra_Operator object (even if the new matrix has the same
        structure). This new operator matrix will be ignored! 
        """
        return _Amesos.Lapack_GetProblem(self, *args)

    def MatrixShapeOK(self, *args):
        """
        MatrixShapeOK(Lapack self) -> bool

        bool
        Amesos_Lapack::MatrixShapeOK() const

        Returns true if the solver can handle this matrix shape.

        Returns true if the matrix shape is one that the underlying sparse
        direct solver can handle. Classes that work only on square matrices
        should return false for rectangular matrices. Classes that work only
        on symmetric matrices whould return false for non-symmetric matrices.

        """
        return _Amesos.Lapack_MatrixShapeOK(self, *args)

    def SetUseTranspose(self, *args):
        """
        SetUseTranspose(Lapack self, bool UseTranspose_in) -> int

        int
        Amesos_Lapack::SetUseTranspose(bool UseTranspose_in)

        If set true, X will be set to the solution of AT X = B (not A X = B)

        If the implementation of this interface does not support transpose
        use, this method should return a value of -1.

        <br >Preconditions:  SetUseTranspose() should be called prior to the
        call to SymbolicFactorization() If NumericFactorization() or Solve()
        is called after SetUseTranspose() without an intervening call to
        SymbolicFactorization() the result is implementation dependent.

        <br >Postconditions: The next factorization and solve will be
        performed with the new value of UseTranspose.

        Parameters:
        -----------

        UseTranspose:  -- (In) If true, solve AT X = B, otherwise solve A X =
        B.

        Integer error code, set to 0 if successful. Set to -1 if this
        implementation does not support transpose. 
        """
        return _Amesos.Lapack_SetUseTranspose(self, *args)

    def UseTranspose(self, *args):
        """
        UseTranspose(Lapack self) -> bool

        bool
        Amesos_Lapack::UseTranspose() const

        Returns the current UseTranspose setting. 
        """
        return _Amesos.Lapack_UseTranspose(self, *args)

    def Comm(self, *args):
        """
        Comm(Lapack self) -> Comm

        const Epetra_Comm&
        Amesos_Lapack::Comm() const

        Returns a pointer to the Epetra_Comm communicator associated with this
        operator. 
        """
        return _Amesos.Lapack_Comm(self, *args)

    def setParameterList(self, *args):
        """
        setParameterList(Lapack self, Teuchos::RCP< Teuchos::ParameterList > const & paramList)

        void
        Amesos_Lapack::setParameterList(Teuchos::RCP< Teuchos::ParameterList >
        const &paramList)

        Use this parameter list to read values from.

        Redefined from Teuchos::ParameterListAcceptor 
        """
        return _Amesos.Lapack_setParameterList(self, *args)

    def unsetParameterList(self, *args):
        """
        unsetParameterList(Lapack self) -> Teuchos::RCP< Teuchos::ParameterList >

        Teuchos::RCP< Teuchos::ParameterList >
        Amesos_Lapack::unsetParameterList()

        This is an empty stub. 
        """
        return _Amesos.Lapack_unsetParameterList(self, *args)

    def SetParameters(self, *args):
        """
        SetParameters(Lapack self, ParameterList ParameterList) -> int

        int
        Amesos_Lapack::SetParameters(Teuchos::ParameterList &ParameterList)

        Deprecated - Sets parameters. 
        """
        return _Amesos.Lapack_SetParameters(self, *args)

    def GEEV(self, *args):
        """
        GEEV(Lapack self, Epetra_Vector Er, Epetra_Vector Ei) -> int

        int
        Amesos_Lapack::GEEV(Epetra_Vector &Er, Epetra_Vector &Ei)

        Computes the eigenvalues of the linear system matrix using DGEEV.

        Parameters:
        -----------

        Er:  - (Out) On processor zero only, it will contain the real
        component of the eigenvalues.

        Ei:  - (Out) On processor zero only, it will contain the imaginary
        component of the eigenvalues.

        Er and Ei must have been allocated so that the local length on
        processor 0 equals the global size of the matrix. 
        """
        return _Amesos.Lapack_GEEV(self, *args)

    def NumSymbolicFact(self, *args):
        """
        NumSymbolicFact(Lapack self) -> int

        int
        Amesos_Lapack::NumSymbolicFact() const

        Returns the number of symbolic factorizations performed by this
        object. 
        """
        return _Amesos.Lapack_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """
        NumNumericFact(Lapack self) -> int

        int
        Amesos_Lapack::NumNumericFact() const

        Returns the number of numeric factorizations performed by this object.

        """
        return _Amesos.Lapack_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """
        NumSolve(Lapack self) -> int

        int
        Amesos_Lapack::NumSolve() const

        Returns the number of solves performed by this object. 
        """
        return _Amesos.Lapack_NumSolve(self, *args)

    def PrintTiming(self, *args):
        """
        PrintTiming(Lapack self)

        void
        Amesos_Lapack::PrintTiming() const

        Print timing information. 
        """
        return _Amesos.Lapack_PrintTiming(self, *args)

    def PrintStatus(self, *args):
        """
        PrintStatus(Lapack self)

        void
        Amesos_Lapack::PrintStatus() const

        Print information about the factorization and solution phases. 
        """
        return _Amesos.Lapack_PrintStatus(self, *args)

    def GetTiming(self, *args):
        """
        GetTiming(Lapack self, ParameterList TimingParameterList)

        void
        Amesos_Lapack::GetTiming(Teuchos::ParameterList &TimingParameterList)
        const

        Extracts timing information from the current solver and places it in
        the parameter list. 
        """
        return _Amesos.Lapack_GetTiming(self, *args)

Lapack_swigregister = _Amesos.Lapack_swigregister
Lapack_swigregister(Lapack)

class Klu(BaseSolver):
    """
    Interface to KLU internal solver.

    Interface to UMFPACK.

    C++ includes: Amesos_Umfpack.h 
    """
    __swig_setmethods__ = {}
    for _s in [BaseSolver]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Klu, name, value)
    __swig_getmethods__ = {}
    for _s in [BaseSolver]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Klu, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Amesos_Klu self, LinearProblem LinearProblem) -> Klu

        Amesos_Klu::Amesos_Klu(const Epetra_LinearProblem &LinearProblem)

        Amesos_Klu Constructor.

        Creates an Amesos_Klu instance, using an Epetra_LinearProblem, passing
        in an already- defined Epetra_LinearProblem object.

        Note: The operator in LinearProblem must be an Epetra_RowMatrix. 
        """
        this = _Amesos.new_Klu(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Klu
    def SymbolicFactorization(self, *args):
        """
        SymbolicFactorization(Klu self) -> int

        int
        Amesos_Klu::SymbolicFactorization()

        Performs SymbolicFactorization on the matrix A.

        In addition to performing symbolic factorization on the matrix A, the
        call to SymbolicFactorization() implies that no change will be made to
        the non-zero structure of the underlying matrix without a subsequent
        call to SymbolicFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        <br >Postconditions: Symbolic Factorization will be performed (or
        marked to be performed) allowing NumericFactorization() and Solve() to
        be called.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Klu_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """
        NumericFactorization(Klu self) -> int

        int
        Amesos_Klu::NumericFactorization()

        Performs NumericFactorization on the matrix A.

        In addition to performing numeric factorization on the matrix A, the
        call to NumericFactorization() implies that no change will be made to
        the underlying matrix without a subsequent call to
        NumericFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization(). (return -2 if the number of non-
        zeros changes) Other changes can have arbitrary consequences.

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should be indexed from 0 to n-1, unless the parameter
        "Reindex" was set to "true" prior to the call to
        SymbolicFactorization(). (return -3 - if caught)

        The paremeter "Reindex" should not be set to "true" except on
        CrsMatrices. (return -4)

        The paremeter "Reindex" should not be set to "true" unless Amesos
        was built with EpetraExt, i.e. with --enable-epetraext on the
        configure line. (return -4)

        Internal errors retur -5.

        <br >Postconditions: Numeric Factorization will be performed (or
        marked to be performed) allowing Solve() to be performed correctly
        despite a potential change in in the matrix values (though not in the
        non-zero structure).

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Klu_NumericFactorization(self, *args)

    def Solve(self, *args):
        """
        Solve(Klu self) -> int

        int Amesos_Klu::Solve()

        Solves A X = B (or AT x = B)

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        GetProblem()->CheckInput (see Epetra_LinearProblem::CheckInput() for
        return values)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization().

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should not have changed since the last call to
        NumericFactorization().

        <br >Postconditions: X will be set such that A X = B (or AT X = B),
        within the limits of the accuracy of the underlying solver.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Klu_Solve(self, *args)

    def GetProblem(self, *args):
        """
        GetProblem(Klu self) -> LinearProblem

        const
        Epetra_LinearProblem* Amesos_Klu::GetProblem() const

        Get a pointer to the Problem. 
        """
        return _Amesos.Klu_GetProblem(self, *args)

    def MatrixShapeOK(self, *args):
        """
        MatrixShapeOK(Klu self) -> bool

        bool
        Amesos_Klu::MatrixShapeOK() const

        Returns true if KLU can handle this matrix shape.

        Returns true if the matrix shape is one that KLU can handle. KLU only
        works with square matrices. 
        """
        return _Amesos.Klu_MatrixShapeOK(self, *args)

    def SetUseTranspose(self, *args):
        """
        SetUseTranspose(Klu self, bool UseTranspose_in) -> int

        int
        Amesos_Klu::SetUseTranspose(bool UseTranspose_in)

        SetUseTranpose(true) is more efficient in Amesos_Klu.

        If SetUseTranspose() is set to true, $A^T X = B$ is computed. 
        """
        return _Amesos.Klu_SetUseTranspose(self, *args)

    def UseTranspose(self, *args):
        """
        UseTranspose(Klu self) -> bool

        bool
        Amesos_Klu::UseTranspose() const

        Returns the current UseTranspose setting. 
        """
        return _Amesos.Klu_UseTranspose(self, *args)

    def Comm(self, *args):
        """
        Comm(Klu self) -> Comm

        const Epetra_Comm&
        Amesos_Klu::Comm() const

        Returns a pointer to the Epetra_Comm communicator associated with this
        operator. 
        """
        return _Amesos.Klu_Comm(self, *args)

    def SetParameters(self, *args):
        """
        SetParameters(Klu self, ParameterList ParameterList) -> int

        int
        Amesos_Klu::SetParameters(Teuchos::ParameterList &ParameterList)

        Updates internal variables.

        <br >Preconditions: None.

        <br >Postconditions: Internal variables controlling the factorization
        and solve will be updated and take effect on all subseuent calls to
        NumericFactorization() and Solve().

        All parameters whose value are to differ from the default values must
        be included in ParameterList. Parameters not specified in
        ParameterList revert to their default values.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Klu_SetParameters(self, *args)

    def NumSymbolicFact(self, *args):
        """
        NumSymbolicFact(Klu self) -> int

        int
        Amesos_Klu::NumSymbolicFact() const

        Returns the number of symbolic factorizations performed by this
        object. 
        """
        return _Amesos.Klu_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """
        NumNumericFact(Klu self) -> int

        int
        Amesos_Klu::NumNumericFact() const

        Returns the number of numeric factorizations performed by this object.

        """
        return _Amesos.Klu_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """
        NumSolve(Klu self) -> int

        int
        Amesos_Klu::NumSolve() const

        Returns the number of solves performed by this object. 
        """
        return _Amesos.Klu_NumSolve(self, *args)

    def PrintTiming(self, *args):
        """
        PrintTiming(Klu self)

        void
        Amesos_Klu::PrintTiming() const

        Prints timing information. 
        """
        return _Amesos.Klu_PrintTiming(self, *args)

    def PrintStatus(self, *args):
        """
        PrintStatus(Klu self)

        void
        Amesos_Klu::PrintStatus() const

        Prints information about the factorization and solution phases. 
        """
        return _Amesos.Klu_PrintStatus(self, *args)

    def GetTiming(self, *args):
        """
        GetTiming(Klu self, ParameterList TimingParameterList)

        void
        Amesos_Klu::GetTiming(Teuchos::ParameterList &TimingParameterList)
        const

        Extracts timing information and places in parameter list. 
        """
        return _Amesos.Klu_GetTiming(self, *args)

Klu_swigregister = _Amesos.Klu_swigregister
Klu_swigregister(Klu)

class Umfpack(BaseSolver):
    """
    Class Amesos_Umfpack: An object-oriented wrapper for UMFPACK.

    Amesos_Umfpack will solve a linear systems of equations: A X = B using
    Epetra objects and the UMFPACK solver library, where A is an
    Epetra_RowMatrix and X and B are Epetra_MultiVector objects.

    C++ includes: Amesos_Umfpack.h 
    """
    __swig_setmethods__ = {}
    for _s in [BaseSolver]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Umfpack, name, value)
    __swig_getmethods__ = {}
    for _s in [BaseSolver]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Umfpack, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Amesos_Umfpack self, LinearProblem LinearProblem) -> Umfpack

        Amesos_Umfpack::Amesos_Umfpack(const Epetra_LinearProblem
        &LinearProblem)

        Amesos_Umfpack Constructor.

        Creates an Amesos_Umfpack instance, using an Epetra_LinearProblem,
        passing in an already- defined Epetra_LinearProblem object.

        Note: The operator in LinearProblem must be an Epetra_RowMatrix. 
        """
        this = _Amesos.new_Umfpack(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Umfpack
    def SymbolicFactorization(self, *args):
        """
        SymbolicFactorization(Umfpack self) -> int

        int
        Amesos_Umfpack::SymbolicFactorization()

        Performs SymbolicFactorization on the matrix A.

        In addition to performing symbolic factorization on the matrix A, the
        call to SymbolicFactorization() implies that no change will be made to
        the non-zero structure of the underlying matrix without a subsequent
        call to SymbolicFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        <br >Postconditions: Symbolic Factorization will be performed (or
        marked to be performed) allowing NumericFactorization() and Solve() to
        be called.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Umfpack_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """
        NumericFactorization(Umfpack self) -> int

        int
        Amesos_Umfpack::NumericFactorization()

        Performs NumericFactorization on the matrix A.

        In addition to performing numeric factorization on the matrix A, the
        call to NumericFactorization() implies that no change will be made to
        the underlying matrix without a subsequent call to
        NumericFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization(). (return -2 if the number of non-
        zeros changes) Other changes can have arbitrary consequences.

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should be indexed from 0 to n-1, unless the parameter
        "Reindex" was set to "true" prior to the call to
        SymbolicFactorization(). (return -3 - if caught)

        The paremeter "Reindex" should not be set to "true" except on
        CrsMatrices. (return -4)

        The paremeter "Reindex" should not be set to "true" unless Amesos
        was built with EpetraExt, i.e. with --enable-epetraext on the
        configure line. (return -4)

        Internal errors retur -5.

        <br >Postconditions: Numeric Factorization will be performed (or
        marked to be performed) allowing Solve() to be performed correctly
        despite a potential change in in the matrix values (though not in the
        non-zero structure).

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Umfpack_NumericFactorization(self, *args)

    def Solve(self, *args):
        """
        Solve(Umfpack self) -> int

        int
        Amesos_Umfpack::Solve()

        Solves A X = B (or AT x = B)

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        GetProblem()->CheckInput (see Epetra_LinearProblem::CheckInput() for
        return values)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization().

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should not have changed since the last call to
        NumericFactorization().

        <br >Postconditions: X will be set such that A X = B (or AT X = B),
        within the limits of the accuracy of the underlying solver.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Umfpack_Solve(self, *args)

    def GetProblem(self, *args):
        """
        GetProblem(Umfpack self) -> LinearProblem

        const
        Epetra_LinearProblem* Amesos_Umfpack::GetProblem() const

        Returns the Epetra_LinearProblem.

        Warning! Do not call return->SetOperator(...) to attempt to change the
        Epetra_Operator object (even if the new matrix has the same
        structure). This new operator matrix will be ignored! 
        """
        return _Amesos.Umfpack_GetProblem(self, *args)

    def MatrixShapeOK(self, *args):
        """
        MatrixShapeOK(Umfpack self) -> bool

        bool
        Amesos_Umfpack::MatrixShapeOK() const

        Returns true if UMFPACK can handle this matrix shape.

        Returns true if the matrix shape is one that UMFPACK can handle.
        UMFPACK only works with square matrices. 
        """
        return _Amesos.Umfpack_MatrixShapeOK(self, *args)

    def SetUseTranspose(self, *args):
        """
        SetUseTranspose(Umfpack self, bool UseTranspose_in) -> int

        int
        Amesos_Umfpack::SetUseTranspose(bool UseTranspose_in)

        If set true, X will be set to the solution of AT X = B (not A X = B)

        If the implementation of this interface does not support transpose
        use, this method should return a value of -1.

        <br >Preconditions:  SetUseTranspose() should be called prior to the
        call to SymbolicFactorization() If NumericFactorization() or Solve()
        is called after SetUseTranspose() without an intervening call to
        SymbolicFactorization() the result is implementation dependent.

        <br >Postconditions: The next factorization and solve will be
        performed with the new value of UseTranspose.

        Parameters:
        -----------

        UseTranspose:  -- (In) If true, solve AT X = B, otherwise solve A X =
        B.

        Integer error code, set to 0 if successful. Set to -1 if this
        implementation does not support transpose. 
        """
        return _Amesos.Umfpack_SetUseTranspose(self, *args)

    def UseTranspose(self, *args):
        """
        UseTranspose(Umfpack self) -> bool

        bool
        Amesos_Umfpack::UseTranspose() const

        Returns the current UseTranspose setting. 
        """
        return _Amesos.Umfpack_UseTranspose(self, *args)

    def Comm(self, *args):
        """
        Comm(Umfpack self) -> Comm

        const Epetra_Comm&
        Amesos_Umfpack::Comm() const

        Returns a pointer to the Epetra_Comm communicator associated with this
        operator. 
        """
        return _Amesos.Umfpack_Comm(self, *args)

    def GetRcond(self, *args):
        """
        GetRcond(Umfpack self) -> double

        double
        Amesos_Umfpack::GetRcond() const

        Returns an estimate of the reciprocal of the condition number. 
        """
        return _Amesos.Umfpack_GetRcond(self, *args)

    def SetParameters(self, *args):
        """
        SetParameters(Umfpack self, ParameterList ParameterList) -> int

        int
        Amesos_Umfpack::SetParameters(Teuchos::ParameterList &ParameterList)

        Updates internal variables.

        <br >Preconditions: None.

        <br >Postconditions: Internal variables controlling the factorization
        and solve will be updated and take effect on all subseuent calls to
        NumericFactorization() and Solve().

        All parameters whose value are to differ from the default values must
        be included in ParameterList. Parameters not specified in
        ParameterList revert to their default values.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Umfpack_SetParameters(self, *args)

    def NumSymbolicFact(self, *args):
        """
        NumSymbolicFact(Umfpack self) -> int

        int
        Amesos_Umfpack::NumSymbolicFact() const

        Returns the number of symbolic factorizations performed by this
        object. 
        """
        return _Amesos.Umfpack_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """
        NumNumericFact(Umfpack self) -> int

        int
        Amesos_Umfpack::NumNumericFact() const

        Returns the number of numeric factorizations performed by this object.

        """
        return _Amesos.Umfpack_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """
        NumSolve(Umfpack self) -> int

        int
        Amesos_Umfpack::NumSolve() const

        Returns the number of solves performed by this object. 
        """
        return _Amesos.Umfpack_NumSolve(self, *args)

    def PrintTiming(self, *args):
        """
        PrintTiming(Umfpack self)

        void
        Amesos_Umfpack::PrintTiming() const

        Prints timing information. 
        """
        return _Amesos.Umfpack_PrintTiming(self, *args)

    def PrintStatus(self, *args):
        """
        PrintStatus(Umfpack self)

        void
        Amesos_Umfpack::PrintStatus() const

        Prints information about the factorization and solution phases. 
        """
        return _Amesos.Umfpack_PrintStatus(self, *args)

    def GetTiming(self, *args):
        """
        GetTiming(Umfpack self, ParameterList TimingParameterList)

        void
        Amesos_Umfpack::GetTiming(Teuchos::ParameterList &TimingParameterList)
        const

        Extracts timing information from the current solver and places it in
        the parameter list. 
        """
        return _Amesos.Umfpack_GetTiming(self, *args)

Umfpack_swigregister = _Amesos.Umfpack_swigregister
Umfpack_swigregister(Umfpack)

class Scalapack(BaseSolver):
    """
    Amesos_Scalapack: A serial and parallel dense solver. For now, we
    implement only the unsymmetric ScaLAPACK solver.

    Amesos_Scalapack, an object-oriented wrapper for LAPACK and ScaLAPACK,
    will solve a linear systems of equations: A X = B using Epetra objects
    and the ScaLAPACK library, where A is an Epetra_RowMatrix and X and B
    are Epetra_MultiVector objects.

    Amesos_Scalapack can be competitive for matrices that are not
    particularly sparse. ScaLAPACK solves matrices for which the fill-in
    is roughly 10% to 20% of the matrix size in time comparable to that
    achieve by other Amesos classes. Amesos_Scalapack scales well and
    hence its performance advantage will be largest when large number of
    processes are involved.

    Amesos_Scalapack uses the ScaLAPACK functions PDGETRF and PDGETRS if
    more than one process is used. If only one process is used,
    Amesos_ScaLAPACK uses the LAPACK function PDGETRF and PDGETRS.

    AmesosScaLAPACK uses full partial pivoting and will therefore provide
    answers that are at least as accurate as any direct sparse solver.

    AmesosScalapack makes sense under the following circumstances: There
    is sufficient memory to store the entrie dense matrix. 8*n^2/p bytes
    will be required on each process. -AND- one of the following The
    matrix is relatively small and dense. Amesos_Scalapack will solve
    matrices less than 100 by 100 faster than other Amesos classes unless
    the matrices are very sparse.

    The matrix is relatively dense and many processes are available. If a
    thousand processes are available, Amesos_Scalapack should be
    competetive with other sparse direct solvers even for matrices whose L
    and U factors contain only 5% non-zeros.

    The matrix is quite dense. Amesos_Scalapack will be well on any matrix
    whose L and U factors contain 20% or more non-zeros.

    Execution time is less important than robustness. Amesos_Scalapack is
    among the most robust parallel direct solvers.

    Common control parameters :

    Amesos_Scalapack supports the following parameters which are common to
    across multiple Amesos solvers: ParamList.set("MaxProcs", int
    MaximumProcessesToUse ); By default, this is set to -1, which causes
    Amesos_Scalapack to use a heuristic to determine how many processes to
    use. If set to a postive value, MaximumProcessesToUse,
    Amesos_Scalapack will use MaximumProcessesToUse provided that there
    are that many processes available. Testing should be performed with
    MaximumProcessesToUse set to some value larger than one to force
    parallel execution.

    ParamList.set("PrintTiming", bool );

    ParamList.set("PrintStatus", bool );

    ParamList.set("ComputeVectorNorms", bool );

    ParamList.set("ComputeTrueResidual", bool );

    ParamList.set("OutputLevel", int );

    ParamList.set("DebugLevel", int );

    ParamList.set("ComputeTrueResidual", bool );  Amesos_Scalapack
    supports the following parameters specific to Amesos_Scalapack.
    Teuchos::ParameterList ScalapackParams =
    ParameterList.sublist("Scalapack") ; ScalapackParams.set("2D
    distribution", bool ); By default this is set "true". In general,
    because a two dimensional data distribution generally produces faster
    results. However, in some cases, a one dimensional data distribution
    may provide faster execution time. The code for the one dimensional
    data distribution uses a different data redistribution algorithm and
    uses the transpose of the matrix internally (all of which is
    transparent to the user).

    ScalapackParams.set("grid_nb", bool ); By default this is set to 32.
    On some machines, it may be possible to improve performance by up to
    10% by changing the value of grid_nb. (16,24,48,64 or 128) are
    reasonable values to try. For testing on small matrices, small values
    of grid_nb will (if "MaxProcs" is set to a value greater than 1)
    force the code to execute in parallel. Limitations:

    None of the following limitations would be particularly difficult to
    remove.

    The present implementation limits the number of right hand sides to
    the number of rows assigned to each process. i.e. nrhs < n/p.

    The present implementation does not take advantage of symmetric or
    symmetric positive definite matrices, although ScaLAPACK has separate
    routines to take advantages of such matrices.

    C++ includes: Amesos_Scalapack.h 
    """
    __swig_setmethods__ = {}
    for _s in [BaseSolver]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Scalapack, name, value)
    __swig_getmethods__ = {}
    for _s in [BaseSolver]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Scalapack, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Amesos_Scalapack self, LinearProblem LinearProblem) -> Scalapack

        Amesos_Scalapack::Amesos_Scalapack(const Epetra_LinearProblem
        &LinearProblem)

        Amesos_Scalapack Constructor.

        Creates an Amesos_Scalapack instance, using an Epetra_LinearProblem,
        passing in an already- defined Epetra_LinearProblem object.

        Note: The operator in LinearProblem must be an Epetra_RowMatrix. 
        """
        this = _Amesos.new_Scalapack(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Scalapack
    def SymbolicFactorization(self, *args):
        """
        SymbolicFactorization(Scalapack self) -> int

        int
        Amesos_Scalapack::SymbolicFactorization()

        Performs SymbolicFactorization on the matrix A.

        There is no symbolic factorization phase in ScaLAPACK, as it operates
        only on dense matrices. Hence,
        Amesos_Scalapack::SymbolicFactorization() takes no action.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Scalapack_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """
        NumericFactorization(Scalapack self) -> int

        int
        Amesos_Scalapack::NumericFactorization()

        Performs NumericFactorization on the matrix A.

        In addition to performing numeric factorization on the matrix A, the
        call to NumericFactorization() implies that no change will be made to
        the underlying matrix without a subsequent call to
        NumericFactorization().

        preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6) NOT
        IMPLEMENTED

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization(). Irrelevant for Amesos_Scalapack.

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization(). Irrelevant for Amesos_Scalapack.

        postconditions: nprow_, npcol_, DescA_

        DenseA will be factored

        Ipiv_ contains the pivots

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Scalapack_NumericFactorization(self, *args)

    def Solve(self, *args):
        """
        Solve(Scalapack self) -> int

        int
        Amesos_Scalapack::Solve()

        Solves A X = B (or AT X = B)

        preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6) NOT
        IMPLEMENTED

        X and B must have the same shape (NOT CHECKED)

        X and B must have fewer than nb right hand sides. EPETRA_CHK_ERR(-2)

        GetProblem()->CheckInput (see Epetra_LinearProblem::CheckInput() for
        return values)

        The matrix should not have changed since the last call to
        NumericFactorization().

        postconditions: X will be set such that A X = B (or AT X = B), within
        the limits of the accuracy of the the Scalapack solver.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Scalapack_Solve(self, *args)

    def GetProblem(self, *args):
        """
        GetProblem(Scalapack self) -> LinearProblem

        const
        Epetra_LinearProblem* Amesos_Scalapack::GetProblem() const

        Get a pointer to the Problem. 
        """
        return _Amesos.Scalapack_GetProblem(self, *args)

    def MatrixShapeOK(self, *args):
        """
        MatrixShapeOK(Scalapack self) -> bool

        bool
        Amesos_Scalapack::MatrixShapeOK() const

        Returns true if SCALAPACK can handle this matrix shape.

        Returns true if the matrix shape is one that SCALAPACK can handle.
        SCALAPACK only works with square matrices. 
        """
        return _Amesos.Scalapack_MatrixShapeOK(self, *args)

    def SetUseTranspose(self, *args):
        """
        SetUseTranspose(Scalapack self, bool UseTranspose) -> int

        int
        Amesos_Scalapack::SetUseTranspose(bool UseTranspose)

        SetUseTranpose(true) is more efficient in Amesos_Scalapack.

        If SetUseTranspose() is set to true,

        AT X = B is computed

        else

        A X = B is computed 
        """
        return _Amesos.Scalapack_SetUseTranspose(self, *args)

    def UseTranspose(self, *args):
        """
        UseTranspose(Scalapack self) -> bool

        bool
        Amesos_Scalapack::UseTranspose() const

        Returns the current UseTranspose setting. 
        """
        return _Amesos.Scalapack_UseTranspose(self, *args)

    def Comm(self, *args):
        """
        Comm(Scalapack self) -> Comm

        const Epetra_Comm&
        Amesos_Scalapack::Comm() const

        Returns a pointer to the Epetra_Comm communicator associated with this
        matrix. 
        """
        return _Amesos.Scalapack_Comm(self, *args)

    def SetParameters(self, *args):
        """
        SetParameters(Scalapack self, ParameterList ParameterList) -> int

        int
        Amesos_Scalapack::SetParameters(Teuchos::ParameterList &ParameterList)

        Updates internal variables.

        <br >Preconditions: None.

        <br >Postconditions: Internal variables controlling the factorization
        and solve will be updated and take effect on all subsequent calls to
        NumericFactorization() and Solve().

        All parameters whose value are to differ from the default values must
        be included in ParameterList. Parameters not specified in
        ParameterList revert to their default values.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Scalapack_SetParameters(self, *args)

    def NumSymbolicFact(self, *args):
        """
        NumSymbolicFact(Scalapack self) -> int

        int
        Amesos_Scalapack::NumSymbolicFact() const

        Returns the number of symbolic factorizations performed by this
        object. 
        """
        return _Amesos.Scalapack_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """
        NumNumericFact(Scalapack self) -> int

        int
        Amesos_Scalapack::NumNumericFact() const

        Returns the number of numeric factorizations performed by this object.

        """
        return _Amesos.Scalapack_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """
        NumSolve(Scalapack self) -> int

        int
        Amesos_Scalapack::NumSolve() const

        Returns the number of solves performed by this object. 
        """
        return _Amesos.Scalapack_NumSolve(self, *args)

    def PrintTiming(self, *args):
        """
        PrintTiming(Scalapack self)

        void
        Amesos_Scalapack::PrintTiming() const

        Print timing information. 
        """
        return _Amesos.Scalapack_PrintTiming(self, *args)

    def PrintStatus(self, *args):
        """
        PrintStatus(Scalapack self)

        void
        Amesos_Scalapack::PrintStatus() const

        Print information about the factorization and solution phases. 
        """
        return _Amesos.Scalapack_PrintStatus(self, *args)

    def GetTiming(self, *args):
        """
        GetTiming(Scalapack self, ParameterList TimingParameterList)

        void
        Amesos_Scalapack::GetTiming(Teuchos::ParameterList
        &TimingParameterList) const

        Extracts timing information from the current solver and places it in
        the parameter list. 
        """
        return _Amesos.Scalapack_GetTiming(self, *args)

Scalapack_swigregister = _Amesos.Scalapack_swigregister
Scalapack_swigregister(Scalapack)

class Taucs(BaseSolver):
    """
    Interface to TAUCS.

    C++ includes: Amesos_Taucs.h 
    """
    __swig_setmethods__ = {}
    for _s in [BaseSolver]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Taucs, name, value)
    __swig_getmethods__ = {}
    for _s in [BaseSolver]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Taucs, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Amesos_Taucs self, LinearProblem LinearProblem) -> Taucs

        Amesos_Taucs::Amesos_Taucs(const Epetra_LinearProblem &LinearProblem)

        Default constructor. 
        """
        this = _Amesos.new_Taucs(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Taucs
    def SymbolicFactorization(self, *args):
        """
        SymbolicFactorization(Taucs self) -> int

        int
        Amesos_Taucs::SymbolicFactorization()

        Performs SymbolicFactorization on the matrix A.

        In addition to performing symbolic factorization on the matrix A, the
        call to SymbolicFactorization() implies that no change will be made to
        the non-zero structure of the underlying matrix without a subsequent
        call to SymbolicFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        <br >Postconditions: Symbolic Factorization will be performed (or
        marked to be performed) allowing NumericFactorization() and Solve() to
        be called.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Taucs_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """
        NumericFactorization(Taucs self) -> int

        int
        Amesos_Taucs::NumericFactorization()

        Performs NumericFactorization on the matrix A.

        In addition to performing numeric factorization on the matrix A, the
        call to NumericFactorization() implies that no change will be made to
        the underlying matrix without a subsequent call to
        NumericFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization(). (return -2 if the number of non-
        zeros changes) Other changes can have arbitrary consequences.

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should be indexed from 0 to n-1, unless the parameter
        "Reindex" was set to "true" prior to the call to
        SymbolicFactorization(). (return -3 - if caught)

        The paremeter "Reindex" should not be set to "true" except on
        CrsMatrices. (return -4)

        The paremeter "Reindex" should not be set to "true" unless Amesos
        was built with EpetraExt, i.e. with --enable-epetraext on the
        configure line. (return -4)

        Internal errors retur -5.

        <br >Postconditions: Numeric Factorization will be performed (or
        marked to be performed) allowing Solve() to be performed correctly
        despite a potential change in in the matrix values (though not in the
        non-zero structure).

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Taucs_NumericFactorization(self, *args)

    def Solve(self, *args):
        """
        Solve(Taucs self) -> int

        int Amesos_Taucs::Solve()

        Solves A X = B (or AT x = B)

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        GetProblem()->CheckInput (see Epetra_LinearProblem::CheckInput() for
        return values)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization().

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should not have changed since the last call to
        NumericFactorization().

        <br >Postconditions: X will be set such that A X = B (or AT X = B),
        within the limits of the accuracy of the underlying solver.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Taucs_Solve(self, *args)

    def GetProblem(self, *args):
        """
        GetProblem(Taucs self) -> LinearProblem

        const
        Epetra_LinearProblem* Amesos_Taucs::GetProblem() const

        Returns the Epetra_LinearProblem.

        Warning! Do not call return->SetOperator(...) to attempt to change the
        Epetra_Operator object (even if the new matrix has the same
        structure). This new operator matrix will be ignored! 
        """
        return _Amesos.Taucs_GetProblem(self, *args)

    def MatrixShapeOK(self, *args):
        """
        MatrixShapeOK(Taucs self) -> bool

        bool
        Amesos_Taucs::MatrixShapeOK() const

        Returns true if the solver can handle this matrix shape.

        Returns true if the matrix shape is one that the underlying sparse
        direct solver can handle. Classes that work only on square matrices
        should return false for rectangular matrices. Classes that work only
        on symmetric matrices whould return false for non-symmetric matrices.

        """
        return _Amesos.Taucs_MatrixShapeOK(self, *args)

    def SetUseTranspose(self, *args):
        """
        SetUseTranspose(Taucs self, bool UseTranspose) -> int

        int
        Amesos_Taucs::SetUseTranspose(bool UseTranspose)

        Amesos_Taucs supports only symmetric matrices, hence transpose is
        irrelevant, but harmless. 
        """
        return _Amesos.Taucs_SetUseTranspose(self, *args)

    def UseTranspose(self, *args):
        """
        UseTranspose(Taucs self) -> bool

        bool
        Amesos_Taucs::UseTranspose() const

        Returns the current UseTranspose setting. 
        """
        return _Amesos.Taucs_UseTranspose(self, *args)

    def Comm(self, *args):
        """
        Comm(Taucs self) -> Comm

        const Epetra_Comm&
        Amesos_Taucs::Comm() const

        Returns a pointer to the Epetra_Comm communicator associated with this
        operator. 
        """
        return _Amesos.Taucs_Comm(self, *args)

    def SetParameters(self, *args):
        """
        SetParameters(Taucs self, ParameterList ParameterList) -> int

        int
        Amesos_Taucs::SetParameters(Teuchos::ParameterList &ParameterList)

        Updates internal variables.

        <br >Preconditions: None.

        <br >Postconditions: Internal variables controlling the factorization
        and solve will be updated and take effect on all subseuent calls to
        NumericFactorization() and Solve().

        All parameters whose value are to differ from the default values must
        be included in ParameterList. Parameters not specified in
        ParameterList revert to their default values.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Taucs_SetParameters(self, *args)

    def NumSymbolicFact(self, *args):
        """
        NumSymbolicFact(Taucs self) -> int

        int
        Amesos_Taucs::NumSymbolicFact() const

        Returns the number of symbolic factorizations performed by this
        object. 
        """
        return _Amesos.Taucs_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """
        NumNumericFact(Taucs self) -> int

        int
        Amesos_Taucs::NumNumericFact() const

        Returns the number of numeric factorizations performed by this object.

        """
        return _Amesos.Taucs_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """
        NumSolve(Taucs self) -> int

        int
        Amesos_Taucs::NumSolve() const

        Returns the number of solves performed by this object. 
        """
        return _Amesos.Taucs_NumSolve(self, *args)

    def PrintTiming(self, *args):
        """
        PrintTiming(Taucs self)

        void
        Amesos_Taucs::PrintTiming() const

        Prints timing information. 
        """
        return _Amesos.Taucs_PrintTiming(self, *args)

    def PrintStatus(self, *args):
        """
        PrintStatus(Taucs self)

        void
        Amesos_Taucs::PrintStatus() const

        Prints status information. 
        """
        return _Amesos.Taucs_PrintStatus(self, *args)

    def GetTiming(self, *args):
        """
        GetTiming(Taucs self, ParameterList TimingParameterList)

        void
        Amesos_Taucs::GetTiming(Teuchos::ParameterList &TimingParameterList)
        const

        Extracts timing information from the current solver and places it in
        the parameter list. 
        """
        return _Amesos.Taucs_GetTiming(self, *args)

Taucs_swigregister = _Amesos.Taucs_swigregister
Taucs_swigregister(Taucs)

class Superlu(BaseSolver):
    """
    Amesos_Superlu: Amesos interface to Xioye Li's SuperLU 3.0 serial
    code.

    Class Amesos_Superlu solves the linear systems of equations A X = B,
    where A is defined as an Epetra_RowMatrix, and X and B are two
    Epetra_MultiVector's.

    C++ includes: Amesos_Superlu.h 
    """
    __swig_setmethods__ = {}
    for _s in [BaseSolver]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Superlu, name, value)
    __swig_getmethods__ = {}
    for _s in [BaseSolver]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Superlu, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Amesos_Superlu self, LinearProblem LinearProblem) -> Superlu

        Amesos_Superlu::Amesos_Superlu(const Epetra_LinearProblem
        &LinearProblem)

        Amesos_Superlu Constructor.

        Creates an Amesos_Superlu instance, using an Epetra_LinearProblem,
        passing in an already- defined Epetra_LinearProblem object.

        Note: The operator in LinearProblem must be an Epetra_RowMatrix. 
        """
        this = _Amesos.new_Superlu(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Superlu
    def SymbolicFactorization(self, *args):
        """
        SymbolicFactorization(Superlu self) -> int

        int
        Amesos_Superlu::SymbolicFactorization()

        Performs SymbolicFactorization on the matrix A.

        In addition to performing symbolic factorization on the matrix A, the
        call to SymbolicFactorization() implies that no change will be made to
        the non-zero structure of the underlying matrix without a subsequent
        call to SymbolicFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        <br >Postconditions: Symbolic Factorization will be performed (or
        marked to be performed) allowing NumericFactorization() and Solve() to
        be called.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Superlu_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """
        NumericFactorization(Superlu self) -> int

        int
        Amesos_Superlu::NumericFactorization()

        Performs NumericFactorization on the matrix A.

        In addition to performing numeric factorization on the matrix A, the
        call to NumericFactorization() implies that no change will be made to
        the underlying matrix without a subsequent call to
        NumericFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization(). (return -2 if the number of non-
        zeros changes) Other changes can have arbitrary consequences.

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should be indexed from 0 to n-1, unless the parameter
        "Reindex" was set to "true" prior to the call to
        SymbolicFactorization(). (return -3 - if caught)

        The paremeter "Reindex" should not be set to "true" except on
        CrsMatrices. (return -4)

        The paremeter "Reindex" should not be set to "true" unless Amesos
        was built with EpetraExt, i.e. with --enable-epetraext on the
        configure line. (return -4)

        Internal errors retur -5.

        <br >Postconditions: Numeric Factorization will be performed (or
        marked to be performed) allowing Solve() to be performed correctly
        despite a potential change in in the matrix values (though not in the
        non-zero structure).

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Superlu_NumericFactorization(self, *args)

    def Solve(self, *args):
        """
        Solve(Superlu self) -> int

        int
        Amesos_Superlu::Solve()

        Solves A X = B (or AT x = B)

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        GetProblem()->CheckInput (see Epetra_LinearProblem::CheckInput() for
        return values)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization().

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should not have changed since the last call to
        NumericFactorization().

        <br >Postconditions: X will be set such that A X = B (or AT X = B),
        within the limits of the accuracy of the underlying solver.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Superlu_Solve(self, *args)

    def GetProblem(self, *args):
        """
        GetProblem(Superlu self) -> LinearProblem

        const
        Epetra_LinearProblem* Amesos_Superlu::GetProblem() const

        Returns the Epetra_LinearProblem.

        Warning! Do not call return->SetOperator(...) to attempt to change the
        Epetra_Operator object (even if the new matrix has the same
        structure). This new operator matrix will be ignored! 
        """
        return _Amesos.Superlu_GetProblem(self, *args)

    def MatrixShapeOK(self, *args):
        """
        MatrixShapeOK(Superlu self) -> bool

        bool
        Amesos_Superlu::MatrixShapeOK() const

        Returns true if the solver can handle this matrix shape.

        Returns true if the matrix shape is one that the underlying sparse
        direct solver can handle. Classes that work only on square matrices
        should return false for rectangular matrices. Classes that work only
        on symmetric matrices whould return false for non-symmetric matrices.

        """
        return _Amesos.Superlu_MatrixShapeOK(self, *args)

    def SetUseTranspose(self, *args):
        """
        SetUseTranspose(Superlu self, bool UseTranspose) -> int

        int
        Amesos_Superlu::SetUseTranspose(bool UseTranspose)

        If set true, X will be set to the solution of AT X = B (not A X = B)

        If the implementation of this interface does not support transpose
        use, this method should return a value of -1.

        <br >Preconditions:  SetUseTranspose() should be called prior to the
        call to SymbolicFactorization() If NumericFactorization() or Solve()
        is called after SetUseTranspose() without an intervening call to
        SymbolicFactorization() the result is implementation dependent.

        <br >Postconditions: The next factorization and solve will be
        performed with the new value of UseTranspose.

        Parameters:
        -----------

        UseTranspose:  -- (In) If true, solve AT X = B, otherwise solve A X =
        B.

        Integer error code, set to 0 if successful. Set to -1 if this
        implementation does not support transpose. 
        """
        return _Amesos.Superlu_SetUseTranspose(self, *args)

    def UseTranspose(self, *args):
        """
        UseTranspose(Superlu self) -> bool

        bool
        Amesos_Superlu::UseTranspose() const

        Returns the current UseTranspose setting. 
        """
        return _Amesos.Superlu_UseTranspose(self, *args)

    def Comm(self, *args):
        """
        Comm(Superlu self) -> Comm

        const Epetra_Comm&
        Amesos_Superlu::Comm() const

        Returns a pointer to the Epetra_Comm communicator associated with this
        operator. 
        """
        return _Amesos.Superlu_Comm(self, *args)

    def SetParameters(self, *args):
        """
        SetParameters(Superlu self, ParameterList ParameterList) -> int

        int
        Amesos_Superlu::SetParameters(Teuchos::ParameterList &ParameterList)

        Updates internal variables.

        <br >Preconditions: None.

        <br >Postconditions: Internal variables controlling the factorization
        and solve will be updated and take effect on all subseuent calls to
        NumericFactorization() and Solve().

        All parameters whose value are to differ from the default values must
        be included in ParameterList. Parameters not specified in
        ParameterList revert to their default values.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Superlu_SetParameters(self, *args)

    def NumSymbolicFact(self, *args):
        """
        NumSymbolicFact(Superlu self) -> int

        int
        Amesos_Superlu::NumSymbolicFact() const

        Returns the number of symbolic factorizations performed by this
        object. 
        """
        return _Amesos.Superlu_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """
        NumNumericFact(Superlu self) -> int

        int
        Amesos_Superlu::NumNumericFact() const

        Returns the number of numeric factorizations performed by this object.

        """
        return _Amesos.Superlu_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """
        NumSolve(Superlu self) -> int

        int
        Amesos_Superlu::NumSolve() const

        Returns the number of solves performed by this object. 
        """
        return _Amesos.Superlu_NumSolve(self, *args)

    def PrintTiming(self, *args):
        """
        PrintTiming(Superlu self)

        void
        Amesos_Superlu::PrintTiming() const

        Prints timing information. 
        """
        return _Amesos.Superlu_PrintTiming(self, *args)

    def PrintStatus(self, *args):
        """
        PrintStatus(Superlu self)

        void
        Amesos_Superlu::PrintStatus() const

        Prints status information. 
        """
        return _Amesos.Superlu_PrintStatus(self, *args)

    def GetTiming(self, *args):
        """
        GetTiming(Superlu self, ParameterList TimingParameterList)

        void
        Amesos_Superlu::GetTiming(Teuchos::ParameterList &TimingParameterList)
        const

        Extracts timing information from the current solver and places it in
        the parameter list. 
        """
        return _Amesos.Superlu_GetTiming(self, *args)

Superlu_swigregister = _Amesos.Superlu_swigregister
Superlu_swigregister(Superlu)

class Superludist(BaseSolver):
    """
    Amesos_Superludist: An object-oriented wrapper for Superludist.

    Amesos_Superludist will solve a linear systems of equations: A X = B
    using Epetra objects and the Superludist solver library, where A is an
    Epetra_RowMatrix and X and B are Epetra_MultiVector objects.

    C++ includes: Amesos_Superludist.h 
    """
    __swig_setmethods__ = {}
    for _s in [BaseSolver]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Superludist, name, value)
    __swig_getmethods__ = {}
    for _s in [BaseSolver]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Superludist, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Amesos_Superludist self, LinearProblem LinearProblem) -> Superludist

        Amesos_Superludist::Amesos_Superludist(const Epetra_LinearProblem
        &LinearProblem)

        Amesos_Superludist Constructor.

        Creates an Amesos_Superludist instance, using an Epetra_LinearProblem,
        passing in an already- defined Epetra_LinearProblem object.

        Note: The operator in LinearProblem must be an Epetra_RowMatrix. 
        """
        this = _Amesos.new_Superludist(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Superludist
    def SymbolicFactorization(self, *args):
        """
        SymbolicFactorization(Superludist self) -> int

        int
        Amesos_Superludist::SymbolicFactorization()

        Performs SymbolicFactorization on the matrix A.

        In addition to performing symbolic factorization on the matrix A, the
        call to SymbolicFactorization() implies that no change will be made to
        the non-zero structure of the underlying matrix without a subsequent
        call to SymbolicFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        <br >Postconditions: Symbolic Factorization will be performed (or
        marked to be performed) allowing NumericFactorization() and Solve() to
        be called.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Superludist_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """
        NumericFactorization(Superludist self) -> int

        int
        Amesos_Superludist::NumericFactorization()

        Performs NumericFactorization on the matrix A.

        In addition to performing numeric factorization on the matrix A, the
        call to NumericFactorization() implies that no change will be made to
        the underlying matrix without a subsequent call to
        NumericFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization(). (return -2 if the number of non-
        zeros changes) Other changes can have arbitrary consequences.

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should be indexed from 0 to n-1, unless the parameter
        "Reindex" was set to "true" prior to the call to
        SymbolicFactorization(). (return -3 - if caught)

        The paremeter "Reindex" should not be set to "true" except on
        CrsMatrices. (return -4)

        The paremeter "Reindex" should not be set to "true" unless Amesos
        was built with EpetraExt, i.e. with --enable-epetraext on the
        configure line. (return -4)

        Internal errors retur -5.

        <br >Postconditions: Numeric Factorization will be performed (or
        marked to be performed) allowing Solve() to be performed correctly
        despite a potential change in in the matrix values (though not in the
        non-zero structure).

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Superludist_NumericFactorization(self, *args)

    def Solve(self, *args):
        """
        Solve(Superludist self) -> int

        int
        Amesos_Superludist::Solve()

        Solves A X = B (or AT x = B)

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        GetProblem()->CheckInput (see Epetra_LinearProblem::CheckInput() for
        return values)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization().

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should not have changed since the last call to
        NumericFactorization().

        <br >Postconditions: X will be set such that A X = B (or AT X = B),
        within the limits of the accuracy of the underlying solver.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Superludist_Solve(self, *args)

    def SetUseTranspose(self, *args):
        """
        SetUseTranspose(Superludist self, bool UseTranspose) -> int

        int
        Amesos_Superludist::SetUseTranspose(bool UseTranspose)

        Amesos_Superludist does not support transpose at this time.

        returns 0 if UseTranspose is set to false, else 1 (failure) 
        """
        return _Amesos.Superludist_SetUseTranspose(self, *args)

    def GetProblem(self, *args):
        """
        GetProblem(Superludist self) -> LinearProblem

        const
        Epetra_LinearProblem* Amesos_Superludist::GetProblem() const

        Returns the Epetra_LinearProblem.

        Warning! Do not call return->SetOperator(...) to attempt to change the
        Epetra_Operator object (even if the new matrix has the same
        structure). This new operator matrix will be ignored! 
        """
        return _Amesos.Superludist_GetProblem(self, *args)

    def MatrixShapeOK(self, *args):
        """
        MatrixShapeOK(Superludist self) -> bool

        bool
        Amesos_Superludist::MatrixShapeOK() const

        Returns true if SUPERLUDIST can handle this matrix shape.

        Returns true if the matrix shape is one that SUPERLUDIST can handle.
        SUPERLUDIST only works with square matrices. 
        """
        return _Amesos.Superludist_MatrixShapeOK(self, *args)

    def UseTranspose(self, *args):
        """
        UseTranspose(Superludist self) -> bool

        bool
        Amesos_Superludist::UseTranspose() const

        Always returns false. Superludist doesn't support transpose solve. 
        """
        return _Amesos.Superludist_UseTranspose(self, *args)

    def SetParameters(self, *args):
        """
        SetParameters(Superludist self, ParameterList ParameterList) -> int

        int
        Amesos_Superludist::SetParameters(Teuchos::ParameterList
        &ParameterList)

        Updates internal variables.

        <br >Preconditions: None.

        <br >Postconditions: Internal variables controlling the factorization
        and solve will be updated and take effect on all subseuent calls to
        NumericFactorization() and Solve().

        All parameters whose value are to differ from the default values must
        be included in ParameterList. Parameters not specified in
        ParameterList revert to their default values.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Superludist_SetParameters(self, *args)

    def NumSymbolicFact(self, *args):
        """
        NumSymbolicFact(Superludist self) -> int

        int
        Amesos_Superludist::NumSymbolicFact() const

        Returns the number of symbolic factorizations performed by this
        object. 
        """
        return _Amesos.Superludist_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """
        NumNumericFact(Superludist self) -> int

        int
        Amesos_Superludist::NumNumericFact() const

        Returns the number of numeric factorizations performed by this object.

        """
        return _Amesos.Superludist_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """
        NumSolve(Superludist self) -> int

        int
        Amesos_Superludist::NumSolve() const

        Returns the number of solves performed by this object. 
        """
        return _Amesos.Superludist_NumSolve(self, *args)

    def PrintTiming(self, *args):
        """
        PrintTiming(Superludist self)

        void
        Amesos_Superludist::PrintTiming() const

        Print various timig. 
        """
        return _Amesos.Superludist_PrintTiming(self, *args)

    def PrintStatus(self, *args):
        """
        PrintStatus(Superludist self)

        void
        Amesos_Superludist::PrintStatus() const

        Print various information about the parameters used by Superludist. 
        """
        return _Amesos.Superludist_PrintStatus(self, *args)

    def GetTiming(self, *args):
        """
        GetTiming(Superludist self, ParameterList TimingParameterList)

        void
        Amesos_Superludist::GetTiming(Teuchos::ParameterList
        &TimingParameterList) const

        Extracts timing information from the current solver and places it in
        the parameter list. 
        """
        return _Amesos.Superludist_GetTiming(self, *args)

Superludist_swigregister = _Amesos.Superludist_swigregister
Superludist_swigregister(Superludist)

class Mumps(BaseSolver):
    """
    Amesos_Mumps: An object-oriented wrapper for the double precision
    version of MUMPS.

    Amesos_Mumps is an interface to the the double precision version of
    the sparse parallel direct solver MUMPS. Given an Epetra_RowMatrix A,
    and two Epetra_MultiVectors X and B, the solution with Amesos_Mumps
    reads as follows:

    Epetra_LinearProblem Problem; Amesos_BaseSolver * Solver; Amesos
    Amesos_Factory;

    Solver = Amesos_Factory.Create("Amesos_Mumps", Problem);

    if( Solver == 0 ) std::cerr << "library not available" << std::endl;

    Problem.SetMatrix(&A);

    Solver-> SymbolicFactorization();

    Solver-> NumericFactorization();

    Problem.SetLHS(&X);

    Problem.SetLHS(&B);

    Solver-> Solve();

    A number of parameters is available to tune the performances of MUMPS.
    We refer to the Amesos Reference Guide for a detailed overview of
    these parameters. Here, we just recall that it is possible to solve
    the linear system on a subset of the processes contained in the Comm
    object of the Epetra_LinearProblem.

    Amesos_Mumps accepts any Epetra_RowMatrix derived class. However,
    special functions are available for Epetra_CrsMatrix and
    Epetra_VbrMatrix objects.

    As Amesos is based on Epetra, and Epetra is only double-precision, we
    still require an Epetra_LinearProblem composed by a double-precision
    matrix, and two double-precision vectors. The solution vector is
    casted to double after solution. Single precision may be of interest
    if Amesos is used with ML, to solve the coarse problem (for which
    single-precision can be enough in term of numerical error, and usually
    save memory and CPU time).

    Amesos_Mumps is based on Amesos_EpetraBaseSolver, that is derived from
    Amesos_BaseSolver. The main redistribution utilities, as well as a
    getrow function, is obtained by EpetraBaseSolver.

    WARNING:  This interface is compatible with MUMPS 4.5.4.

    Marzio Sala, ETHZ.

    C++ includes: Amesos_Mumps.h 
    """
    __swig_setmethods__ = {}
    for _s in [BaseSolver]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Mumps, name, value)
    __swig_getmethods__ = {}
    for _s in [BaseSolver]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Mumps, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Amesos_Mumps self, LinearProblem LinearProblem) -> Mumps

        Amesos_Mumps::Amesos_Mumps(const Epetra_LinearProblem &LinearProblem)

        Amesos_Mumps Constructor.

        Creates an Amesos_Mumps instance, using an Epetra_LinearProblem, 
        """
        this = _Amesos.new_Mumps(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Amesos.delete_Mumps
    def SymbolicFactorization(self, *args):
        """
        SymbolicFactorization(Mumps self) -> int

        int
        Amesos_Mumps::SymbolicFactorization()

        Performs SymbolicFactorization on the matrix A.

        In addition to performing symbolic factorization on the matrix A, the
        call to SymbolicFactorization() implies that no change will be made to
        the non-zero structure of the underlying matrix without a subsequent
        call to SymbolicFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        <br >Postconditions: Symbolic Factorization will be performed (or
        marked to be performed) allowing NumericFactorization() and Solve() to
        be called.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Mumps_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args):
        """
        NumericFactorization(Mumps self) -> int

        int
        Amesos_Mumps::NumericFactorization()

        Performs NumericFactorization on the matrix A.

        In addition to performing numeric factorization on the matrix A, the
        call to NumericFactorization() implies that no change will be made to
        the underlying matrix without a subsequent call to
        NumericFactorization().

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization(). (return -2 if the number of non-
        zeros changes) Other changes can have arbitrary consequences.

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should be indexed from 0 to n-1, unless the parameter
        "Reindex" was set to "true" prior to the call to
        SymbolicFactorization(). (return -3 - if caught)

        The paremeter "Reindex" should not be set to "true" except on
        CrsMatrices. (return -4)

        The paremeter "Reindex" should not be set to "true" unless Amesos
        was built with EpetraExt, i.e. with --enable-epetraext on the
        configure line. (return -4)

        Internal errors retur -5.

        <br >Postconditions: Numeric Factorization will be performed (or
        marked to be performed) allowing Solve() to be performed correctly
        despite a potential change in in the matrix values (though not in the
        non-zero structure).

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Mumps_NumericFactorization(self, *args)

    def Solve(self, *args):
        """
        Solve(Mumps self) -> int

        int Amesos_Mumps::Solve()

        Solves A X = B (or AT x = B)

        <br >Preconditions:  GetProblem().GetOperator() != 0 (return -1)

        MatrixShapeOk( GetProblem().GetOperator()) == true (return -6)

        GetProblem()->CheckInput (see Epetra_LinearProblem::CheckInput() for
        return values)

        The non-zero structure of the matrix should not have changed since the
        last call to SymbolicFactorization().

        The distribution of the matrix should not have changed since the last
        call to SymbolicFactorization()

        The matrix should not have changed since the last call to
        NumericFactorization().

        <br >Postconditions: X will be set such that A X = B (or AT X = B),
        within the limits of the accuracy of the underlying solver.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Mumps_Solve(self, *args)

    def Destroy(self, *args):
        """
        Destroy(Mumps self)

        void
        Amesos_Mumps::Destroy()

        Destroys all data associated with  this object. 
        """
        return _Amesos.Mumps_Destroy(self, *args)

    def SetUseTranspose(self, *args):
        """
        SetUseTranspose(Mumps self, bool UseTranspose_in) -> int

        int
        Amesos_Mumps::SetUseTranspose(bool UseTranspose_in)

        If set true, X will be set to the solution of AT X = B (not A X = B)

        If the implementation of this interface does not support transpose
        use, this method should return a value of -1.

        <br >Preconditions:  SetUseTranspose() should be called prior to the
        call to SymbolicFactorization() If NumericFactorization() or Solve()
        is called after SetUseTranspose() without an intervening call to
        SymbolicFactorization() the result is implementation dependent.

        <br >Postconditions: The next factorization and solve will be
        performed with the new value of UseTranspose.

        Parameters:
        -----------

        UseTranspose:  -- (In) If true, solve AT X = B, otherwise solve A X =
        B.

        Integer error code, set to 0 if successful. Set to -1 if this
        implementation does not support transpose. 
        """
        return _Amesos.Mumps_SetUseTranspose(self, *args)

    def UseTranspose(self, *args):
        """
        UseTranspose(Mumps self) -> bool

        bool
        Amesos_Mumps::UseTranspose() const

        Returns the current UseTranspose setting. 
        """
        return _Amesos.Mumps_UseTranspose(self, *args)

    def SetParameters(self, *args):
        """
        SetParameters(Mumps self, ParameterList ParameterList) -> int

        int
        Amesos_Mumps::SetParameters(Teuchos::ParameterList &ParameterList)

        Updates internal variables.

        <br >Preconditions: None.

        <br >Postconditions: Internal variables controlling the factorization
        and solve will be updated and take effect on all subseuent calls to
        NumericFactorization() and Solve().

        All parameters whose value are to differ from the default values must
        be included in ParameterList. Parameters not specified in
        ParameterList revert to their default values.

        Integer error code, set to 0 if successful. 
        """
        return _Amesos.Mumps_SetParameters(self, *args)

    def NumSymbolicFact(self, *args):
        """
        NumSymbolicFact(Mumps self) -> int

        int
        Amesos_Mumps::NumSymbolicFact() const

        Returns the number of symbolic factorizations performed by this
        object. 
        """
        return _Amesos.Mumps_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args):
        """
        NumNumericFact(Mumps self) -> int

        int
        Amesos_Mumps::NumNumericFact() const

        Returns the number of numeric factorizations performed by this object.

        """
        return _Amesos.Mumps_NumNumericFact(self, *args)

    def NumSolve(self, *args):
        """
        NumSolve(Mumps self) -> int

        int
        Amesos_Mumps::NumSolve() const

        Returns the number of solves performed by this object. 
        """
        return _Amesos.Mumps_NumSolve(self, *args)

    def PrintTiming(self, *args):
        """
        PrintTiming(Mumps self)

        void
        Amesos_Mumps::PrintTiming() const

        Prints timing information.

        In the destruction phase, prints out detailed information about the
        various phases: symbolic and numeric factorization, solution,
        gather/scatter for vectors and matrices. 
        """
        return _Amesos.Mumps_PrintTiming(self, *args)

    def PrintStatus(self, *args):
        """
        PrintStatus(Mumps self)

        void
        Amesos_Mumps::PrintStatus() const

        Prints information about the factorization and solution phases.

        In the destruction phase, prints out some information furnished by
        MUMPS, like the amount of required memory, the MFLOPS. 
        """
        return _Amesos.Mumps_PrintStatus(self, *args)

    def GetTiming(self, *args):
        """
        GetTiming(Mumps self, ParameterList TimingParameterList)

        void
        Amesos_Mumps::GetTiming(Teuchos::ParameterList &TimingParameterList)
        const

        Extracts timing information from the current solver and places it in
        the parameter list. 
        """
        return _Amesos.Mumps_GetTiming(self, *args)

    def SetPrecscaling(self, *args):
        """
        SetPrecscaling(Mumps self, double * ColSca, double * RowSca) -> int

        int
        Amesos_Mumps::SetPrecscaling(double *ColSca, double *RowSca)

        Set prescaling.

        Use double precision vectors of size N (global dimension of the
        matrix) as scaling for columns and rows. ColSca and RowSca must be
        defined on the host only, and allocated by the user, if the user sets
        ICNTL(8) = -1.

        Both input vectors are float with --enable-amesos-smumps, double
        otherwise. 
        """
        return _Amesos.Mumps_SetPrecscaling(self, *args)

    def SetRowScaling(self, *args):
        """
        SetRowScaling(Mumps self, double * RowSca) -> int

        int
        Amesos_Mumps::SetRowScaling(double *RowSca)

        Set row scaling.

        Use double precision vectors of size N (global dimension of the
        matrix) for row scaling.

        Parameters:
        -----------

        RowSca:  (In) - float pointer with --enable-amesos-smumps, double
        pointer otherwise. 
        """
        return _Amesos.Mumps_SetRowScaling(self, *args)

    def SetColScaling(self, *args):
        """
        SetColScaling(Mumps self, double * ColSca) -> int

        int
        Amesos_Mumps::SetColScaling(double *ColSca)

        Set column scaling.

        Use double precision vectors of size N (global dimension of the
        matrix) for column scaling.

        Parameters:
        -----------

        ColSca:  (In) - float pointer with --enable-amesos-smumps, double
        pointer otherwise. 
        """
        return _Amesos.Mumps_SetColScaling(self, *args)

    def SetOrdering(self, *args):
        """
        SetOrdering(Mumps self, int * PermIn) -> int

        int
        Amesos_Mumps::SetOrdering(int *PermIn)

        Sets ordering.

        Use integer vectors of size N (global dimension of the matrix) as
        given ordering. PermIn must be defined on the host only, and allocated
        by the user, if the user sets ICNTL(7) = 1. 
        """
        return _Amesos.Mumps_SetOrdering(self, *args)

    def GetRINFO(self, *args):
        """
        GetRINFO(Mumps self) -> double *

        double *
        Amesos_Mumps::GetRINFO()

        Gets the pointer to the RINFO array (defined on all processes).

        Gets the pointer to the internally stored RINFO array, of type float
        if option --enable-amesos-smumps is enabled, double otherwise. 
        """
        return _Amesos.Mumps_GetRINFO(self, *args)

    def GetINFO(self, *args):
        """
        GetINFO(Mumps self) -> int *

        int *
        Amesos_Mumps::GetINFO()

        Gets the pointer to the INFO array (defined on all processes).

        Gets the pointer to the internally stored INFO array, of type int. 
        """
        return _Amesos.Mumps_GetINFO(self, *args)

    def GetRINFOG(self, *args):
        """
        GetRINFOG(Mumps self) -> double *

        double *
        Amesos_Mumps::GetRINFOG()

        Gets the pointer to the RINFOG array (defined on host only).

        Gets the pointer to the internally stored RINFOG array (defined on the
        host process only), of type float if option --enable-amesos-smumps is
        enabled, double otherwise. 
        """
        return _Amesos.Mumps_GetRINFOG(self, *args)

    def GetINFOG(self, *args):
        """
        GetINFOG(Mumps self) -> int *

        int *
        Amesos_Mumps::GetINFOG()

        Get the pointer to the INFOG array (defined on host only).

        Gets the pointer to the internally stored INFOG (defined on the host
        process only) array, of type int. 
        """
        return _Amesos.Mumps_GetINFOG(self, *args)

    def SetICNTL(self, *args):
        """
        SetICNTL(Mumps self, int pos, int value)

        void
        Amesos_Mumps::SetICNTL(int pos, int value)

        Set ICNTL[pos] to value. pos is expressed in FORTRAN style (starting
        from 1). 
        """
        return _Amesos.Mumps_SetICNTL(self, *args)

    def SetCNTL(self, *args):
        """
        SetCNTL(Mumps self, int pos, double value)

        void
        Amesos_Mumps::SetCNTL(int pos, double value)

        Set CNTL[pos] to value. pos is expressed in FORTRAN style (starting
        from 1). 
        """
        return _Amesos.Mumps_SetCNTL(self, *args)

    def MatrixShapeOK(self, *args):
        """
        MatrixShapeOK(Mumps self) -> bool

        bool
        Amesos_Mumps::MatrixShapeOK() const

        Returns true if the solver can handle this matrix shape.

        Returns true if the matrix shape is one that the underlying sparse
        direct solver can handle. Classes that work only on square matrices
        should return false for rectangular matrices. Classes that work only
        on symmetric matrices whould return false for non-symmetric matrices.

        """
        return _Amesos.Mumps_MatrixShapeOK(self, *args)

    def Comm(self, *args):
        """
        Comm(Mumps self) -> Comm

        const Epetra_Comm&
        Amesos_Mumps::Comm() const

        Returns a pointer to the Epetra_Comm communicator associated with this
        matrix. 
        """
        return _Amesos.Mumps_Comm(self, *args)

    def GetProblem(self, *args):
        """
        GetProblem(Mumps self) -> LinearProblem

        const
        Epetra_LinearProblem* Amesos_Mumps::GetProblem() const

        Gets a pointer to the Epetra_LinearProblem. 
        """
        return _Amesos.Mumps_GetProblem(self, *args)

Mumps_swigregister = _Amesos.Mumps_swigregister
Mumps_swigregister(Mumps)

# This file is compatible with both classic and new-style classes.


