# This file was automatically generated by SWIG (http://www.swig.org).
# Version 2.0.8
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.


"""

PyTrilinos.NOX.Epetra is the python interface to namespace Epetra for
the Trilinos package NOX:

    http://trilinos.sandia.gov/packages/nox

The purpose of NOX.Epetra is to provide a concrete interface beteen
NOX and Epetra.

NOX.Epetra provides the following user-level classes:

    * Group                    - Epetra implementation of Abstract.Group
    * Vector                   - Epetra implementation of Abstract.Vector
    * FiniteDifference         - Class for estimating Jacobian w/finite differences
    * FiniteDifferenceColoring - FiniteDifference class, w/coloring efficiencies
    * MatrixFree               - Base class for Jacobian-free algorithms
    * Scaling                  - Class for controlling scalling of algebraic objects
    * LinearSystem             - Base class for interface to linear solvers
    * LinearSystemAztecOO      - Concrete implementation of LinearSystem

"""


from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('___init__', [dirname(__file__)])
        except ImportError:
            import ___init__
            return ___init__
        if fp is not None:
            try:
                _mod = imp.load_module('___init__', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    ___init__ = swig_import_helper()
    del swig_import_helper
else:
    import ___init__
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


class SwigPyIterator(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_SwigPyIterator
    def value(self): return ___init__.SwigPyIterator_value(self)
    def incr(self, n=1): return ___init__.SwigPyIterator_incr(self, n)
    def decr(self, n=1): return ___init__.SwigPyIterator_decr(self, n)
    def distance(self, *args): return ___init__.SwigPyIterator_distance(self, *args)
    def equal(self, *args): return ___init__.SwigPyIterator_equal(self, *args)
    def copy(self): return ___init__.SwigPyIterator_copy(self)
    def next(self): return ___init__.SwigPyIterator_next(self)
    def __next__(self): return ___init__.SwigPyIterator___next__(self)
    def previous(self): return ___init__.SwigPyIterator_previous(self)
    def advance(self, *args): return ___init__.SwigPyIterator_advance(self, *args)
    def __eq__(self, *args): return ___init__.SwigPyIterator___eq__(self, *args)
    def __ne__(self, *args): return ___init__.SwigPyIterator___ne__(self, *args)
    def __iadd__(self, *args): return ___init__.SwigPyIterator___iadd__(self, *args)
    def __isub__(self, *args): return ___init__.SwigPyIterator___isub__(self, *args)
    def __add__(self, *args): return ___init__.SwigPyIterator___add__(self, *args)
    def __sub__(self, *args): return ___init__.SwigPyIterator___sub__(self, *args)
    def __iter__(self): return self
SwigPyIterator_swigregister = ___init__.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)

import PyTrilinos.Teuchos
# Much of the Epetra module is compatible with the numpy module
import numpy

# From numpy version 1.0 forward, we want to use the following import syntax for
# user_array.container.  We rename it UserArray for backward compatibility with
# 0.9.x versions of numpy:
try:
    from numpy.lib.user_array import container as UserArray

# If the previous import failed, it is because we are using a numpy version
# prior to 1.0.  So we catch it and try again with different syntax.
except ImportError:

    # There is a bug in UserArray from numpy 0.9.8.  If this is the case, we
    # have our own patched version.
    try:
        from UserArrayFix import UserArray
        
    # If the previous import failed, it is because we are using a version of
    # numpy prior to 0.9.8, such as 0.9.6, which has no bug and therefore has no
    # local patch.  Now we can import using the old syntax:
    except ImportError:
        from numpy.lib.UserArray import UserArray

Error = ___init__.Error

def Epetra_Version(*args):
  """Epetra_Version() -> string"""
  return ___init__.Epetra_Version(*args)
Version = Epetra_Version
__version__ = Version().split()[2]

Add = ___init__.Add
Zero = ___init__.Zero
Insert = ___init__.Insert
InsertAdd = ___init__.InsertAdd
Average = ___init__.Average
Epetra_Max = ___init__.Epetra_Max
Epetra_Min = ___init__.Epetra_Min
AbsMax = ___init__.AbsMax
AbsMin = ___init__.AbsMin
Copy = ___init__.Copy
View = ___init__.View
class Object(_object):
    """
    The base Epetra class.
        
    The Epetra_Object class provides capabilities common to all Epetra
    objects, such as a label that identifies an object instance, constant
    definitions, enum types.  In C++, it supports a ``Print()`` method
    that takes an output stream as an argument.  In the python
    implementation for this and all derived classes, this method takes an
    optional file object argument whose default value is standard out.
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Object, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Object, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_Object self, int TracebackModeIn=-1, bool set_label=True) -> Object
        __init__(Epetra_Object self, char const *const Label, int TracebackModeIn=-1) -> Object
        __init__(Epetra_Object self, Object Object) -> Object

        The base Epetra class.
            
        The Epetra_Object class provides capabilities common to all Epetra
        objects, such as a label that identifies an object instance, constant
        definitions, enum types.  In C++, it supports a ``Print()`` method
        that takes an output stream as an argument.  In the python
        implementation for this and all derived classes, this method takes an
        optional file object argument whose default value is standard out.
        """
        this = ___init__.new_Object(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Object
    def SetLabel(self, *args):
        """SetLabel(Object self, char const *const Label)"""
        return ___init__.Object_SetLabel(self, *args)

    def Label(self, *args):
        """Label(Object self) -> char const *"""
        return ___init__.Object_Label(self, *args)

    def SetTracebackMode(*args):
        """SetTracebackMode(int TracebackModeValue)"""
        return ___init__.Object_SetTracebackMode(*args)

    if _newclass:SetTracebackMode = staticmethod(SetTracebackMode)
    __swig_getmethods__["SetTracebackMode"] = lambda x: SetTracebackMode
    def GetTracebackMode(*args):
        """GetTracebackMode() -> int"""
        return ___init__.Object_GetTracebackMode(*args)

    if _newclass:GetTracebackMode = staticmethod(GetTracebackMode)
    __swig_getmethods__["GetTracebackMode"] = lambda x: GetTracebackMode
    def GetTracebackStream(*args):
        """GetTracebackStream() -> std::ostream &"""
        return ___init__.Object_GetTracebackStream(*args)

    if _newclass:GetTracebackStream = staticmethod(GetTracebackStream)
    __swig_getmethods__["GetTracebackStream"] = lambda x: GetTracebackStream
    def ReportError(self, *args):
        """ReportError(Object self, string const Message, int ErrorCode) -> int"""
        return ___init__.Object_ReportError(self, *args)

    __swig_setmethods__["TracebackMode"] = ___init__.Object_TracebackMode_set
    __swig_getmethods__["TracebackMode"] = ___init__.Object_TracebackMode_get
    if _newclass:TracebackMode = _swig_property(___init__.Object_TracebackMode_get, ___init__.Object_TracebackMode_set)
    def __str__(self, *args):
        """
        __str__(Object self) -> PyObject *

        Returns the results of ``Print()`` in a string, so that
        the python ``print`` command will work on ``Epetra`` objects.  The
        ``Print()`` methods are designed to run correctly in parallel, so do
        not execute ``print`` on an Epetra object conditionally on the
        processor number.  For example, do not do

          ``if comm.MyPID() == 0: print epetra_obj``

        or it will hang your code.
        """
        return ___init__.Object___str__(self, *args)

    def Print(self, *args):
        """Print(Object self, PyObject * pf=None)"""
        return ___init__.Object_Print(self, *args)

Object_swigregister = ___init__.Object_swigregister
Object_swigregister(Object)

def Object_SetTracebackMode(*args):
  """Object_SetTracebackMode(int TracebackModeValue)"""
  return ___init__.Object_SetTracebackMode(*args)

def Object_GetTracebackMode(*args):
  """Object_GetTracebackMode() -> int"""
  return ___init__.Object_GetTracebackMode(*args)

def Object_GetTracebackStream(*args):
  """Object_GetTracebackStream() -> std::ostream &"""
  return ___init__.Object_GetTracebackStream(*args)
cvar = ___init__.cvar

class CompObject(_object):
    """Proxy of C++ Epetra_CompObject class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CompObject, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CompObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_CompObject self) -> CompObject
        __init__(Epetra_CompObject self, CompObject Source) -> CompObject
        """
        this = ___init__.new_CompObject(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_CompObject
    def SetFlopCounter(self, *args):
        """
        SetFlopCounter(CompObject self, FLOPS FlopCounter_in)
        SetFlopCounter(CompObject self, CompObject CompObject)
        """
        return ___init__.CompObject_SetFlopCounter(self, *args)

    def UnsetFlopCounter(self, *args):
        """UnsetFlopCounter(CompObject self)"""
        return ___init__.CompObject_UnsetFlopCounter(self, *args)

    def GetFlopCounter(self, *args):
        """GetFlopCounter(CompObject self) -> FLOPS"""
        return ___init__.CompObject_GetFlopCounter(self, *args)

    def ResetFlops(self, *args):
        """ResetFlops(CompObject self)"""
        return ___init__.CompObject_ResetFlops(self, *args)

    def Flops(self, *args):
        """Flops(CompObject self) -> double"""
        return ___init__.CompObject_Flops(self, *args)

    def UpdateFlops(self, *args):
        """
        UpdateFlops(CompObject self, long Flops_in)
        UpdateFlops(CompObject self, long long Flops_in)
        UpdateFlops(CompObject self, double Flops_in)
        """
        return ___init__.CompObject_UpdateFlops(self, *args)

CompObject_swigregister = ___init__.CompObject_swigregister
CompObject_swigregister(CompObject)

class BLAS(_object):
    """Proxy of C++ Epetra_BLAS class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, BLAS, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, BLAS, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_BLAS self) -> BLAS
        __init__(Epetra_BLAS self, BLAS BLAS) -> BLAS
        """
        this = ___init__.new_BLAS(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_BLAS
    def SYRK(self, *args):
        """
        SYRK(BLAS self, char const UPLO, char const TRANS, int const N, int const K, float const ALPHA, float const * A, 
            int const LDA, float const BETA, float * C, int const LDC)
        SYRK(BLAS self, char const UPLO, char const TRANS, int const N, int const K, double const ALPHA, 
            double const * A, int const LDA, double const BETA, double * C, int const LDC)
        """
        return ___init__.BLAS_SYRK(self, *args)

BLAS_swigregister = ___init__.BLAS_swigregister
BLAS_swigregister(BLAS)

class LAPACK(_object):
    """Proxy of C++ Epetra_LAPACK class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LAPACK, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LAPACK, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_LAPACK self) -> LAPACK
        __init__(Epetra_LAPACK self, LAPACK LAPACK) -> LAPACK
        """
        this = ___init__.new_LAPACK(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_LAPACK
    def TRTRS(self, *args):
        """
        TRTRS(LAPACK self, char const UPLO, char const TRANS, char const DIAG, int const N, int const NRHS, 
            float const * A, int const LDA, float * B, int const LDB, int * INFO)
        TRTRS(LAPACK self, char const UPLO, char const TRANS, char const DIAG, int const N, int const NRHS, 
            double const * A, int const LDA, double * B, int const LDB, int * INFO)
        """
        return ___init__.LAPACK_TRTRS(self, *args)

LAPACK_swigregister = ___init__.LAPACK_swigregister
LAPACK_swigregister(LAPACK)

class FLOPS(_object):
    """Proxy of C++ Epetra_Flops class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, FLOPS, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, FLOPS, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_Flops self) -> FLOPS
        __init__(Epetra_Flops self, FLOPS Flops_in) -> FLOPS
        """
        this = ___init__.new_FLOPS(*args)
        try: self.this.append(this)
        except: self.this = this
    def Flops(self, *args):
        """Flops(FLOPS self) -> double"""
        return ___init__.FLOPS_Flops(self, *args)

    def ResetFlops(self, *args):
        """ResetFlops(FLOPS self)"""
        return ___init__.FLOPS_ResetFlops(self, *args)

    __swig_destroy__ = ___init__.delete_FLOPS
FLOPS_swigregister = ___init__.FLOPS_swigregister
FLOPS_swigregister(FLOPS)

class Time(Object):
    """Proxy of C++ Epetra_Time class"""
    __swig_setmethods__ = {}
    for _s in [Object]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Time, name, value)
    __swig_getmethods__ = {}
    for _s in [Object]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Time, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_Time self, Comm Comm) -> Time
        __init__(Epetra_Time self, Time Time) -> Time
        """
        this = ___init__.new_Time(*args)
        try: self.this.append(this)
        except: self.this = this
    def WallTime(self, *args):
        """WallTime(Time self) -> double"""
        return ___init__.Time_WallTime(self, *args)

    def ResetStartTime(self, *args):
        """ResetStartTime(Time self)"""
        return ___init__.Time_ResetStartTime(self, *args)

    def ElapsedTime(self, *args):
        """ElapsedTime(Time self) -> double"""
        return ___init__.Time_ElapsedTime(self, *args)

    __swig_destroy__ = ___init__.delete_Time
Time_swigregister = ___init__.Time_swigregister
Time_swigregister(Time)

class Comm(_object):
    """Proxy of C++ Epetra_Comm class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Comm, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Comm, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def Clone(self, *args):
        """Clone(Comm self) -> Comm"""
        return ___init__.Comm_Clone(self, *args)

    __swig_destroy__ = ___init__.delete_Comm
    def Barrier(self, *args):
        """Barrier(Comm self)"""
        return ___init__.Comm_Barrier(self, *args)

    def MyPID(self, *args):
        """MyPID(Comm self) -> int"""
        return ___init__.Comm_MyPID(self, *args)

    def NumProc(self, *args):
        """NumProc(Comm self) -> int"""
        return ___init__.Comm_NumProc(self, *args)

    def CreateDistributor(self, *args):
        """CreateDistributor(Comm self) -> Distributor"""
        return ___init__.Comm_CreateDistributor(self, *args)

    def CreateDirectory(self, *args):
        """CreateDirectory(Comm self, BlockMap Map) -> Directory"""
        return ___init__.Comm_CreateDirectory(self, *args)

    def PrintInfo(self, *args):
        """PrintInfo(Comm self, ostream & os)"""
        return ___init__.Comm_PrintInfo(self, *args)

    def Broadcast(self, *args):
        """
        Broadcast(self, numpy.ndarray myObj, int root)

        Argument myObj must be a numpy array, so that the Broadcast can be
        performed in-place.  Its scalar data type must be int, long, double or
        string.  In C++, this routine has an integer error return code.  In
        python, a non-zero return code is converted to an exception.
        """
        return ___init__.Comm_Broadcast(self, *args)

    def GatherAll(self, *args):
        """
        GatherAll(Comm self, PyObject * myObj) -> PyObject *

        Argument myObj can be a numpy array or any sequence that can be
        converted to a numpy array.  Its scalar data type must be int, long or
        double.  The return argument is a numpy array of the same type.  In
        C++, this routine has an integer error return code.  In python, a
        non-zero return code is converted to an exception.
        """
        return ___init__.Comm_GatherAll(self, *args)

    def SumAll(self, *args):
        """
        SumAll(Comm self, PyObject * partialObj) -> PyObject *

        Argument myObj can be a numpy array or any sequence that can be
        converted to a numpy array.  Its scalar data type must be int, long or
        double.  The return argument is a numpy array of the same type.  In
        C++, this routine has an integer error return code.  In python, a
        non-zero return code is converted to an exception.
        """
        return ___init__.Comm_SumAll(self, *args)

    def MaxAll(self, *args):
        """
        MaxAll(Comm self, PyObject * partialObj) -> PyObject *

        Argument myObj can be a numpy array or any sequence that can be
        converted to a numpy array.  Its scalar data type must be int, long or
        double.  The return argument is a numpy array of the same type.  In
        C++, this routine has an integer error return code.  In python, a
        non-zero return code is converted to an exception.
        """
        return ___init__.Comm_MaxAll(self, *args)

    def MinAll(self, *args):
        """
        MinAll(Comm self, PyObject * partialObj) -> PyObject *

        Argument myObj can be a numpy array or any sequence that can be
        converted to a numpy array.  Its scalar data type must be int, long or
        double.  The return argument is a numpy array of the same type.  In
        C++, this routine has an integer error return code.  In python, a
        non-zero return code is converted to an exception.
        """
        return ___init__.Comm_MinAll(self, *args)

    def ScanSum(self, *args):
        """
        ScanSum(Comm self, PyObject * partialObj) -> PyObject *

        Argument myObj can be a numpy array or any sequence that can be
        converted to a numpy array.  Its scalar data type must be int, long or
        double.  The return argument is a numpy array of the same type.  In
        C++, this routine has an integer error return code.  In python, a
        non-zero return code is converted to an exception.
        """
        return ___init__.Comm_ScanSum(self, *args)

Comm_swigregister = ___init__.Comm_swigregister
Comm_swigregister(Comm)

class SerialComm(Object,Comm):
    """Proxy of C++ Epetra_SerialComm class"""
    __swig_setmethods__ = {}
    for _s in [Object,Comm]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerialComm, name, value)
    __swig_getmethods__ = {}
    for _s in [Object,Comm]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SerialComm, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_SerialComm self) -> SerialComm
        __init__(Epetra_SerialComm self, SerialComm Comm) -> SerialComm
        """
        this = ___init__.new_SerialComm(*args)
        try: self.this.append(this)
        except: self.this = this
    def Clone(self, *args):
        """Clone(SerialComm self) -> Comm"""
        return ___init__.SerialComm_Clone(self, *args)

    __swig_destroy__ = ___init__.delete_SerialComm
    def Barrier(self, *args):
        """Barrier(SerialComm self)"""
        return ___init__.SerialComm_Barrier(self, *args)

    def MyPID(self, *args):
        """MyPID(SerialComm self) -> int"""
        return ___init__.SerialComm_MyPID(self, *args)

    def NumProc(self, *args):
        """NumProc(SerialComm self) -> int"""
        return ___init__.SerialComm_NumProc(self, *args)

    def CreateDistributor(self, *args):
        """CreateDistributor(SerialComm self) -> Distributor"""
        return ___init__.SerialComm_CreateDistributor(self, *args)

    def CreateDirectory(self, *args):
        """CreateDirectory(SerialComm self, BlockMap Map) -> Directory"""
        return ___init__.SerialComm_CreateDirectory(self, *args)

    def PrintInfo(self, *args):
        """PrintInfo(SerialComm self, ostream & os)"""
        return ___init__.SerialComm_PrintInfo(self, *args)

    def ReferenceCount(self, *args):
        """ReferenceCount(SerialComm self) -> int"""
        return ___init__.SerialComm_ReferenceCount(self, *args)

    def DataPtr(self, *args):
        """DataPtr(SerialComm self) -> Epetra_SerialCommData const *"""
        return ___init__.SerialComm_DataPtr(self, *args)

SerialComm_swigregister = ___init__.SerialComm_swigregister
SerialComm_swigregister(SerialComm)

class Distributor(_object):
    """Proxy of C++ Epetra_Distributor class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Distributor, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Distributor, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def Clone(self, *args):
        """Clone(Distributor self) -> Distributor"""
        return ___init__.Distributor_Clone(self, *args)

    __swig_destroy__ = ___init__.delete_Distributor
    def CreateFromSends(self, *args):
        """CreateFromSends(Distributor self, int const & NumExportIDs, int const * ExportPIDs, bool Deterministic, int & NumRemoteIDs) -> int"""
        return ___init__.Distributor_CreateFromSends(self, *args)

    def CreateFromRecvs(self, *args):
        """
        CreateFromRecvs(Distributor self, int const & NumRemoteIDs, int const * RemoteGIDs, int const * RemotePIDs, bool Deterministic, 
            int & NumExportIDs, int *& ExportGIDs, int *& ExportPIDs) -> int
        CreateFromRecvs(Distributor self, int const & NumRemoteIDs, long long const * RemoteGIDs, int const * RemotePIDs, bool Deterministic, 
            int & NumExportIDs, long long *& ExportGIDs, int *& ExportPIDs) -> int
        """
        return ___init__.Distributor_CreateFromRecvs(self, *args)

    def DoWaits(self, *args):
        """DoWaits(Distributor self) -> int"""
        return ___init__.Distributor_DoWaits(self, *args)

    def DoReverseWaits(self, *args):
        """DoReverseWaits(Distributor self) -> int"""
        return ___init__.Distributor_DoReverseWaits(self, *args)

    def Do(self, *args):
        """
        Do(Distributor self, char * export_objs, int obj_size, int & len_import_objs, char *& import_objs) -> int
        Do(Distributor self, char * export_objs, int obj_size, int *& sizes, int & len_import_objs, char *& import_objs) -> int
        """
        return ___init__.Distributor_Do(self, *args)

    def DoReverse(self, *args):
        """
        DoReverse(Distributor self, char * export_objs, int obj_size, int & len_import_objs, char *& import_objs) -> int
        DoReverse(Distributor self, char * export_objs, int obj_size, int *& sizes, int & len_import_objs, char *& import_objs) -> int
        """
        return ___init__.Distributor_DoReverse(self, *args)

    def DoPosts(self, *args):
        """
        DoPosts(Distributor self, char * export_objs, int obj_size, int & len_import_objs, char *& import_objs) -> int
        DoPosts(Distributor self, char * export_objs, int obj_size, int *& sizes, int & len_import_objs, char *& import_objs) -> int
        """
        return ___init__.Distributor_DoPosts(self, *args)

    def DoReversePosts(self, *args):
        """
        DoReversePosts(Distributor self, char * export_objs, int obj_size, int & len_import_objs, char *& import_objs) -> int
        DoReversePosts(Distributor self, char * export_objs, int obj_size, int *& sizes, int & len_import_objs, char *& import_objs) -> int
        """
        return ___init__.Distributor_DoReversePosts(self, *args)

Distributor_swigregister = ___init__.Distributor_swigregister
Distributor_swigregister(Distributor)

class Epetra_SerialDistributor(Object,Distributor):
    """Proxy of C++ Epetra_SerialDistributor class"""
    __swig_setmethods__ = {}
    for _s in [Object,Distributor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Epetra_SerialDistributor, name, value)
    __swig_getmethods__ = {}
    for _s in [Object,Distributor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Epetra_SerialDistributor, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_SerialDistributor self, SerialComm Comm) -> Epetra_SerialDistributor
        __init__(Epetra_SerialDistributor self, Epetra_SerialDistributor Plan) -> Epetra_SerialDistributor
        """
        this = ___init__.new_Epetra_SerialDistributor(*args)
        try: self.this.append(this)
        except: self.this = this
    def Clone(self, *args):
        """Clone(Epetra_SerialDistributor self) -> Distributor"""
        return ___init__.Epetra_SerialDistributor_Clone(self, *args)

    __swig_destroy__ = ___init__.delete_Epetra_SerialDistributor
    def CreateFromSends(self, *args):
        """CreateFromSends(Epetra_SerialDistributor self, int const & NumExportIDs, int const * ExportPIDs, bool Deterministic, int & NumRemoteIDs) -> int"""
        return ___init__.Epetra_SerialDistributor_CreateFromSends(self, *args)

    def CreateFromRecvs(self, *args):
        """
        CreateFromRecvs(Epetra_SerialDistributor self, int const & NumRemoteIDs, int const * RemoteGIDs, int const * RemotePIDs, bool Deterministic, 
            int & NumExportIDs, int *& ExportGIDs, int *& ExportPIDs) -> int
        CreateFromRecvs(Epetra_SerialDistributor self, int const & NumRemoteIDs, long long const * RemoteGIDs, int const * RemotePIDs, bool Deterministic, 
            int & NumExportIDs, long long *& ExportGIDs, int *& ExportPIDs) -> int
        """
        return ___init__.Epetra_SerialDistributor_CreateFromRecvs(self, *args)

    def DoWaits(self, *args):
        """DoWaits(Epetra_SerialDistributor self) -> int"""
        return ___init__.Epetra_SerialDistributor_DoWaits(self, *args)

    def DoReverseWaits(self, *args):
        """DoReverseWaits(Epetra_SerialDistributor self) -> int"""
        return ___init__.Epetra_SerialDistributor_DoReverseWaits(self, *args)

    def Do(self, *args):
        """
        Do(Epetra_SerialDistributor self, char * export_objs, int obj_size, int & len_import_objs, char *& import_objs) -> int
        Do(Epetra_SerialDistributor self, char * export_objs, int obj_size, int *& sizes, int & len_import_objs, char *& import_objs) -> int
        """
        return ___init__.Epetra_SerialDistributor_Do(self, *args)

    def DoReverse(self, *args):
        """
        DoReverse(Epetra_SerialDistributor self, char * export_objs, int obj_size, int & len_import_objs, char *& import_objs) -> int
        DoReverse(Epetra_SerialDistributor self, char * export_objs, int obj_size, int *& sizes, int & len_import_objs, char *& import_objs) -> int
        """
        return ___init__.Epetra_SerialDistributor_DoReverse(self, *args)

    def DoPosts(self, *args):
        """
        DoPosts(Epetra_SerialDistributor self, char * export_objs, int obj_size, int & len_import_objs, char *& import_objs) -> int
        DoPosts(Epetra_SerialDistributor self, char * export_objs, int obj_size, int *& sizes, int & len_import_objs, char *& import_objs) -> int
        """
        return ___init__.Epetra_SerialDistributor_DoPosts(self, *args)

    def DoReversePosts(self, *args):
        """
        DoReversePosts(Epetra_SerialDistributor self, char * export_objs, int obj_size, int & len_import_objs, char *& import_objs) -> int
        DoReversePosts(Epetra_SerialDistributor self, char * export_objs, int obj_size, int *& sizes, int & len_import_objs, char *& import_objs) -> int
        """
        return ___init__.Epetra_SerialDistributor_DoReversePosts(self, *args)

Epetra_SerialDistributor_swigregister = ___init__.Epetra_SerialDistributor_swigregister
Epetra_SerialDistributor_swigregister(Epetra_SerialDistributor)


def Epetra_MPI_Init_Argv(*args):
  """Epetra_MPI_Init_Argv(PyObject * args) -> PyObject *"""
  return ___init__.Epetra_MPI_Init_Argv(*args)

def Epetra_MPI_Finalize(*args):
  """Epetra_MPI_Finalize() -> PyObject *"""
  return ___init__.Epetra_MPI_Finalize(*args)
# Call MPI_Init if appropriate
import sys
calledMpiInit = Epetra_MPI_Init_Argv(sys.argv)

# Arrange for MPI_Finalize to be called at exit, if appropriate
if calledMpiInit:
    import atexit
    atexit.register(Epetra_MPI_Finalize)

class MpiComm(Object,Comm):
    """Proxy of C++ Epetra_MpiComm class"""
    __swig_setmethods__ = {}
    for _s in [Object,Comm]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MpiComm, name, value)
    __swig_getmethods__ = {}
    for _s in [Object,Comm]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MpiComm, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_MpiComm self, MPI_Comm comm) -> MpiComm
        __init__(Epetra_MpiComm self, MpiComm Comm) -> MpiComm
        """
        this = ___init__.new_MpiComm(*args)
        try: self.this.append(this)
        except: self.this = this
    def Clone(self, *args):
        """Clone(MpiComm self) -> Comm"""
        return ___init__.MpiComm_Clone(self, *args)

    __swig_destroy__ = ___init__.delete_MpiComm
    def Barrier(self, *args):
        """Barrier(MpiComm self)"""
        return ___init__.MpiComm_Barrier(self, *args)

    def Comm(self, *args):
        """Comm(MpiComm self) -> MPI_Comm"""
        return ___init__.MpiComm_Comm(self, *args)

    def MyPID(self, *args):
        """MyPID(MpiComm self) -> int"""
        return ___init__.MpiComm_MyPID(self, *args)

    def NumProc(self, *args):
        """NumProc(MpiComm self) -> int"""
        return ___init__.MpiComm_NumProc(self, *args)

    def CreateDistributor(self, *args):
        """CreateDistributor(MpiComm self) -> Distributor"""
        return ___init__.MpiComm_CreateDistributor(self, *args)

    def CreateDirectory(self, *args):
        """CreateDirectory(MpiComm self, BlockMap Map) -> Directory"""
        return ___init__.MpiComm_CreateDirectory(self, *args)

    def GetMpiTag(self, *args):
        """GetMpiTag(MpiComm self) -> int"""
        return ___init__.MpiComm_GetMpiTag(self, *args)

    def GetMpiComm(self, *args):
        """GetMpiComm(MpiComm self) -> MPI_Comm"""
        return ___init__.MpiComm_GetMpiComm(self, *args)

    def PrintInfo(self, *args):
        """PrintInfo(MpiComm self, ostream & os)"""
        return ___init__.MpiComm_PrintInfo(self, *args)

    def ReferenceCount(self, *args):
        """ReferenceCount(MpiComm self) -> int"""
        return ___init__.MpiComm_ReferenceCount(self, *args)

    def DataPtr(self, *args):
        """DataPtr(MpiComm self) -> Epetra_MpiCommData const *"""
        return ___init__.MpiComm_DataPtr(self, *args)

MpiComm_swigregister = ___init__.MpiComm_swigregister
MpiComm_swigregister(MpiComm)
CommWorld = cvar.CommWorld

class MpiDistributor(Object,Distributor):
    """Proxy of C++ Epetra_MpiDistributor class"""
    __swig_setmethods__ = {}
    for _s in [Object,Distributor]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MpiDistributor, name, value)
    __swig_getmethods__ = {}
    for _s in [Object,Distributor]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MpiDistributor, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_MpiDistributor self, MpiComm Comm) -> MpiDistributor
        __init__(Epetra_MpiDistributor self, MpiDistributor Distributor) -> MpiDistributor
        """
        this = ___init__.new_MpiDistributor(*args)
        try: self.this.append(this)
        except: self.this = this
    def Clone(self, *args):
        """Clone(MpiDistributor self) -> Distributor"""
        return ___init__.MpiDistributor_Clone(self, *args)

    __swig_destroy__ = ___init__.delete_MpiDistributor
    def CreateFromSends(self, *args):
        """CreateFromSends(MpiDistributor self, int const & NumExportIDs, int const * ExportPIDs, bool Deterministic, int & NumRemoteIDs) -> int"""
        return ___init__.MpiDistributor_CreateFromSends(self, *args)

    def CreateFromRecvs(self, *args):
        """
        CreateFromRecvs(MpiDistributor self, int const & NumRemoteIDs, int const * RemoteGIDs, int const * RemotePIDs, bool Deterministic, 
            int & NumExportIDs, int *& ExportGIDs, int *& ExportPIDs) -> int
        CreateFromRecvs(MpiDistributor self, int const & NumRemoteIDs, long long const * RemoteGIDs, int const * RemotePIDs, bool Deterministic, 
            int & NumExportIDs, long long *& ExportGIDs, int *& ExportPIDs) -> int
        """
        return ___init__.MpiDistributor_CreateFromRecvs(self, *args)

    def DoWaits(self, *args):
        """DoWaits(MpiDistributor self) -> int"""
        return ___init__.MpiDistributor_DoWaits(self, *args)

    def DoReverseWaits(self, *args):
        """DoReverseWaits(MpiDistributor self) -> int"""
        return ___init__.MpiDistributor_DoReverseWaits(self, *args)

    def Do(self, *args):
        """
        Do(MpiDistributor self, char * export_objs, int obj_size, int & len_import_objs, char *& import_objs) -> int
        Do(MpiDistributor self, char * export_objs, int obj_size, int *& sizes, int & len_import_objs, char *& import_objs) -> int
        """
        return ___init__.MpiDistributor_Do(self, *args)

    def DoReverse(self, *args):
        """
        DoReverse(MpiDistributor self, char * export_objs, int obj_size, int & len_import_objs, char *& import_objs) -> int
        DoReverse(MpiDistributor self, char * export_objs, int obj_size, int *& sizes, int & len_import_objs, char *& import_objs) -> int
        """
        return ___init__.MpiDistributor_DoReverse(self, *args)

    def DoPosts(self, *args):
        """
        DoPosts(MpiDistributor self, char * export_objs, int obj_size, int & len_import_objs, char *& import_objs) -> int
        DoPosts(MpiDistributor self, char * export_objs, int obj_size, int *& sizes, int & len_import_objs, char *& import_objs) -> int
        """
        return ___init__.MpiDistributor_DoPosts(self, *args)

    def DoReversePosts(self, *args):
        """
        DoReversePosts(MpiDistributor self, char * export_objs, int obj_size, int & len_import_objs, char *& import_objs) -> int
        DoReversePosts(MpiDistributor self, char * export_objs, int obj_size, int *& sizes, int & len_import_objs, char *& import_objs) -> int
        """
        return ___init__.MpiDistributor_DoReversePosts(self, *args)

    def NumReceives(self, *args):
        """NumReceives(MpiDistributor self) -> int"""
        return ___init__.MpiDistributor_NumReceives(self, *args)

    def NumSends(self, *args):
        """NumSends(MpiDistributor self) -> int"""
        return ___init__.MpiDistributor_NumSends(self, *args)

    def MaxSendLength(self, *args):
        """MaxSendLength(MpiDistributor self) -> int"""
        return ___init__.MpiDistributor_MaxSendLength(self, *args)

    def TotalReceiveLength(self, *args):
        """TotalReceiveLength(MpiDistributor self) -> int"""
        return ___init__.MpiDistributor_TotalReceiveLength(self, *args)

    def ProcsFrom(self, *args):
        """ProcsFrom(MpiDistributor self) -> int const *"""
        return ___init__.MpiDistributor_ProcsFrom(self, *args)

    def ProcsTo(self, *args):
        """ProcsTo(MpiDistributor self) -> int const *"""
        return ___init__.MpiDistributor_ProcsTo(self, *args)

    def LengthsFrom(self, *args):
        """LengthsFrom(MpiDistributor self) -> int const *"""
        return ___init__.MpiDistributor_LengthsFrom(self, *args)

    def LengthsTo(self, *args):
        """LengthsTo(MpiDistributor self) -> int const *"""
        return ___init__.MpiDistributor_LengthsTo(self, *args)

MpiDistributor_swigregister = ___init__.MpiDistributor_swigregister
MpiDistributor_swigregister(MpiDistributor)

from mpi4py import MPI

def PyComm():
  "PyComm() -> Epetra.MpiComm(MPI_COMM_WORLD)"
  return MpiComm(cvar.CommWorld);

class BlockMap(Object):
    """Proxy of C++ Epetra_BlockMap class"""
    __swig_setmethods__ = {}
    for _s in [Object]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BlockMap, name, value)
    __swig_getmethods__ = {}
    for _s in [Object]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BlockMap, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_BlockMap
    def LID(self, *args):
        """
        LID(BlockMap self, int GID) -> int
        LID(BlockMap self, long long GID) -> int
        """
        return ___init__.BlockMap_LID(self, *args)

    def GID(self, *args):
        """GID(BlockMap self, int LID) -> int"""
        return ___init__.BlockMap_GID(self, *args)

    def GID64(self, *args):
        """GID64(BlockMap self, int LID) -> long long"""
        return ___init__.BlockMap_GID64(self, *args)

    def MyGID(self, *args):
        """
        MyGID(BlockMap self, int GID_in) -> bool
        MyGID(BlockMap self, long long GID_in) -> bool
        """
        return ___init__.BlockMap_MyGID(self, *args)

    def MyLID(self, *args):
        """MyLID(BlockMap self, int LID_in) -> bool"""
        return ___init__.BlockMap_MyLID(self, *args)

    def MinAllGID(self, *args):
        """MinAllGID(BlockMap self) -> int"""
        return ___init__.BlockMap_MinAllGID(self, *args)

    def MinAllGID64(self, *args):
        """MinAllGID64(BlockMap self) -> long long"""
        return ___init__.BlockMap_MinAllGID64(self, *args)

    def MaxAllGID(self, *args):
        """MaxAllGID(BlockMap self) -> int"""
        return ___init__.BlockMap_MaxAllGID(self, *args)

    def MaxAllGID64(self, *args):
        """MaxAllGID64(BlockMap self) -> long long"""
        return ___init__.BlockMap_MaxAllGID64(self, *args)

    def MinMyGID(self, *args):
        """MinMyGID(BlockMap self) -> int"""
        return ___init__.BlockMap_MinMyGID(self, *args)

    def MinMyGID64(self, *args):
        """MinMyGID64(BlockMap self) -> long long"""
        return ___init__.BlockMap_MinMyGID64(self, *args)

    def MaxMyGID(self, *args):
        """MaxMyGID(BlockMap self) -> int"""
        return ___init__.BlockMap_MaxMyGID(self, *args)

    def MaxMyGID64(self, *args):
        """MaxMyGID64(BlockMap self) -> long long"""
        return ___init__.BlockMap_MaxMyGID64(self, *args)

    def MinLID(self, *args):
        """MinLID(BlockMap self) -> int"""
        return ___init__.BlockMap_MinLID(self, *args)

    def MaxLID(self, *args):
        """MaxLID(BlockMap self) -> int"""
        return ___init__.BlockMap_MaxLID(self, *args)

    def NumGlobalElements(self, *args):
        """NumGlobalElements(BlockMap self) -> int"""
        return ___init__.BlockMap_NumGlobalElements(self, *args)

    def NumGlobalElements64(self, *args):
        """NumGlobalElements64(BlockMap self) -> long long"""
        return ___init__.BlockMap_NumGlobalElements64(self, *args)

    def NumMyElements(self, *args):
        """NumMyElements(BlockMap self) -> int"""
        return ___init__.BlockMap_NumMyElements(self, *args)

    def MyGlobalElementsPtr(self, *args):
        """
        MyGlobalElementsPtr(BlockMap self, int *& MyGlobalElementList) -> int
        MyGlobalElementsPtr(BlockMap self, long long *& MyGlobalElementList) -> int
        """
        return ___init__.BlockMap_MyGlobalElementsPtr(self, *args)

    def ElementSize(self, *args):
        """
        ElementSize(BlockMap self) -> int
        ElementSize(BlockMap self, int LID) -> int
        """
        return ___init__.BlockMap_ElementSize(self, *args)

    def FirstPointInElement(self, *args):
        """FirstPointInElement(BlockMap self, int LID) -> int"""
        return ___init__.BlockMap_FirstPointInElement(self, *args)

    def IndexBase(self, *args):
        """IndexBase(BlockMap self) -> int"""
        return ___init__.BlockMap_IndexBase(self, *args)

    def NumGlobalPoints(self, *args):
        """NumGlobalPoints(BlockMap self) -> int"""
        return ___init__.BlockMap_NumGlobalPoints(self, *args)

    def NumGlobalPoints64(self, *args):
        """NumGlobalPoints64(BlockMap self) -> long long"""
        return ___init__.BlockMap_NumGlobalPoints64(self, *args)

    def NumMyPoints(self, *args):
        """NumMyPoints(BlockMap self) -> int"""
        return ___init__.BlockMap_NumMyPoints(self, *args)

    def MinMyElementSize(self, *args):
        """MinMyElementSize(BlockMap self) -> int"""
        return ___init__.BlockMap_MinMyElementSize(self, *args)

    def MaxMyElementSize(self, *args):
        """MaxMyElementSize(BlockMap self) -> int"""
        return ___init__.BlockMap_MaxMyElementSize(self, *args)

    def MinElementSize(self, *args):
        """MinElementSize(BlockMap self) -> int"""
        return ___init__.BlockMap_MinElementSize(self, *args)

    def MaxElementSize(self, *args):
        """MaxElementSize(BlockMap self) -> int"""
        return ___init__.BlockMap_MaxElementSize(self, *args)

    def UniqueGIDs(self, *args):
        """UniqueGIDs(BlockMap self) -> bool"""
        return ___init__.BlockMap_UniqueGIDs(self, *args)

    def GlobalIndicesInt(self, *args):
        """GlobalIndicesInt(BlockMap self) -> bool"""
        return ___init__.BlockMap_GlobalIndicesInt(self, *args)

    def GlobalIndicesLongLong(self, *args):
        """GlobalIndicesLongLong(BlockMap self) -> bool"""
        return ___init__.BlockMap_GlobalIndicesLongLong(self, *args)

    def GlobalIndicesTypeValid(self, *args):
        """GlobalIndicesTypeValid(BlockMap self) -> bool"""
        return ___init__.BlockMap_GlobalIndicesTypeValid(self, *args)

    def GlobalIndicesTypeMatch(self, *args):
        """GlobalIndicesTypeMatch(BlockMap self, BlockMap other) -> bool"""
        return ___init__.BlockMap_GlobalIndicesTypeMatch(self, *args)

    def ConstantElementSize(self, *args):
        """ConstantElementSize(BlockMap self) -> bool"""
        return ___init__.BlockMap_ConstantElementSize(self, *args)

    def SameAs(self, *args):
        """SameAs(BlockMap self, BlockMap Map) -> bool"""
        return ___init__.BlockMap_SameAs(self, *args)

    def PointSameAs(self, *args):
        """PointSameAs(BlockMap self, BlockMap Map) -> bool"""
        return ___init__.BlockMap_PointSameAs(self, *args)

    def LinearMap(self, *args):
        """LinearMap(BlockMap self) -> bool"""
        return ___init__.BlockMap_LinearMap(self, *args)

    def DistributedGlobal(self, *args):
        """DistributedGlobal(BlockMap self) -> bool"""
        return ___init__.BlockMap_DistributedGlobal(self, *args)

    def MyGlobalElements64(self, *args):
        """MyGlobalElements64(BlockMap self) -> long long *"""
        return ___init__.BlockMap_MyGlobalElements64(self, *args)

    def Comm(self, *args):
        """Comm(BlockMap self) -> Comm"""
        return ___init__.BlockMap_Comm(self, *args)

    def IsOneToOne(self, *args):
        """IsOneToOne(BlockMap self) -> bool"""
        return ___init__.BlockMap_IsOneToOne(self, *args)

    def __init__(self, *args): 
        """
        __init__(self, int numGlobalElements, int elementSize, int indexBase,
             Comm comm) -> BlockMap

        BlockMap constructor with implicit local elements and constant element
        size.  Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             elementSize        - The number of degrees of freedom associated
                                  with every element.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.
        __init__(Epetra_BlockMap self, long long NumGlobalElements, int ElementSize, int IndexBase, Comm Comm) -> BlockMap

        __init__(self, int numGlobalElements, int numMyElements, int elementSize,
             int indexBase, Comm comm) -> BlockMap

        BlockMap constructor with specified number of local elements and
        constant element size.  Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             numMyElements      - Number of local elements on this processor.
             elementSize        - The number of degrees of freedom associated
                                  with every element.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.
        __init__(Epetra_BlockMap self, long long NumGlobalElements, int NumMyElements, int ElementSize, int IndexBase, Comm Comm) -> BlockMap

        __init__(self, int numGlobalElements, PySequence myGlobalElements,
             int elementSize, int indexBase, Comm comm) -> BlockMap

        BlockMap constructor with specified list of local elements and
        constant element size.  Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             myGlobalElements   - A sequence of integers specifying the global
                                  element indexes on this processor.
             elementSize        - The number of degrees of freedom associated
                                  with every element.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.
        __init__(Epetra_BlockMap self, long long NumGlobalElements, int NumMyElements, long long const * MyGlobalElements, 
            int ElementSize, int IndexBase, Comm Comm) -> BlockMap
        __init__(Epetra_BlockMap self, long long NumGlobalElements, int NumMyElements, long long const * MyGlobalElements, 
            int const * ElementSizeList, int IndexBase, Comm Comm) -> BlockMap

        __init__(self, BlockMap map) -> BlockMap

        BlockMap copy constructor.

        __init__(self, int numGlobalElements, PySequence myGlobalElements,
             PySequence elementsSizes, int indexBase, Comm comm) -> BlockMap

        BlockMap constructor with specified list of local elements and
        specified list of element sizes.  Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             myGlobalElements   - A sequence of integers specifying the global
                                  element indexes on this processor.
             elementSizes       - A sequence of integers specifying the number of
                                  degrees of freedom associated with each element
                                  on this processor.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.
        """
        this = ___init__.new_BlockMap(*args)
        try: self.this.append(this)
        except: self.this = this
    def RemoteIDList(self, *args):
        """
        RemoteIDList(BlockMap self, int NumIDs, long long const * GIDList, int * PIDList, int * LIDList) -> int
        RemoteIDList(BlockMap self, int NumIDs, long long const * GIDList, int * PIDList, int * LIDList, int * SizeList) -> int
        RemoteIDList(BlockMap self, PyObject * GIDList) -> PyObject *

        ``GIDList`` is a sequence of integer global IDs, and the return
        argument is the three-tuple ``(PIDList, LIDList, sizeList)``, which
        are ``numpy.ndarray`` objects of integers representing the processor
        IDs, local IDs and element sizes, respectively.
        """
        return ___init__.BlockMap_RemoteIDList(self, *args)

    def FindLocalElementID(self, *args):
        """
        FindLocalElementID(BlockMap self, int pointID) -> PyObject *

        Returns a tuple containing the local ID of the element that contains
        the given local pointID, and the offset of the point in that element.
        """
        return ___init__.BlockMap_FindLocalElementID(self, *args)

    def MyGlobalElements(self, *args):
        """
        MyGlobalElements(BlockMap self, long long * MyGlobalElementList) -> int
        MyGlobalElements(BlockMap self) -> PyObject *

        Returns a numpy array of integers specifying the list of global IDs on
        the processor.
        """
        return ___init__.BlockMap_MyGlobalElements(self, *args)

    def FirstPointInElementList(self, *args):
        """
        FirstPointInElementList(BlockMap self) -> PyObject *

        Returns a numpy array of integer first local point numbers for all of
        the local elements.
        """
        return ___init__.BlockMap_FirstPointInElementList(self, *args)

    def ElementSizeList(self, *args):
        """
        ElementSizeList(BlockMap self) -> PyObject *

        Returns a numpy array of integer sizes for each local element.
        """
        return ___init__.BlockMap_ElementSizeList(self, *args)

    def PointToElementList(self, *args):
        """
        PointToElementList(BlockMap self) -> PyObject *

        Returns a numpy array of integers such that for each local point, it
        indicates the local element ID that the point belongs to.
        """
        return ___init__.BlockMap_PointToElementList(self, *args)

BlockMap_swigregister = ___init__.BlockMap_swigregister
BlockMap_swigregister(BlockMap)

class Map(BlockMap):
    """Proxy of C++ Epetra_Map class"""
    __swig_setmethods__ = {}
    for _s in [BlockMap]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Map, name, value)
    __swig_getmethods__ = {}
    for _s in [BlockMap]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Map, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, int numGlobalElements, int indexBase, Comm comm) -> Map

        Map constructor with implicit number of elements per processor.
        Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.
        __init__(Epetra_Map self, long long NumGlobalElements, int IndexBase, Comm Comm) -> Map

        __init__(self, int numGlobalElements, int numMyElements, int indexBase,
             Comm comm) -> Map

        Map constructor with specified number of elements per processor.
        Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             numMyElements      - Number of local elements on this processor.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.
        __init__(Epetra_Map self, long long NumGlobalElements, int NumMyElements, int IndexBase, Comm Comm) -> Map

        __init__(self, int numGlobalElements, PySequence myGlobalElements,
             int indexBase, Comm comm) -> Map

        Map constructor with specified list of global element IDs for each
        processor.  Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             myGlobalElements   - A sequence of integers specifying the global
                                  element indexes on this processor.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.
        __init__(Epetra_Map self, long long NumGlobalElements, int NumMyElements, long long const * MyGlobalElements, 
            int IndexBase, Comm Comm) -> Map

        __init__(self, Map map) -> Map

        Map copy constructor.
        """
        this = ___init__.new_Map(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Map
Map_swigregister = ___init__.Map_swigregister
Map_swigregister(Map)

class LocalMap(Map):
    """Proxy of C++ Epetra_LocalMap class"""
    __swig_setmethods__ = {}
    for _s in [Map]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LocalMap, name, value)
    __swig_getmethods__ = {}
    for _s in [Map]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LocalMap, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_LocalMap self, int NumMyElements, int IndexBase, Comm Comm) -> LocalMap
        __init__(Epetra_LocalMap self, long long NumMyElements, int IndexBase, Comm Comm) -> LocalMap
        __init__(Epetra_LocalMap self, LocalMap map) -> LocalMap
        """
        this = ___init__.new_LocalMap(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_LocalMap
LocalMap_swigregister = ___init__.LocalMap_swigregister
LocalMap_swigregister(LocalMap)

class Directory(_object):
    """Proxy of C++ Epetra_Directory class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Directory, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Directory, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_Directory
    def GetDirectoryEntries(self, *args):
        """
        GetDirectoryEntries(Directory self, BlockMap Map, int const NumEntries, int const * GlobalEntries, int * Procs, int * LocalEntries, 
            int * EntrySizes, bool high_rank_sharing_procs=False) -> int
        GetDirectoryEntries(Directory self, BlockMap Map, int const NumEntries, long long const * GlobalEntries, int * Procs, 
            int * LocalEntries, int * EntrySizes, bool high_rank_sharing_procs=False) -> int
        """
        return ___init__.Directory_GetDirectoryEntries(self, *args)

    def GIDsAllUniquelyOwned(self, *args):
        """GIDsAllUniquelyOwned(Directory self) -> bool"""
        return ___init__.Directory_GIDsAllUniquelyOwned(self, *args)

Directory_swigregister = ___init__.Directory_swigregister
Directory_swigregister(Directory)

class BasicDirectory(Directory):
    """Proxy of C++ Epetra_BasicDirectory class"""
    __swig_setmethods__ = {}
    for _s in [Directory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BasicDirectory, name, value)
    __swig_getmethods__ = {}
    for _s in [Directory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BasicDirectory, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_BasicDirectory self, BlockMap Map) -> BasicDirectory
        __init__(Epetra_BasicDirectory self, BasicDirectory Directory) -> BasicDirectory
        """
        this = ___init__.new_BasicDirectory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_BasicDirectory
    def GetDirectoryEntries(self, *args):
        """
        GetDirectoryEntries(BasicDirectory self, BlockMap Map, int const NumEntries, int const * GlobalEntries, int * Procs, int * LocalEntries, 
            int * EntrySizes, bool high_rank_sharing_procs=False) -> int
        GetDirectoryEntries(BasicDirectory self, BlockMap Map, int const NumEntries, long long const * GlobalEntries, int * Procs, 
            int * LocalEntries, int * EntrySizes, bool high_rank_sharing_procs=False) -> int
        """
        return ___init__.BasicDirectory_GetDirectoryEntries(self, *args)

    def GIDsAllUniquelyOwned(self, *args):
        """GIDsAllUniquelyOwned(BasicDirectory self) -> bool"""
        return ___init__.BasicDirectory_GIDsAllUniquelyOwned(self, *args)

BasicDirectory_swigregister = ___init__.BasicDirectory_swigregister
BasicDirectory_swigregister(BasicDirectory)

class Import(Object):
    """Proxy of C++ Epetra_Import class"""
    __swig_setmethods__ = {}
    for _s in [Object]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Import, name, value)
    __swig_getmethods__ = {}
    for _s in [Object]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Import, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_Import self, BlockMap TargetMap, BlockMap SourceMap) -> Import
        __init__(Epetra_Import self, Import Importer) -> Import
        """
        this = ___init__.new_Import(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Import
    def NumSameIDs(self, *args):
        """NumSameIDs(Import self) -> int"""
        return ___init__.Import_NumSameIDs(self, *args)

    def NumPermuteIDs(self, *args):
        """NumPermuteIDs(Import self) -> int"""
        return ___init__.Import_NumPermuteIDs(self, *args)

    def NumRemoteIDs(self, *args):
        """NumRemoteIDs(Import self) -> int"""
        return ___init__.Import_NumRemoteIDs(self, *args)

    def NumExportIDs(self, *args):
        """NumExportIDs(Import self) -> int"""
        return ___init__.Import_NumExportIDs(self, *args)

    def NumSend(self, *args):
        """NumSend(Import self) -> int"""
        return ___init__.Import_NumSend(self, *args)

    def NumRecv(self, *args):
        """NumRecv(Import self) -> int"""
        return ___init__.Import_NumRecv(self, *args)

    def SourceMap(self, *args):
        """SourceMap(Import self) -> BlockMap"""
        return ___init__.Import_SourceMap(self, *args)

    def TargetMap(self, *args):
        """TargetMap(Import self) -> BlockMap"""
        return ___init__.Import_TargetMap(self, *args)

    def Distributor(self, *args):
        """Distributor(Import self) -> Distributor"""
        return ___init__.Import_Distributor(self, *args)

    def PermuteFromLIDs(self, *args):
        """PermuteFromLIDs(Import self) -> PyObject *"""
        return ___init__.Import_PermuteFromLIDs(self, *args)

    def PermuteToLIDs(self, *args):
        """PermuteToLIDs(Import self) -> PyObject *"""
        return ___init__.Import_PermuteToLIDs(self, *args)

    def RemoteLIDs(self, *args):
        """RemoteLIDs(Import self) -> PyObject *"""
        return ___init__.Import_RemoteLIDs(self, *args)

    def ExportLIDs(self, *args):
        """ExportLIDs(Import self) -> PyObject *"""
        return ___init__.Import_ExportLIDs(self, *args)

    def ExportPIDs(self, *args):
        """ExportPIDs(Import self) -> PyObject *"""
        return ___init__.Import_ExportPIDs(self, *args)

Import_swigregister = ___init__.Import_swigregister
Import_swigregister(Import)

class Export(Object):
    """Proxy of C++ Epetra_Export class"""
    __swig_setmethods__ = {}
    for _s in [Object]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Export, name, value)
    __swig_getmethods__ = {}
    for _s in [Object]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Export, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_Export self, BlockMap SourceMap, BlockMap TargetMap) -> Export
        __init__(Epetra_Export self, Export Exporter) -> Export
        """
        this = ___init__.new_Export(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Export
    def NumSameIDs(self, *args):
        """NumSameIDs(Export self) -> int"""
        return ___init__.Export_NumSameIDs(self, *args)

    def NumPermuteIDs(self, *args):
        """NumPermuteIDs(Export self) -> int"""
        return ___init__.Export_NumPermuteIDs(self, *args)

    def NumRemoteIDs(self, *args):
        """NumRemoteIDs(Export self) -> int"""
        return ___init__.Export_NumRemoteIDs(self, *args)

    def NumExportIDs(self, *args):
        """NumExportIDs(Export self) -> int"""
        return ___init__.Export_NumExportIDs(self, *args)

    def NumSend(self, *args):
        """NumSend(Export self) -> int"""
        return ___init__.Export_NumSend(self, *args)

    def NumRecv(self, *args):
        """NumRecv(Export self) -> int"""
        return ___init__.Export_NumRecv(self, *args)

    def SourceMap(self, *args):
        """SourceMap(Export self) -> BlockMap"""
        return ___init__.Export_SourceMap(self, *args)

    def TargetMap(self, *args):
        """TargetMap(Export self) -> BlockMap"""
        return ___init__.Export_TargetMap(self, *args)

    def Distributor(self, *args):
        """Distributor(Export self) -> Distributor"""
        return ___init__.Export_Distributor(self, *args)

    def PermuteFromLIDs(self, *args):
        """PermuteFromLIDs(Export self) -> PyObject *"""
        return ___init__.Export_PermuteFromLIDs(self, *args)

    def PermuteToLIDs(self, *args):
        """PermuteToLIDs(Export self) -> PyObject *"""
        return ___init__.Export_PermuteToLIDs(self, *args)

    def RemoteLIDs(self, *args):
        """RemoteLIDs(Export self) -> PyObject *"""
        return ___init__.Export_RemoteLIDs(self, *args)

    def ExportLIDs(self, *args):
        """ExportLIDs(Export self) -> PyObject *"""
        return ___init__.Export_ExportLIDs(self, *args)

    def ExportPIDs(self, *args):
        """ExportPIDs(Export self) -> PyObject *"""
        return ___init__.Export_ExportPIDs(self, *args)

Export_swigregister = ___init__.Export_swigregister
Export_swigregister(Export)

class SrcDistObject(_object):
    """Proxy of C++ Epetra_SrcDistObject class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SrcDistObject, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SrcDistObject, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_SrcDistObject
    def Map(self, *args):
        """Map(SrcDistObject self) -> BlockMap"""
        return ___init__.SrcDistObject_Map(self, *args)

SrcDistObject_swigregister = ___init__.SrcDistObject_swigregister
SrcDistObject_swigregister(SrcDistObject)

class DistObject(Object,SrcDistObject):
    """Proxy of C++ Epetra_DistObject class"""
    __swig_setmethods__ = {}
    for _s in [Object,SrcDistObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DistObject, name, value)
    __swig_getmethods__ = {}
    for _s in [Object,SrcDistObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DistObject, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_DistObject
    def Import(self, *args):
        """
        Import(DistObject self, SrcDistObject A, Import Importer, Epetra_CombineMode CombineMode, OffsetIndex Indexor=None) -> int
        Import(DistObject self, SrcDistObject A, Export Exporter, Epetra_CombineMode CombineMode, OffsetIndex Indexor=None) -> int
        """
        return ___init__.DistObject_Import(self, *args)

    def Export(self, *args):
        """
        Export(DistObject self, SrcDistObject A, Import Importer, Epetra_CombineMode CombineMode, OffsetIndex Indexor=None) -> int
        Export(DistObject self, SrcDistObject A, Export Exporter, Epetra_CombineMode CombineMode, OffsetIndex Indexor=None) -> int
        """
        return ___init__.DistObject_Export(self, *args)

    def Map(self, *args):
        """Map(DistObject self) -> BlockMap"""
        return ___init__.DistObject_Map(self, *args)

    def Comm(self, *args):
        """Comm(DistObject self) -> Comm"""
        return ___init__.DistObject_Comm(self, *args)

    def DistributedGlobal(self, *args):
        """DistributedGlobal(DistObject self) -> bool"""
        return ___init__.DistObject_DistributedGlobal(self, *args)

DistObject_swigregister = ___init__.DistObject_swigregister
DistObject_swigregister(DistObject)

class MapColoring(DistObject):
    """Proxy of C++ Epetra_MapColoring class"""
    __swig_setmethods__ = {}
    for _s in [DistObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MapColoring, name, value)
    __swig_getmethods__ = {}
    for _s in [DistObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MapColoring, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_MapColoring
    def __call__(self, *args):
        """__call__(MapColoring self, int GID) -> int &"""
        return ___init__.MapColoring___call__(self, *args)

    def NumColors(self, *args):
        """NumColors(MapColoring self) -> int"""
        return ___init__.MapColoring_NumColors(self, *args)

    def MaxNumColors(self, *args):
        """MaxNumColors(MapColoring self) -> int"""
        return ___init__.MapColoring_MaxNumColors(self, *args)

    def DefaultColor(self, *args):
        """DefaultColor(MapColoring self) -> int"""
        return ___init__.MapColoring_DefaultColor(self, *args)

    def NumElementsWithColor(self, *args):
        """NumElementsWithColor(MapColoring self, int Color) -> int"""
        return ___init__.MapColoring_NumElementsWithColor(self, *args)

    def GenerateMap(self, *args):
        """GenerateMap(MapColoring self, int Color) -> Map"""
        return ___init__.MapColoring_GenerateMap(self, *args)

    def GenerateBlockMap(self, *args):
        """GenerateBlockMap(MapColoring self, int Color) -> BlockMap"""
        return ___init__.MapColoring_GenerateBlockMap(self, *args)

    def __init__(self, *args): 
        """
        __init__(Epetra_MapColoring self, BlockMap Map, int const DefaultColor=0) -> MapColoring
        __init__(Epetra_MapColoring self, MapColoring Source) -> MapColoring
        __init__(Epetra_MapColoring self, BlockMap map, int numColors, int const defaultColor=0) -> MapColoring
        """
        this = ___init__.new_MapColoring(*args)
        try: self.this.append(this)
        except: self.this = this
    def __getitem__(self, *args):
        """__getitem__(MapColoring self, int i) -> int"""
        return ___init__.MapColoring___getitem__(self, *args)

    def __setitem__(self, *args):
        """__setitem__(MapColoring self, int i, int color)"""
        return ___init__.MapColoring___setitem__(self, *args)

    def ListOfColors(self, *args):
        """ListOfColors(MapColoring self) -> PyObject *"""
        return ___init__.MapColoring_ListOfColors(self, *args)

    def ColorLIDList(self, *args):
        """ColorLIDList(MapColoring self, int color) -> PyObject *"""
        return ___init__.MapColoring_ColorLIDList(self, *args)

    def ElementColors(self, *args):
        """ElementColors(MapColoring self) -> PyObject *"""
        return ___init__.MapColoring_ElementColors(self, *args)

MapColoring_swigregister = ___init__.MapColoring_swigregister
MapColoring_swigregister(MapColoring)

class CrsGraph(DistObject):
    """Proxy of C++ Epetra_CrsGraph class"""
    __swig_setmethods__ = {}
    for _s in [DistObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CrsGraph, name, value)
    __swig_getmethods__ = {}
    for _s in [DistObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CrsGraph, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_CrsGraph
    def InsertGlobalIndices(self, *args):
        """
        InsertGlobalIndices(self, int globalRow, PySequence indices) -> int

        Insert a sequence of global indices into the set of nonzero columns
        for the specified global row.  Argument indices can be a numpy array
        of integers or any python sequence that can be converted to a numpy
        array of integers.  The integers represent global IDs that are to be
        inserted into the graph.  An integer error/warning code is returned.

        InsertGlobalIndices(self, int globalRow, PySequence indices) -> int

        Insert a sequence of global indices into the set of nonzero columns
        for the specified global row.  Argument indices can be a numpy array
        of integers or any python sequence that can be converted to a numpy
        array of integers.  The integers represent global IDs that are to be
        inserted into the graph.  An integer error/warning code is returned.

        """
        return ___init__.CrsGraph_InsertGlobalIndices(self, *args)

    def RemoveGlobalIndices(self, *args):
        """
        RemoveGlobalIndices(self, int globalRow, PySequence indices) -> int

        Remove a sequence of global indices from the set of nonzero columns
        for the specified global row.  Argument indices can be a numpy array
        of integers or any python sequence that can be converted to a numpy
        array of integers.  The integers represent global IDs that are to be
        removed from the graph.  An integer error/warning code is returned.

        RemoveGlobalIndices(CrsGraph self, long long GlobalRow, int NumIndices, long long * Indices) -> int
        RemoveGlobalIndices(CrsGraph self, long long Row) -> int
        """
        return ___init__.CrsGraph_RemoveGlobalIndices(self, *args)

    def InsertMyIndices(self, *args):
        """
        InsertMyIndices(self, int localRow, PySequence indices) -> int

        Insert a sequence of local indices into the set of nonzero columns for
        the specified local row.  Argument indices can be a numpy array of
        integers or any python sequence that can be converted to a numpy array
        of integers.  The integers represent local IDs that are to be inserted
        into the graph.  An integer error/warning code is returned.

        """
        return ___init__.CrsGraph_InsertMyIndices(self, *args)

    def RemoveMyIndices(self, *args):
        """
        RemoveMyIndices(self, int localRow, PySequence indices) -> int

        Remove a sequence of local indices from the set of nonzero columns for
        the specified local row.  Argument indices can be a numpy array of
        integers or any python sequence that can be converted to a numpy array
        of integers.  The integers represent local IDs that are to be removed
        from the graph.  An integer error/warning code is returned.

        RemoveMyIndices(CrsGraph self, int Row) -> int
        """
        return ___init__.CrsGraph_RemoveMyIndices(self, *args)

    def FillComplete(self, *args):
        """
        FillComplete(CrsGraph self) -> int
        FillComplete(CrsGraph self, BlockMap DomainMap, BlockMap RangeMap) -> int
        """
        return ___init__.CrsGraph_FillComplete(self, *args)

    def OptimizeStorage(self, *args):
        """OptimizeStorage(CrsGraph self) -> int"""
        return ___init__.CrsGraph_OptimizeStorage(self, *args)

    def ExtractGlobalRowView(self, *args):
        """ExtractGlobalRowView(CrsGraph self, long long GlobalRow, int & NumIndices, long long *& Indices) -> int"""
        return ___init__.CrsGraph_ExtractGlobalRowView(self, *args)

    def Filled(self, *args):
        """Filled(CrsGraph self) -> bool"""
        return ___init__.CrsGraph_Filled(self, *args)

    def StorageOptimized(self, *args):
        """StorageOptimized(CrsGraph self) -> bool"""
        return ___init__.CrsGraph_StorageOptimized(self, *args)

    def IndicesAreGlobal(self, *args):
        """IndicesAreGlobal(CrsGraph self) -> bool"""
        return ___init__.CrsGraph_IndicesAreGlobal(self, *args)

    def IndicesAreLocal(self, *args):
        """IndicesAreLocal(CrsGraph self) -> bool"""
        return ___init__.CrsGraph_IndicesAreLocal(self, *args)

    def LowerTriangular(self, *args):
        """LowerTriangular(CrsGraph self) -> bool"""
        return ___init__.CrsGraph_LowerTriangular(self, *args)

    def UpperTriangular(self, *args):
        """UpperTriangular(CrsGraph self) -> bool"""
        return ___init__.CrsGraph_UpperTriangular(self, *args)

    def NoDiagonal(self, *args):
        """NoDiagonal(CrsGraph self) -> bool"""
        return ___init__.CrsGraph_NoDiagonal(self, *args)

    def MyGlobalRow(self, *args):
        """
        MyGlobalRow(CrsGraph self, int GID) -> bool
        MyGlobalRow(CrsGraph self, long long GID) -> bool
        """
        return ___init__.CrsGraph_MyGlobalRow(self, *args)

    def HaveColMap(self, *args):
        """HaveColMap(CrsGraph self) -> bool"""
        return ___init__.CrsGraph_HaveColMap(self, *args)

    def NumMyRows(self, *args):
        """NumMyRows(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumMyRows(self, *args)

    def NumGlobalRows(self, *args):
        """NumGlobalRows(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumGlobalRows(self, *args)

    def NumGlobalRows64(self, *args):
        """NumGlobalRows64(CrsGraph self) -> long long"""
        return ___init__.CrsGraph_NumGlobalRows64(self, *args)

    def NumMyCols(self, *args):
        """NumMyCols(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumMyCols(self, *args)

    def NumGlobalCols(self, *args):
        """NumGlobalCols(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumGlobalCols(self, *args)

    def NumGlobalCols64(self, *args):
        """NumGlobalCols64(CrsGraph self) -> long long"""
        return ___init__.CrsGraph_NumGlobalCols64(self, *args)

    def NumGlobalNonzeros(self, *args):
        """NumGlobalNonzeros(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumGlobalNonzeros(self, *args)

    def NumGlobalNonzeros64(self, *args):
        """NumGlobalNonzeros64(CrsGraph self) -> long long"""
        return ___init__.CrsGraph_NumGlobalNonzeros64(self, *args)

    def NumGlobalDiagonals(self, *args):
        """NumGlobalDiagonals(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumGlobalDiagonals(self, *args)

    def NumGlobalDiagonals64(self, *args):
        """NumGlobalDiagonals64(CrsGraph self) -> long long"""
        return ___init__.CrsGraph_NumGlobalDiagonals64(self, *args)

    def NumMyDiagonals(self, *args):
        """NumMyDiagonals(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumMyDiagonals(self, *args)

    def NumMyBlockRows(self, *args):
        """NumMyBlockRows(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumMyBlockRows(self, *args)

    def NumGlobalBlockRows(self, *args):
        """NumGlobalBlockRows(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumGlobalBlockRows(self, *args)

    def NumGlobalBlockRows64(self, *args):
        """NumGlobalBlockRows64(CrsGraph self) -> long long"""
        return ___init__.CrsGraph_NumGlobalBlockRows64(self, *args)

    def NumMyBlockCols(self, *args):
        """NumMyBlockCols(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumMyBlockCols(self, *args)

    def NumGlobalBlockCols(self, *args):
        """NumGlobalBlockCols(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumGlobalBlockCols(self, *args)

    def NumGlobalBlockCols64(self, *args):
        """NumGlobalBlockCols64(CrsGraph self) -> long long"""
        return ___init__.CrsGraph_NumGlobalBlockCols64(self, *args)

    def NumMyBlockDiagonals(self, *args):
        """NumMyBlockDiagonals(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumMyBlockDiagonals(self, *args)

    def NumGlobalBlockDiagonals(self, *args):
        """NumGlobalBlockDiagonals(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumGlobalBlockDiagonals(self, *args)

    def NumGlobalBlockDiagonals64(self, *args):
        """NumGlobalBlockDiagonals64(CrsGraph self) -> long long"""
        return ___init__.CrsGraph_NumGlobalBlockDiagonals64(self, *args)

    def NumGlobalEntries(self, *args):
        """NumGlobalEntries(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumGlobalEntries(self, *args)

    def NumGlobalEntries64(self, *args):
        """NumGlobalEntries64(CrsGraph self) -> long long"""
        return ___init__.CrsGraph_NumGlobalEntries64(self, *args)

    def NumMyEntries(self, *args):
        """NumMyEntries(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumMyEntries(self, *args)

    def MaxRowDim(self, *args):
        """MaxRowDim(CrsGraph self) -> int"""
        return ___init__.CrsGraph_MaxRowDim(self, *args)

    def GlobalMaxRowDim(self, *args):
        """GlobalMaxRowDim(CrsGraph self) -> int"""
        return ___init__.CrsGraph_GlobalMaxRowDim(self, *args)

    def MaxColDim(self, *args):
        """MaxColDim(CrsGraph self) -> int"""
        return ___init__.CrsGraph_MaxColDim(self, *args)

    def GlobalMaxColDim(self, *args):
        """GlobalMaxColDim(CrsGraph self) -> int"""
        return ___init__.CrsGraph_GlobalMaxColDim(self, *args)

    def NumMyNonzeros(self, *args):
        """NumMyNonzeros(CrsGraph self) -> int"""
        return ___init__.CrsGraph_NumMyNonzeros(self, *args)

    def NumGlobalIndices(self, *args):
        """NumGlobalIndices(CrsGraph self, long long Row) -> int"""
        return ___init__.CrsGraph_NumGlobalIndices(self, *args)

    def NumAllocatedGlobalIndices(self, *args):
        """NumAllocatedGlobalIndices(CrsGraph self, long long Row) -> int"""
        return ___init__.CrsGraph_NumAllocatedGlobalIndices(self, *args)

    def MaxNumIndices(self, *args):
        """MaxNumIndices(CrsGraph self) -> int"""
        return ___init__.CrsGraph_MaxNumIndices(self, *args)

    def GlobalMaxNumIndices(self, *args):
        """GlobalMaxNumIndices(CrsGraph self) -> int"""
        return ___init__.CrsGraph_GlobalMaxNumIndices(self, *args)

    def MaxNumNonzeros(self, *args):
        """MaxNumNonzeros(CrsGraph self) -> int"""
        return ___init__.CrsGraph_MaxNumNonzeros(self, *args)

    def GlobalMaxNumNonzeros(self, *args):
        """GlobalMaxNumNonzeros(CrsGraph self) -> int"""
        return ___init__.CrsGraph_GlobalMaxNumNonzeros(self, *args)

    def NumMyIndices(self, *args):
        """NumMyIndices(CrsGraph self, int Row) -> int"""
        return ___init__.CrsGraph_NumMyIndices(self, *args)

    def NumAllocatedMyIndices(self, *args):
        """NumAllocatedMyIndices(CrsGraph self, int Row) -> int"""
        return ___init__.CrsGraph_NumAllocatedMyIndices(self, *args)

    def IndexBase(self, *args):
        """IndexBase(CrsGraph self) -> int"""
        return ___init__.CrsGraph_IndexBase(self, *args)

    def RowMap(self, *args):
        """RowMap(CrsGraph self) -> BlockMap"""
        return ___init__.CrsGraph_RowMap(self, *args)

    def ReplaceRowMap(self, *args):
        """ReplaceRowMap(CrsGraph self, BlockMap newmap) -> int"""
        return ___init__.CrsGraph_ReplaceRowMap(self, *args)

    def ReplaceColMap(self, *args):
        """ReplaceColMap(CrsGraph self, BlockMap newmap) -> int"""
        return ___init__.CrsGraph_ReplaceColMap(self, *args)

    def ColMap(self, *args):
        """ColMap(CrsGraph self) -> BlockMap"""
        return ___init__.CrsGraph_ColMap(self, *args)

    def DomainMap(self, *args):
        """DomainMap(CrsGraph self) -> BlockMap"""
        return ___init__.CrsGraph_DomainMap(self, *args)

    def RangeMap(self, *args):
        """RangeMap(CrsGraph self) -> BlockMap"""
        return ___init__.CrsGraph_RangeMap(self, *args)

    def Importer(self, *args):
        """Importer(CrsGraph self) -> Import"""
        return ___init__.CrsGraph_Importer(self, *args)

    def Exporter(self, *args):
        """Exporter(CrsGraph self) -> Export"""
        return ___init__.CrsGraph_Exporter(self, *args)

    def Comm(self, *args):
        """Comm(CrsGraph self) -> Comm"""
        return ___init__.CrsGraph_Comm(self, *args)

    def LRID(self, *args):
        """
        LRID(CrsGraph self, int GRID_in) -> int
        LRID(CrsGraph self, long long GRID_in) -> int
        """
        return ___init__.CrsGraph_LRID(self, *args)

    def GRID(self, *args):
        """GRID(CrsGraph self, int LRID_in) -> int"""
        return ___init__.CrsGraph_GRID(self, *args)

    def GRID64(self, *args):
        """GRID64(CrsGraph self, int LRID_in) -> long long"""
        return ___init__.CrsGraph_GRID64(self, *args)

    def LCID(self, *args):
        """
        LCID(CrsGraph self, int GCID_in) -> int
        LCID(CrsGraph self, long long GCID_in) -> int
        """
        return ___init__.CrsGraph_LCID(self, *args)

    def GCID(self, *args):
        """GCID(CrsGraph self, int LCID_in) -> int"""
        return ___init__.CrsGraph_GCID(self, *args)

    def GCID64(self, *args):
        """GCID64(CrsGraph self, int LCID_in) -> long long"""
        return ___init__.CrsGraph_GCID64(self, *args)

    def MyGRID(self, *args):
        """
        MyGRID(CrsGraph self, int GRID_in) -> bool
        MyGRID(CrsGraph self, long long GRID_in) -> bool
        """
        return ___init__.CrsGraph_MyGRID(self, *args)

    def MyLRID(self, *args):
        """MyLRID(CrsGraph self, int LRID_in) -> bool"""
        return ___init__.CrsGraph_MyLRID(self, *args)

    def MyGCID(self, *args):
        """
        MyGCID(CrsGraph self, int GCID_in) -> bool
        MyGCID(CrsGraph self, long long GCID_in) -> bool
        """
        return ___init__.CrsGraph_MyGCID(self, *args)

    def MyLCID(self, *args):
        """MyLCID(CrsGraph self, int LCID_in) -> bool"""
        return ___init__.CrsGraph_MyLCID(self, *args)

    def PrintGraphData(self, *args):
        """
        PrintGraphData(CrsGraph self, ostream & os)
        PrintGraphData(CrsGraph self, ostream & os, int level)
        """
        return ___init__.CrsGraph_PrintGraphData(self, *args)

    def ImportMap(self, *args):
        """ImportMap(CrsGraph self) -> BlockMap"""
        return ___init__.CrsGraph_ImportMap(self, *args)

    def TransformToLocal(self, *args):
        """
        TransformToLocal(CrsGraph self) -> int
        TransformToLocal(CrsGraph self, BlockMap DomainMap, BlockMap RangeMap) -> int
        """
        return ___init__.CrsGraph_TransformToLocal(self, *args)

    def ReferenceCount(self, *args):
        """ReferenceCount(CrsGraph self) -> int"""
        return ___init__.CrsGraph_ReferenceCount(self, *args)

    def DataPtr(self, *args):
        """DataPtr(CrsGraph self) -> Epetra_CrsGraphData const *"""
        return ___init__.CrsGraph_DataPtr(self, *args)

    def SortGhostsAssociatedWithEachProcessor(self, *args):
        """SortGhostsAssociatedWithEachProcessor(CrsGraph self, bool Flag)"""
        return ___init__.CrsGraph_SortGhostsAssociatedWithEachProcessor(self, *args)

    def __init__(self, *args): 
        """
        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, int numIndicesPerRow,
            bool staticProfile=False) -> CrsGraph

          Constructor with implicit column map and constant indices per row.
          Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - Map describing distribution of rows across processors
            numIndicesPerRow  - Integer number of indices per row
            staticProfile     - Static profile flag

        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, BlockMap colMap,
            int numIndicesPerRow, bool staticProfile=False) -> CrsGraph

          Constructor with specified column map and constant indices per row.
          Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - Map describing distribution of rows across processors
            colMap            - Map describing distribution of columns across processors
            numIndicesPerRow  - Integer number of indices per row
            staticProfile     - Static profile flag

        __init__(self, CrsGraph graph) -> CrsGraph

          Copy constructor.  Arguments:

            graph - Source graph for copy constructor

        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, PySequence
            numIndicesPerRow, bool staticProfile=False) -> CrsGraph

          Constructor with implicit column map and variable indices per row.
          Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - Map describing distribution of rows across processors
            numIndicesPerRow  - Sequence of integers representing the number of indices
                                per row
            staticProfile     - Static profile flag

        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, BlockMap colMap,
            PySequence numIndicesPerRow, bool staticProfile=False) -> CrsGraph

          Constructor with specified column map and variable indices per row.
          Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - Map describing distribution of rows across processors
            colMap            - Map describing distribution of columns across processors
            numIndicesPerRow  - Sequence of integers representing the number of indices
                                per row
            staticProfile     - Static profile flag
        """
        this = ___init__.new_CrsGraph(*args)
        try: self.this.append(this)
        except: self.this = this
    def ExtractGlobalRowCopy(self, *args):
        """
        ExtractGlobalRowCopy(CrsGraph self, long long GlobalRow, int LenOfIndices, int & NumIndices, long long * Indices) -> int
        ExtractGlobalRowCopy(CrsGraph self, int globalRow) -> PyObject *
        """
        return ___init__.CrsGraph_ExtractGlobalRowCopy(self, *args)

    def __getitem__(self, *args):
        """__getitem__(CrsGraph self, int i) -> int *"""
        return ___init__.CrsGraph___getitem__(self, *args)

    def ExtractMyRowCopy(self, *args):
        """ExtractMyRowCopy(CrsGraph self, int localRow) -> PyObject *"""
        return ___init__.CrsGraph_ExtractMyRowCopy(self, *args)

CrsGraph_swigregister = ___init__.CrsGraph_swigregister
CrsGraph_swigregister(CrsGraph)

class OffsetIndex(Object):
    """Proxy of C++ Epetra_OffsetIndex class"""
    __swig_setmethods__ = {}
    for _s in [Object]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, OffsetIndex, name, value)
    __swig_getmethods__ = {}
    for _s in [Object]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, OffsetIndex, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_OffsetIndex self, CrsGraph SourceGraph, CrsGraph TargetGraph, Import Importer) -> OffsetIndex
        __init__(Epetra_OffsetIndex self, CrsGraph SourceGraph, CrsGraph TargetGraph, Export Exporter) -> OffsetIndex
        __init__(Epetra_OffsetIndex self, OffsetIndex Indexor) -> OffsetIndex
        """
        this = ___init__.new_OffsetIndex(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_OffsetIndex
    def SameOffsets(self, *args):
        """SameOffsets(OffsetIndex self) -> int **"""
        return ___init__.OffsetIndex_SameOffsets(self, *args)

    def PermuteOffsets(self, *args):
        """PermuteOffsets(OffsetIndex self) -> int **"""
        return ___init__.OffsetIndex_PermuteOffsets(self, *args)

    def RemoteOffsets(self, *args):
        """RemoteOffsets(OffsetIndex self) -> int **"""
        return ___init__.OffsetIndex_RemoteOffsets(self, *args)

    __swig_setmethods__["NumSame_"] = ___init__.OffsetIndex_NumSame__set
    __swig_getmethods__["NumSame_"] = ___init__.OffsetIndex_NumSame__get
    if _newclass:NumSame_ = _swig_property(___init__.OffsetIndex_NumSame__get, ___init__.OffsetIndex_NumSame__set)
    __swig_setmethods__["SameOffsets_"] = ___init__.OffsetIndex_SameOffsets__set
    __swig_getmethods__["SameOffsets_"] = ___init__.OffsetIndex_SameOffsets__get
    if _newclass:SameOffsets_ = _swig_property(___init__.OffsetIndex_SameOffsets__get, ___init__.OffsetIndex_SameOffsets__set)
    __swig_setmethods__["NumPermute_"] = ___init__.OffsetIndex_NumPermute__set
    __swig_getmethods__["NumPermute_"] = ___init__.OffsetIndex_NumPermute__get
    if _newclass:NumPermute_ = _swig_property(___init__.OffsetIndex_NumPermute__get, ___init__.OffsetIndex_NumPermute__set)
    __swig_setmethods__["PermuteOffsets_"] = ___init__.OffsetIndex_PermuteOffsets__set
    __swig_getmethods__["PermuteOffsets_"] = ___init__.OffsetIndex_PermuteOffsets__get
    if _newclass:PermuteOffsets_ = _swig_property(___init__.OffsetIndex_PermuteOffsets__get, ___init__.OffsetIndex_PermuteOffsets__set)
    __swig_setmethods__["NumExport_"] = ___init__.OffsetIndex_NumExport__set
    __swig_getmethods__["NumExport_"] = ___init__.OffsetIndex_NumExport__get
    if _newclass:NumExport_ = _swig_property(___init__.OffsetIndex_NumExport__get, ___init__.OffsetIndex_NumExport__set)
    __swig_setmethods__["NumRemote_"] = ___init__.OffsetIndex_NumRemote__set
    __swig_getmethods__["NumRemote_"] = ___init__.OffsetIndex_NumRemote__get
    if _newclass:NumRemote_ = _swig_property(___init__.OffsetIndex_NumRemote__get, ___init__.OffsetIndex_NumRemote__set)
    __swig_setmethods__["RemoteOffsets_"] = ___init__.OffsetIndex_RemoteOffsets__set
    __swig_getmethods__["RemoteOffsets_"] = ___init__.OffsetIndex_RemoteOffsets__get
    if _newclass:RemoteOffsets_ = _swig_property(___init__.OffsetIndex_RemoteOffsets__get, ___init__.OffsetIndex_RemoteOffsets__set)
    __swig_setmethods__["DataOwned_"] = ___init__.OffsetIndex_DataOwned__set
    __swig_getmethods__["DataOwned_"] = ___init__.OffsetIndex_DataOwned__get
    if _newclass:DataOwned_ = _swig_property(___init__.OffsetIndex_DataOwned__get, ___init__.OffsetIndex_DataOwned__set)
OffsetIndex_swigregister = ___init__.OffsetIndex_swigregister
OffsetIndex_swigregister(OffsetIndex)

class Operator(_object):
    """
    For cross-language polymorphism to work in python, you must call this
    constructor::

        from PyTrilinos import Epetra
        class MyOperator(Epetra.Operator):
            def __init__(self):
                Epetra.Operator.__init__(self)

    Other than that, the Epetra.Operator class is much more forgiving than
    its C++ counterpart.  Often, you can override just the Label() and
    Apply() methods.

    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Operator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Operator, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_Operator
    def SetUseTranspose(self, *args):
        """SetUseTranspose(Operator self, bool UseTranspose) -> int"""
        return ___init__.Operator_SetUseTranspose(self, *args)

    def Apply(self, *args):
        """
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return ___init__.Operator_Apply(self, *args)

    def ApplyInverse(self, *args):
        """
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return ___init__.Operator_ApplyInverse(self, *args)

    def NormInf(self, *args):
        """NormInf(Operator self) -> double"""
        return ___init__.Operator_NormInf(self, *args)

    def Label(self, *args):
        """Label(Operator self) -> char const *"""
        return ___init__.Operator_Label(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(Operator self) -> bool"""
        return ___init__.Operator_UseTranspose(self, *args)

    def HasNormInf(self, *args):
        """HasNormInf(Operator self) -> bool"""
        return ___init__.Operator_HasNormInf(self, *args)

    def Comm(self, *args):
        """Comm(Operator self) -> Comm"""
        return ___init__.Operator_Comm(self, *args)

    def OperatorDomainMap(self, *args):
        """OperatorDomainMap(Operator self) -> Map"""
        return ___init__.Operator_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        """OperatorRangeMap(Operator self) -> Map"""
        return ___init__.Operator_OperatorRangeMap(self, *args)

    def __init__(self, *args): 
        """__init__(Epetra_Operator self) -> Operator"""
        if self.__class__ == Operator:
            _self = None
        else:
            _self = self
        this = ___init__.new_Operator(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    def __disown__(self):
        self.this.disown()
        ___init__.disown_Operator(self)
        return weakref_proxy(self)
Operator_swigregister = ___init__.Operator_swigregister
Operator_swigregister(Operator)

class InvOperator(Operator):
    """Proxy of C++ Epetra_InvOperator class"""
    __swig_setmethods__ = {}
    for _s in [Operator]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, InvOperator, name, value)
    __swig_getmethods__ = {}
    for _s in [Operator]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, InvOperator, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(Epetra_InvOperator self, Operator operatorIn) -> InvOperator"""
        if self.__class__ == InvOperator:
            _self = None
        else:
            _self = self
        this = ___init__.new_InvOperator(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_InvOperator
    def SetUseTranspose(self, *args):
        """SetUseTranspose(InvOperator self, bool UseTranspose_in) -> int"""
        return ___init__.InvOperator_SetUseTranspose(self, *args)

    def Apply(self, *args):
        """
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return ___init__.InvOperator_Apply(self, *args)

    def ApplyInverse(self, *args):
        """
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return ___init__.InvOperator_ApplyInverse(self, *args)

    def NormInf(self, *args):
        """NormInf(InvOperator self) -> double"""
        return ___init__.InvOperator_NormInf(self, *args)

    def Label(self, *args):
        """Label(InvOperator self) -> char const *"""
        return ___init__.InvOperator_Label(self, *args)

    def Operator(self, *args):
        """Operator(InvOperator self) -> Operator"""
        return ___init__.InvOperator_Operator(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(InvOperator self) -> bool"""
        return ___init__.InvOperator_UseTranspose(self, *args)

    def HasNormInf(self, *args):
        """HasNormInf(InvOperator self) -> bool"""
        return ___init__.InvOperator_HasNormInf(self, *args)

    def Comm(self, *args):
        """Comm(InvOperator self) -> Comm"""
        return ___init__.InvOperator_Comm(self, *args)

    def OperatorDomainMap(self, *args):
        """OperatorDomainMap(InvOperator self) -> Map"""
        return ___init__.InvOperator_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        """OperatorRangeMap(InvOperator self) -> Map"""
        return ___init__.InvOperator_OperatorRangeMap(self, *args)

    def __disown__(self):
        self.this.disown()
        ___init__.disown_InvOperator(self)
        return weakref_proxy(self)
InvOperator_swigregister = ___init__.InvOperator_swigregister
InvOperator_swigregister(InvOperator)

class RowMatrix(Operator,SrcDistObject):
    """Proxy of C++ Epetra_RowMatrix class"""
    __swig_setmethods__ = {}
    for _s in [Operator,SrcDistObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RowMatrix, name, value)
    __swig_getmethods__ = {}
    for _s in [Operator,SrcDistObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RowMatrix, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_RowMatrix
    def NumMyRowEntries(self, *args):
        """
        NumMyRowEntries(int myRow, numpy.ndarray numEntries) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....
        """
        return ___init__.RowMatrix_NumMyRowEntries(self, *args)

    def MaxNumEntries(self, *args):
        """MaxNumEntries(RowMatrix self) -> int"""
        return ___init__.RowMatrix_MaxNumEntries(self, *args)

    def ExtractMyRowCopy(self, *args):
        """
        ExtractMyRowCopy(int myRow, int length, numpy.ndarray numEntries,
            numpy.ndarray values, numpy.ndarray indices) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....

        Arguments values and indices are double* and int*, respectively, in
        C++.  In python, these are provided to you as numpy arrays of the
        given length, so that you may alter their entries in-place.
        """
        return ___init__.RowMatrix_ExtractMyRowCopy(self, *args)

    def ExtractDiagonalCopy(self, *args):
        """
        ExtractDiagonalCopy(Vector diagonal) -> int

        Argument diagonal is provided to you as a numpy-hybrid Epetra.Vector,
        giving you access to the numpy interface in addition to the
        Epetra_Vector C++ interface.
        """
        return ___init__.RowMatrix_ExtractDiagonalCopy(self, *args)

    def Multiply(self, *args):
        """
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.RowMatrix_Multiply(self, *args)

    def Solve(self, *args):
        """
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.RowMatrix_Solve(self, *args)

    def InvRowSums(self, *args):
        """
        InvRowSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.RowMatrix_InvRowSums(self, *args)

    def LeftScale(self, *args):
        """
        LeftScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.RowMatrix_LeftScale(self, *args)

    def InvColSums(self, *args):
        """
        InvColSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.RowMatrix_InvColSums(self, *args)

    def RightScale(self, *args):
        """
        RightScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.RowMatrix_RightScale(self, *args)

    def Filled(self, *args):
        """Filled(RowMatrix self) -> bool"""
        return ___init__.RowMatrix_Filled(self, *args)

    def NormInf(self, *args):
        """NormInf(RowMatrix self) -> double"""
        return ___init__.RowMatrix_NormInf(self, *args)

    def NormOne(self, *args):
        """NormOne(RowMatrix self) -> double"""
        return ___init__.RowMatrix_NormOne(self, *args)

    def NumGlobalNonzeros(self, *args):
        """NumGlobalNonzeros(RowMatrix self) -> int"""
        return ___init__.RowMatrix_NumGlobalNonzeros(self, *args)

    def NumGlobalNonzeros64(self, *args):
        """NumGlobalNonzeros64(RowMatrix self) -> long long"""
        return ___init__.RowMatrix_NumGlobalNonzeros64(self, *args)

    def NumGlobalRows(self, *args):
        """NumGlobalRows(RowMatrix self) -> int"""
        return ___init__.RowMatrix_NumGlobalRows(self, *args)

    def NumGlobalRows64(self, *args):
        """NumGlobalRows64(RowMatrix self) -> long long"""
        return ___init__.RowMatrix_NumGlobalRows64(self, *args)

    def NumGlobalCols(self, *args):
        """NumGlobalCols(RowMatrix self) -> int"""
        return ___init__.RowMatrix_NumGlobalCols(self, *args)

    def NumGlobalCols64(self, *args):
        """NumGlobalCols64(RowMatrix self) -> long long"""
        return ___init__.RowMatrix_NumGlobalCols64(self, *args)

    def NumGlobalDiagonals(self, *args):
        """NumGlobalDiagonals(RowMatrix self) -> int"""
        return ___init__.RowMatrix_NumGlobalDiagonals(self, *args)

    def NumGlobalDiagonals64(self, *args):
        """NumGlobalDiagonals64(RowMatrix self) -> long long"""
        return ___init__.RowMatrix_NumGlobalDiagonals64(self, *args)

    def NumMyNonzeros(self, *args):
        """NumMyNonzeros(RowMatrix self) -> int"""
        return ___init__.RowMatrix_NumMyNonzeros(self, *args)

    def NumMyRows(self, *args):
        """NumMyRows(RowMatrix self) -> int"""
        return ___init__.RowMatrix_NumMyRows(self, *args)

    def NumMyCols(self, *args):
        """NumMyCols(RowMatrix self) -> int"""
        return ___init__.RowMatrix_NumMyCols(self, *args)

    def NumMyDiagonals(self, *args):
        """NumMyDiagonals(RowMatrix self) -> int"""
        return ___init__.RowMatrix_NumMyDiagonals(self, *args)

    def LowerTriangular(self, *args):
        """LowerTriangular(RowMatrix self) -> bool"""
        return ___init__.RowMatrix_LowerTriangular(self, *args)

    def UpperTriangular(self, *args):
        """UpperTriangular(RowMatrix self) -> bool"""
        return ___init__.RowMatrix_UpperTriangular(self, *args)

    def RowMatrixRowMap(self, *args):
        """RowMatrixRowMap(RowMatrix self) -> Map"""
        return ___init__.RowMatrix_RowMatrixRowMap(self, *args)

    def RowMatrixColMap(self, *args):
        """RowMatrixColMap(RowMatrix self) -> Map"""
        return ___init__.RowMatrix_RowMatrixColMap(self, *args)

    def RowMatrixImporter(self, *args):
        """RowMatrixImporter(RowMatrix self) -> Import"""
        return ___init__.RowMatrix_RowMatrixImporter(self, *args)

    def __init__(self, *args): 
        """__init__(Epetra_RowMatrix self) -> RowMatrix"""
        if self.__class__ == RowMatrix:
            _self = None
        else:
            _self = self
        this = ___init__.new_RowMatrix(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    def __disown__(self):
        self.this.disown()
        ___init__.disown_RowMatrix(self)
        return weakref_proxy(self)
RowMatrix_swigregister = ___init__.RowMatrix_swigregister
RowMatrix_swigregister(RowMatrix)

class BasicRowMatrix(CompObject,Object,RowMatrix):
    """Proxy of C++ Epetra_BasicRowMatrix class"""
    __swig_setmethods__ = {}
    for _s in [CompObject,Object,RowMatrix]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BasicRowMatrix, name, value)
    __swig_getmethods__ = {}
    for _s in [CompObject,Object,RowMatrix]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BasicRowMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(Epetra_BasicRowMatrix self, Comm Comm) -> BasicRowMatrix"""
        if self.__class__ == BasicRowMatrix:
            _self = None
        else:
            _self = self
        this = ___init__.new_BasicRowMatrix(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_BasicRowMatrix
    def SetMaps(self, *args):
        """
        SetMaps(BasicRowMatrix self, Map RowMap, Map ColMap)
        SetMaps(BasicRowMatrix self, Map RowMap, Map ColMap, Map DomainMap, Map RangeMap)
        """
        return ___init__.BasicRowMatrix_SetMaps(self, *args)

    def ExtractMyRowCopy(self, *args):
        """
        ExtractMyRowCopy(int myRow, int length, numpy.ndarray numEntries,
            numpy.ndarray values, numpy.ndarray indices) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....

        Arguments values and indices are double* and int*, respectively, in
        C++.  In python, these are provided to you as numpy arrays of the
        given length, so that you may alter their entries in-place.
        """
        return ___init__.BasicRowMatrix_ExtractMyRowCopy(self, *args)

    def ExtractMyEntryView(self, *args):
        """ExtractMyEntryView(BasicRowMatrix self, int CurEntry, double *& Value, int & RowIndex, int & ColIndex) -> int"""
        return ___init__.BasicRowMatrix_ExtractMyEntryView(self, *args)

    def NumMyRowEntries(self, *args):
        """
        NumMyRowEntries(int myRow, numpy.ndarray numEntries) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....
        """
        return ___init__.BasicRowMatrix_NumMyRowEntries(self, *args)

    def Multiply(self, *args):
        """
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.BasicRowMatrix_Multiply(self, *args)

    def Solve(self, *args):
        """
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.BasicRowMatrix_Solve(self, *args)

    def ExtractDiagonalCopy(self, *args):
        """
        ExtractDiagonalCopy(Vector diagonal) -> int

        Argument diagonal is provided to you as a numpy-hybrid Epetra.Vector,
        giving you access to the numpy interface in addition to the
        Epetra_Vector C++ interface.
        """
        return ___init__.BasicRowMatrix_ExtractDiagonalCopy(self, *args)

    def InvRowSums(self, *args):
        """
        InvRowSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.BasicRowMatrix_InvRowSums(self, *args)

    def LeftScale(self, *args):
        """
        LeftScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.BasicRowMatrix_LeftScale(self, *args)

    def InvColSums(self, *args):
        """
        InvColSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.BasicRowMatrix_InvColSums(self, *args)

    def RightScale(self, *args):
        """
        RightScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.BasicRowMatrix_RightScale(self, *args)

    def Filled(self, *args):
        """Filled(BasicRowMatrix self) -> bool"""
        return ___init__.BasicRowMatrix_Filled(self, *args)

    def LowerTriangular(self, *args):
        """LowerTriangular(BasicRowMatrix self) -> bool"""
        return ___init__.BasicRowMatrix_LowerTriangular(self, *args)

    def UpperTriangular(self, *args):
        """UpperTriangular(BasicRowMatrix self) -> bool"""
        return ___init__.BasicRowMatrix_UpperTriangular(self, *args)

    def NormInf(self, *args):
        """NormInf(BasicRowMatrix self) -> double"""
        return ___init__.BasicRowMatrix_NormInf(self, *args)

    def NormOne(self, *args):
        """NormOne(BasicRowMatrix self) -> double"""
        return ___init__.BasicRowMatrix_NormOne(self, *args)

    def NumGlobalNonzeros(self, *args):
        """NumGlobalNonzeros(BasicRowMatrix self) -> int"""
        return ___init__.BasicRowMatrix_NumGlobalNonzeros(self, *args)

    def NumGlobalNonzeros64(self, *args):
        """NumGlobalNonzeros64(BasicRowMatrix self) -> long long"""
        return ___init__.BasicRowMatrix_NumGlobalNonzeros64(self, *args)

    def NumGlobalRows(self, *args):
        """NumGlobalRows(BasicRowMatrix self) -> int"""
        return ___init__.BasicRowMatrix_NumGlobalRows(self, *args)

    def NumGlobalRows64(self, *args):
        """NumGlobalRows64(BasicRowMatrix self) -> long long"""
        return ___init__.BasicRowMatrix_NumGlobalRows64(self, *args)

    def NumGlobalCols(self, *args):
        """NumGlobalCols(BasicRowMatrix self) -> int"""
        return ___init__.BasicRowMatrix_NumGlobalCols(self, *args)

    def NumGlobalCols64(self, *args):
        """NumGlobalCols64(BasicRowMatrix self) -> long long"""
        return ___init__.BasicRowMatrix_NumGlobalCols64(self, *args)

    def NumGlobalDiagonals(self, *args):
        """NumGlobalDiagonals(BasicRowMatrix self) -> int"""
        return ___init__.BasicRowMatrix_NumGlobalDiagonals(self, *args)

    def NumGlobalDiagonals64(self, *args):
        """NumGlobalDiagonals64(BasicRowMatrix self) -> long long"""
        return ___init__.BasicRowMatrix_NumGlobalDiagonals64(self, *args)

    def NumMyNonzeros(self, *args):
        """NumMyNonzeros(BasicRowMatrix self) -> int"""
        return ___init__.BasicRowMatrix_NumMyNonzeros(self, *args)

    def NumMyRows(self, *args):
        """NumMyRows(BasicRowMatrix self) -> int"""
        return ___init__.BasicRowMatrix_NumMyRows(self, *args)

    def NumMyCols(self, *args):
        """NumMyCols(BasicRowMatrix self) -> int"""
        return ___init__.BasicRowMatrix_NumMyCols(self, *args)

    def NumMyDiagonals(self, *args):
        """NumMyDiagonals(BasicRowMatrix self) -> int"""
        return ___init__.BasicRowMatrix_NumMyDiagonals(self, *args)

    def MaxNumEntries(self, *args):
        """MaxNumEntries(BasicRowMatrix self) -> int"""
        return ___init__.BasicRowMatrix_MaxNumEntries(self, *args)

    def OperatorDomainMap(self, *args):
        """OperatorDomainMap(BasicRowMatrix self) -> Map"""
        return ___init__.BasicRowMatrix_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        """OperatorRangeMap(BasicRowMatrix self) -> Map"""
        return ___init__.BasicRowMatrix_OperatorRangeMap(self, *args)

    def Map(self, *args):
        """Map(BasicRowMatrix self) -> BlockMap"""
        return ___init__.BasicRowMatrix_Map(self, *args)

    def RowMatrixRowMap(self, *args):
        """RowMatrixRowMap(BasicRowMatrix self) -> Map"""
        return ___init__.BasicRowMatrix_RowMatrixRowMap(self, *args)

    def RowMatrixColMap(self, *args):
        """RowMatrixColMap(BasicRowMatrix self) -> Map"""
        return ___init__.BasicRowMatrix_RowMatrixColMap(self, *args)

    def RowMatrixImporter(self, *args):
        """RowMatrixImporter(BasicRowMatrix self) -> Import"""
        return ___init__.BasicRowMatrix_RowMatrixImporter(self, *args)

    def Comm(self, *args):
        """Comm(BasicRowMatrix self) -> Comm"""
        return ___init__.BasicRowMatrix_Comm(self, *args)

    def SetUseTranspose(self, *args):
        """SetUseTranspose(BasicRowMatrix self, bool use_transpose) -> int"""
        return ___init__.BasicRowMatrix_SetUseTranspose(self, *args)

    def Label(self, *args):
        """Label(BasicRowMatrix self) -> char const *"""
        return ___init__.BasicRowMatrix_Label(self, *args)

    def Apply(self, *args):
        """
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return ___init__.BasicRowMatrix_Apply(self, *args)

    def ApplyInverse(self, *args):
        """
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return ___init__.BasicRowMatrix_ApplyInverse(self, *args)

    def HasNormInf(self, *args):
        """HasNormInf(BasicRowMatrix self) -> bool"""
        return ___init__.BasicRowMatrix_HasNormInf(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(BasicRowMatrix self) -> bool"""
        return ___init__.BasicRowMatrix_UseTranspose(self, *args)

    def Importer(self, *args):
        """Importer(BasicRowMatrix self) -> Import"""
        return ___init__.BasicRowMatrix_Importer(self, *args)

    def Exporter(self, *args):
        """Exporter(BasicRowMatrix self) -> Export"""
        return ___init__.BasicRowMatrix_Exporter(self, *args)

    def ComputeStructureConstants(self, *args):
        """ComputeStructureConstants(BasicRowMatrix self)"""
        return ___init__.BasicRowMatrix_ComputeStructureConstants(self, *args)

    def ComputeNumericConstants(self, *args):
        """ComputeNumericConstants(BasicRowMatrix self)"""
        return ___init__.BasicRowMatrix_ComputeNumericConstants(self, *args)

    def __disown__(self):
        self.this.disown()
        ___init__.disown_BasicRowMatrix(self)
        return weakref_proxy(self)
BasicRowMatrix_swigregister = ___init__.BasicRowMatrix_swigregister
BasicRowMatrix_swigregister(BasicRowMatrix)

class CrsMatrix(DistObject,CompObject,BLAS,RowMatrix):
    """Proxy of C++ Epetra_CrsMatrix class"""
    __swig_setmethods__ = {}
    for _s in [DistObject,CompObject,BLAS,RowMatrix]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CrsMatrix, name, value)
    __swig_getmethods__ = {}
    for _s in [DistObject,CompObject,BLAS,RowMatrix]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CrsMatrix, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_CrsMatrix
    def PutScalar(self, *args):
        """PutScalar(CrsMatrix self, double ScalarConstant) -> int"""
        return ___init__.CrsMatrix_PutScalar(self, *args)

    def Scale(self, *args):
        """Scale(CrsMatrix self, double ScalarConstant) -> int"""
        return ___init__.CrsMatrix_Scale(self, *args)

    def ReplaceDiagonalValues(self, *args):
        """ReplaceDiagonalValues(CrsMatrix self, Epetra_Vector Diagonal) -> int"""
        return ___init__.CrsMatrix_ReplaceDiagonalValues(self, *args)

    def FillComplete(self, *args):
        """
        FillComplete(CrsMatrix self, bool OptimizeDataStorage=True) -> int
        FillComplete(CrsMatrix self, Map DomainMap, Map RangeMap, bool OptimizeDataStorage=True) -> int
        """
        return ___init__.CrsMatrix_FillComplete(self, *args)

    def OptimizeStorage(self, *args):
        """OptimizeStorage(CrsMatrix self) -> int"""
        return ___init__.CrsMatrix_OptimizeStorage(self, *args)

    def MakeDataContiguous(self, *args):
        """MakeDataContiguous(CrsMatrix self) -> int"""
        return ___init__.CrsMatrix_MakeDataContiguous(self, *args)

    def ExtractDiagonalCopy(self, *args):
        """
        ExtractDiagonalCopy(Vector diagonal) -> int

        Argument diagonal is provided to you as a numpy-hybrid Epetra.Vector,
        giving you access to the numpy interface in addition to the
        Epetra_Vector C++ interface.
        """
        return ___init__.CrsMatrix_ExtractDiagonalCopy(self, *args)

    def Multiply(self, *args):
        """
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.CrsMatrix_Multiply(self, *args)

    def Multiply1(self, *args):
        """
        Multiply1(CrsMatrix self, bool TransA, Epetra_Vector x, Epetra_Vector y) -> int
        Multiply1(CrsMatrix self, bool TransA, Epetra_MultiVector X, Epetra_MultiVector Y) -> int
        """
        return ___init__.CrsMatrix_Multiply1(self, *args)

    def Solve(self, *args):
        """
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.CrsMatrix_Solve(self, *args)

    def InvRowSums(self, *args):
        """
        InvRowSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.CrsMatrix_InvRowSums(self, *args)

    def InvRowMaxs(self, *args):
        """InvRowMaxs(CrsMatrix self, Epetra_Vector x) -> int"""
        return ___init__.CrsMatrix_InvRowMaxs(self, *args)

    def LeftScale(self, *args):
        """
        LeftScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.CrsMatrix_LeftScale(self, *args)

    def InvColSums(self, *args):
        """
        InvColSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.CrsMatrix_InvColSums(self, *args)

    def InvColMaxs(self, *args):
        """InvColMaxs(CrsMatrix self, Epetra_Vector x) -> int"""
        return ___init__.CrsMatrix_InvColMaxs(self, *args)

    def RightScale(self, *args):
        """
        RightScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.CrsMatrix_RightScale(self, *args)

    def Filled(self, *args):
        """Filled(CrsMatrix self) -> bool"""
        return ___init__.CrsMatrix_Filled(self, *args)

    def StorageOptimized(self, *args):
        """StorageOptimized(CrsMatrix self) -> bool"""
        return ___init__.CrsMatrix_StorageOptimized(self, *args)

    def IndicesAreGlobal(self, *args):
        """IndicesAreGlobal(CrsMatrix self) -> bool"""
        return ___init__.CrsMatrix_IndicesAreGlobal(self, *args)

    def IndicesAreLocal(self, *args):
        """IndicesAreLocal(CrsMatrix self) -> bool"""
        return ___init__.CrsMatrix_IndicesAreLocal(self, *args)

    def IndicesAreContiguous(self, *args):
        """IndicesAreContiguous(CrsMatrix self) -> bool"""
        return ___init__.CrsMatrix_IndicesAreContiguous(self, *args)

    def LowerTriangular(self, *args):
        """LowerTriangular(CrsMatrix self) -> bool"""
        return ___init__.CrsMatrix_LowerTriangular(self, *args)

    def UpperTriangular(self, *args):
        """UpperTriangular(CrsMatrix self) -> bool"""
        return ___init__.CrsMatrix_UpperTriangular(self, *args)

    def NoDiagonal(self, *args):
        """NoDiagonal(CrsMatrix self) -> bool"""
        return ___init__.CrsMatrix_NoDiagonal(self, *args)

    def NormInf(self, *args):
        """NormInf(CrsMatrix self) -> double"""
        return ___init__.CrsMatrix_NormInf(self, *args)

    def NormOne(self, *args):
        """NormOne(CrsMatrix self) -> double"""
        return ___init__.CrsMatrix_NormOne(self, *args)

    def NormFrobenius(self, *args):
        """NormFrobenius(CrsMatrix self) -> double"""
        return ___init__.CrsMatrix_NormFrobenius(self, *args)

    def NumGlobalNonzeros(self, *args):
        """NumGlobalNonzeros(CrsMatrix self) -> int"""
        return ___init__.CrsMatrix_NumGlobalNonzeros(self, *args)

    def NumGlobalNonzeros64(self, *args):
        """NumGlobalNonzeros64(CrsMatrix self) -> long long"""
        return ___init__.CrsMatrix_NumGlobalNonzeros64(self, *args)

    def NumGlobalRows(self, *args):
        """NumGlobalRows(CrsMatrix self) -> int"""
        return ___init__.CrsMatrix_NumGlobalRows(self, *args)

    def NumGlobalRows64(self, *args):
        """NumGlobalRows64(CrsMatrix self) -> long long"""
        return ___init__.CrsMatrix_NumGlobalRows64(self, *args)

    def NumGlobalCols(self, *args):
        """NumGlobalCols(CrsMatrix self) -> int"""
        return ___init__.CrsMatrix_NumGlobalCols(self, *args)

    def NumGlobalCols64(self, *args):
        """NumGlobalCols64(CrsMatrix self) -> long long"""
        return ___init__.CrsMatrix_NumGlobalCols64(self, *args)

    def NumGlobalDiagonals(self, *args):
        """NumGlobalDiagonals(CrsMatrix self) -> int"""
        return ___init__.CrsMatrix_NumGlobalDiagonals(self, *args)

    def NumGlobalDiagonals64(self, *args):
        """NumGlobalDiagonals64(CrsMatrix self) -> long long"""
        return ___init__.CrsMatrix_NumGlobalDiagonals64(self, *args)

    def NumMyNonzeros(self, *args):
        """NumMyNonzeros(CrsMatrix self) -> int"""
        return ___init__.CrsMatrix_NumMyNonzeros(self, *args)

    def NumMyRows(self, *args):
        """NumMyRows(CrsMatrix self) -> int"""
        return ___init__.CrsMatrix_NumMyRows(self, *args)

    def NumMyCols(self, *args):
        """NumMyCols(CrsMatrix self) -> int"""
        return ___init__.CrsMatrix_NumMyCols(self, *args)

    def NumMyDiagonals(self, *args):
        """NumMyDiagonals(CrsMatrix self) -> int"""
        return ___init__.CrsMatrix_NumMyDiagonals(self, *args)

    def NumGlobalEntries(self, *args):
        """NumGlobalEntries(CrsMatrix self, long long Row) -> int"""
        return ___init__.CrsMatrix_NumGlobalEntries(self, *args)

    def NumAllocatedGlobalEntries(self, *args):
        """NumAllocatedGlobalEntries(CrsMatrix self, int Row) -> int"""
        return ___init__.CrsMatrix_NumAllocatedGlobalEntries(self, *args)

    def MaxNumEntries(self, *args):
        """MaxNumEntries(CrsMatrix self) -> int"""
        return ___init__.CrsMatrix_MaxNumEntries(self, *args)

    def GlobalMaxNumEntries(self, *args):
        """GlobalMaxNumEntries(CrsMatrix self) -> int"""
        return ___init__.CrsMatrix_GlobalMaxNumEntries(self, *args)

    def NumMyEntries(self, *args):
        """NumMyEntries(CrsMatrix self, int Row) -> int"""
        return ___init__.CrsMatrix_NumMyEntries(self, *args)

    def NumAllocatedMyEntries(self, *args):
        """NumAllocatedMyEntries(CrsMatrix self, int Row) -> int"""
        return ___init__.CrsMatrix_NumAllocatedMyEntries(self, *args)

    def IndexBase(self, *args):
        """IndexBase(CrsMatrix self) -> int"""
        return ___init__.CrsMatrix_IndexBase(self, *args)

    def StaticGraph(self, *args):
        """StaticGraph(CrsMatrix self) -> bool"""
        return ___init__.CrsMatrix_StaticGraph(self, *args)

    def Graph(self, *args):
        """Graph(CrsMatrix self) -> CrsGraph"""
        return ___init__.CrsMatrix_Graph(self, *args)

    def RowMap(self, *args):
        """RowMap(CrsMatrix self) -> Map"""
        return ___init__.CrsMatrix_RowMap(self, *args)

    def ReplaceRowMap(self, *args):
        """ReplaceRowMap(CrsMatrix self, BlockMap newmap) -> int"""
        return ___init__.CrsMatrix_ReplaceRowMap(self, *args)

    def HaveColMap(self, *args):
        """HaveColMap(CrsMatrix self) -> bool"""
        return ___init__.CrsMatrix_HaveColMap(self, *args)

    def ReplaceColMap(self, *args):
        """ReplaceColMap(CrsMatrix self, BlockMap newmap) -> int"""
        return ___init__.CrsMatrix_ReplaceColMap(self, *args)

    def ColMap(self, *args):
        """ColMap(CrsMatrix self) -> Map"""
        return ___init__.CrsMatrix_ColMap(self, *args)

    def DomainMap(self, *args):
        """DomainMap(CrsMatrix self) -> Map"""
        return ___init__.CrsMatrix_DomainMap(self, *args)

    def RangeMap(self, *args):
        """RangeMap(CrsMatrix self) -> Map"""
        return ___init__.CrsMatrix_RangeMap(self, *args)

    def Importer(self, *args):
        """Importer(CrsMatrix self) -> Import"""
        return ___init__.CrsMatrix_Importer(self, *args)

    def Exporter(self, *args):
        """Exporter(CrsMatrix self) -> Export"""
        return ___init__.CrsMatrix_Exporter(self, *args)

    def Comm(self, *args):
        """Comm(CrsMatrix self) -> Comm"""
        return ___init__.CrsMatrix_Comm(self, *args)

    def LRID(self, *args):
        """
        LRID(CrsMatrix self, int GRID_in) -> int
        LRID(CrsMatrix self, long long GRID_in) -> int
        """
        return ___init__.CrsMatrix_LRID(self, *args)

    def GRID(self, *args):
        """GRID(CrsMatrix self, int LRID_in) -> int"""
        return ___init__.CrsMatrix_GRID(self, *args)

    def GRID64(self, *args):
        """GRID64(CrsMatrix self, int LRID_in) -> long long"""
        return ___init__.CrsMatrix_GRID64(self, *args)

    def LCID(self, *args):
        """
        LCID(CrsMatrix self, int GCID_in) -> int
        LCID(CrsMatrix self, long long GCID_in) -> int
        """
        return ___init__.CrsMatrix_LCID(self, *args)

    def GCID(self, *args):
        """GCID(CrsMatrix self, int LCID_in) -> int"""
        return ___init__.CrsMatrix_GCID(self, *args)

    def GCID64(self, *args):
        """GCID64(CrsMatrix self, int LCID_in) -> long long"""
        return ___init__.CrsMatrix_GCID64(self, *args)

    def MyGRID(self, *args):
        """
        MyGRID(CrsMatrix self, int GRID_in) -> bool
        MyGRID(CrsMatrix self, long long GRID_in) -> bool
        """
        return ___init__.CrsMatrix_MyGRID(self, *args)

    def MyLRID(self, *args):
        """MyLRID(CrsMatrix self, int LRID_in) -> bool"""
        return ___init__.CrsMatrix_MyLRID(self, *args)

    def MyGCID(self, *args):
        """
        MyGCID(CrsMatrix self, int GCID_in) -> bool
        MyGCID(CrsMatrix self, long long GCID_in) -> bool
        """
        return ___init__.CrsMatrix_MyGCID(self, *args)

    def MyLCID(self, *args):
        """MyLCID(CrsMatrix self, int LCID_in) -> bool"""
        return ___init__.CrsMatrix_MyLCID(self, *args)

    def MyGlobalRow(self, *args):
        """
        MyGlobalRow(CrsMatrix self, int GID) -> bool
        MyGlobalRow(CrsMatrix self, long long GID) -> bool
        """
        return ___init__.CrsMatrix_MyGlobalRow(self, *args)

    def Label(self, *args):
        """Label(CrsMatrix self) -> char const *"""
        return ___init__.CrsMatrix_Label(self, *args)

    def SetUseTranspose(self, *args):
        """SetUseTranspose(CrsMatrix self, bool UseTranspose_in) -> int"""
        return ___init__.CrsMatrix_SetUseTranspose(self, *args)

    def Apply(self, *args):
        """
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return ___init__.CrsMatrix_Apply(self, *args)

    def ApplyInverse(self, *args):
        """
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return ___init__.CrsMatrix_ApplyInverse(self, *args)

    def HasNormInf(self, *args):
        """HasNormInf(CrsMatrix self) -> bool"""
        return ___init__.CrsMatrix_HasNormInf(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(CrsMatrix self) -> bool"""
        return ___init__.CrsMatrix_UseTranspose(self, *args)

    def OperatorDomainMap(self, *args):
        """OperatorDomainMap(CrsMatrix self) -> Map"""
        return ___init__.CrsMatrix_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        """OperatorRangeMap(CrsMatrix self) -> Map"""
        return ___init__.CrsMatrix_OperatorRangeMap(self, *args)

    def NumMyRowEntries(self, *args):
        """
        NumMyRowEntries(int myRow, numpy.ndarray numEntries) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....
        """
        return ___init__.CrsMatrix_NumMyRowEntries(self, *args)

    def Map(self, *args):
        """Map(CrsMatrix self) -> BlockMap"""
        return ___init__.CrsMatrix_Map(self, *args)

    def RowMatrixRowMap(self, *args):
        """RowMatrixRowMap(CrsMatrix self) -> Map"""
        return ___init__.CrsMatrix_RowMatrixRowMap(self, *args)

    def RowMatrixColMap(self, *args):
        """RowMatrixColMap(CrsMatrix self) -> Map"""
        return ___init__.CrsMatrix_RowMatrixColMap(self, *args)

    def RowMatrixImporter(self, *args):
        """RowMatrixImporter(CrsMatrix self) -> Import"""
        return ___init__.CrsMatrix_RowMatrixImporter(self, *args)

    def SortGhostsAssociatedWithEachProcessor(self, *args):
        """SortGhostsAssociatedWithEachProcessor(CrsMatrix self, bool Flag) -> int"""
        return ___init__.CrsMatrix_SortGhostsAssociatedWithEachProcessor(self, *args)

    def ImportMap(self, *args):
        """ImportMap(CrsMatrix self) -> Map"""
        return ___init__.CrsMatrix_ImportMap(self, *args)

    def TransformToLocal(self, *args):
        """
        TransformToLocal(CrsMatrix self) -> int
        TransformToLocal(CrsMatrix self, Map DomainMap, Map RangeMap) -> int
        """
        return ___init__.CrsMatrix_TransformToLocal(self, *args)

    def InsertGlobalValues(self, *args):
        """
        InsertGlobalValues(self, int globalRow, PySequence values, PySequence
            indices) -> int

          Arguments:

            globalRow - global row index
            values    - a sequence of doubles that represent the values to insert
            indices   - a sequence of integers that represent the indices to insert

        InsertGlobalValues(self, PySequence rows, PySequence cols, PySequence
            values) -> int

          Arguments:

            rows    - a sequence of integers that represent the row indices to insert
            cols    - a sequence of integers that represent the column indices to
                      insert
            values  - a sequence of doubles that represent the values to insert

        """
        return ___init__.CrsMatrix_InsertGlobalValues(self, *args)

    def ReplaceGlobalValues(self, *args):
        """
        ReplaceGlobalValues(self, int globalRow, PySequence values, PySequence
            indices) -> int

          Arguments:

            globalRow - global row index
            values    - a sequence of doubles that represent the values to replace
            indices   - a sequence of integers that represent the indices to replace

        ReplaceGlobalValues(self, PySequence rows, PySequence cols, PySequence
            values) -> int

          Arguments:

            rows    - a sequence of integers that represent the row indices to replace
            cols    - a sequence of integers that represent the column indices to
                      replace
            values  - a sequence of doubles that represent the values to replace

        """
        return ___init__.CrsMatrix_ReplaceGlobalValues(self, *args)

    def SumIntoGlobalValues(self, *args):
        """
        SumIntoGlobalValues(self, int globalRow, PySequence values, PySequence
            indices) -> int

          Arguments:

            globalRow - global row index
            values    - a sequence of doubles that represent the values to sum into
            indices   - a sequence of integers that represent the indices to sum into

        SumIntoGlobalValues(self, PySequence rows, PySequence cols, PySequence
            values) -> int

          Arguments:

            rows    - a sequence of integers that represent the row indices to sum into
            cols    - a sequence of integers that represent the column indices to
                      sum into
            values  - a sequence of doubles that represent the values to sum into

        """
        return ___init__.CrsMatrix_SumIntoGlobalValues(self, *args)

    def InsertMyValues(self, *args):
        """
        InsertMyValues(CrsMatrix self, int MyRow, int NumEntries, double const * Values, int const * Indices) -> int
        InsertMyValues(self, int myRow, PySequence values, PySequence indices) -> int

          Arguments:

            myRow     - local row index
            values    - a sequence of doubles that represent the values to insert
            indices   - a sequence of integers that represent the indices to insert

        InsertMyValues(self, PySequence rows, PySequence cols, PySequence
            values) -> int

          Arguments:

            rows    - a sequence of integers that represent the row indices to insert
            cols    - a sequence of integers that represent the column indices to
                      insert
            values  - a sequence of doubles that represent the values to insert

        """
        return ___init__.CrsMatrix_InsertMyValues(self, *args)

    def ReplaceMyValues(self, *args):
        """
        ReplaceMyValues(CrsMatrix self, int MyRow, int NumEntries, double const * Values, int const * Indices) -> int
        ReplaceMyValues(self, int myRow, PySequence values, PySequence indices) -> int

          Arguments:

            myRow     - local row index
            values    - a sequence of doubles that represent the values to replace
            indices   - a sequence of integers that represent the indices to replace

        ReplaceMyValues(self, PySequence rows, PySequence cols, PySequence
            values) -> int

          Arguments:

            rows    - a sequence of integers that represent the row indices to replace
            cols    - a sequence of integers that represent the column indices to
                      replace
            values  - a sequence of doubles that represent the values to replace

        """
        return ___init__.CrsMatrix_ReplaceMyValues(self, *args)

    def SumIntoMyValues(self, *args):
        """
        SumIntoMyValues(CrsMatrix self, int MyRow, int NumEntries, double const * Values, int const * Indices) -> int
        SumIntoMyValues(self, int myRow, PySequence values, PySequence indices) -> int

          Arguments:

            myRow     - local row index
            values    - a sequence of doubles that represent the values to sum into
            indices   - a sequence of integers that represent the indices to sum into

        SumIntoMyValues(CrsMatrix self, PyObject * Rows, PyObject * Cols, PyObject * Values) -> int
        """
        return ___init__.CrsMatrix_SumIntoMyValues(self, *args)

    def __init__(self, *args): 
        """
        __init__(self, Epetra_DataAccess CV, Map rowMap, int numEntriesPerRow, 
            bool staticProfile=False) -> CrsMatrix

          CrsMatrix constructor with implicit column map and constant number
          of entries per row.  Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - describes distribution of rows across processors
            numEntriesPerRow  - constant number of entries per row
            staticProfile     - static profile flag

        __init__(self, Epetra_DataAccess CV, Map rowMap, Map colMap, int numEntriesPerRow, 
            bool staticProfile=False) -> CrsMatrix

          CrsMatrix constructor with specified column map and constant number
          of entries per row.  Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - describes distribution of rows across processors
            colMap            - describes distribution of columns across processors
            numEntriesPerRow  - constant number of entries per row
            staticProfile     - static profile flag

        __init__(self, Epetra_DataAccess CV, CrsGraph graph) -> CrsMatrix

          CrsMatrix constructor with CrsGraph.  Arguments:

            CV     - Epetra.Copy or Epetra.View
            graph  - CrsGraph describing structure of matrix

        __init__(self, CrsMatrix matrix) -> CrsMatrix

          CrsMatrix copy constructor.  Argument:

            matrix  - source CrsMatrix

        __init__(self, Epetra_DataAccess CV, Map rowMap, PySequence numEntriesPerRow, 
            bool staticProfile=False) -> CrsMatrix

          CrsMatrix constructor with implicit column map and variable number
          of entries per row.  Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - describes distribution of rows across processors
            numEntriesPerRow  - variable number of entries per row
            staticProfile     - static profile flag

        __init__(self, Epetra_DataAccess CV, Map rowMap, Map colMap, PySequence
            numEntriesPerRow, bool staticProfile=False) -> CrsMatrix

          CrsMatrix constructor with specified column map and variable number
          of entries per row.  Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - describes distribution of rows across processors
            colMap            - describes distribution of columns across processors
            numEntriesPerRow  - variable number of entries per row
            staticProfile     - static profile flag

        """
        this = ___init__.new_CrsMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    def ExtractGlobalRowCopy(self, *args):
        """
        ExtractGlobalRowCopy(self, int globalRow) -> (numpy.ndarray,numpy.ndarray)

          Returns a two-tuple of numpy arrays of the same size; the first is
          an array of integers that represent the nonzero columns on the
          matrix; the second is an array of doubles that represent the values
          of the matrix entries.  The input argument is a global row index.
        """
        return ___init__.CrsMatrix_ExtractGlobalRowCopy(self, *args)

    def ExtractMyRowCopy(self, *args):
        """
        ExtractMyRowCopy(self, int myRow) -> (numpy.ndarray,numpy.ndarray)

          Returns a two-tuple of numpy arrays of the same size; the first is
          an array of integers that represent the nonzero columns on the
          matrix; the second is an array of doubles that represent the values
          of the matrix entries.  The input argument is a local row index.
        """
        return ___init__.CrsMatrix_ExtractMyRowCopy(self, *args)

    def __setitem__(self, *args):
        """
        __setitem__(self, PyTuple index, double val)

        The __setitem__() method is called when square-bracket indexing is
        used to set a value of the matrix.  For example, the last line of::

            comm = Epetra.SerialComm()
            m = Epetra.CrsMatrix(9,0,comm)
            m[0,0] = 3.14

        calls::

            m.__setitem__((0,0), 3.14)

        Thus, argument 'index' is a tuple filled with whatever indices you
        give the square-bracket operator when setting.  For __setitem__(),
        this raises an IndexError unless 'index' is a two-tuple of integers.
        Argument 'val' must be convertible to a double.  Under the covers,
        __setitem__() calls ReplaceGlobalValues() or InsertGlobalValues() as
        necessary, so the indices are expected to be global IDs.  Note that if
        you use __setitem__() to insert a new matrix element, you will need to
        call FillComplete() again, whether or not you have called it before.

        """
        return ___init__.CrsMatrix___setitem__(self, *args)

    def __getitem__(self, *args):
        """
        __getitem__(self, PyTuple index) -> double
        __getitem__(self, int row) -> numpy.ndarray

        The __getitem__() method is called when square-bracket indexing is
        used to get a value from the matrix.  For example, the last two lines
        of::

            comm = Epetra.SerialComm()
            m = Epetra.CrsMatrix(9,0,comm)
            m.InsertGlobalValues(0, [0.0, 1.0, 2.0], [0,1,2])
            diag = m[0,0]
            row  = m[0]

        call::

            m.__getitem__((0,0))
            m.__getitem__(0)

        The __getitem__() method behaves according to the following table:

                            FillComplete()    #    
            Index               called      procs  Return value
            --------------  --------------  -----  ---------------------------
            single integer       true        any   numpy array of doubles
            single integer       false        1    numpy array of doubles
            single integer       false       >1    raise IndexError
            two integers         either      any   double

        You should provide global IDs as the integer indices if FillComplete()
        has been called.  If not, you should provide local IDs.  If you
        reference a matrix element that is off-processor, __getitem__() will
        raise an IndexError.

        Under the covers, __getitem__() will call ExtractGlobalRowView() if
        FillComplete() has been called, or ExtractMyRowView() if it has not.
        If either of these return a non-zero return code, this is converted to
        a python RuntimeError.  The resulting data is copied to the output
        array.

        """
        return ___init__.CrsMatrix___getitem__(self, *args)

CrsMatrix_swigregister = ___init__.CrsMatrix_swigregister
CrsMatrix_swigregister(CrsMatrix)

class FECrsMatrix(CrsMatrix):
    """Proxy of C++ Epetra_FECrsMatrix class"""
    __swig_setmethods__ = {}
    for _s in [CrsMatrix]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FECrsMatrix, name, value)
    __swig_getmethods__ = {}
    for _s in [CrsMatrix]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FECrsMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_FECrsMatrix self, Epetra_DataAccess CV, Map RowMap, int * NumEntriesPerRow, bool ignoreNonLocalEntries=False) -> FECrsMatrix
        __init__(Epetra_FECrsMatrix self, Epetra_DataAccess CV, Map RowMap, int NumEntriesPerRow, bool ignoreNonLocalEntries=False) -> FECrsMatrix
        __init__(Epetra_FECrsMatrix self, Epetra_DataAccess CV, Map RowMap, Map ColMap, int * NumEntriesPerRow, bool ignoreNonLocalEntries=False) -> FECrsMatrix
        __init__(Epetra_FECrsMatrix self, Epetra_DataAccess CV, Map RowMap, Map ColMap, int NumEntriesPerRow, bool ignoreNonLocalEntries=False) -> FECrsMatrix
        __init__(Epetra_FECrsMatrix self, Epetra_DataAccess CV, CrsGraph Graph, bool ignoreNonLocalEntries=False) -> FECrsMatrix
        __init__(Epetra_FECrsMatrix self, Epetra_DataAccess CV, Epetra_FECrsGraph const & Graph, bool ignoreNonLocalEntries=False) -> FECrsMatrix
        __init__(Epetra_FECrsMatrix self, FECrsMatrix src) -> FECrsMatrix
        """
        this = ___init__.new_FECrsMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_FECrsMatrix
    ROW_MAJOR = ___init__.FECrsMatrix_ROW_MAJOR
    COLUMN_MAJOR = ___init__.FECrsMatrix_COLUMN_MAJOR
    def GlobalAssemble(self, *args):
        """
        GlobalAssemble(FECrsMatrix self, bool callFillComplete=True, Epetra_CombineMode combineMode=Add, bool save_off_and_reuse_map_exporter=False) -> int
        GlobalAssemble(FECrsMatrix self, Map domain_map, Map range_map, bool callFillComplete=True, Epetra_CombineMode combineMode=Add, 
            bool save_off_and_reuse_map_exporter=False) -> int
        """
        return ___init__.FECrsMatrix_GlobalAssemble(self, *args)

    def setIgnoreNonLocalEntries(self, *args):
        """setIgnoreNonLocalEntries(FECrsMatrix self, bool flag)"""
        return ___init__.FECrsMatrix_setIgnoreNonLocalEntries(self, *args)

    def __setitem__(self, *args):
        """__setitem__(FECrsMatrix self, PyObject * args, double val)"""
        return ___init__.FECrsMatrix___setitem__(self, *args)

    def __getitem__(self, *args):
        """__getitem__(FECrsMatrix self, PyObject * args) -> PyObject *"""
        return ___init__.FECrsMatrix___getitem__(self, *args)

    def InsertGlobalValues(self, *args):
        """InsertGlobalValues(FECrsMatrix self, int const Row, int const Size, Epetra_SerialDenseVector Values, Epetra_IntSerialDenseVector Entries) -> int"""
        return ___init__.FECrsMatrix_InsertGlobalValues(self, *args)

    def InsertGlobalValue(self, *args):
        """InsertGlobalValue(FECrsMatrix self, int i, int j, double val) -> int"""
        return ___init__.FECrsMatrix_InsertGlobalValue(self, *args)

FECrsMatrix_swigregister = ___init__.FECrsMatrix_swigregister
FECrsMatrix_swigregister(FECrsMatrix)

class CrsSingletonFilter(_object):
    """Proxy of C++ Epetra_CrsSingletonFilter class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CrsSingletonFilter, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CrsSingletonFilter, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(Epetra_CrsSingletonFilter self) -> CrsSingletonFilter"""
        this = ___init__.new_CrsSingletonFilter(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_CrsSingletonFilter
    def Analyze(self, *args):
        """Analyze(CrsSingletonFilter self, RowMatrix FullMatrix) -> int"""
        return ___init__.CrsSingletonFilter_Analyze(self, *args)

    def SingletonsDetected(self, *args):
        """SingletonsDetected(CrsSingletonFilter self) -> bool"""
        return ___init__.CrsSingletonFilter_SingletonsDetected(self, *args)

    def ConstructReducedProblem(self, *args):
        """ConstructReducedProblem(CrsSingletonFilter self, LinearProblem Problem) -> int"""
        return ___init__.CrsSingletonFilter_ConstructReducedProblem(self, *args)

    def UpdateReducedProblem(self, *args):
        """UpdateReducedProblem(CrsSingletonFilter self, LinearProblem Problem) -> int"""
        return ___init__.CrsSingletonFilter_UpdateReducedProblem(self, *args)

    def ComputeFullSolution(self, *args):
        """ComputeFullSolution(CrsSingletonFilter self) -> int"""
        return ___init__.CrsSingletonFilter_ComputeFullSolution(self, *args)

    def NumRowSingletons(self, *args):
        """NumRowSingletons(CrsSingletonFilter self) -> int"""
        return ___init__.CrsSingletonFilter_NumRowSingletons(self, *args)

    def NumColSingletons(self, *args):
        """NumColSingletons(CrsSingletonFilter self) -> int"""
        return ___init__.CrsSingletonFilter_NumColSingletons(self, *args)

    def NumSingletons(self, *args):
        """NumSingletons(CrsSingletonFilter self) -> int"""
        return ___init__.CrsSingletonFilter_NumSingletons(self, *args)

    def RatioOfDimensions(self, *args):
        """RatioOfDimensions(CrsSingletonFilter self) -> double"""
        return ___init__.CrsSingletonFilter_RatioOfDimensions(self, *args)

    def RatioOfNonzeros(self, *args):
        """RatioOfNonzeros(CrsSingletonFilter self) -> double"""
        return ___init__.CrsSingletonFilter_RatioOfNonzeros(self, *args)

    def FullProblem(self, *args):
        """FullProblem(CrsSingletonFilter self) -> LinearProblem"""
        return ___init__.CrsSingletonFilter_FullProblem(self, *args)

    def ReducedProblem(self, *args):
        """ReducedProblem(CrsSingletonFilter self) -> LinearProblem"""
        return ___init__.CrsSingletonFilter_ReducedProblem(self, *args)

    def FullMatrix(self, *args):
        """FullMatrix(CrsSingletonFilter self) -> RowMatrix"""
        return ___init__.CrsSingletonFilter_FullMatrix(self, *args)

    def ReducedMatrix(self, *args):
        """ReducedMatrix(CrsSingletonFilter self) -> CrsMatrix"""
        return ___init__.CrsSingletonFilter_ReducedMatrix(self, *args)

    def RowMapColors(self, *args):
        """RowMapColors(CrsSingletonFilter self) -> MapColoring"""
        return ___init__.CrsSingletonFilter_RowMapColors(self, *args)

    def ColMapColors(self, *args):
        """ColMapColors(CrsSingletonFilter self) -> MapColoring"""
        return ___init__.CrsSingletonFilter_ColMapColors(self, *args)

    def ReducedMatrixRowMap(self, *args):
        """ReducedMatrixRowMap(CrsSingletonFilter self) -> Map"""
        return ___init__.CrsSingletonFilter_ReducedMatrixRowMap(self, *args)

    def ReducedMatrixColMap(self, *args):
        """ReducedMatrixColMap(CrsSingletonFilter self) -> Map"""
        return ___init__.CrsSingletonFilter_ReducedMatrixColMap(self, *args)

    def ReducedMatrixDomainMap(self, *args):
        """ReducedMatrixDomainMap(CrsSingletonFilter self) -> Map"""
        return ___init__.CrsSingletonFilter_ReducedMatrixDomainMap(self, *args)

    def ReducedMatrixRangeMap(self, *args):
        """ReducedMatrixRangeMap(CrsSingletonFilter self) -> Map"""
        return ___init__.CrsSingletonFilter_ReducedMatrixRangeMap(self, *args)

CrsSingletonFilter_swigregister = ___init__.CrsSingletonFilter_swigregister
CrsSingletonFilter_swigregister(CrsSingletonFilter)

class VbrMatrix(DistObject,CompObject,BLAS,RowMatrix):
    """Proxy of C++ Epetra_VbrMatrix class"""
    __swig_setmethods__ = {}
    for _s in [DistObject,CompObject,BLAS,RowMatrix]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, VbrMatrix, name, value)
    __swig_getmethods__ = {}
    for _s in [DistObject,CompObject,BLAS,RowMatrix]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, VbrMatrix, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_VbrMatrix
    def PutScalar(self, *args):
        """PutScalar(VbrMatrix self, double ScalarConstant) -> int"""
        return ___init__.VbrMatrix_PutScalar(self, *args)

    def Scale(self, *args):
        """Scale(VbrMatrix self, double ScalarConstant) -> int"""
        return ___init__.VbrMatrix_Scale(self, *args)

    def DirectSubmitBlockEntry(self, *args):
        """
        DirectSubmitBlockEntry(VbrMatrix self, int GlobalBlockRow, int GlobalBlockCol, double const * values, int LDA, int NumRows, 
            int NumCols, bool sum_into) -> int
        """
        return ___init__.VbrMatrix_DirectSubmitBlockEntry(self, *args)

    def BeginInsertGlobalValues(self, *args):
        """BeginInsertGlobalValues(VbrMatrix self, int BlockRow, int NumBlockEntries) -> int"""
        return ___init__.VbrMatrix_BeginInsertGlobalValues(self, *args)

    def BeginInsertMyValues(self, *args):
        """BeginInsertMyValues(VbrMatrix self, int BlockRow, int NumBlockEntries) -> int"""
        return ___init__.VbrMatrix_BeginInsertMyValues(self, *args)

    def BeginReplaceGlobalValues(self, *args):
        """BeginReplaceGlobalValues(VbrMatrix self, int BlockRow, int NumBlockEntries) -> int"""
        return ___init__.VbrMatrix_BeginReplaceGlobalValues(self, *args)

    def BeginReplaceMyValues(self, *args):
        """BeginReplaceMyValues(VbrMatrix self, int BlockRow, int NumBlockEntries) -> int"""
        return ___init__.VbrMatrix_BeginReplaceMyValues(self, *args)

    def BeginSumIntoGlobalValues(self, *args):
        """BeginSumIntoGlobalValues(VbrMatrix self, int BlockRow, int NumBlockEntries) -> int"""
        return ___init__.VbrMatrix_BeginSumIntoGlobalValues(self, *args)

    def BeginSumIntoMyValues(self, *args):
        """BeginSumIntoMyValues(VbrMatrix self, int BlockRow, int NumBlockEntries) -> int"""
        return ___init__.VbrMatrix_BeginSumIntoMyValues(self, *args)

    def SubmitBlockEntry(self, *args):
        """
        SubmitBlockEntry(VbrMatrix self, double * Values, int LDA, int NumRows, int NumCols) -> int
        SubmitBlockEntry(VbrMatrix self, Epetra_SerialDenseMatrix Mat) -> int
        """
        return ___init__.VbrMatrix_SubmitBlockEntry(self, *args)

    def EndSubmitEntries(self, *args):
        """EndSubmitEntries(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_EndSubmitEntries(self, *args)

    def ReplaceDiagonalValues(self, *args):
        """ReplaceDiagonalValues(VbrMatrix self, Epetra_Vector Diagonal) -> int"""
        return ___init__.VbrMatrix_ReplaceDiagonalValues(self, *args)

    def FillComplete(self, *args):
        """
        FillComplete(VbrMatrix self) -> int
        FillComplete(VbrMatrix self, BlockMap DomainMap, BlockMap RangeMap) -> int
        """
        return ___init__.VbrMatrix_FillComplete(self, *args)

    def Filled(self, *args):
        """Filled(VbrMatrix self) -> bool"""
        return ___init__.VbrMatrix_Filled(self, *args)

    def ExtractGlobalBlockRowPointers(self, *args):
        """
        ExtractGlobalBlockRowPointers(VbrMatrix self, int BlockRow, int MaxNumBlockEntries, int & RowDim, int & NumBlockEntries, int * BlockIndices, 
            Epetra_SerialDenseMatrix **& Values) -> int
        """
        return ___init__.VbrMatrix_ExtractGlobalBlockRowPointers(self, *args)

    def ExtractMyBlockRowPointers(self, *args):
        """
        ExtractMyBlockRowPointers(VbrMatrix self, int BlockRow, int MaxNumBlockEntries, int & RowDim, int & NumBlockEntries, int * BlockIndices, 
            Epetra_SerialDenseMatrix **& Values) -> int
        """
        return ___init__.VbrMatrix_ExtractMyBlockRowPointers(self, *args)

    def BeginExtractGlobalBlockRowCopy(self, *args):
        """
        BeginExtractGlobalBlockRowCopy(VbrMatrix self, int BlockRow, int MaxNumBlockEntries, int & RowDim, int & NumBlockEntries, int * BlockIndices, 
            int * ColDims) -> int
        """
        return ___init__.VbrMatrix_BeginExtractGlobalBlockRowCopy(self, *args)

    def BeginExtractMyBlockRowCopy(self, *args):
        """
        BeginExtractMyBlockRowCopy(VbrMatrix self, int BlockRow, int MaxNumBlockEntries, int & RowDim, int & NumBlockEntries, int * BlockIndices, 
            int * ColDims) -> int
        """
        return ___init__.VbrMatrix_BeginExtractMyBlockRowCopy(self, *args)

    def ExtractEntryCopy(self, *args):
        """ExtractEntryCopy(VbrMatrix self, int SizeOfValues, double * Values, int LDA, bool SumInto) -> int"""
        return ___init__.VbrMatrix_ExtractEntryCopy(self, *args)

    def BeginExtractGlobalBlockRowView(self, *args):
        """BeginExtractGlobalBlockRowView(VbrMatrix self, int BlockRow, int & RowDim, int & NumBlockEntries, int *& BlockIndices) -> int"""
        return ___init__.VbrMatrix_BeginExtractGlobalBlockRowView(self, *args)

    def BeginExtractMyBlockRowView(self, *args):
        """BeginExtractMyBlockRowView(VbrMatrix self, int BlockRow, int & RowDim, int & NumBlockEntries, int *& BlockIndices) -> int"""
        return ___init__.VbrMatrix_BeginExtractMyBlockRowView(self, *args)

    def ExtractEntryView(self, *args):
        """ExtractEntryView(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_ExtractEntryView(self, *args)

    def ExtractGlobalBlockRowView(self, *args):
        """ExtractGlobalBlockRowView(VbrMatrix self, int BlockRow, int & RowDim, int & NumBlockEntries, int *& BlockIndices, Epetra_SerialDenseMatrix **& Values) -> int"""
        return ___init__.VbrMatrix_ExtractGlobalBlockRowView(self, *args)

    def ExtractMyBlockRowView(self, *args):
        """ExtractMyBlockRowView(VbrMatrix self, int BlockRow, int & RowDim, int & NumBlockEntries, int *& BlockIndices, Epetra_SerialDenseMatrix **& Values) -> int"""
        return ___init__.VbrMatrix_ExtractMyBlockRowView(self, *args)

    def ExtractDiagonalCopy(self, *args):
        """
        ExtractDiagonalCopy(Vector diagonal) -> int

        Argument diagonal is provided to you as a numpy-hybrid Epetra.Vector,
        giving you access to the numpy interface in addition to the
        Epetra_Vector C++ interface.
        """
        return ___init__.VbrMatrix_ExtractDiagonalCopy(self, *args)

    def BeginExtractBlockDiagonalCopy(self, *args):
        """BeginExtractBlockDiagonalCopy(VbrMatrix self, int MaxNumBlockDiagonalEntries, int & NumBlockDiagonalEntries, int * RowColDims) -> int"""
        return ___init__.VbrMatrix_BeginExtractBlockDiagonalCopy(self, *args)

    def ExtractBlockDiagonalEntryCopy(self, *args):
        """ExtractBlockDiagonalEntryCopy(VbrMatrix self, int SizeOfValues, double * Values, int LDA, bool SumInto) -> int"""
        return ___init__.VbrMatrix_ExtractBlockDiagonalEntryCopy(self, *args)

    def BeginExtractBlockDiagonalView(self, *args):
        """BeginExtractBlockDiagonalView(VbrMatrix self, int & NumBlockDiagonalEntries, int *& RowColDims) -> int"""
        return ___init__.VbrMatrix_BeginExtractBlockDiagonalView(self, *args)

    def ExtractBlockDiagonalEntryView(self, *args):
        """ExtractBlockDiagonalEntryView(VbrMatrix self, double *& Values, int & LDA) -> int"""
        return ___init__.VbrMatrix_ExtractBlockDiagonalEntryView(self, *args)

    def Multiply1(self, *args):
        """Multiply1(VbrMatrix self, bool TransA, Epetra_Vector x, Epetra_Vector y) -> int"""
        return ___init__.VbrMatrix_Multiply1(self, *args)

    def Multiply(self, *args):
        """
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.VbrMatrix_Multiply(self, *args)

    def Solve(self, *args):
        """
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.VbrMatrix_Solve(self, *args)

    def InvRowSums(self, *args):
        """
        InvRowSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.VbrMatrix_InvRowSums(self, *args)

    def LeftScale(self, *args):
        """
        LeftScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.VbrMatrix_LeftScale(self, *args)

    def InvColSums(self, *args):
        """
        InvColSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.VbrMatrix_InvColSums(self, *args)

    def RightScale(self, *args):
        """
        RightScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.VbrMatrix_RightScale(self, *args)

    def OptimizeStorage(self, *args):
        """OptimizeStorage(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_OptimizeStorage(self, *args)

    def StorageOptimized(self, *args):
        """StorageOptimized(VbrMatrix self) -> bool"""
        return ___init__.VbrMatrix_StorageOptimized(self, *args)

    def IndicesAreGlobal(self, *args):
        """IndicesAreGlobal(VbrMatrix self) -> bool"""
        return ___init__.VbrMatrix_IndicesAreGlobal(self, *args)

    def IndicesAreLocal(self, *args):
        """IndicesAreLocal(VbrMatrix self) -> bool"""
        return ___init__.VbrMatrix_IndicesAreLocal(self, *args)

    def IndicesAreContiguous(self, *args):
        """IndicesAreContiguous(VbrMatrix self) -> bool"""
        return ___init__.VbrMatrix_IndicesAreContiguous(self, *args)

    def LowerTriangular(self, *args):
        """LowerTriangular(VbrMatrix self) -> bool"""
        return ___init__.VbrMatrix_LowerTriangular(self, *args)

    def UpperTriangular(self, *args):
        """UpperTriangular(VbrMatrix self) -> bool"""
        return ___init__.VbrMatrix_UpperTriangular(self, *args)

    def NoDiagonal(self, *args):
        """NoDiagonal(VbrMatrix self) -> bool"""
        return ___init__.VbrMatrix_NoDiagonal(self, *args)

    def NormInf(self, *args):
        """NormInf(VbrMatrix self) -> double"""
        return ___init__.VbrMatrix_NormInf(self, *args)

    def NormOne(self, *args):
        """NormOne(VbrMatrix self) -> double"""
        return ___init__.VbrMatrix_NormOne(self, *args)

    def NormFrobenius(self, *args):
        """NormFrobenius(VbrMatrix self) -> double"""
        return ___init__.VbrMatrix_NormFrobenius(self, *args)

    def MaxRowDim(self, *args):
        """MaxRowDim(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_MaxRowDim(self, *args)

    def MaxColDim(self, *args):
        """MaxColDim(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_MaxColDim(self, *args)

    def GlobalMaxRowDim(self, *args):
        """GlobalMaxRowDim(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_GlobalMaxRowDim(self, *args)

    def GlobalMaxColDim(self, *args):
        """GlobalMaxColDim(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_GlobalMaxColDim(self, *args)

    def NumMyRows(self, *args):
        """NumMyRows(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_NumMyRows(self, *args)

    def NumMyCols(self, *args):
        """NumMyCols(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_NumMyCols(self, *args)

    def NumMyNonzeros(self, *args):
        """NumMyNonzeros(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_NumMyNonzeros(self, *args)

    def NumGlobalRows(self, *args):
        """NumGlobalRows(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_NumGlobalRows(self, *args)

    def NumGlobalRows64(self, *args):
        """NumGlobalRows64(VbrMatrix self) -> long long"""
        return ___init__.VbrMatrix_NumGlobalRows64(self, *args)

    def NumGlobalCols(self, *args):
        """NumGlobalCols(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_NumGlobalCols(self, *args)

    def NumGlobalCols64(self, *args):
        """NumGlobalCols64(VbrMatrix self) -> long long"""
        return ___init__.VbrMatrix_NumGlobalCols64(self, *args)

    def NumGlobalNonzeros(self, *args):
        """NumGlobalNonzeros(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_NumGlobalNonzeros(self, *args)

    def NumGlobalNonzeros64(self, *args):
        """NumGlobalNonzeros64(VbrMatrix self) -> long long"""
        return ___init__.VbrMatrix_NumGlobalNonzeros64(self, *args)

    def NumMyBlockRows(self, *args):
        """NumMyBlockRows(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_NumMyBlockRows(self, *args)

    def NumMyBlockCols(self, *args):
        """NumMyBlockCols(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_NumMyBlockCols(self, *args)

    def NumMyBlockDiagonals(self, *args):
        """NumMyBlockDiagonals(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_NumMyBlockDiagonals(self, *args)

    def NumMyDiagonals(self, *args):
        """NumMyDiagonals(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_NumMyDiagonals(self, *args)

    def NumGlobalBlockRows(self, *args):
        """NumGlobalBlockRows(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_NumGlobalBlockRows(self, *args)

    def NumGlobalBlockRows64(self, *args):
        """NumGlobalBlockRows64(VbrMatrix self) -> long long"""
        return ___init__.VbrMatrix_NumGlobalBlockRows64(self, *args)

    def NumGlobalBlockCols(self, *args):
        """NumGlobalBlockCols(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_NumGlobalBlockCols(self, *args)

    def NumGlobalBlockCols64(self, *args):
        """NumGlobalBlockCols64(VbrMatrix self) -> long long"""
        return ___init__.VbrMatrix_NumGlobalBlockCols64(self, *args)

    def NumGlobalBlockEntries64(self, *args):
        """NumGlobalBlockEntries64(VbrMatrix self) -> long long"""
        return ___init__.VbrMatrix_NumGlobalBlockEntries64(self, *args)

    def NumGlobalBlockDiagonals(self, *args):
        """NumGlobalBlockDiagonals(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_NumGlobalBlockDiagonals(self, *args)

    def NumGlobalBlockDiagonals64(self, *args):
        """NumGlobalBlockDiagonals64(VbrMatrix self) -> long long"""
        return ___init__.VbrMatrix_NumGlobalBlockDiagonals64(self, *args)

    def NumGlobalDiagonals(self, *args):
        """NumGlobalDiagonals(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_NumGlobalDiagonals(self, *args)

    def NumGlobalDiagonals64(self, *args):
        """NumGlobalDiagonals64(VbrMatrix self) -> long long"""
        return ___init__.VbrMatrix_NumGlobalDiagonals64(self, *args)

    def NumGlobalBlockEntries(self, *args):
        """
        NumGlobalBlockEntries(VbrMatrix self) -> int
        NumGlobalBlockEntries(VbrMatrix self, int Row) -> int
        """
        return ___init__.VbrMatrix_NumGlobalBlockEntries(self, *args)

    def NumAllocatedGlobalBlockEntries(self, *args):
        """NumAllocatedGlobalBlockEntries(VbrMatrix self, int Row) -> int"""
        return ___init__.VbrMatrix_NumAllocatedGlobalBlockEntries(self, *args)

    def MaxNumBlockEntries(self, *args):
        """MaxNumBlockEntries(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_MaxNumBlockEntries(self, *args)

    def GlobalMaxNumBlockEntries(self, *args):
        """GlobalMaxNumBlockEntries(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_GlobalMaxNumBlockEntries(self, *args)

    def NumMyBlockEntries(self, *args):
        """
        NumMyBlockEntries(VbrMatrix self) -> int
        NumMyBlockEntries(VbrMatrix self, int Row) -> int
        """
        return ___init__.VbrMatrix_NumMyBlockEntries(self, *args)

    def NumAllocatedMyBlockEntries(self, *args):
        """NumAllocatedMyBlockEntries(VbrMatrix self, int Row) -> int"""
        return ___init__.VbrMatrix_NumAllocatedMyBlockEntries(self, *args)

    def MaxNumNonzeros(self, *args):
        """MaxNumNonzeros(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_MaxNumNonzeros(self, *args)

    def GlobalMaxNumNonzeros(self, *args):
        """GlobalMaxNumNonzeros(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_GlobalMaxNumNonzeros(self, *args)

    def IndexBase(self, *args):
        """IndexBase(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_IndexBase(self, *args)

    def Graph(self, *args):
        """Graph(VbrMatrix self) -> CrsGraph"""
        return ___init__.VbrMatrix_Graph(self, *args)

    def Importer(self, *args):
        """Importer(VbrMatrix self) -> Import"""
        return ___init__.VbrMatrix_Importer(self, *args)

    def Exporter(self, *args):
        """Exporter(VbrMatrix self) -> Export"""
        return ___init__.VbrMatrix_Exporter(self, *args)

    def DomainMap(self, *args):
        """DomainMap(VbrMatrix self) -> BlockMap"""
        return ___init__.VbrMatrix_DomainMap(self, *args)

    def RangeMap(self, *args):
        """RangeMap(VbrMatrix self) -> BlockMap"""
        return ___init__.VbrMatrix_RangeMap(self, *args)

    def RowMap(self, *args):
        """RowMap(VbrMatrix self) -> BlockMap"""
        return ___init__.VbrMatrix_RowMap(self, *args)

    def ColMap(self, *args):
        """ColMap(VbrMatrix self) -> BlockMap"""
        return ___init__.VbrMatrix_ColMap(self, *args)

    def Comm(self, *args):
        """Comm(VbrMatrix self) -> Comm"""
        return ___init__.VbrMatrix_Comm(self, *args)

    def LRID(self, *args):
        """
        LRID(VbrMatrix self, int GRID_in) -> int
        LRID(VbrMatrix self, long long GRID_in) -> int
        """
        return ___init__.VbrMatrix_LRID(self, *args)

    def GRID(self, *args):
        """GRID(VbrMatrix self, int LRID_in) -> int"""
        return ___init__.VbrMatrix_GRID(self, *args)

    def GRID64(self, *args):
        """GRID64(VbrMatrix self, int LRID_in) -> long long"""
        return ___init__.VbrMatrix_GRID64(self, *args)

    def LCID(self, *args):
        """
        LCID(VbrMatrix self, int GCID_in) -> int
        LCID(VbrMatrix self, long long GCID_in) -> int
        """
        return ___init__.VbrMatrix_LCID(self, *args)

    def GCID(self, *args):
        """GCID(VbrMatrix self, int LCID_in) -> int"""
        return ___init__.VbrMatrix_GCID(self, *args)

    def GCID64(self, *args):
        """GCID64(VbrMatrix self, int LCID_in) -> long long"""
        return ___init__.VbrMatrix_GCID64(self, *args)

    def MyGRID(self, *args):
        """
        MyGRID(VbrMatrix self, int GRID_in) -> bool
        MyGRID(VbrMatrix self, long long GRID_in) -> bool
        """
        return ___init__.VbrMatrix_MyGRID(self, *args)

    def MyLRID(self, *args):
        """MyLRID(VbrMatrix self, int LRID_in) -> bool"""
        return ___init__.VbrMatrix_MyLRID(self, *args)

    def MyGCID(self, *args):
        """
        MyGCID(VbrMatrix self, int GCID_in) -> bool
        MyGCID(VbrMatrix self, long long GCID_in) -> bool
        """
        return ___init__.VbrMatrix_MyGCID(self, *args)

    def MyLCID(self, *args):
        """MyLCID(VbrMatrix self, int LCID_in) -> bool"""
        return ___init__.VbrMatrix_MyLCID(self, *args)

    def MyGlobalBlockRow(self, *args):
        """
        MyGlobalBlockRow(VbrMatrix self, int GID) -> bool
        MyGlobalBlockRow(VbrMatrix self, long long GID) -> bool
        """
        return ___init__.VbrMatrix_MyGlobalBlockRow(self, *args)

    def Label(self, *args):
        """Label(VbrMatrix self) -> char const *"""
        return ___init__.VbrMatrix_Label(self, *args)

    def SetUseTranspose(self, *args):
        """SetUseTranspose(VbrMatrix self, bool UseTranspose_in) -> int"""
        return ___init__.VbrMatrix_SetUseTranspose(self, *args)

    def Apply(self, *args):
        """
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return ___init__.VbrMatrix_Apply(self, *args)

    def ApplyInverse(self, *args):
        """
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return ___init__.VbrMatrix_ApplyInverse(self, *args)

    def HasNormInf(self, *args):
        """HasNormInf(VbrMatrix self) -> bool"""
        return ___init__.VbrMatrix_HasNormInf(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(VbrMatrix self) -> bool"""
        return ___init__.VbrMatrix_UseTranspose(self, *args)

    def OperatorDomainMap(self, *args):
        """OperatorDomainMap(VbrMatrix self) -> Map"""
        return ___init__.VbrMatrix_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        """OperatorRangeMap(VbrMatrix self) -> Map"""
        return ___init__.VbrMatrix_OperatorRangeMap(self, *args)

    def ExtractGlobalRowCopy(self, *args):
        """ExtractGlobalRowCopy(VbrMatrix self, int GlobalRow, int Length, int & NumEntries, double * Values, int * Indices) -> int"""
        return ___init__.VbrMatrix_ExtractGlobalRowCopy(self, *args)

    def ExtractMyRowCopy(self, *args):
        """
        ExtractMyRowCopy(int myRow, int length, numpy.ndarray numEntries,
            numpy.ndarray values, numpy.ndarray indices) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....

        Arguments values and indices are double* and int*, respectively, in
        C++.  In python, these are provided to you as numpy arrays of the
        given length, so that you may alter their entries in-place.
        """
        return ___init__.VbrMatrix_ExtractMyRowCopy(self, *args)

    def NumMyRowEntries(self, *args):
        """
        NumMyRowEntries(int myRow, numpy.ndarray numEntries) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....
        """
        return ___init__.VbrMatrix_NumMyRowEntries(self, *args)

    def MaxNumEntries(self, *args):
        """MaxNumEntries(VbrMatrix self) -> int"""
        return ___init__.VbrMatrix_MaxNumEntries(self, *args)

    def Map(self, *args):
        """Map(VbrMatrix self) -> BlockMap"""
        return ___init__.VbrMatrix_Map(self, *args)

    def RowMatrixRowMap(self, *args):
        """RowMatrixRowMap(VbrMatrix self) -> Map"""
        return ___init__.VbrMatrix_RowMatrixRowMap(self, *args)

    def RowMatrixColMap(self, *args):
        """RowMatrixColMap(VbrMatrix self) -> Map"""
        return ___init__.VbrMatrix_RowMatrixColMap(self, *args)

    def RowMatrixImporter(self, *args):
        """RowMatrixImporter(VbrMatrix self) -> Import"""
        return ___init__.VbrMatrix_RowMatrixImporter(self, *args)

    def BlockImportMap(self, *args):
        """BlockImportMap(VbrMatrix self) -> BlockMap"""
        return ___init__.VbrMatrix_BlockImportMap(self, *args)

    def TransformToLocal(self, *args):
        """
        TransformToLocal(VbrMatrix self) -> int
        TransformToLocal(VbrMatrix self, BlockMap DomainMap, BlockMap RangeMap) -> int
        """
        return ___init__.VbrMatrix_TransformToLocal(self, *args)

    def __init__(self, *args): 
        """
        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, int
            numBlockEntriesPerRow) -> VbrMatrix

          VbrMatrix constructor with implicit column map and constant number
          of block entries per row.


        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, BlockMap colMap,
            int numBlockEntriesPerRow) -> VbrMatrix

          VbrMatrix constructor with specified column map and constant number
          of block entries per row.



        __init__(self, Epetra_DataAccess CV, CrsGraph graph) -> VbrMatrix

          CrsGraph constructor.


        __init__(self, VbrMatrix matrix) -> VbrMatrix

          Copy constructor.


        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, PySequence
            numBlockEntriesPerRow) -> VbrMatrix

          VbrMatrix constructor with implicit column map and variable number
          of block entries per row.



        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, BlockMap colMap,
            PySequence numBlockEntriesPerRow) -> VbrMatrix

          VbrMatrix constructor with specified column map and variable number
          of block entries per row.


        """
        this = ___init__.new_VbrMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
VbrMatrix_swigregister = ___init__.VbrMatrix_swigregister
VbrMatrix_swigregister(VbrMatrix)

class FEVbrMatrix(VbrMatrix):
    """Proxy of C++ Epetra_FEVbrMatrix class"""
    __swig_setmethods__ = {}
    for _s in [VbrMatrix]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FEVbrMatrix, name, value)
    __swig_getmethods__ = {}
    for _s in [VbrMatrix]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FEVbrMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_FEVbrMatrix self, Epetra_DataAccess CV, BlockMap RowMap, int * NumBlockEntriesPerRow, bool ignoreNonLocalEntries=False) -> FEVbrMatrix
        __init__(Epetra_FEVbrMatrix self, Epetra_DataAccess CV, BlockMap RowMap, int NumBlockEntriesPerRow, bool ignoreNonLocalEntries=False) -> FEVbrMatrix
        __init__(Epetra_FEVbrMatrix self, Epetra_DataAccess CV, BlockMap RowMap, BlockMap ColMap, int * NumBlockEntriesPerRow, 
            bool ignoreNonLocalEntries=False) -> FEVbrMatrix
        __init__(Epetra_FEVbrMatrix self, Epetra_DataAccess CV, BlockMap RowMap, BlockMap ColMap, int NumBlockEntriesPerRow, 
            bool ignoreNonLocalEntries=False) -> FEVbrMatrix
        __init__(Epetra_FEVbrMatrix self, Epetra_DataAccess CV, CrsGraph Graph, bool ignoreNonLocalEntries=False) -> FEVbrMatrix
        __init__(Epetra_FEVbrMatrix self, FEVbrMatrix src) -> FEVbrMatrix
        """
        this = ___init__.new_FEVbrMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_FEVbrMatrix
    def PutScalar(self, *args):
        """PutScalar(FEVbrMatrix self, double ScalarConstant) -> int"""
        return ___init__.FEVbrMatrix_PutScalar(self, *args)

    def BeginInsertGlobalValues(self, *args):
        """BeginInsertGlobalValues(FEVbrMatrix self, int BlockRow, int NumBlockEntries, int * BlockIndices) -> int"""
        return ___init__.FEVbrMatrix_BeginInsertGlobalValues(self, *args)

    def BeginReplaceGlobalValues(self, *args):
        """BeginReplaceGlobalValues(FEVbrMatrix self, int BlockRow, int NumBlockEntries, int * BlockIndices) -> int"""
        return ___init__.FEVbrMatrix_BeginReplaceGlobalValues(self, *args)

    def BeginSumIntoGlobalValues(self, *args):
        """BeginSumIntoGlobalValues(FEVbrMatrix self, int BlockRow, int NumBlockEntries, int * BlockIndices) -> int"""
        return ___init__.FEVbrMatrix_BeginSumIntoGlobalValues(self, *args)

    def SubmitBlockEntry(self, *args):
        """
        SubmitBlockEntry(FEVbrMatrix self, Epetra_SerialDenseMatrix Mat) -> int
        SubmitBlockEntry(FEVbrMatrix self, double * Values, int LDA, int NumRows, int NumCols) -> int
        """
        return ___init__.FEVbrMatrix_SubmitBlockEntry(self, *args)

    def EndSubmitEntries(self, *args):
        """EndSubmitEntries(FEVbrMatrix self) -> int"""
        return ___init__.FEVbrMatrix_EndSubmitEntries(self, *args)

    def GlobalAssemble(self, *args):
        """GlobalAssemble(FEVbrMatrix self, bool callFillComplete=True) -> int"""
        return ___init__.FEVbrMatrix_GlobalAssemble(self, *args)

FEVbrMatrix_swigregister = ___init__.FEVbrMatrix_swigregister
FEVbrMatrix_swigregister(FEVbrMatrix)

class JadMatrix(BasicRowMatrix):
    """Proxy of C++ Epetra_JadMatrix class"""
    __swig_setmethods__ = {}
    for _s in [BasicRowMatrix]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, JadMatrix, name, value)
    __swig_getmethods__ = {}
    for _s in [BasicRowMatrix]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, JadMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(Epetra_JadMatrix self, RowMatrix Matrix) -> JadMatrix"""
        this = ___init__.new_JadMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_JadMatrix
    def UpdateValues(self, *args):
        """UpdateValues(JadMatrix self, RowMatrix Matrix, bool CheckStructure=False) -> int"""
        return ___init__.JadMatrix_UpdateValues(self, *args)

    def ExtractMyRowCopy(self, *args):
        """
        ExtractMyRowCopy(int myRow, int length, numpy.ndarray numEntries,
            numpy.ndarray values, numpy.ndarray indices) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....

        Arguments values and indices are double* and int*, respectively, in
        C++.  In python, these are provided to you as numpy arrays of the
        given length, so that you may alter their entries in-place.
        """
        return ___init__.JadMatrix_ExtractMyRowCopy(self, *args)

    def NumMyRowEntries(self, *args):
        """
        NumMyRowEntries(int myRow, numpy.ndarray numEntries) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....
        """
        return ___init__.JadMatrix_NumMyRowEntries(self, *args)

    def Multiply(self, *args):
        """
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.JadMatrix_Multiply(self, *args)

    def Solve(self, *args):
        """
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.JadMatrix_Solve(self, *args)

JadMatrix_swigregister = ___init__.JadMatrix_swigregister
JadMatrix_swigregister(JadMatrix)

easy = ___init__.easy
moderate = ___init__.moderate
hard = ___init__.hard
unsure = ___init__.unsure
class LinearProblem(_object):
    """Proxy of C++ Epetra_LinearProblem class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearProblem, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LinearProblem, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_LinearProblem self) -> LinearProblem
        __init__(Epetra_LinearProblem self, RowMatrix A, Epetra_MultiVector X, Epetra_MultiVector B) -> LinearProblem
        __init__(Epetra_LinearProblem self, Operator A, Epetra_MultiVector X, Epetra_MultiVector B) -> LinearProblem
        __init__(Epetra_LinearProblem self, LinearProblem Problem) -> LinearProblem
        """
        this = ___init__.new_LinearProblem(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_LinearProblem
    def CheckInput(self, *args):
        """CheckInput(LinearProblem self) -> int"""
        return ___init__.LinearProblem_CheckInput(self, *args)

    def AssertSymmetric(self, *args):
        """AssertSymmetric(LinearProblem self)"""
        return ___init__.LinearProblem_AssertSymmetric(self, *args)

    def SetPDL(self, *args):
        """SetPDL(LinearProblem self, ProblemDifficultyLevel PDL)"""
        return ___init__.LinearProblem_SetPDL(self, *args)

    def SetOperator(self, *args):
        """
        SetOperator(LinearProblem self, RowMatrix A)
        SetOperator(LinearProblem self, Operator A)
        """
        return ___init__.LinearProblem_SetOperator(self, *args)

    def SetLHS(self, *args):
        """SetLHS(LinearProblem self, Epetra_MultiVector X)"""
        return ___init__.LinearProblem_SetLHS(self, *args)

    def SetRHS(self, *args):
        """SetRHS(LinearProblem self, Epetra_MultiVector B)"""
        return ___init__.LinearProblem_SetRHS(self, *args)

    def LeftScale(self, *args):
        """LeftScale(LinearProblem self, Epetra_Vector D) -> int"""
        return ___init__.LinearProblem_LeftScale(self, *args)

    def RightScale(self, *args):
        """RightScale(LinearProblem self, Epetra_Vector D) -> int"""
        return ___init__.LinearProblem_RightScale(self, *args)

    def GetOperator(self, *args):
        """GetOperator(LinearProblem self) -> Operator"""
        return ___init__.LinearProblem_GetOperator(self, *args)

    def GetMatrix(self, *args):
        """GetMatrix(LinearProblem self) -> RowMatrix"""
        return ___init__.LinearProblem_GetMatrix(self, *args)

    def GetLHS(self, *args):
        """GetLHS(LinearProblem self) -> Epetra_MultiVector"""
        return ___init__.LinearProblem_GetLHS(self, *args)

    def GetRHS(self, *args):
        """GetRHS(LinearProblem self) -> Epetra_MultiVector"""
        return ___init__.LinearProblem_GetRHS(self, *args)

    def GetPDL(self, *args):
        """GetPDL(LinearProblem self) -> ProblemDifficultyLevel"""
        return ___init__.LinearProblem_GetPDL(self, *args)

    def IsOperatorSymmetric(self, *args):
        """IsOperatorSymmetric(LinearProblem self) -> bool"""
        return ___init__.LinearProblem_IsOperatorSymmetric(self, *args)

LinearProblem_swigregister = ___init__.LinearProblem_swigregister
LinearProblem_swigregister(LinearProblem)

class Util(_object):
    """
    Epetra Util Wrapper Class.

    The Epetra.Util class is a collection of useful functions that cut
    across a broad set of other classes.  A random number generator is
    provided, along with methods to set and retrieve the random-number
    seed.

    The random number generator is a multiplicative linear congruential
    generator, with multiplier 16807 and modulus 2^31 - 1. It is based on
    the algorithm described in 'Random Number Generators: Good Ones Are
    Hard To Find', S. K. Park and K. W. Miller, Communications of the ACM,
    vol. 31, no. 10, pp. 1192-1201.

    The C++ Sort() method is not supported in python.

    A static function is provided for creating a new Epetra.Map object
    with 1-to-1 ownership of entries from an existing map which may have
    entries that appear on multiple processors.

    Epetra.Util is a serial interface only.  This is appropriate since the
    standard utilities are only specified for serial execution (or shared
    memory parallel).
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Util, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Util, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(Epetra_Util self) -> Util
        __init__(Epetra_Util self, Util Util) -> Util

        Epetra Util Wrapper Class.

        The Epetra.Util class is a collection of useful functions that cut
        across a broad set of other classes.  A random number generator is
        provided, along with methods to set and retrieve the random-number
        seed.

        The random number generator is a multiplicative linear congruential
        generator, with multiplier 16807 and modulus 2^31 - 1. It is based on
        the algorithm described in 'Random Number Generators: Good Ones Are
        Hard To Find', S. K. Park and K. W. Miller, Communications of the ACM,
        vol. 31, no. 10, pp. 1192-1201.

        The C++ Sort() method is not supported in python.

        A static function is provided for creating a new Epetra.Map object
        with 1-to-1 ownership of entries from an existing map which may have
        entries that appear on multiple processors.

        Epetra.Util is a serial interface only.  This is appropriate since the
        standard utilities are only specified for serial execution (or shared
        memory parallel).
        """
        this = ___init__.new_Util(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Util
    def RandomInt(self, *args):
        """RandomInt(Util self) -> unsigned int"""
        return ___init__.Util_RandomInt(self, *args)

    def RandomDouble(self, *args):
        """RandomDouble(Util self) -> double"""
        return ___init__.Util_RandomDouble(self, *args)

    def Seed(self, *args):
        """Seed(Util self) -> unsigned int"""
        return ___init__.Util_Seed(self, *args)

    def SetSeed(self, *args):
        """SetSeed(Util self, unsigned int Seed_in) -> int"""
        return ___init__.Util_SetSeed(self, *args)

    def Create_Root_Map(*args):
        """Create_Root_Map(Map usermap, int root=0) -> Map"""
        return ___init__.Util_Create_Root_Map(*args)

    if _newclass:Create_Root_Map = staticmethod(Create_Root_Map)
    __swig_getmethods__["Create_Root_Map"] = lambda x: Create_Root_Map
    def Create_OneToOne_Map(*args):
        """Create_OneToOne_Map(Map usermap, bool high_rank_proc_owns_shared=False) -> Map"""
        return ___init__.Util_Create_OneToOne_Map(*args)

    if _newclass:Create_OneToOne_Map = staticmethod(Create_OneToOne_Map)
    __swig_getmethods__["Create_OneToOne_Map"] = lambda x: Create_OneToOne_Map
    def Create_OneToOne_BlockMap(*args):
        """Create_OneToOne_BlockMap(BlockMap usermap, bool high_rank_proc_owns_shared=False) -> BlockMap"""
        return ___init__.Util_Create_OneToOne_BlockMap(*args)

    if _newclass:Create_OneToOne_BlockMap = staticmethod(Create_OneToOne_BlockMap)
    __swig_getmethods__["Create_OneToOne_BlockMap"] = lambda x: Create_OneToOne_BlockMap
    def Chop(*args):
        """Chop(double const & Value) -> double"""
        return ___init__.Util_Chop(*args)

    if _newclass:Chop = staticmethod(Chop)
    __swig_getmethods__["Chop"] = lambda x: Chop
Util_swigregister = ___init__.Util_swigregister
Util_swigregister(Util)

def Util_Create_Root_Map(*args):
  """Util_Create_Root_Map(Map usermap, int root=0) -> Map"""
  return ___init__.Util_Create_Root_Map(*args)

def Util_Create_OneToOne_Map(*args):
  """Util_Create_OneToOne_Map(Map usermap, bool high_rank_proc_owns_shared=False) -> Map"""
  return ___init__.Util_Create_OneToOne_Map(*args)

def Util_Create_OneToOne_BlockMap(*args):
  """Util_Create_OneToOne_BlockMap(BlockMap usermap, bool high_rank_proc_owns_shared=False) -> BlockMap"""
  return ___init__.Util_Create_OneToOne_BlockMap(*args)

def Util_Chop(*args):
  """Util_Chop(double const & Value) -> double"""
  return ___init__.Util_Chop(*args)
Util.chopVal_ = ___init__.cvar.Util_chopVal_


def Epetra_Util_binary_search(*args):
  """
    Epetra_Util_binary_search(int item, int const * list, int len, int & insertPoint) -> int
    Epetra_Util_binary_search(long long item, long long const * list, int len, int & insertPoint) -> int
    """
  return ___init__.Epetra_Util_binary_search(*args)

def Epetra_Util_ExtractHbData(*args):
  """
    Epetra_Util_ExtractHbData(CrsMatrix A, Epetra_MultiVector LHS, Epetra_MultiVector RHS, int & M, int & N, int & nz, 
        int *& ptr, int *& ind, double *& val, int & Nrhs, double *& rhs, int & ldrhs, 
        double *& lhs, int & ldlhs) -> int
    """
  return ___init__.Epetra_Util_ExtractHbData(*args)
import PyTrilinos.Epetra

def EpetraExt_Version(*args):
  """
    EpetraExt_Version() -> std::string

    std::string
    EpetraExt::EpetraExt_Version() 
    """
  return ___init__.EpetraExt_Version(*args)
__version__ = EpetraExt_Version().split()[2]

class HDF5(_object):
    """Proxy of C++ EpetraExt::HDF5 class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, HDF5, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, HDF5, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(EpetraExt::HDF5 self, Comm Comm) -> HDF5"""
        this = ___init__.new_HDF5(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_HDF5
    def Create(self, *args):
        """Create(HDF5 self, std::string const FileName)"""
        return ___init__.HDF5_Create(self, *args)

    def Open(self, *args):
        """Open(HDF5 self, std::string const FileName, int AccessType=H5F_ACC_RDWR)"""
        return ___init__.HDF5_Open(self, *args)

    def Close(self, *args):
        """Close(HDF5 self)"""
        return ___init__.HDF5_Close(self, *args)

    def Flush(self, *args):
        """Flush(HDF5 self)"""
        return ___init__.HDF5_Flush(self, *args)

    def IsOpen(self, *args):
        """IsOpen(HDF5 self) -> bool"""
        return ___init__.HDF5_IsOpen(self, *args)

    def CreateGroup(self, *args):
        """CreateGroup(HDF5 self, std::string const & GroupName)"""
        return ___init__.HDF5_CreateGroup(self, *args)

    def IsContained(self, *args):
        """IsContained(HDF5 self, std::string const Name) -> bool"""
        return ___init__.HDF5_IsContained(self, *args)

    def WriteComment(self, *args):
        """WriteComment(HDF5 self, std::string const & GroupName, std::string Comment)"""
        return ___init__.HDF5_WriteComment(self, *args)

    def ReadComment(self, *args):
        """ReadComment(HDF5 self, std::string const & GroupName)"""
        return ___init__.HDF5_ReadComment(self, *args)

    def ReadMapProperties(self, *args):
        """
        ReadMapProperties(str groupName) -> (numGlobalElements, indexBase, numProc)

        Return the properties of a Map from an HDF5 file.
        """
        return ___init__.HDF5_ReadMapProperties(self, *args)

    def ReadBlockMapProperties(self, *args):
        """
        ReadBlockMapProperties(str groupName) -> (numGlobalElements, numGlobalPoints,
                                                   indexBase, numProc)

        Return the properties of a BlockMap from an HDF5 file.
        """
        return ___init__.HDF5_ReadBlockMapProperties(self, *args)

    def ReadCrsGraphProperties(self, *args):
        """
        ReadCrsGraphProperties(str groupName) -> (numGlobalRows, numGlobalCols,
                                                   numGlobalNonzeros, numGlobalDiagonals,
                                                   maxNumIndices)

        Return the properties of a CrsGraph from an HDF5 file.
        """
        return ___init__.HDF5_ReadCrsGraphProperties(self, *args)

    def ReadIntVectorProperties(self, *args):
        """
        ReadIntVectorProperties(str groupName) -> int globalLength

        Return the global length of an IntVector from an HDF5 file.
        """
        return ___init__.HDF5_ReadIntVectorProperties(self, *args)

    def ReadMultiVectorProperties(self, *args):
        """
        ReadMultiVectorProperties(str groupName) -> (globalLength, numVectors)

        Return the properties of a MultiVector from an HDF5 file.
        """
        return ___init__.HDF5_ReadMultiVectorProperties(self, *args)

    def ReadCrsMatrixProperties(self, *args):
        """
        ReadCrsMatrixProperties(str groupName) -> (numGlobalRows, numGlobalCols,
                                                   numNonzeros, numGlobalDiagonals,
                                                   maxNumEntries, normOne, normInf)

        Return the properties of a CrsMatrix from an HDF5 file.
        """
        return ___init__.HDF5_ReadCrsMatrixProperties(self, *args)

    def Write(self, *args):
        """
        Write(HDF5 self, std::string const & GroupName, std::string const & DataSetName, int data)
        Write(HDF5 self, std::string const & GroupName, std::string const & DataSetName, double data)
        Write(HDF5 self, std::string const & GroupName, std::string const & DataSetName, std::string const & data)
        Write(HDF5 self, std::string const & GroupName, std::string const & DataSetName, int const type, int const Length, 
            void * data)
        Write(HDF5 self, std::string const & GroupName, std::string const & DataSetName, int MySize, int GlobalSize, 
            int type, void const * data)
        Write(HDF5 self, std::string const & GroupName, Map Map)
        Write(HDF5 self, std::string const & GroupName, BlockMap Map)
        Write(HDF5 self, std::string const & GroupName, CrsGraph Graph)
        Write(HDF5 self, std::string const & GroupName, Epetra_IntVector x)
        Write(HDF5 self, std::string const & GroupName, Epetra_MultiVector x, bool writeTranspose=False)
        Write(HDF5 self, std::string const & GroupName, RowMatrix Matrix)
        Write(HDF5 self, std::string const & GroupName, ParameterList List)
        Write(HDF5 self, std::string const & GroupName, EpetraExt::DistArray< int > const & array)
        Write(HDF5 self, std::string const & GroupName, EpetraExt::DistArray< double > const & array)
        Write(HDF5 self, std::string const & GroupName, EpetraExt::Handle const & List)
        """
        return ___init__.HDF5_Write(self, *args)

    def ReadInt(self, *args):
        """ReadInt(HDF5 self, std::string const & group, std::string const & name) -> int"""
        return ___init__.HDF5_ReadInt(self, *args)

    def ReadFloat(self, *args):
        """ReadFloat(HDF5 self, std::string const & group, std::string const & name) -> double"""
        return ___init__.HDF5_ReadFloat(self, *args)

    def ReadString(self, *args):
        """ReadString(HDF5 self, std::string const & group, std::string const & name) -> std::string"""
        return ___init__.HDF5_ReadString(self, *args)

    def ReadBlockMap(self, *args):
        """
        ReadBlockMap(HDF5 self, std::string const & name) -> BlockMap

        Return a BlockMap read from an open HDF5 file with group name 'name'.

        """
        return ___init__.HDF5_ReadBlockMap(self, *args)

    def ReadMap(self, *args):
        """
        ReadMap(HDF5 self, std::string const & name) -> Map

        Return a Map read from an open HDF5 file with group name 'name'.

        """
        return ___init__.HDF5_ReadMap(self, *args)

    def ReadMultiVector(self, *args):
        """
        ReadMultiVector(HDF5 self, std::string const & name) -> Epetra_MultiVector

        Return a MultiVector read from an open HDF5 file with group name 'name'.

        """
        return ___init__.HDF5_ReadMultiVector(self, *args)

    def ReadCrsGraph(self, *args):
        """
        ReadCrsGraph(HDF5 self, std::string const & name) -> CrsGraph

        Return a CrsGraph read from an open HDF5 file with group name 'name'.

        """
        return ___init__.HDF5_ReadCrsGraph(self, *args)

    def ReadCrsMatrix(self, *args):
        """
        ReadCrsMatrix(HDF5 self, std::string const & name) -> CrsMatrix

        Return a CrsMatrix read from an open HDF5 file with group name 'name'.

        """
        return ___init__.HDF5_ReadCrsMatrix(self, *args)

    def ReadIntVector(self, *args):
        """
        ReadIntVector(HDF5 self, std::string const & name) -> Epetra_IntVector

        Return an IntVector read from an open HDF5 file with group name 'name'.

        """
        return ___init__.HDF5_ReadIntVector(self, *args)

    def ReadParameterList(self, *args):
        """ReadParameterList(HDF5 self, std::string const & name) -> ParameterList"""
        return ___init__.HDF5_ReadParameterList(self, *args)

HDF5_swigregister = ___init__.HDF5_swigregister
HDF5_swigregister(HDF5)

class XMLReader(_object):
    """
    class XMLReader: A class for reading Epetra objects stored in XML
    files.

    Class EpetraExt::XMLReader allows to read several Trilinos objects
    stored in XML files. The XML data format is specified in the
    documentation of class EpetraExt::XMLWriter, which also contains a
    MATLAB script. A typical usage of this class is reported in file
    epetraext/example/inout/XML_IO.cpp.

    This class requires Teuchos to be configured with the option --enable-
    teuchos-expat.

    Reading objects from a file requires the following steps. First, we
    define an XMLReader object, Then, we define a set of pointers, Reading
    simply goes as follows: In distributed environments,
    Epetra_MultiVector, Epetra_CrsGraph and Epetra_CrsMatrix objects have
    a linear distribution. Epetra_Map objects can be read only when using
    the same number of processors used for writing.

    WARNING:  All the created objects must be deleted from the user using
    delete.

    Marzio Sala, D-INFK/ETHZ

    C++ includes: EpetraExt_XMLReader.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, XMLReader, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, XMLReader, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(EpetraExt::XMLReader self, Comm Comm, std::string const & FileName) -> XMLReader

        EpetraExt::XMLReader::XMLReader(const Epetra_Comm &Comm, const
        std::string &FileName)

        ctor 
        """
        this = ___init__.new_XMLReader(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_XMLReader
    def ReadMap(self, *args):
        """
        ReadMap(XMLReader self, std::string const & name) -> Map

        Return a Map read from an XML file specified by filename 'name'.

        """
        return ___init__.XMLReader_ReadMap(self, *args)

    def ReadMultiVector(self, *args):
        """
        ReadMultiVector(XMLReader self, std::string const & name) -> Epetra_MultiVector

        Return a MultiVector read from an XML file specified by filename
        'name'.

        """
        return ___init__.XMLReader_ReadMultiVector(self, *args)

    def ReadCrsGraph(self, *args):
        """
        ReadCrsGraph(XMLReader self, std::string const & name) -> CrsGraph

        Return a CrsGraph read from an XML file specified by filename 'name'.

        """
        return ___init__.XMLReader_ReadCrsGraph(self, *args)

    def ReadCrsMatrix(self, *args):
        """
        ReadCrsMatrix(XMLReader self, std::string const & name) -> CrsMatrix

        Return a CrsMatrix read from an XML file specified by filename 'name'.

        """
        return ___init__.XMLReader_ReadCrsMatrix(self, *args)

XMLReader_swigregister = ___init__.XMLReader_swigregister
XMLReader_swigregister(XMLReader)

class XMLWriter(_object):
    """
    class XMLWriter: A class for writing Trilinos objects to XML files.

    Class EpetraExt::XMLWriter writes several Trilinos objects in an XML-
    compatible format. The list of supported objects contains: Epetra_Map;

    Epetra_MultiVector;

    Epetra_CrsGraph;

    Epetra_CrsMatrix;

    Epetra_RowMatrix;

    Teuchos::ParameterList.

    All objects can be read and written, with the std::exception of
    Epetra_RowMatrix objects, that can only be written to files.

    An example of usage is reported in file
    epetraext/example/inout/XML_IO.cpp.

    Writing objects goes as follows. Let Map, Matrix, LHS and RHS an
    Epetra_Map, Epetra_CrsMatrix, and two Epetra_MultiVector's,
    respectively. First, we define an XMLWriter object and we open the
    file using MyProblem label: Writing objects simply goes as A
    Teuchos::ParameterList (List), a std::string, and a
    std::vector<std::string> can be written as Finally, we close the file
    Note that only processor 0 writes the Teuchos::ParameterList,
    std::string, and std::vector<std::string>.

    The written file is as follows:

    This class requires Teuchos to be configured with the option --enable-
    teuchos-expat.

    Marzio Sala, D-INFK/ETHZ

    C++ includes: EpetraExt_XMLWriter.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, XMLWriter, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, XMLWriter, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(EpetraExt::XMLWriter self, Comm Comm, std::string const & FileName) -> XMLWriter

        EpetraExt::XMLWriter::XMLWriter(const Epetra_Comm &Comm, const
        std::string &FileName)

        ctor 
        """
        this = ___init__.new_XMLWriter(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_XMLWriter
    def Create(self, *args):
        """
        Create(XMLWriter self, std::string const & Label)

        void
        EpetraExt::XMLWriter::Create(const std::string &Label)

        Creates the file, giving Label to the whole object. 
        """
        return ___init__.XMLWriter_Create(self, *args)

    def Close(self, *args):
        """
        Close(XMLWriter self)

        void
        EpetraExt::XMLWriter::Close()

        Closes the file. No Write operations can follow. 
        """
        return ___init__.XMLWriter_Close(self, *args)

    def Write(self, *args):
        """
        Write(XMLWriter self, std::string const & Label, Map Map)
        Write(XMLWriter self, std::string const & Label, RowMatrix Matrix)
        Write(XMLWriter self, std::string const & Label, Epetra_MultiVector MultiVector)
        Write(XMLWriter self, std::string const & Label, std::vector< std::string,std::allocator< std::string > > const & Content)
        Write(XMLWriter self, std::string const & Label, std::string const & Text)
        Write(XMLWriter self, std::string const & Label, ParameterList List)

        void
        EpetraExt::XMLWriter::Write(const std::string &Label,
        Teuchos::ParameterList &List)

        Writes a Teuchos::ParameterList using label Label. 
        """
        return ___init__.XMLWriter_Write(self, *args)

XMLWriter_swigregister = ___init__.XMLWriter_swigregister
XMLWriter_swigregister(XMLWriter)

class CrsGraph_MapColoring(_object):
    """
    Map Coloring of independent columns in a Graph

    Generates a Epetra_MapColoring object for which all column indices
    form independent sets.

    C++ includes: EpetraExt_MapColoring.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CrsGraph_MapColoring, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CrsGraph_MapColoring, name)
    __repr__ = _swig_repr
    GREEDY = ___init__.CrsGraph_MapColoring_GREEDY
    LUBY = ___init__.CrsGraph_MapColoring_LUBY
    JONES_PLASSMAN = ___init__.CrsGraph_MapColoring_JONES_PLASSMAN
    PSEUDO_PARALLEL = ___init__.CrsGraph_MapColoring_PSEUDO_PARALLEL
    __swig_destroy__ = ___init__.delete_CrsGraph_MapColoring
    def __init__(self, *args): 
        """
        __init__(EpetraExt::CrsGraph_MapColoring self, EpetraExt::CrsGraph_MapColoring::ColoringAlgorithm algo=GREEDY, int reordering=0, 
            bool distance1=False, int verbosity=0) -> CrsGraph_MapColoring

        EpetraExt::CrsGraph_MapColoring::CrsGraph_MapColoring(ColoringAlgorithm
        algo=GREEDY, int reordering=0, bool distance1=false, int verbosity=0)

        Constructor 
        """
        this = ___init__.new_CrsGraph_MapColoring(*args)
        try: self.this.append(this)
        except: self.this = this
    def __call__(self, *args):
        """__call__(CrsGraph_MapColoring self, CrsGraph orig) -> MapColoring"""
        return ___init__.CrsGraph_MapColoring___call__(self, *args)

CrsGraph_MapColoring_swigregister = ___init__.CrsGraph_MapColoring_swigregister
CrsGraph_MapColoring_swigregister(CrsGraph_MapColoring)

class CrsGraph_MapColoringIndex(_object):
    """
    Generates a std::vector of Epetra_IntVector's to be used to map
    perturbation contributions to a CrsGraph/CrsMatrix from a perturbed
    vector.

    C++ includes: EpetraExt_MapColoringIndex.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CrsGraph_MapColoringIndex, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CrsGraph_MapColoringIndex, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_CrsGraph_MapColoringIndex
    def __init__(self, *args): 
        """
        __init__(EpetraExt::CrsGraph_MapColoringIndex self, MapColoring ColorMap) -> CrsGraph_MapColoringIndex

        EpetraExt::CrsGraph_MapColoringIndex::CrsGraph_MapColoringIndex(const
        Epetra_MapColoring &ColorMap)

        Constructor input param ColorMap defines the perturbation coloring 
        """
        this = ___init__.new_CrsGraph_MapColoringIndex(*args)
        try: self.this.append(this)
        except: self.this = this
    def __call__(self, *args):
        """__call__(CrsGraph_MapColoringIndex self, CrsGraph orig) -> EpetraExt::Transform< Epetra_CrsGraph,std::vector< Epetra_IntVector > >::NewTypeRef"""
        return ___init__.CrsGraph_MapColoringIndex___call__(self, *args)

CrsGraph_MapColoringIndex_swigregister = ___init__.CrsGraph_MapColoringIndex_swigregister
CrsGraph_MapColoringIndex_swigregister(CrsGraph_MapColoringIndex)


def MatrixMarketFileToMultiVector(*args):
  """
    MatrixMarketFileToMultiVector(str filename, Epetra.BlockMap) ->
        Epetra.MultiVector

    Return a MultiVector read from a matix market file.

    int
    EpetraExt::MatrixMarketFileToMultiVector(const char *filename, const
    Epetra_BlockMap &map, Epetra_MultiVector *&A)

    Constructs an Epetra_MultiVector object from a Matrix Market format
    file.

    This function constructs an Epetra_MultiVector object by reading a
    Matrix Market file.

    Parameters:
    -----------

    filename:  (In) A filename, including path if desired. The multivector
    to be read should be in this file in Matrix Market array format.

    map:  (In) An Epetra_Map or Epetra_BlockMap object describing the
    desired distribution of the multivector.

    A:  (Out) An Epetra_MultiVector object constructed from file contents.

    WARNING:  User must delete!!.

    Returns 0 if no error, -1 if any problems with file system. 
    """
  return ___init__.MatrixMarketFileToMultiVector(*args)

def MultiVectorToMatrixMarketFile(*args):
  """
    MultiVectorToMatrixMarketFile(char const * filename, Epetra_MultiVector A, char const * matrixName=None, char const * matrixDescription=None, 
        bool writeHeader=True) -> int

    int
    EpetraExt::MultiVectorToMatrixMarketFile(const char *filename, const
    Epetra_MultiVector &A, const char *matrixName=0, const char
    *matrixDescription=0, bool writeHeader=true)

    Writes an Epetra_MultiVector object to a Matrix Market format file.

    This function takes an Epetra_MultiVector object and writes it to the
    specified file. The multivector can be distributed or serial. The user
    can provide a strings containing the object name, a description, and
    specify that header information should or should not be printed to the
    file.

    Parameters:
    -----------

    filename:  (In) A filename, including path if desired. If a file with
    this name already exists, it will be deleted. On exit, this file will
    contained any requested header information followed by the matrix
    coefficients. The file will contain a row for each entry. All entries
    for a column are listed before going to the next column.

    A:  (In) An Epetra_MultiVector Object containing the user matrix to be
    dumped to file.

    matrixName:  (In) A C-style string pointer to a name that will be
    stored in the comment field of the file. This is not a required
    argument. Note that it is possible to pass in the method A.Label().

    matrixDescription:  (In) A C-style string pointer to a matrix
    description that will be stored in the comment field of the file.

    writeHeader:  (In) If true, the header will be written, otherwise only
    the matrix entries will be written.

    Returns 0 if no error, -1 if any problems with file system. 
    """
  return ___init__.MultiVectorToMatrixMarketFile(*args)

def MultiVectorToMatlabFile(*args):
  """
    MultiVectorToMatlabFile(char const * filename, Epetra_MultiVector A) -> int

    int
    EpetraExt::MultiVectorToMatlabFile(const char *filename, const
    Epetra_MultiVector &A)

    Writes an Epetra_MultiVector object to a file that is compatible with
    Matlab.

    This function takes any matrix that implements the Epetra_MultiVector
    interface and writes it to the specified file. The matrix can be
    distributed or serial. This function is a convenience wrapper around
    MultiVectorToMatrixMarketFile. The following Matlab commands can be
    used to read the resulting file and convert to it to a Matlab sparse
    matrix: load filename;  For example: load A.dat;  The above produces a
    dense matrix A with each vector in the multivector as a column in A.

    Parameters:
    -----------

    filename:  (In) A filename, including path if desired. If a file with
    this name already exists, it will be deleted. On exit, this file will
    contain a row for each row of the multivector.

    A:  (In) An Epetra_MultiVector Object containing the user matrix to be
    dumped to file.

    Returns 0 if no error, -1 if any problems with file system. 
    """
  return ___init__.MultiVectorToMatlabFile(*args)

def MultiVectorToMatrixMarketHandle(*args):
  """
    MultiVectorToMatrixMarketHandle(std::FILE * handle, Epetra_MultiVector A) -> int

    int EpetraExt::MultiVectorToMatrixMarketHandle(std::FILE *handle,
    const Epetra_MultiVector &A)

    Writes an Epetra_MultiVector object that is compatible with Matrix
    Market array format to a file handle.

    This function takes an Epetra_MultiVector and writes it to the
    specified file handle.

    Parameters:
    -----------

    handle:  (In) A C-style file handle, already opened. On exit, the file
    associated with this handle will have appended to it a row for each
    multivector row.

    A:  (In) An Epetra_MultiVector Object containing the user object to be
    dumped to file.

    Returns 0 if no error, -1 if any problems with file system. 
    """
  return ___init__.MultiVectorToMatrixMarketHandle(*args)

def MultiVectorToMatlabHandle(*args):
  """
    MultiVectorToMatlabHandle(std::FILE * handle, Epetra_MultiVector A) -> int

    int
    EpetraExt::MultiVectorToMatlabHandle(std::FILE *handle, const
    Epetra_MultiVector &A)

    Writes an Epetra_MultiVector object that is compatible with Matlab to
    a file handle.

    This function takes an Epetra_MultiVector and writes it to the
    specified file handle.

    Parameters:
    -----------

    handle:  (In) A C-style file handle, already opened. On exit, the file
    associated with this handle will have appended to it a row for each
    multivector row.

    A:  (In) An Epetra_MultiVector Object containing the user object to be
    dumped to file.

    Returns 0 if no error, -1 if any problems with file system. 
    """
  return ___init__.MultiVectorToMatlabHandle(*args)

def MultiVectorToHandle(*args):
  """
    MultiVectorToHandle(std::FILE * handle, Epetra_MultiVector A, bool mmFormat) -> int

    int
    EpetraExt::MultiVectorToHandle(std::FILE *handle, const
    Epetra_MultiVector &A, bool mmFormat) 
    """
  return ___init__.MultiVectorToHandle(*args)

def writeMultiVector(*args):
  """
    writeMultiVector(std::FILE * handle, Epetra_MultiVector A, bool mmFormat) -> int

    int
    EpetraExt::writeMultiVector(std::FILE *handle, const
    Epetra_MultiVector &A, bool mmFormat) 
    """
  return ___init__.writeMultiVector(*args)

def MatlabFileToCrsMatrix(*args):
  """
    MatlabFileToCrsMatrix(str filename, Epetra.Comm) -> Epetra.CrsMatrix

    Return a CrsMatrix read from a matlab file.

    int
    EpetraExt::MatlabFileToCrsMatrix(const char *filename, const
    Epetra_Comm &comm, Epetra_CrsMatrix *&A)

    Constructs an Epetra_CrsMatrix object from a Matlab format file,
    distributes rows evenly across processors.

    This function constructs an Epetra_CrsMatrix object by reading a
    Matlab (i,j,value) format file.

    Parameters:
    -----------

    filename:  (In) A filename, including path if desired. The matrix to
    be read should be in this file in Matlab coordinate format.

    comm:  (In) An Epetra_Comm object. The matrix will have its rows
    distributed evenly by row-count across the parallel machine.

    A:  (Out) An Epetra_CrsMatrix object constructed from file contents.
    The input matrix can be any dimension, square or rectangular.

    WARNING:  User must delete matrix A!!.

    Returns 0 if no error, -1 if any problems with file system.  Notes:
    The file will be read twice: first to get the maximum row and column
    dimensions. Next to insert values.

    The global row and column dimensions will be determined by the maximum
    row and column index, respectively, contained in the file. If some
    rows or columns are empty they will still be present in the matrix.

    The format expected for the input file is a list of nonzero entries
    with one entry per row. Each row will have the row index, column index
    and value listed with space in between each item. The number of lines
    in the file should be exactly the number of entries of the matrix. For
    example, consider the following matrix where only the nonzero values
    are stored:

    \\[ \\left[\\begin{array}{cccc} 5 & 7 & 0 & 0 \\\\ 3 & 2 & 0
    & 1 \\\\ 0 & 0 & 0 & 4 \\\\ \\end{array}\\right]. \\]

    A Matlab format file for this matrix would be: 1 1 5.0 1 2 7.0 2 1 3.0
    2 2 2.0 2 4 1.0 4 4 4.0

    Note that the entries can be listed in any order and that the matrix
    does not need to be square. Values in the first and second columns
    must be integer values and in those in the third column must be
    floating point format.

    (See the <a href="http://www.mathworks.com">Matlab</a> home page for
    details.) 
    """
  return ___init__.MatlabFileToCrsMatrix(*args)

def MatrixMarketFileToCrsMatrix(*args):
  """
    MatrixMarketFileToCrsMatrix(str filename, Epetra.Map rowMap, Epetra.Map
        colMap=None, Epetra.Map rangeMap=None, Epetra.Map domainMap=None) ->
        Epetra.CrsMatrix

    Return a CrsMatrix read from a matrix market file.
    MatrixMarketFileToCrsMatrix(str filename, Epetra.Map rowMap, Epetra.Map
        colMap=None, Epetra.Map rangeMap=None, Epetra.Map domainMap=None) ->
        Epetra.CrsMatrix

    Return a CrsMatrix read from a matrix market file.
    MatrixMarketFileToCrsMatrix(str filename, Epetra.Map rowMap, Epetra.Map
        colMap=None, Epetra.Map rangeMap=None, Epetra.Map domainMap=None) ->
        Epetra.CrsMatrix

    Return a CrsMatrix read from a matrix market file.
    MatrixMarketFileToCrsMatrix(str filename, Epetra.Map rowMap, Epetra.Map
        colMap=None, Epetra.Map rangeMap=None, Epetra.Map domainMap=None) ->
        Epetra.CrsMatrix

    Return a CrsMatrix read from a matrix market file.
    MatrixMarketFileToCrsMatrix(str filename, Epetra.Map rowMap, Epetra.Map
        colMap=None, Epetra.Map rangeMap=None, Epetra.Map domainMap=None) ->
        Epetra.CrsMatrix

    Return a CrsMatrix read from a matrix market file.

    int
    EpetraExt::MatrixMarketFileToCrsMatrix(const char *filename, const
    Epetra_Map &rowMap, const Epetra_Map &colMap, const Epetra_Map
    &rangeMap, const Epetra_Map &domainMap, Epetra_CrsMatrix *&A, const
    bool transpose=0, const bool verbose=0)

    Constructs an Epetra_CrsMatrix object from a Matrix Market format
    file, row, column, range and domain map specified; this version is
    seldom required unless you want explicit control over column map.

    Reads an Epetra_CrsMatrix object from a matrix-market file, but uses
    the specified maps for constructing and 'FillComplete()'ing the
    matrix. Successfully creates rectangular matrices.

    Parameters:
    -----------

    filename:  (In) A filename, including path if desired. The matrix to
    be read should be in this file in Matrix Market coordinate format.

    rowMap:  (In) An Epetra_Map object describing the desired row
    distribution of the matrix.

    colMap:  (In) An Epetra_Map object describing the desired column
    distribution of the matrix.

    rangeMap:  (In) An Epetra_Map object describing the distribution of
    range vectors that will be used with this matrix, must be 1-to-1.

    domainMap:  (In) An Epetra_Map object describing the distribution of
    domain vectors that will be used with this matrix, must be 1-to-1.

    transpose:  (In) A boolean value indicating whether the reader should
    transpose the matrix as it is read into matrix A. (default = 0).

    verbose:  (In) A boolean value indicating whether the reader should
    print diagnostic statements to stdout. (default = 0).

    A:  (Out) An Epetra_CrsMatrix object constructed from file contents.

    WARNING:  User must delete!!.

    Returns 0 if no error, -1 if any problems with file system.  (See the
    <a href="http://math.nist.gov/MatrixMarket">Matrix Market</a> home
    page for details.) 
    """
  return ___init__.MatrixMarketFileToCrsMatrix(*args)

def HypreFileToCrsMatrix(*args):
  """
    HypreFileToCrsMatrix(char const * filename, Comm comm) -> int

    int
    EpetraExt::HypreFileToCrsMatrix(const char *filename, const
    Epetra_Comm &comm, Epetra_CrsMatrix *&A)

    Constructs an Epetra_CrsMatrix object from a Hypre Matrix Print
    command, the row map is specified.

    Reads an Epetra_CrsMatrix object from a Hypre Matrix Printout, the
    matrix should be square.

    Parameters:
    -----------

    filename:  (In) A filename not including the processor id extension,
    including path if desired.

    comm:  (In) An Epetra_Comm object describing the communication among
    processors.

    A:  (Out) An Epetra_CrsMatrix object constructed from file contents.

    WARNING:  User must delete!!.

    Returns 0 if no error, -1 if any problems with file system. 
    """
  return ___init__.HypreFileToCrsMatrix(*args)

def MatrixMarketFileToCrsMatrixHandle(*args):
  """
    MatrixMarketFileToCrsMatrixHandle(char const * filename, Comm comm, Map rowMap=None, Map colMap=None, Map rangeMap=None, 
        Map domainMap=None, bool const transpose=0, bool const verbose=0) -> int

    int EpetraExt::MatrixMarketFileToCrsMatrixHandle(const char *filename,
    const Epetra_Comm &comm, Epetra_CrsMatrix *&A, const Epetra_Map
    *rowMap, const Epetra_Map *colMap, const Epetra_Map *rangeMap, const
    Epetra_Map *domainMap, const bool transpose, const bool verbose) 
    """
  return ___init__.MatrixMarketFileToCrsMatrixHandle(*args)

def RowMatrixToMatrixMarketFile(*args):
  """
    RowMatrixToMatrixMarketFile(char const * filename, RowMatrix A, char const * matrixName=None, char const * matrixDescription=None, 
        bool writeHeader=True) -> int

    int
    EpetraExt::RowMatrixToMatrixMarketFile(const char *filename, const
    Epetra_RowMatrix &A, const char *matrixName=0, const char
    *matrixDescription=0, bool writeHeader=true)

    Writes an Epetra_RowMatrix object to a Matrix Market format file.

    This function takes any matrix that implements the Epetra_RowMatrix
    interface and writes it to the specified file. The matrix can be
    distributed or serial. The user can provide a strings containing the
    matrix name, a matrix description, and specify that header information
    should or should not be printed to the file.

    Parameters:
    -----------

    filename:  (In) A filename, including path if desired. If a file with
    this name already exists, it will be deleted. On exit, this file will
    contained any requested header information followed by the matrix
    coefficients. The file will contain a row for each matrix entry The
    first column is the global row index, using base 1, the second column
    is the global column index of the entry, the third value is the matrix
    value for that entry.

    A:  (In) An Epetra_RowMatrix Object containing the user matrix to be
    dumped to file. Any object that implements the Epetra_RowMatrix
    interface can be passed in. In particular, the Epetra_CrsMatrix,
    Epetra_VbrMatrix, Epetra_FECrsMatrix, Epetra_FEVbrMatrix and
    Epetra_MsrMatrix classes are compatible with this interface.

    matrixName:  (In) A C-style std::string pointer to a name that will be
    stored in the comment field of the file. This is not a required
    argument. Note that it is possible to pass in the method A.Label() if
    the matrix is one of the four types: Epetra_CrsMatrix,
    Epetra_VbrMatrix, Epetra_FECrsMatrix, Epetra_FEVbrMatrix.

    matrixDescription:  (In) A C-style std::string pointer to a matrix
    description that will be stored in the comment field of the file.

    writeHeader:  (In) If true, the header will be written, otherwise only
    the matrix entries will be written.

    Returns 0 if no error, -1 if any problems with file system. 
    """
  return ___init__.RowMatrixToMatrixMarketFile(*args)

def RowMatrixToMatlabFile(*args):
  """
    RowMatrixToMatlabFile(char const * filename, RowMatrix A) -> int

    int
    EpetraExt::RowMatrixToMatlabFile(const char *filename, const
    Epetra_RowMatrix &A)

    Writes an Epetra_RowMatrix object to a file that is compatible with
    Matlab.

    This function takes any matrix that implements the Epetra_RowMatrix
    interface and writes it to the specified file. The matrix can be
    distributed or serial. This function is a convenience wrapper around
    RowMatrixToMatrixMarketFile. The following Matlab commands can be used
    to read the resulting file and convert to it to a Matlab sparse
    matrix: load filename;

    matrix_name = spconvert(filename_root);  For example: load A.dat;

    A = spconvert(filename_root);  The above produces a sparse matrix A.

    Parameters:
    -----------

    filename:  (In) A filename, including path if desired. If a file with
    this name already exists, it will be deleted. On exit, this file will
    contain a row for each matrix entry The first column is the global row
    index, using base 1, the second column is the global column index of
    the entry, the third value is the matrix value for that entry.

    A:  (In) An Epetra_RowMatrix Object containing the user matrix to be
    dumped to file. Any object that implements the Epetra_RowMatrix
    interface can be passed in. In particular, the Epetra_CrsMatrix,
    Epetra_VbrMatrix, Epetra_FECrsMatrix, Epetra_FEVbrMatrix and
    Epetra_MsrMatrix classes are compatible with this interface.

    Returns 0 if no error, -1 if any problems with file system. 
    """
  return ___init__.RowMatrixToMatlabFile(*args)

def RowMatrixToHandle(*args):
  """
    RowMatrixToHandle(std::FILE * handle, RowMatrix A) -> int

    int
    EpetraExt::RowMatrixToHandle(std::FILE *handle, const Epetra_RowMatrix
    &A)

    Writes an Epetra_RowMatrix object to a format file that is compatible
    with Matlab.

    This function takes any matrix that implements the Epetra_RowMatrix
    interface and writes it to the specified file handle. The matrix can
    be distributed or serial. This function is a convenience wrapper
    around RowMatrixToMatrixMarketFile.

    Parameters:
    -----------

    handle:  (In) A C-style file handle, already opened. On exit, the file
    associated with this handle will have appended to it a row for each
    matrix entry The first column is the global row index, using base 1,
    the second column is the global column index of the entry, the third
    value is the matrix value for that entry.

    A:  (In) An Epetra_RowMatrix Object containing the user matrix to be
    dumped to file. Any object that implements the Epetra_RowMatrix
    interface can be passed in. In particular, the Epetra_CrsMatrix,
    Epetra_VbrMatrix, Epetra_FECrsMatrix, Epetra_FEVbrMatrix and
    Epetra_MsrMatrix classes are compatible with this interface.

    Returns 0 if no error, -1 if any problems with file system. 
    """
  return ___init__.RowMatrixToHandle(*args)

def writeRowMatrix(*args):
  """
    writeRowMatrix(std::FILE * handle, RowMatrix A) -> int

    int
    EpetraExt::writeRowMatrix(std::FILE *handle, const Epetra_RowMatrix
    &A) 
    """
  return ___init__.writeRowMatrix(*args)

def MatrixMarketFileToBlockMap(*args):
  """
    MatrixMarketFileToBlockMap(str filename, Epetra.Comm) -> Epetra.BlockMap

    Return a BlockMap read from a matrix market file.

    int
    EpetraExt::MatrixMarketFileToBlockMap(const char *filename, const
    Epetra_Comm &comm, Epetra_BlockMap *&blockMap)

    Constructs an Epetra_BlockMap object from a Matrix Market format file.

    This function constructs an Epetra_BlockMap or Epetra_Map object by
    reading a Matrix Market file. If the file was created using the
    EpetraExt::BlockMapOut functions, special information was encoded in
    the comment field of this map that allows for identical reproduction
    of the map, including distribution across processors and element size
    information. If the same of processors is being used to create the
    object as were used to write it, the object will be an exact
    reproduction of the original. Otherwise, a uniform distribution of the
    GIDs will be created.

    The first column of the input file will must be the list of GIDs in
    the map. If the block map has non-uniform sizes, a second column must
    contain the element sizes.

    Parameters:
    -----------

    filename:  (In) A filename, including path if desired. If a file with
    this name already exists, it will be deleted. On exit, this file will
    contained any requested header information followed by the map GIDs. A
    second column may be present if the BlockMap has nonuniform sizes.

    comm:  (In) An Epetra_Comm object describing the parallel machine.

    blockMap:  (Out) An Epetra_BlockMap object constructed from file
    contents.

    WARNING:  User must delete!!.

    Returns 0 if no error, -1 if any problems with file system, returns 1
    if number of processors differs from file creator. 
    """
  return ___init__.MatrixMarketFileToBlockMap(*args)

def MatrixMarketFileToMap(*args):
  """
    MatrixMarketFileToMap(str filename, Epetra.Comm) -> Epetra.Map

    Return a Map read from a matrix market file.

    int
    EpetraExt::MatrixMarketFileToMap(const char *filename, const
    Epetra_Comm &comm, Epetra_Map *&map)

    Constructs an Epetra_BlockMap object from a Matrix Market format file.

    This function constructs an Epetra_BlockMap or Epetra_Map object by
    reading a Matrix Market file. If the file was created using the
    EpetraExt::BlockMapOut functions, special information was encoded in
    the comment field of this map that allows for identical reproduction
    of the map, including distribution across processors and element size
    information. If the same of processors is being used to create the
    object as were used to write it, the object will be an exact
    reproduction of the original. Otherwise, a uniform distribution of the
    GIDs will be created.

    The first column of the input file will must be the list of GIDs in
    the map. If the block map has non-uniform sizes, a second column must
    contain the element sizes.

    Parameters:
    -----------

    filename:  (In) A filename, including path if desired. If a file with
    this name already exists, it will be deleted. On exit, this file will
    contained any requested header information followed by the map GIDs. A
    second column may be present if the BlockMap has nonuniform sizes.

    comm:  (In) An Epetra_Comm object describing the parallel machine.

    map:  (Out) An Epetra_Map object constructed from file contents.

    WARNING:  User must delete!!.

    Returns 0 if no error, -1 if any problems with file system, -2 if file
    contained nontrivial Epetra_BlockMap, 1 if number of processors
    differs from file creator. 
    """
  return ___init__.MatrixMarketFileToMap(*args)

def MatrixMarketFileToBlockMaps(*args):
  """
    MatrixMarketFileToBlockMaps(str filename, Epetra.Comm) ->
        (Epetra.BlockMap rowMap, Epetra.BlockMap colMap, Epetra.BlockMap rangeMap,
         Epetra.BlockMap domainMap)

    Return a tuple of BlockMaps read from a matrix market file.  The
    BlockMaps, listed in order, are the row map, the column map, the range
    map and the domain map.

    int
    EpetraExt::MatrixMarketFileToBlockMaps(const char *filename, const
    Epetra_Comm &comm, Epetra_BlockMap *&rowmap, Epetra_BlockMap *&colmap,
    Epetra_BlockMap *&rangemap, Epetra_BlockMap *&domainmap)

    Constructs row,col,range and domain maps from a matrix-market matrix
    file. 
    """
  return ___init__.MatrixMarketFileToBlockMaps(*args)

def BlockMapToMatrixMarketFile(*args):
  """
    BlockMapToMatrixMarketFile(char const * filename, BlockMap blockMap, char const * mapName=None, char const * mapDescription=None, 
        bool writeHeader=True) -> int

    int
    EpetraExt::BlockMapToMatrixMarketFile(const char *filename, const
    Epetra_BlockMap &blockMap, const char *mapName=0, const char
    *mapDescription=0, bool writeHeader=true)

    Writes an Epetra_BlockMap or Epetra_Map object to a Matrix Market
    format file.

    This function takes an Epetra_BlockMap or Epetra_Map object and writes
    it to the specified file. The map can be distributed or serial. The
    user can provide a strings containing the object name, a description,
    and specify that header information should or should not be printed to
    the file.

    Special information is encoded in the comment field of this map that
    allows for identical reproduction of the map, including distribution
    across processors and element size information.

    The first column of the output file will be the list of GIDs in the
    map. If the block map has non-uniform sizes, a second column will be
    generated containing the element sizes.

    Parameters:
    -----------

    filename:  (In) A filename, including path if desired. If a file with
    this name already exists, it will be deleted. On exit, this file will
    contained any requested header information followed by the map GIDs. A
    second column may be present if the BlockMap has nonuniform sizes.

    blockMap:  (In) An Epetra_BlockMap Object containing the user map to
    be dumped to file.

    mapName:  (In) A C-style string pointer to a name that will be stored
    in the comment field of the file. This is not a required argument.
    Note that it is possible to pass in the method A.Label().

    mapDescription:  (In) A C-style string pointer to a map description
    that will be stored in the comment field of the file.

    writeHeader:  (In) If true, the header will be written, otherwise only
    the map entries will be written.

    Returns 0 if no error, -1 if any problems with file system. 
    """
  return ___init__.BlockMapToMatrixMarketFile(*args)

def BlockMapToHandle(*args):
  """
    BlockMapToHandle(std::FILE * handle, BlockMap blockMap) -> int

    int
    EpetraExt::BlockMapToHandle(std::FILE *handle, const Epetra_BlockMap
    &blockMap)

    Writes an Epetra_BlockMap or Epetra_Map object to a file handle.

    This function takes an Epetra_BlockMap or Epetra_Map object and writes
    it to the specified file handle.

    Parameters:
    -----------

    handle:  (In) A C-style file handle, already opened. On exit, the file
    associated with this handle will have appended to it a row for each
    multivector row.

    blockMap:  (In) An Epetra_BlockMap object containing the user object
    to be dumped to file.

    Returns 0 if no error, -1 if any problems with file system. 
    """
  return ___init__.BlockMapToHandle(*args)

def writeBlockMap(*args):
  """
    writeBlockMap(std::FILE * handle, int length, int const * v1, int const * v2, bool doSizes) -> int

    int
    EpetraExt::writeBlockMap(std::FILE *handle, int length, const int *v1,
    const int *v2, bool doSizes) 
    """
  return ___init__.writeBlockMap(*args)
class CrsMatrix_SubCopy(_object):
    """
    Generates a sub-block view of a Epetra_CrsMatrix.

    C++ includes: EpetraExt_SubCopy_CrsMatrix.h 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CrsMatrix_SubCopy, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CrsMatrix_SubCopy, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_CrsMatrix_SubCopy
    def __init__(self, *args): 
        """
        __init__(EpetraExt::CrsMatrix_SubCopy self, Map newMap) -> CrsMatrix_SubCopy
        __init__(EpetraExt::CrsMatrix_SubCopy self, Map newRangeAndRowMap, Map newDomainMap) -> CrsMatrix_SubCopy

        EpetraExt::CrsMatrix_SubCopy::CrsMatrix_SubCopy(const Epetra_Map
        &newRangeAndRowMap, const Epetra_Map &newDomainMap)

        Constructor. 
        """
        this = ___init__.new_CrsMatrix_SubCopy(*args)
        try: self.this.append(this)
        except: self.this = this
    def __call__(self, *args):
        """__call__(CrsMatrix_SubCopy self, CrsMatrix orig) -> CrsMatrix"""
        return ___init__.CrsMatrix_SubCopy___call__(self, *args)

    def fwd(self, *args):
        """
        fwd(CrsMatrix_SubCopy self) -> bool

        bool
        EpetraExt::CrsMatrix_SubCopy::fwd()

        Forward transfer of data from orig object input in the operator()
        method call to the new object created in this same call. Returns true
        is operation is successful.

        Preconditions: 
        """
        return ___init__.CrsMatrix_SubCopy_fwd(self, *args)

    def rvs(self, *args):
        """
        rvs(CrsMatrix_SubCopy self) -> bool

        bool
        EpetraExt::CrsMatrix_SubCopy::rvs()

        Reverse transfer of data from new object created in the operator()
        method call to the orig object input to this same method. Returns true
        if operation is successful.

        Preconditions: 
        """
        return ___init__.CrsMatrix_SubCopy_rvs(self, *args)

CrsMatrix_SubCopy_swigregister = ___init__.CrsMatrix_SubCopy_swigregister
CrsMatrix_SubCopy_swigregister(CrsMatrix_SubCopy)


def Multiply(*args):
  """
    Multiply(Epetra.CrsMatrix A, bool transposeA, Epetra.CrsMatrix B, bool
        transposeB, Epetra.CrsMatrix C) -> int

    Compute C <- A * B, where transposeA and transposeB control the
    transposition of A and B respectively.  C must have the structure of A
    * B, or not yet have FillComplete() called on it.
    """
  return ___init__.Multiply(*args)
from PyTrilinos import Epetra
from PyTrilinos import PropertyBase
from PyTrilinos import typed_tuple
from PyTrilinos import tuple_of_int
from PyTrilinos import tuple_of_str
tuple_of_Vector = typed_tuple(Epetra.Vector)


class InArgs(PropertyBase):
    """
    InArgs proxy class.

    This is a 'Property' class restricted to specific attributes that are
    type-checked. These properties are:

    description  - string description of associated ModelEvaluation
    x            - bool or Epetra.Vector: solution vector support.  If True, the
                   solver should allocate the vector.  If False, x is not
                   supported.  If a vector, the solver should use the
                   user-provided data.  (default False)
    x_dot        - bool or Epetra.Vector: time derivative of solution vector
                   support.  If True, the solver should allocate the vector.  If
                   False, x_dot is not supported.  If a vector, the solver
                   should use the user- provided data.  (default False)
    p            - int or tuple_of_Vector: VARIABLE P support.  If an int, the
                   solver should allocate an array of the given number of
                   vectors.  If 0, p is not supported.  If a tuple_of_Vector,
                   the solver should use the user-provided data.  (default 0)
    t            - float: time (default None)
    alpha        - float: VARIABLE ALPHA (default None)
    beta         - float: VARIABLE BETA (default None)
    """
    props = {'description' : str,
             'x'           : (bool, Epetra.Vector),
             #'x_poly'      : Teuchos.Polynomial,
             'x_dot'       : (bool, Epetra.Vector),
             #'x_dot_poly'  : Teuchos.Polynomial,
             'p'           : (int, tuple_of_Vector),
             't'           : float,
             'alpha'       : float,
             'beta'        : float
             }
    defaults = {'description' : 'WARNING!  THIS INARGS OBJECT IS UNINITALIZED!',
                'x'           : False,
                'x_dot'       : False,
                'p'           : 0
                }
    def __init__(self, **kwargs):
        PropertyBase.__init__(self, **kwargs)


class Evaluation(PropertyBase):
    """
    Evaluation< RCP<Epetra_Vector> > proxy class

    This is a 'Property' class restricted to specific attributes that are
    type-checked. These properties are:

    vector  - Epetra.Vector: (default None)
    type    - str: an enumeration limited to 'exact', 'approx_deriv', and
              'very_approx_deriv' (default None)
    """
    props = {'vector' : Epetra.Vector,
             'type'   : ('exact', 'approx_deriv', 'very_approx_deriv')
             }
    def __init__(self, **kwargs):
        PropertyBase.__init__(self, **kwargs)

tuple_of_Evaluation = typed_tuple(Evaluation)


class DerivativeSupport(PropertyBase):
    """
    DerivativeSupport proxy class

    This is a 'Property' class restricted to specific attributes that are
    type-checked. These properties are:

    linearOp      - bool: True indicates that derivative is a linear operator
                    (default False)
    mVByCol       - bool: True indicates that derivative is a MultiVector stored
                    by column (defualt False)
    transMVByRow  - bool: True indicates that derivative is a transpose
                    MultiVector stored by row (default False)
    """
    props = {'linearOp'     : bool,
             'mVByCol'      : bool,
             'transMVByRow' : bool
             }
    defaults = {'linearOp'     : False,
                'mVByCol'      : False,
                'transMVByRow' : False
                }
    def __init__(self, **kwargs):
        PropertyBase.__init__(self, **kwargs)
    def none(self):
        noTrue = [True] * len(self.props)
        return (props.values() == noTrue)

tuple_of_DerivativeSupport = typed_tuple(DerivativeSupport)


class DerivativeProperties(PropertyBase):
    """
    DerivativeProperties proxy class

    This is a 'Property' class restricted to specific attributes that are
    type-checked. These properties are:

    linearity        - str: an enumeration limited to 'unknown', 'const' and
                       'nonconst' (default 'unknown')
    rank             - str: an enumeration limited to 'unknown', 'full' and
                       'deficient' (default 'unknown')
    supportsAdjoint  - bool: True indicates that the adjoint is supported
                       (default False)
    """
    props = {'linearity'       : ('unknown', 'const', 'nonconst'),
             'rank'            : ('unknown', 'full', 'deficient'),
             'supportsAdjoint' : bool}
    defaults = {'linearity'       : 'unknown',
                'rank'            : 'unknown',
                'supportsAdjoint' : False}
    def __init__(self, **kwargs):
        PropertyBase.__init__(self, **kwargs)

tuple_of_DerivativeProperties = typed_tuple(DerivativeProperties)


class DerivativeMultiVector(PropertyBase):
    """
    DerivativeMultiVector proxy class

    This is a 'Property' class restricted to specific attributes that are
    type-checked. These properties are:

    multiVector   - Epetra.MultiVector: (default None)
    orientation   - str: an enumeration limited to 'mv_by_col', and
                    'trans_mv_by_row' (default None)
    paramIndexes  - tuple_of_int: (default None)
    """
    props = {'multiVector'  : Epetra.MultiVector,
             'orientation'  : ('mv_by_col', 'trans_mv_by_row'),
             'paramIndexes' : tuple_of_int
             }
    def __init__(self, **kwargs):
        PropertyBase.__init__(self, **kwargs)


class Derivative(PropertyBase):
    """
    Derivative proxy class

    This is a 'Property' class restricted to specific attributes that are
    type-checked. These properties are:

    operator               - Epetra.Operator (default None)
    derivativeMultiVector  - DerivativeMultiVector (default None)

    Only one or the other of these two attributes should be set, to indicate the
    nature of the derivitive evaluation.
    """
    props = {'operator'              : Epetra.Operator,
             'derivativeMultiVector' : DerivativeMultiVector
             }
    def __init__(self, **kwargs):
        PropertyBase.__init__(self, **kwargs)
    def isEmpty(self):
        return (self.operator is None) and (self.derivativeMultiVector is None)

tuple_of_Derivative = typed_tuple(Derivative)


class OutArgs(PropertyBase):
    """
    OutArgs proxy class

    This is a 'Property' class restricted to specific attributes that are
    type-checked. These properties are:

    description          - string description of associated ModelEvaluation
    g                    - (int, tuple_of_Evaluation): VARIABLE G support.  If
                           an int, the solver should allocate an array of the
                           given number of Evaluations.  If 0, g is not
                           supported.  If a tuple_of_Evaluation, the solver
                           should use the user-provided data.  (default 0)
    f                    - (bool, Evaluation): VARIABLE F support.  If True, the
                           solver should allocate the Evaluation.  If False, f
                           is not supported.  If an Evaluation, the solver
                           should use the user-supplied data.  (default False)
    W                    - (bool, Epetra.Operator): VARIABLE W support.  If True, the
                           solver should allocate the operator.  If False, W
                           is not supported.  If an operator, the solver
                           should use the user-supplied data.  (default False)
    W_properties         - DerivativeProperties: derivative properties for
                           VARIABLE W.  (default None)
    DfDp                 - (int, tuple_of_Derivative): VARIABLE DFDP support.  If
                           an int, the solver should allocate an array of the
                           given number of Derivatives.  If 0, DfDp is not
                           supported.  If a tuple_of_Derivative, the solver
                           should use the user-provided data.  (default 0)
    DfDp_properties      - tuple_of_DerivativeProperties: derivative properties
                           for VARIABLE DFDP.  (default None)
    DgDx                 - (int, tuple_of_Derivative): VARIABLE DGDX support.  If
                           an int, the solver should allocate an array of the
                           given number of Derivatives.  If 0, DgDx is not
                           supported.  If a tuple_of_Derivative, the solver
                           should use the user-provided data.  (default 0)
    DgDx_properties      - tuple_of_DerivativeProperties: derivative properties
                           for VARIABLE DGDX.  (default None)
    DgDx_dot             - (int, tuple_of_Derivative): VARIABLE DGDX_DOT support.
                           If an int, the solver should allocate an array of the
                           given number of Derivatives.  If 0, DgDx_dot is not
                           supported.  If a tuple_of_Derivative, the solver
                           should use the user-provided data.  (default 0)
    DgDx_dot_properties  - tuple_of_DerivativeProperties: derivative properties
                           for VARIABLE DGDX_DOT.  (default None)
    DgDp                 - (int, tuple_of_Derivative): VARIABLE DGDP support.  If
                           an int, the solver should allocate an array of the
                           given number of Derivatives.  If 0, DgDp is not
                           supported.  If a tuple_of_Derivative, the solver
                           should use the user-provided data.  (default 0)
    DgDp_properties      - tuple_of_DerivativeProperties: derivative properties
                           for VARIABLE DGDP.  (default None)
    """
    props = {'description'         : str,
             'g'                   : (int, tuple_of_Evaluation),
             'f'                   : (bool, Evaluation),
             'W'                   : (bool, Epetra.Operator),
             'W_properties'        : DerivativeProperties,
             #'f_poly'              : Teuchos.Polynomial,
             'DfDp'                : (int, tuple_of_Derivative),
             'DfDp_properties'     : tuple_of_DerivativeProperties,
             'DgDx'                : (int, tuple_of_Derivative),
             'DgDx_properties'     : tuple_of_DerivativeProperties,
             'DgDx_dot'            : (int, tuple_of_Derivative),
             'DgDx_dot_properties' : tuple_of_DerivativeProperties,
             'DgDp'                : (int, tuple_of_Derivative),
             'DgDp_properties'     : tuple_of_DerivativeProperties
             }
    defaults = {'description' : 'WARNING!  THIS OUTARGS OBJECT IS UNINITALIZED!',
                'g'           : 0,
                'f'           : False,
                'W'           : False,
                'DfDp'        : 0,
                'DgDx'        : 0,
                'DgDx_dot'    : 0,
                'DgDp'        : 0
                }
    def __init__(self, **kwargs):
        PropertyBase.__init__(self, **kwargs)


class ModelEvaluator(PyTrilinos.Teuchos.Describable):
    """Proxy of C++ EpetraExt::ModelEvaluator class"""
    __swig_setmethods__ = {}
    for _s in [PyTrilinos.Teuchos.Describable]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ModelEvaluator, name, value)
    __swig_getmethods__ = {}
    for _s in [PyTrilinos.Teuchos.Describable]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ModelEvaluator, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_ModelEvaluator
    def get_x_map(self, *args):
        """get_x_map(ModelEvaluator self) -> Teuchos::RCP< Epetra_Map const >"""
        return ___init__.ModelEvaluator_get_x_map(self, *args)

    def get_f_map(self, *args):
        """get_f_map(ModelEvaluator self) -> Teuchos::RCP< Epetra_Map const >"""
        return ___init__.ModelEvaluator_get_f_map(self, *args)

    def get_p_map(self, *args):
        """get_p_map(ModelEvaluator self, int l) -> Teuchos::RCP< Epetra_Map const >"""
        return ___init__.ModelEvaluator_get_p_map(self, *args)

    def get_p_names(self, *args):
        """get_p_names(ModelEvaluator self, int l) -> Teuchos::RCP< Teuchos::Array< std::string > const >"""
        return ___init__.ModelEvaluator_get_p_names(self, *args)

    def get_g_map(self, *args):
        """get_g_map(ModelEvaluator self, int j) -> Teuchos::RCP< Epetra_Map const >"""
        return ___init__.ModelEvaluator_get_g_map(self, *args)

    def get_x_init(self, *args):
        """get_x_init(ModelEvaluator self) -> Teuchos::RCP< Epetra_Vector const >"""
        return ___init__.ModelEvaluator_get_x_init(self, *args)

    def get_x_dot_init(self, *args):
        """get_x_dot_init(ModelEvaluator self) -> Teuchos::RCP< Epetra_Vector const >"""
        return ___init__.ModelEvaluator_get_x_dot_init(self, *args)

    def get_p_init(self, *args):
        """get_p_init(ModelEvaluator self, int l) -> Teuchos::RCP< Epetra_Vector const >"""
        return ___init__.ModelEvaluator_get_p_init(self, *args)

    def get_t_init(self, *args):
        """get_t_init(ModelEvaluator self) -> double"""
        return ___init__.ModelEvaluator_get_t_init(self, *args)

    def getInfBound(self, *args):
        """getInfBound(ModelEvaluator self) -> double"""
        return ___init__.ModelEvaluator_getInfBound(self, *args)

    def get_x_lower_bounds(self, *args):
        """get_x_lower_bounds(ModelEvaluator self) -> Teuchos::RCP< Epetra_Vector const >"""
        return ___init__.ModelEvaluator_get_x_lower_bounds(self, *args)

    def get_x_upper_bounds(self, *args):
        """get_x_upper_bounds(ModelEvaluator self) -> Teuchos::RCP< Epetra_Vector const >"""
        return ___init__.ModelEvaluator_get_x_upper_bounds(self, *args)

    def get_p_lower_bounds(self, *args):
        """get_p_lower_bounds(ModelEvaluator self, int l) -> Teuchos::RCP< Epetra_Vector const >"""
        return ___init__.ModelEvaluator_get_p_lower_bounds(self, *args)

    def get_p_upper_bounds(self, *args):
        """get_p_upper_bounds(ModelEvaluator self, int l) -> Teuchos::RCP< Epetra_Vector const >"""
        return ___init__.ModelEvaluator_get_p_upper_bounds(self, *args)

    def get_t_lower_bound(self, *args):
        """get_t_lower_bound(ModelEvaluator self) -> double"""
        return ___init__.ModelEvaluator_get_t_lower_bound(self, *args)

    def get_t_upper_bound(self, *args):
        """get_t_upper_bound(ModelEvaluator self) -> double"""
        return ___init__.ModelEvaluator_get_t_upper_bound(self, *args)

    def create_W(self, *args):
        """create_W(ModelEvaluator self) -> Teuchos::RCP< Epetra_Operator >"""
        return ___init__.ModelEvaluator_create_W(self, *args)

    def create_DfDp_op(self, *args):
        """create_DfDp_op(ModelEvaluator self, int l) -> Teuchos::RCP< Epetra_Operator >"""
        return ___init__.ModelEvaluator_create_DfDp_op(self, *args)

    def create_DgDx_dot_op(self, *args):
        """create_DgDx_dot_op(ModelEvaluator self, int j) -> Teuchos::RCP< Epetra_Operator >"""
        return ___init__.ModelEvaluator_create_DgDx_dot_op(self, *args)

    def create_DgDx_op(self, *args):
        """create_DgDx_op(ModelEvaluator self, int j) -> Teuchos::RCP< Epetra_Operator >"""
        return ___init__.ModelEvaluator_create_DgDx_op(self, *args)

    def create_DgDp_op(self, *args):
        """create_DgDp_op(ModelEvaluator self, int j, int l) -> Teuchos::RCP< Epetra_Operator >"""
        return ___init__.ModelEvaluator_create_DgDp_op(self, *args)

    def createInArgs(self, *args):
        """createInArgs(ModelEvaluator self) -> EpetraExt::ModelEvaluator::InArgs"""
        return ___init__.ModelEvaluator_createInArgs(self, *args)

    def createOutArgs(self, *args):
        """createOutArgs(ModelEvaluator self) -> EpetraExt::ModelEvaluator::OutArgs"""
        return ___init__.ModelEvaluator_createOutArgs(self, *args)

    def evalModel(self, *args):
        """evalModel(ModelEvaluator self, EpetraExt::ModelEvaluator::InArgs const & inArgs, EpetraExt::ModelEvaluator::OutArgs const & outArgs)"""
        return ___init__.ModelEvaluator_evalModel(self, *args)

    def __init__(self, *args): 
        """__init__(EpetraExt::ModelEvaluator self) -> ModelEvaluator"""
        if self.__class__ == ModelEvaluator:
            _self = None
        else:
            _self = self
        this = ___init__.new_ModelEvaluator(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    def __disown__(self):
        self.this.disown()
        ___init__.disown_ModelEvaluator(self)
        return weakref_proxy(self)
ModelEvaluator_swigregister = ___init__.ModelEvaluator_swigregister
ModelEvaluator_swigregister(ModelEvaluator)

import PyTrilinos.NOX.Abstract
import Interface
class Group(PyTrilinos.NOX.Abstract.Group):
    """
    Concrete implementation of NOX::Abstract::Group for Trilinos/Epetra.

    This group is set up to use the linear algebra services provided
    through the Trilinos/Epetra package with AztecOO for the linear
    solver.

    C++ includes: NOX_Epetra_Group.H 
    """
    __swig_setmethods__ = {}
    for _s in [PyTrilinos.NOX.Abstract.Group]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Group, name, value)
    __swig_getmethods__ = {}
    for _s in [PyTrilinos.NOX.Abstract.Group]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Group, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(NOX::Epetra::Group self, ParameterList printingParams, Teuchos::RCP< NOX::Epetra::Interface::Required > const & i, 
            Vector initialGuess) -> Group
        __init__(NOX::Epetra::Group self, ParameterList printingParams, Teuchos::RCP< NOX::Epetra::Interface::Required > const & i, 
            Vector initialGuess, Teuchos::RCP< NOX::Epetra::LinearSystem > const & linSys) -> Group
        __init__(NOX::Epetra::Group self, Group source, NOX::CopyType type=DeepCopy) -> Group

        Group::Group(const
        NOX::Epetra::Group &source, NOX::CopyType type=NOX::DeepCopy)

        Copy constructor. If type is DeepCopy, takes ownership of valid shared
        linear system. 
        """
        this = ___init__.new_Group(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Group
    def setX(self, *args):
        """
        setX(Group self, Vector y)
        setX(Group self, Vector y)

        void
        Group::setX(const NOX::Abstract::Vector &y)

        Set the solution vector x to y.

        This should invalidate the function value, Jacobian, gradient, and
        Newton direction.

        Throw an error if the copy fails.

        Reference to this object 
        """
        return ___init__.Group_setX(self, *args)

    def computeX(self, *args):
        """
        computeX(Group self, Group grp, Vector d, double step)
        computeX(Group self, Group grp, Vector d, double step)

        void
        Group::computeX(const NOX::Abstract::Group &grp, const
        NOX::Abstract::Vector &d, double step)

        Compute x = grp.x + step * d.

        Let $x$ denote this group's solution vector. Let $\\hat x$ denote
        the result of grp.getX(). Then set \\[ x = \\hat x +
        \\mbox{step} \\; d. \\]

        This should invalidate the function value, Jacobian, gradient, and
        Newton direction.

        Throw an error if the copy fails.

        Reference to this object 
        """
        return ___init__.Group_computeX(self, *args)

    def computeF(self, *args):
        """
        computeF(Group self) -> NOX::Abstract::Group::ReturnType

        Abstract::Group::ReturnType Group::computeF()

        Compute and store F(x).

        It's generally useful to also compute and store the 2-norm of F(x) at
        this point for later access by the getNormF() function.

        NOX::Abstract::Group::Failed - If the computation fails in any way

        NOX::Abstract::Group::Ok - Otherwise 
        """
        return ___init__.Group_computeF(self, *args)

    def computeJacobian(self, *args):
        """
        computeJacobian(Group self) -> NOX::Abstract::Group::ReturnType

        Abstract::Group::ReturnType Group::computeJacobian()

        Compute and store Jacobian.

        Recall that \\[ F(x) = \\left[ \\begin{array}{c} F_1(x) \\\\
        F_2(x) \\\\ \\vdots \\\\ F_n(x) \\\\ \\end{array}
        \\right]. \\]

        The Jacobian is denoted by $J$ and defined by \\[ J_{ij} =
        \\frac{\\partial F_i}{\\partial x_j} (x). \\]

        If this is a shared object, this group should taken ownership of the
        Jacobian before it computes it.

        NOX::Abstract::Group::NotDefined - Returned by default implementation
        in NOX::Abstract::Group

        NOX::Abstract::Group::Failed - If the computation fails in any other
        way

        NOX::Abstract::Group::Ok - Otherwise 
        """
        return ___init__.Group_computeJacobian(self, *args)

    def computeGradient(self, *args):
        """
        computeGradient(Group self) -> NOX::Abstract::Group::ReturnType

        Abstract::Group::ReturnType Group::computeGradient()

        Compute and store gradient.

        We can pose the nonlinear equation problem $F(x) = 0$ as an
        optimization problem as follows: \\[ \\min f(x) \\equiv
        \\frac{1}{2} \\|F(x)\\|_2^2. \\]

        In that case, the gradient (of $f$) is defined as \\[ g \\equiv
        J^T F. \\]

        NOX::Abstract::Group::NotDefined - Returned by default implementation
        in NOX::Abstract::Group

        NOX::Abstract::Group::BadDependency - If either $F$ or $J$ has not
        been computed

        NOX::Abstract::Group::Failed - If the computation fails in any other
        way

        NOX::Abstract::Group::Ok - Otherwise 
        """
        return ___init__.Group_computeGradient(self, *args)

    def computeNewton(self, *args):
        """
        computeNewton(Group self, ParameterList params) -> NOX::Abstract::Group::ReturnType

        Abstract::Group::ReturnType
        Group::computeNewton(Teuchos::ParameterList &params)

        Compute the Newton direction, using parameters for the linear solve.

        The Newton direction is the solution, s, of \\[ J s = -F. \\]

        The parameters are from the "Linear %Solver" sublist of the
        "Direction" sublist that is passed to solver during construction.

        The "Tolerance" parameter may be added/modified in the sublist of
        "Linear Solver" parameters that is passed into this function. The
        solution should be such that \\[ \\frac{\\| J s - (-F)
        \\|_2}{\\max \\{ 1, \\|F\\|_2\\} } < \\mbox{Tolerance}
        \\]

        NOX::Abstract::Group::NotDefined - Returned by default implementation
        in NOX::Abstract::Group

        NOX::Abstract::Group::BadDependency - If either $F$ or $J$ has not
        been computed

        NOX::Abstract::Group::NotConverged - If the linear solve fails to
        satisfy the "Tolerance" specified in params

        NOX::Abstract::Group::Failed - If the computation fails in any other
        way

        NOX::Abstract::Group::Ok - Otherwise 
        """
        return ___init__.Group_computeNewton(self, *args)

    def applyJacobian(self, *args):
        """
        applyJacobian(Group self, Vector input, Vector result) -> NOX::Abstract::Group::ReturnType
        applyJacobian(Group self, Vector input, Vector result) -> NOX::Abstract::Group::ReturnType

        Abstract::Group::ReturnType Group::applyJacobian(const
        NOX::Abstract::Vector &input, NOX::Abstract::Vector &result) const

        Applies Jacobian to the given input vector and puts the answer in the
        result.

        Computes \\[ v = J u, \\] where $J$ is the Jacobian, $u$ is the
        input vector, and $v$ is the result vector.

        NOX::Abstract::Group::NotDefined - Returned by default implementation
        in NOX::Abstract::Group

        NOX::Abstract::Group::BadDependency - If the Jacobian $J$ has not been
        computed

        NOX::Abstract::Group::Failed - If the computation fails

        NOX::Abstract::Group::Ok - Otherwise 
        """
        return ___init__.Group_applyJacobian(self, *args)

    def applyJacobianTranspose(self, *args):
        """
        applyJacobianTranspose(Group self, Vector input, Vector result) -> NOX::Abstract::Group::ReturnType
        applyJacobianTranspose(Group self, Vector input, Vector result) -> NOX::Abstract::Group::ReturnType

        Abstract::Group::ReturnType Group::applyJacobianTranspose(const
        NOX::Abstract::Vector &input, NOX::Abstract::Vector &result) const

        Applies Jacobian-Transpose to the given input vector and puts the
        answer in the result.

        Computes \\[ v = J^T u, \\] where $J$ is the Jacobian, $u$ is the
        input vector, and $v$ is the result vector.

        NOX::Abstract::Group::NotDefined - Returned by default implementation
        in NOX::Abstract::Group

        NOX::Abstract::Group::BadDependency - If $J$ has not been computed

        NOX::Abstract::Group::Failed - If the computation fails

        NOX::Abstract::Group::Ok - Otherwise 
        """
        return ___init__.Group_applyJacobianTranspose(self, *args)

    def applyJacobianInverse(self, *args):
        """
        applyJacobianInverse(Group self, ParameterList params, Vector input, Vector result) -> NOX::Abstract::Group::ReturnType
        applyJacobianInverse(Group self, ParameterList params, Vector input, Vector result) -> NOX::Abstract::Group::ReturnType

        Abstract::Group::ReturnType
        Group::applyJacobianInverse(Teuchos::ParameterList &params, const
        NOX::Abstract::Vector &input, NOX::Abstract::Vector &result) const

        Applies the inverse of the Jacobian matrix to the given input vector
        and puts the answer in result.

        Computes \\[ v = J^{-1} u, \\] where $J$ is the Jacobian, $u$ is
        the input vector, and $v$ is the result vector.

        The "Tolerance" parameter specifies that the solution should be such
        that \\[ \\frac{\\| J v - u \\|_2}{\\max \\{ 1,
        \\|u\\|_2\\} } < \\mbox{Tolerance} \\]

        NOX::Abstract::Group::NotDefined - Returned by default implementation
        in NOX::Abstract::Group

        NOX::Abstract::Group::BadDependency - If $J$ has not been computed

        NOX::Abstract::Group::NotConverged - If the linear solve fails to
        satisfy the "Tolerance" specified in params

        NOX::Abstract::Group::Failed - If the computation fails

        NOX::Abstract::Group::Ok - Otherwise

        The parameter "Tolerance" may be added/modified in the list of
        parameters - this is the ideal solution tolerance for an iterative
        linear solve. 
        """
        return ___init__.Group_applyJacobianInverse(self, *args)

    def applyRightPreconditioning(self, *args):
        """
        applyRightPreconditioning(Group self, bool useTranspose, ParameterList params, Vector input, Vector result) -> NOX::Abstract::Group::ReturnType
        applyRightPreconditioning(Group self, bool useTranspose, ParameterList params, Vector input, Vector result) -> NOX::Abstract::Group::ReturnType

        Abstract::Group::ReturnType Group::applyRightPreconditioning(bool
        useTranspose, Teuchos::ParameterList &params, const
        NOX::Abstract::Vector &input, NOX::Abstract::Vector &result) const

        Apply right preconditiong to the given input vector.

        Let $M$ be a right preconditioner for the Jacobian $J$; in other
        words, $M$ is a matrix such that \\[ JM \\approx I. \\]

        Compute \\[ u = M^{-1} v, \\] where $u$ is the input vector and
        $v$ is the result vector.

        If useTranspose is true, then the transpose of the preconditioner is
        applied: \\[ u = {M^{-1}}^T v, \\] The transpose preconditioner is
        currently only required for Tensor methods.

        The "Tolerance" parameter specifies that the solution should be such
        that \\[ \\frac{\\| M v - u \\|_2}{\\max \\{ 1,
        \\|u\\|_2\\} } < \\mbox{Tolerance} \\]

        NOX::Abstract::Group::NotDefined - Returned by default implementation
        in NOX::Abstract::Group

        NOX::Abstract::Group::NotConverged - If the linear solve fails to
        satisfy the "Tolerance" specified in params

        NOX::Abstract::Group::Failed - If the computation fails

        NOX::Abstract::Group::Ok - Otherwise

        The parameters are from the "Linear %Solver" sublist of the
        "Direction" sublist that is passed to solver during construction. 
        """
        return ___init__.Group_applyRightPreconditioning(self, *args)

    def isF(self, *args):
        """
        isF(Group self) -> bool

        bool Group::isF()
        const

        Return true if F is valid. 
        """
        return ___init__.Group_isF(self, *args)

    def isJacobian(self, *args):
        """
        isJacobian(Group self) -> bool

        bool
        Group::isJacobian() const

        Return true if the Jacobian is valid.

        Default implementation in NOX::Abstract::Group returns false. 
        """
        return ___init__.Group_isJacobian(self, *args)

    def isGradient(self, *args):
        """
        isGradient(Group self) -> bool

        bool
        Group::isGradient() const

        Return true if the gradient is valid.

        Default implementation in NOX::Abstract::Group returns false. 
        """
        return ___init__.Group_isGradient(self, *args)

    def isNewton(self, *args):
        """
        isNewton(Group self) -> bool

        bool
        Group::isNewton() const

        Return true if the Newton direction is valid.

        Default implementation in NOX::Abstract::Group returns false. 
        """
        return ___init__.Group_isNewton(self, *args)

    def isNormNewtonSolveResidual(self, *args):
        """
        isNormNewtonSolveResidual(Group self) -> bool

        bool Group::isNormNewtonSolveResidual() const

        Returns true if the value of the Norm of the linear model for a full
        Newton step ||Js + f|| is valid with respect to the current solution
        vector. 
        """
        return ___init__.Group_isNormNewtonSolveResidual(self, *args)

    def isPreconditioner(self, *args):
        """
        isPreconditioner(Group self) -> bool

        bool
        Group::isPreconditioner() const

        Returns true if an explicitly constructed preconditioner exists (i.e.
        one that is computed and saved for further use in multiple calls to
        applyRightPreconditioner). 
        """
        return ___init__.Group_isPreconditioner(self, *args)

    def isConditionNumber(self, *args):
        """
        isConditionNumber(Group self) -> bool

        bool
        Group::isConditionNumber() const

        Returns true if the condition number has been computed. 
        """
        return ___init__.Group_isConditionNumber(self, *args)

    def getNormF(self, *args):
        """
        getNormF(Group self) -> double

        double
        Group::getNormF() const

        Return 2-norm of F(x).

        In other words, \\[ \\sqrt{\\sum_{i=1}^n F_i^2} \\] 
        """
        return ___init__.Group_getNormF(self, *args)

    def getX(self, *args):
        """
        getX(Group self) -> Teuchos::RCP< NOX::Abstract::Vector const >

        virtual
        Teuchos::RCP< const NOX::Abstract::Vector >
        NOX::Epetra::Group::getXPtr() const

        Return RCP to solution vector. 
        """
        return ___init__.Group_getX(self, *args)

    def getF(self, *args):
        """
        getF(Group self) -> Teuchos::RCP< NOX::Abstract::Vector const >

        virtual
        Teuchos::RCP< const NOX::Abstract::Vector >
        NOX::Epetra::Group::getFPtr() const

        Return RCP to F(x) 
        """
        return ___init__.Group_getF(self, *args)

    def getGradient(self, *args):
        """
        getGradient(Group self) -> Teuchos::RCP< NOX::Abstract::Vector const >

        virtual
        Teuchos::RCP< const NOX::Abstract::Vector >
        NOX::Epetra::Group::getGradientPtr() const

        Return RCP to gradient. 
        """
        return ___init__.Group_getGradient(self, *args)

    def getNewton(self, *args):
        """
        getNewton(Group self) -> Teuchos::RCP< NOX::Abstract::Vector const >

        virtual
        Teuchos::RCP< const NOX::Abstract::Vector >
        NOX::Epetra::Group::getNewtonPtr() const

        Return RCP to Newton direction. 
        """
        return ___init__.Group_getNewton(self, *args)

    def getNormLastLinearSolveResidual(self, *args):
        """
        getNormLastLinearSolveResidual(Group self, double & residual) -> NOX::Abstract::Group::ReturnType

        Abstract::Group::ReturnType
        NOX::Epetra::Group::getNormLastLinearSolveResidual(double &residual)
        const

        Returns the 2-norm of the residual of the linear model used in the
        Newton solve computation, ||Js+f||. This does not account for line
        search adjustments to the step length! 
        """
        return ___init__.Group_getNormLastLinearSolveResidual(self, *args)

    def clone(self, *args):
        """
        clone(Group self, NOX::CopyType type=DeepCopy) -> Teuchos::RCP< NOX::Abstract::Group >

        Teuchos::RCP<
        NOX::Abstract::Group > Group::clone(CopyType type=DeepCopy) const

        Create a new Group of the same derived type as this one by cloning
        this one, and return a ref count pointer to the new group.

        If type is NOX::DeepCopy, then we need to create an exact replica of
        "this". Otherwise, if type is NOX::ShapeCopy, we need only replicate
        the shape of "this" (only the memory is allocated, the values are
        not copied into the vectors and Jacobian). Returns NULL if clone is
        not supported.

        Any shared data should have its ownership transfered to this group
        from the source for a NOX::DeepCopy. 
        """
        return ___init__.Group_clone(self, *args)

    def getRequiredInterface(self, *args):
        """
        getRequiredInterface(Group self) -> Teuchos::RCP< NOX::Epetra::Interface::Required >

        Teuchos::RCP< NOX::Epetra::Interface::Required >
        Group::getRequiredInterface()

        Return the userInterface. 
        """
        return ___init__.Group_getRequiredInterface(self, *args)

    def getLinearSystem(self, *args):
        """
        getLinearSystem(Group self) -> Teuchos::RCP< NOX::Epetra::LinearSystem const >
        getLinearSystem(Group self) -> Teuchos::RCP< NOX::Epetra::LinearSystem >

        Teuchos::RCP< NOX::Epetra::LinearSystem > Group::getLinearSystem()

        Return the Linear System. 
        """
        return ___init__.Group_getLinearSystem(self, *args)

    def computeJacobianConditionNumber(self, *args):
        """
        computeJacobianConditionNumber(Group self, int maxIters, double tolerance, int krylovSubspaceSize=100, bool printOutput=False) -> NOX::Abstract::Group::ReturnType

        Abstract::Group::ReturnType
        NOX::Epetra::Group::computeJacobianConditionNumber(int maxIters,
        double tolerance, int krylovSubspaceSize=100, bool printOutput=false)

        """
        return ___init__.Group_computeJacobianConditionNumber(self, *args)

    def getJacobianConditionNumber(self, *args):
        """
        getJacobianConditionNumber(Group self) -> double

        double NOX::Epetra::Group::getJacobianConditionNumber() const

        Returns the condition number of the Jacobian matrix. 
        """
        return ___init__.Group_getJacobianConditionNumber(self, *args)

    def disableLinearResidualComputation(self, *args):
        """
        disableLinearResidualComputation(Group self, bool const disableChoice)

        void
        NOX::Epetra::Group::disableLinearResidualComputation(const bool
        disableChoice)

        Sets option to disable linear resid computation. If disabled, this
        saves on a MatVec per Newton but disallows inexact Newton methods. 
        """
        return ___init__.Group_disableLinearResidualComputation(self, *args)

Group_swigregister = ___init__.Group_swigregister
Group_swigregister(Group)

class Vector(PyTrilinos.NOX.Abstract.Vector):
    """
    Implementation of NOX::Abstract::Vector for Epetra vectors.

    C++ includes: NOX_Epetra_Vector.H 
    """
    __swig_setmethods__ = {}
    for _s in [PyTrilinos.NOX.Abstract.Vector]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Vector, name, value)
    __swig_getmethods__ = {}
    for _s in [PyTrilinos.NOX.Abstract.Vector]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Vector, name)
    __repr__ = _swig_repr
    CreateView = ___init__.Vector_CreateView
    CreateCopy = ___init__.Vector_CreateCopy
    def __init__(self, *args): 
        """
        __init__(NOX::Epetra::Vector self, Teuchos::RCP< Epetra_Vector > const & source, NOX::Epetra::Vector::MemoryType memoryType=CreateCopy, 
            NOX::CopyType type=DeepCopy, Teuchos::RCP< NOX::Epetra::VectorSpace > vs=Teuchos::null) -> Vector
        __init__(NOX::Epetra::Vector self, Epetra_Vector source, NOX::CopyType type=DeepCopy, Teuchos::RCP< NOX::Epetra::VectorSpace > vs=Teuchos::null) -> Vector
        __init__(NOX::Epetra::Vector self, Vector source, NOX::CopyType type=DeepCopy) -> Vector

        NOX::Epetra::Vector::Vector(const NOX::Epetra::Vector &source,
        NOX::CopyType type=NOX::DeepCopy)

        Copy constructor. 
        """
        this = ___init__.new_Vector(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Vector
    def getEpetraVector(self, *args):
        """
        getEpetraVector(Vector self) -> Epetra_Vector

        const
        Epetra_Vector & NOX::Epetra::Vector::getEpetraVector() const

        Get const reference to underlying Epetra vector. 
        """
        return ___init__.Vector_getEpetraVector(self, *args)

    def init(self, *args):
        """
        init(Vector self, double gamma) -> Vector

        NOX::Abstract::Vector & NOX::Epetra::Vector::init(double gamma)

        Initialize every element of this vector with gamma.

        Here x represents this vector, and we update it as \\[ x_i =
        \\gamma \\quad \\mbox{for } i=1,\\dots,n \\] Reference to
        this object 
        """
        return ___init__.Vector_init(self, *args)

    def random(self, *args):
        """
        random(Vector self, bool useSeed=False, int seed=1) -> Vector

        NOX::Abstract::Vector & NOX::Epetra::Vector::random(bool
        useSeed=false, int seed=1)

        Initialize each element of this vector with a random value.

        If useSeed is true, uses the value of seed to seed the random number
        generator before filling the entries of this vector. So, if two calls
        are made where useSeed is true and seed is the same, then the vectors
        returned should be the same.

        Default implementation throw an error. Only referenced by LOCA
        methods.

        Reference to this object 
        """
        return ___init__.Vector_random(self, *args)

    def abs(self, *args):
        """
        abs(Vector self, Vector y) -> Vector
        abs(Vector self, Vector y) -> Vector

        NOX::Abstract::Vector & NOX::Epetra::Vector::abs(const
        NOX::Abstract::Vector &y)

        Put element-wise absolute values of source vector y into this vector.

        Here x represents this vector, and we update it as \\[ x_i = | y_i |
        \\quad \\mbox{for } i=1,\\dots,n \\]

        Reference to this object 
        """
        return ___init__.Vector_abs(self, *args)

    def reciprocal(self, *args):
        """
        reciprocal(Vector self, Vector y) -> Vector
        reciprocal(Vector self, Vector y) -> Vector

        NOX::Abstract::Vector & NOX::Epetra::Vector::reciprocal(const
        NOX::Abstract::Vector &y)

        Put element-wise reciprocal of source vector y into this vector.

        Here x represents this vector, and we update it as \\[ x_i =
        \\frac{1}{y_i} \\quad \\mbox{for } i=1,\\dots,n \\]

        Reference to this object 
        """
        return ___init__.Vector_reciprocal(self, *args)

    def scale(self, *args):
        """
        scale(Vector self, double gamma) -> Vector
        scale(Vector self, Vector a) -> Vector
        scale(Vector self, Vector a) -> Vector

        NOX::Abstract::Vector & NOX::Epetra::Vector::scale(const
        NOX::Abstract::Vector &a)

        Scale this vector element-by-element by the vector a.

        Here x represents this vector, and we update it as \\[ x_i = x_i
        \\cdot a_i \\quad \\mbox{for } i=1,\\dots,n \\]

        Reference to this object 
        """
        return ___init__.Vector_scale(self, *args)

    def update(self, *args):
        """
        update(Vector self, double alpha, Vector a, double gamma=0.0) -> Vector
        update(Vector self, double alpha, Vector a, double gamma=0.0) -> Vector
        update(Vector self, double alpha, Vector a, double beta, Vector b, double gamma=0.0) -> Vector
        update(Vector self, double alpha, Vector a, double beta, Vector b, double gamma=0.0) -> Vector

        NOX::Abstract::Vector & NOX::Epetra::Vector::update(double alpha,
        const NOX::Abstract::Vector &a, double beta, const
        NOX::Abstract::Vector &b, double gamma=0.0)

        Compute x = (alpha * a) + (beta * b) + (gamma * x) where x is this
        vector.

        Here x represents this vector, and we update it as \\[ x_i =
        \\alpha \\; a_i + \\beta \\; b_i + \\gamma \\; x_i
        \\quad \\mbox{for } i=1,\\dots,n \\]

        Reference to this object 
        """
        return ___init__.Vector_update(self, *args)

    def clone(self, *args):
        """
        clone(Vector self, NOX::CopyType type=DeepCopy) -> Teuchos::RCP< NOX::Abstract::Vector >

        Teuchos::RCP<
        NOX::Abstract::Vector > NOX::Epetra::Vector::clone(CopyType
        type=DeepCopy) const

        Create a new Vector of the same underlying type by cloning "this",
        and return a pointer to the new vector.

        If type is NOX::DeepCopy, then we need to create an exact replica of
        "this". Otherwise, if type is NOX::ShapeCopy, we need only replicate
        the shape of "this" (the memory is allocated for the objects, but
        the current values are not copied into the vector). Note that there is
        no assumption that a vector created by ShapeCopy is initialized to
        zeros.

        Pointer to newly created vector or NULL if clone is not supported. 
        """
        return ___init__.Vector_clone(self, *args)

    def createMultiVector(self, *args):
        """
        createMultiVector(Vector self, NOX::Abstract::Vector const *const * vecs, int numVecs, NOX::CopyType type=DeepCopy) -> Teuchos::RCP< NOX::Abstract::MultiVector >
        createMultiVector(Vector self, int numVecs, NOX::CopyType type=DeepCopy) -> Teuchos::RCP< NOX::Abstract::MultiVector >

        Teuchos::RCP< NOX::Abstract::MultiVector >
        NOX::Epetra::Vector::createMultiVector(int numVecs, NOX::CopyType
        type=NOX::DeepCopy) const

        Create a MultiVector with numVecs columns.

        The implementation here creates a NOX::Epetra::MultiVector with either
        Shape or Deep copies of the supplied vector. 
        """
        return ___init__.Vector_createMultiVector(self, *args)

    def norm(self, *args):
        """
        norm(Vector self, NOX::Abstract::Vector::NormType type=TwoNorm) -> double
        norm(Vector self, Vector weights) -> double
        norm(Vector self, Vector weights) -> double

        double
        NOX::Epetra::Vector::norm(const NOX::Abstract::Vector &weights) const

        Weighted 2-Norm.

        Here x represents this vector, and we compute its weighted norm as
        follows: \\[ \\|x\\|_w = \\sqrt{\\sum_{i=1}^{n} w_i \\;
        x_i^2} \\]  $ \\|x\\|_w $ 
        """
        return ___init__.Vector_norm(self, *args)

    def innerProduct(self, *args):
        """
        innerProduct(Vector self, Vector y) -> double
        innerProduct(Vector self, Vector y) -> double

        double
        NOX::Epetra::Vector::innerProduct(const NOX::Abstract::Vector &y)
        const

        Inner product with y.

        Here x represents this vector, and we compute its inner product with y
        as follows: \\[ \\langle x,y \\rangle = \\sum_{i=1}^n x_i y_i
        \\]  $\\langle x,y \\rangle$ 
        """
        return ___init__.Vector_innerProduct(self, *args)

    def length(self, *args):
        """
        length(Vector self) -> int

        int
        NOX::Epetra::Vector::length() const

        Return the length of vector.

        The length of this vector

        Even if the vector is distributed across processors, this should
        return the  global length of the vector. 
        """
        return ___init__.Vector_length(self, *args)

    def _print(self, *args):
        """
        _print(Vector self, std::ostream & stream)

        void
        NOX::Epetra::Vector::print(std::ostream &stream) const

        Print the vector. To be used for debugging only. 
        """
        return ___init__.Vector__print(self, *args)

    def getVectorSpace(self, *args):
        """
        getVectorSpace(Vector self) -> Teuchos::RCP< NOX::Epetra::VectorSpace >

        Teuchos::RCP< NOX::Epetra::VectorSpace >
        NOX::Epetra::Vector::getVectorSpace() const

        Returns the NOX::Epetra::VectorSpace associated with this vector. 
        """
        return ___init__.Vector_getVectorSpace(self, *args)

Vector_swigregister = ___init__.Vector_swigregister
Vector_swigregister(Vector)

class FiniteDifference(RowMatrix,Interface.Jacobian,Interface.Preconditioner):
    """
    Concrete implementation for creating an Epetra_RowMatrix Jacobian via
    finite differencing of the residual.

    The Jacobian entries are calculated via 1st order finite differencing.
    This requires $ N + 1 $ calls to computeF() where $ N $ is the number
    of unknowns in the problem.

    \\[ J_{ij} = \\frac{\\partial F_i}{\\partial x_j} =
    \\frac{F_i(x+\\delta\\mathbf{e}_j) - F_i(x)}{\\delta} \\]

    where $J$ is the Jacobian, $F$ is the function evaluation, $x$ is the
    solution vector, and $\\delta$ is a small perturbation to the $x_j$
    entry.

    The perturbation, $ \\delta $, is calculated based on one of the
    following equations:

    \\[ \\delta = \\alpha * | x_j | + \\beta \\] \\[ \\delta
    = \\alpha * | x_j | + \\beta_j \\]

    where $ \\alpha $ is a scalar value (defaults to 1.0e-4) and $
    \\beta $ can be either a scalar or a vector (defaults to a scalar
    value of 1.0e-6). The choice is defined by the type of constructor
    used. All parameters are supplied in the constructor. In addition to
    the forward difference derivative approximation, backward or centered
    differences can be used via the setDifferenceMethod function. Note
    that centered difference provides second order spatial accuracy but at
    the cost of twice as many function evaluations.

    Since this inherits from the Epetra_RowMatrix class, it can be used as
    the preconditioning matrix for AztecOO preconditioners. This method is
    very inefficient when computing the Jacobian and is not recommended
    for large-scale systems but only for debugging purposes.

    C++ includes: NOX_Epetra_FiniteDifference.H 
    """
    __swig_setmethods__ = {}
    for _s in [RowMatrix,Interface.Jacobian,Interface.Preconditioner]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FiniteDifference, name, value)
    __swig_getmethods__ = {}
    for _s in [RowMatrix,Interface.Jacobian,Interface.Preconditioner]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FiniteDifference, name)
    __repr__ = _swig_repr
    Forward = ___init__.FiniteDifference_Forward
    Backward = ___init__.FiniteDifference_Backward
    Centered = ___init__.FiniteDifference_Centered
    def __init__(self, *args): 
        """
        __init__(NOX::Epetra::FiniteDifference self, ParameterList printingParams, Teuchos::RCP< NOX::Epetra::Interface::Required > const & i, 
            Vector initialGuess, double beta=1.0e-6, double alpha=1.0e-4) -> FiniteDifference
        __init__(NOX::Epetra::FiniteDifference self, ParameterList printingParams, Teuchos::RCP< NOX::Epetra::Interface::Required > const & i, 
            Vector initialGuess, Teuchos::RCP< Epetra_Vector const > const & beta, 
            double alpha=1.0e-4) -> FiniteDifference
        __init__(NOX::Epetra::FiniteDifference self, ParameterList printingParams, Teuchos::RCP< NOX::Epetra::Interface::Required > const & i, 
            Vector initialGuess, Teuchos::RCP< Epetra_CrsGraph > const & g, double beta=1.0e-6, 
            double alpha=1.0e-4) -> FiniteDifference
        __init__(NOX::Epetra::FiniteDifference self, ParameterList printingParams, Teuchos::RCP< NOX::Epetra::Interface::Required > const & i, 
            Vector initialGuess, Teuchos::RCP< Epetra_CrsGraph > const & g, Teuchos::RCP< Epetra_Vector const > const & beta, 
            double alpha=1.0e-4) -> FiniteDifference

        FiniteDifference::FiniteDifference(Teuchos::ParameterList
        &printingParams, const Teuchos::RCP< NOX::Epetra::Interface::Required
        > &i, const NOX::Epetra::Vector &initialGuess, const Teuchos::RCP<
        Epetra_CrsGraph > &g, const Teuchos::RCP< const Epetra_Vector > &beta,
        double alpha=1.0e-4)

        Constructor with output control that takes a pre-constructed
        Epetra_CrsGraph so it does not have to determine the non-zero entries
        in the matrix. 
        """
        this = ___init__.new_FiniteDifference(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_FiniteDifference
    def Label(self, *args):
        """
        Label(FiniteDifference self) -> char const *

        const
        char * FiniteDifference::Label() const

        Returns a character string describing the name of the operator. 
        """
        return ___init__.FiniteDifference_Label(self, *args)

    def SetUseTranspose(self, *args):
        """
        SetUseTranspose(FiniteDifference self, bool UseTranspose) -> int

        int FiniteDifference::SetUseTranspose(bool UseTranspose)

        If set true, the transpose of this operator will be applied. 
        """
        return ___init__.FiniteDifference_SetUseTranspose(self, *args)

    def Apply(self, *args):
        """
        Apply(FiniteDifference self, Epetra_MultiVector X, Epetra_MultiVector Y) -> int

        int
        FiniteDifference::Apply(const Epetra_MultiVector &X,
        Epetra_MultiVector &Y) const

        Return the result on an Epetra_Operator applied to an
        Epetra_MultiVector X in Y. 
        """
        return ___init__.FiniteDifference_Apply(self, *args)

    def ApplyInverse(self, *args):
        """
        ApplyInverse(FiniteDifference self, Epetra_MultiVector X, Epetra_MultiVector Y) -> int

        int FiniteDifference::ApplyInverse(const Epetra_MultiVector &X,
        Epetra_MultiVector &Y) const

        Return the result on an Epetra_Operator inverse applied to an
        Epetra_MultiVector X in Y. 
        """
        return ___init__.FiniteDifference_ApplyInverse(self, *args)

    def UseTranspose(self, *args):
        """
        UseTranspose(FiniteDifference self) -> bool

        bool FiniteDifference::UseTranspose() const

        Returns the current use transpose setting. 
        """
        return ___init__.FiniteDifference_UseTranspose(self, *args)

    def HasNormInf(self, *args):
        """
        HasNormInf(FiniteDifference self) -> bool

        bool FiniteDifference::HasNormInf() const

        Returns true if the this object can provide an approximate Inf-norm,
        false otherwise. 
        """
        return ___init__.FiniteDifference_HasNormInf(self, *args)

    def OperatorDomainMap(self, *args):
        """
        OperatorDomainMap(FiniteDifference self) -> Map

        const Epetra_Map &
        FiniteDifference::OperatorDomainMap() const

        Returns the Epetra_BlockMap object associated with the domain of this
        matrix operator. 
        """
        return ___init__.FiniteDifference_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        """
        OperatorRangeMap(FiniteDifference self) -> Map

        const Epetra_Map & FiniteDifference::OperatorRangeMap() const

        Returns the Epetra_BlockMap object associated with the range of this
        matrix operator. 
        """
        return ___init__.FiniteDifference_OperatorRangeMap(self, *args)

    def Filled(self, *args):
        """
        Filled(FiniteDifference self) -> bool

        bool
        FiniteDifference::Filled() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_Filled(self, *args)

    def NumMyRowEntries(self, *args):
        """
        NumMyRowEntries(FiniteDifference self, int MyRow, int & NumEntries) -> int

        int FiniteDifference::NumMyRowEntries(int MyRow, int &NumEntries)
        const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumMyRowEntries(self, *args)

    def MaxNumEntries(self, *args):
        """
        MaxNumEntries(FiniteDifference self) -> int

        int FiniteDifference::MaxNumEntries() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_MaxNumEntries(self, *args)

    def ExtractMyRowCopy(self, *args):
        """
        ExtractMyRowCopy(FiniteDifference self, int MyRow, int Length, int & NumEntries, double * Values, int * Indices) -> int

        int FiniteDifference::ExtractMyRowCopy(int MyRow, int Length, int
        &NumEntries, double *Values, int *Indices) const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_ExtractMyRowCopy(self, *args)

    def ExtractDiagonalCopy(self, *args):
        """
        ExtractDiagonalCopy(FiniteDifference self, Epetra_Vector Diagonal) -> int

        int
        FiniteDifference::ExtractDiagonalCopy(Epetra_Vector &Diagonal) const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_ExtractDiagonalCopy(self, *args)

    def Multiply(self, *args):
        """
        Multiply(FiniteDifference self, bool TransA, Epetra_MultiVector X, Epetra_MultiVector Y) -> int

        int
        FiniteDifference::Multiply(bool TransA, const Epetra_MultiVector &X,
        Epetra_MultiVector &Y) const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_Multiply(self, *args)

    def Solve(self, *args):
        """
        Solve(FiniteDifference self, bool Upper, bool Trans, bool UnitDiagonal, Epetra_MultiVector X, Epetra_MultiVector Y) -> int

        int
        FiniteDifference::Solve(bool Upper, bool Trans, bool UnitDiagonal,
        const Epetra_MultiVector &X, Epetra_MultiVector &Y) const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_Solve(self, *args)

    def InvRowSums(self, *args):
        """
        InvRowSums(FiniteDifference self, Epetra_Vector x) -> int

        int
        FiniteDifference::InvRowSums(Epetra_Vector &x) const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_InvRowSums(self, *args)

    def LeftScale(self, *args):
        """
        LeftScale(FiniteDifference self, Epetra_Vector x) -> int

        int
        FiniteDifference::LeftScale(const Epetra_Vector &x)

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_LeftScale(self, *args)

    def InvColSums(self, *args):
        """
        InvColSums(FiniteDifference self, Epetra_Vector x) -> int

        int
        FiniteDifference::InvColSums(Epetra_Vector &x) const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_InvColSums(self, *args)

    def RightScale(self, *args):
        """
        RightScale(FiniteDifference self, Epetra_Vector x) -> int

        int
        FiniteDifference::RightScale(const Epetra_Vector &x)

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_RightScale(self, *args)

    def NormInf(self, *args):
        """
        NormInf(FiniteDifference self) -> double

        double
        FiniteDifference::NormInf() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NormInf(self, *args)

    def NormOne(self, *args):
        """
        NormOne(FiniteDifference self) -> double

        double
        FiniteDifference::NormOne() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NormOne(self, *args)

    def NumGlobalNonzeros(self, *args):
        """
        NumGlobalNonzeros(FiniteDifference self) -> int

        int
        FiniteDifference::NumGlobalNonzeros() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumGlobalNonzeros(self, *args)

    def NumGlobalNonzeros64(self, *args):
        """
        NumGlobalNonzeros64(FiniteDifference self) -> long long

        virtual
        long long Epetra_RowMatrix::NumGlobalNonzeros64() const =0 
        """
        return ___init__.FiniteDifference_NumGlobalNonzeros64(self, *args)

    def NumGlobalRows(self, *args):
        """
        NumGlobalRows(FiniteDifference self) -> int

        int FiniteDifference::NumGlobalRows() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumGlobalRows(self, *args)

    def NumGlobalRows64(self, *args):
        """
        NumGlobalRows64(FiniteDifference self) -> long long

        virtual
        long long Epetra_RowMatrix::NumGlobalRows64() const =0 
        """
        return ___init__.FiniteDifference_NumGlobalRows64(self, *args)

    def NumGlobalCols(self, *args):
        """
        NumGlobalCols(FiniteDifference self) -> int

        int FiniteDifference::NumGlobalCols() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumGlobalCols(self, *args)

    def NumGlobalCols64(self, *args):
        """
        NumGlobalCols64(FiniteDifference self) -> long long

        virtual
        long long Epetra_RowMatrix::NumGlobalCols64() const =0 
        """
        return ___init__.FiniteDifference_NumGlobalCols64(self, *args)

    def NumGlobalDiagonals(self, *args):
        """
        NumGlobalDiagonals(FiniteDifference self) -> int

        int
        FiniteDifference::NumGlobalDiagonals() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumGlobalDiagonals(self, *args)

    def NumGlobalDiagonals64(self, *args):
        """
        NumGlobalDiagonals64(FiniteDifference self) -> long long

        virtual long long Epetra_RowMatrix::NumGlobalDiagonals64() const =0 
        """
        return ___init__.FiniteDifference_NumGlobalDiagonals64(self, *args)

    def NumMyNonzeros(self, *args):
        """
        NumMyNonzeros(FiniteDifference self) -> int

        int FiniteDifference::NumMyNonzeros() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumMyNonzeros(self, *args)

    def NumMyRows(self, *args):
        """
        NumMyRows(FiniteDifference self) -> int

        int
        FiniteDifference::NumMyRows() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumMyRows(self, *args)

    def NumMyCols(self, *args):
        """
        NumMyCols(FiniteDifference self) -> int

        int
        FiniteDifference::NumMyCols() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumMyCols(self, *args)

    def NumMyDiagonals(self, *args):
        """
        NumMyDiagonals(FiniteDifference self) -> int

        int FiniteDifference::NumMyDiagonals() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumMyDiagonals(self, *args)

    def LowerTriangular(self, *args):
        """
        LowerTriangular(FiniteDifference self) -> bool

        bool FiniteDifference::LowerTriangular() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_LowerTriangular(self, *args)

    def UpperTriangular(self, *args):
        """
        UpperTriangular(FiniteDifference self) -> bool

        bool FiniteDifference::UpperTriangular() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_UpperTriangular(self, *args)

    def Comm(self, *args):
        """
        Comm(FiniteDifference self) -> Comm

        const
        Epetra_Comm & FiniteDifference::Comm() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_Comm(self, *args)

    def RowMatrixRowMap(self, *args):
        """
        RowMatrixRowMap(FiniteDifference self) -> Map

        const Epetra_Map & FiniteDifference::RowMatrixRowMap() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_RowMatrixRowMap(self, *args)

    def RowMatrixColMap(self, *args):
        """
        RowMatrixColMap(FiniteDifference self) -> Map

        const Epetra_Map & FiniteDifference::RowMatrixColMap() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_RowMatrixColMap(self, *args)

    def RowMatrixImporter(self, *args):
        """
        RowMatrixImporter(FiniteDifference self) -> Import

        const Epetra_Import
        * FiniteDifference::RowMatrixImporter() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_RowMatrixImporter(self, *args)

    def Map(self, *args):
        """
        Map(FiniteDifference self) -> BlockMap

        const
        Epetra_BlockMap & FiniteDifference::Map() const

        See Epetra_SrcDistObj documentation. 
        """
        return ___init__.FiniteDifference_Map(self, *args)

    def computeJacobian(self, *args):
        """
        computeJacobian(FiniteDifference self, Epetra_Vector x, Operator Jac) -> bool
        computeJacobian(FiniteDifference self, Epetra_Vector x) -> bool

        bool FiniteDifference::computeJacobian(const Epetra_Vector &x)

        Compute Jacobian given the specified input vector, x. Returns true if
        computation was successful. 
        """
        return ___init__.FiniteDifference_computeJacobian(self, *args)

    def computePreconditioner(self, *args):
        """
        computePreconditioner(FiniteDifference self, Epetra_Vector x, Operator Prec, ParameterList precParams=None) -> bool

        bool
        FiniteDifference::computePreconditioner(const Epetra_Vector &x,
        Epetra_Operator &Prec, Teuchos::ParameterList *precParams=0)

        Compute an Epetra_RowMatrix to be used by Aztec preconditioners given
        the specified input vector, x. Returns true if computation was
        successful. 
        """
        return ___init__.FiniteDifference_computePreconditioner(self, *args)

    def setDifferenceMethod(self, *args):
        """
        setDifferenceMethod(FiniteDifference self, NOX::Epetra::FiniteDifference::DifferenceType type)

        void
        FiniteDifference::setDifferenceMethod(DifferenceType type)

        Set the type of perturbation method used (default is Forward) 
        """
        return ___init__.FiniteDifference_setDifferenceMethod(self, *args)

    def getUnderlyingMatrix(self, *args):
        """
        getUnderlyingMatrix(FiniteDifference self) -> CrsMatrix

        Epetra_CrsMatrix
        & FiniteDifference::getUnderlyingMatrix() const

        An accessor method for the underlying Epetra_CrsMatrix. 
        """
        return ___init__.FiniteDifference_getUnderlyingMatrix(self, *args)

    def setGroupForComputeF(self, *args):
        """
        setGroupForComputeF(FiniteDifference self, Group group)

        void
        FiniteDifference::setGroupForComputeF(NOX::Abstract::Group &group)

        Register a NOX::Abstract::Group derived object and use the computeF()
        method of that group for the perturbation instead of the
        NOX::Epetra::Interface::Required::computeF() method. This is required
        for LOCA to get the operators correct during homotopy. 
        """
        return ___init__.FiniteDifference_setGroupForComputeF(self, *args)

FiniteDifference_swigregister = ___init__.FiniteDifference_swigregister
FiniteDifference_swigregister(FiniteDifference)

class FiniteDifferenceColoring(FiniteDifference):
    """
    Concrete implementation for creating an Epetra_RowMatrix Jacobian via
    finite differencing of the residual using coloring.

    The Jacobian entries are calculated via 1st or 2nd order finite
    differencing. This requires $ N + 1 $ or $ 2N + 1 $ calls to
    computeF(), respectively, where $ N $ is the number of colors.

    \\[ J_{ij} = \\frac{\\partial F_i}{\\partial x_j} =
    \\frac{F_i(x+\\delta\\mathbf{e}_j) - F_i(x)}{\\delta} \\]

    where $J$ is the Jacobian, $F$ is the function evaluation, $x$ is the
    solution vector, and $\\delta$ is a small perturbation to the $x_j$
    entry.

    Instead of perturbing each $ N_{dof} $ problem degrees of freedom
    sequentially and then evaluating all $ N_{dof} $ functions for each
    perturbation, coloring allows several degrees of freedom (all
    belonging to the same color) to be perturbed at the same time. This
    reduces the total number of function evaluations needed to compute
    $\\mathbf{J}$ from $ N_{dof}^2 $ as is required using
    FiniteDifference to $ N\\cdot N_{dof} $, often representing
    substantial computational savings.

    Coloring is based on a user-supplied color map generated using an
    appropriate algorithm, eg greedy-algorithm - Y. Saad, "Iterative
    Methods for Sparse %Linear Systems, 2<sup>nd</sup> ed.," chp. 3,
    SIAM, 2003.. Use can be made of the coloring algorithm provided by the
    EpetraExt package in Trilinos. The 1Dfem_nonlinearColoring and
    Brusselator example problems located in the nox/epetra-examples
    subdirectory demonstrate use of the EpetraExt package, and the
    1Dfem_nonlinearColoring directory also contains a stand-alone coloring
    algorithm very similar to that in EpetraExt.

    The perturbation, $ \\delta $, is calculated using the following
    equation:

    \\[ \\delta = \\alpha * | x_j | + \\beta \\]

    where $ \\alpha $ is a scalar value (defaults to 1.0e-4) and $
    \\beta $ is another scalar (defaults to 1.0e-6).

    Since both FiniteDifferenceColoring and FiniteDifference inherit from
    the Epetra_RowMatrix class, they can be used as preconditioning
    matrices for AztecOO preconditioners.

    As for FiniteDifference, 1st order accurate Forward and Backward
    differences as well as 2nd order accurate Centered difference can be
    specified using setDifferenceMethod with the appropriate enumerated
    type passed as the argument.

    Using FiniteDifferenceColoring in Parallel

    Two ways of using this class in a distributed parallel environment are
    currently supported. From an application standpoint, the two
    approaches differ only in the status of the solution iterate used in
    the residual fill. If an object of this class is contructed with
    parallelColoring = true the solution iterate will be passe back in a
    non-ghosted form. On the contrary, setting this parameter to false in
    the constructor will cause the solution iterate to be in a ghosted
    form when calling back for a residual fill. When using the second
    approach, the user should be aware that the perturbed vector used to
    compute residuals has already been scattered to a form consistent with
    the column space of the Epetra_CrsGraph. In practice, this means that
    the perturbed vector used by computeF() has already been scattered to
    a ghosted or overlapped state. The application should then not perform
    this step but rather simply use the vector provided with the possible
    exception of requiring a local index reordering to bring the column-
    space based vector in sync with a potentially different ghosted index
    ordering. See the Brusselator and %1Dfem_nonlinearColoring example
    problems for details.

    Special Case for Approximate Jacobian Construction

    Provision is made for a simplified and cheaper use of coloring that
    currently provides only for the diagonal of the Jacobian to be
    computed. This is based on using a first-neighbors coloring of the
    original Jacobian graph using the Epetra_Ext MapColoring class with
    the distance1 argument set to true. This same argument should also be
    set to true in the constructor to this class. The result will be a
    diagonal Jacobian filled in a much more efficient manner.

    C++ includes: NOX_Epetra_FiniteDifferenceColoring.H 
    """
    __swig_setmethods__ = {}
    for _s in [FiniteDifference]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FiniteDifferenceColoring, name, value)
    __swig_getmethods__ = {}
    for _s in [FiniteDifference]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FiniteDifferenceColoring, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_FiniteDifferenceColoring
    def computeJacobian(self, *args):
        """
        computeJacobian(FiniteDifferenceColoring self, Epetra_Vector x, Operator Jac) -> bool
        computeJacobian(FiniteDifferenceColoring self, Epetra_Vector x) -> bool

        bool
        FiniteDifferenceColoring::computeJacobian(const Epetra_Vector &x)

        Compute Jacobian given the specified input vector, x. Returns true if
        computation was successful. 
        """
        return ___init__.FiniteDifferenceColoring_computeJacobian(self, *args)

    def createColorContainers(self, *args):
        """
        createColorContainers(FiniteDifferenceColoring self)

        void
        FiniteDifferenceColoring::createColorContainers()

        Output the coloring map, index map and underlying matrix.

        Create containers for using color and index maps in parallel coloring

        """
        return ___init__.FiniteDifferenceColoring_createColorContainers(self, *args)

    def __init__(self, *args): 
        """
        __init__(NOX::Epetra::FiniteDifferenceColoring self, ParameterList printingParams, Teuchos::RCP< NOX::Epetra::Interface::Required > const & i, 
            Vector initialGuess, Teuchos::RCP< Epetra_CrsGraph > const & rawGraph, 
            bool parallelColoring=False, bool distance1=False, double beta=1.0e-6, 
            double alpha=1.0e-4) -> FiniteDifferenceColoring

        FiniteDifferenceColoring::FiniteDifferenceColoring(Teuchos::ParameterList
        &printingParams, const Teuchos::RCP< Interface::Required > &i, const
        NOX::Epetra::Vector &initialGuess, const Teuchos::RCP< Epetra_CrsGraph
        > &rawGraph, const Teuchos::RCP< Epetra_MapColoring > &colorMap, const
        Teuchos::RCP< vector< Epetra_IntVector > > &columns, bool
        parallelColoring=false, bool distance1=false, double beta=1.0e-6,
        double alpha=1.0e-4)

        Constructor with output control. 
        """
        this = ___init__.new_FiniteDifferenceColoring(*args)
        try: self.this.append(this)
        except: self.this = this
FiniteDifferenceColoring_swigregister = ___init__.FiniteDifferenceColoring_swigregister
FiniteDifferenceColoring_swigregister(FiniteDifferenceColoring)

class MatrixFree(Operator,Interface.Jacobian):
    """
    Concrete implementation for creating an Epetra_Operator Jacobian based
    on the Matrix-Free Newton-Krylov method.

    Matrix-Free Newton-Krylov is a method that takes advantage of the fact
    the Newton Krylov solvers do not require an explicit Jacobian matrix.
    Newton-Krylov solvers only require the matrix-vector product $Jy$ in
    the iteration sequence. This product can approximated by the
    following:

    \\[ Jy = \\frac{F(x + \\delta y) - F(x)}{\\delta} \\]

    where $J$ is the Jacobian, $F$ is the function evaluation, $x$ is the
    solution vector, $y$ is the vector to be operated on, and $\\delta$
    is a scalar perturbation calculated by:

    \\[ \\delta = \\lambda * (\\lambda + \\frac{\\|
    x\\|}{\\| y\\|} ) \\]

    where $ \\lambda = 1.0e-6 $.

    C++ includes: NOX_Epetra_MatrixFree.H 
    """
    __swig_setmethods__ = {}
    for _s in [Operator,Interface.Jacobian]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MatrixFree, name, value)
    __swig_getmethods__ = {}
    for _s in [Operator,Interface.Jacobian]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MatrixFree, name)
    __repr__ = _swig_repr
    Forward = ___init__.MatrixFree_Forward
    Backward = ___init__.MatrixFree_Backward
    Centered = ___init__.MatrixFree_Centered
    def __init__(self, *args): 
        """
        __init__(NOX::Epetra::MatrixFree self, ParameterList printParams, Teuchos::RCP< NOX::Epetra::Interface::Required > const & i, 
            Vector cloneVector, bool useNewPerturbation=False) -> MatrixFree

        MatrixFree::MatrixFree(Teuchos::ParameterList &printParams, const
        Teuchos::RCP< NOX::Epetra::Interface::Required > &i, const
        NOX::Epetra::Vector &cloneVector, bool useNewPerturbation=false)

        Constructor.

        The vector x is used to clone the solution vector. 
        """
        this = ___init__.new_MatrixFree(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_MatrixFree
    def SetUseTranspose(self, *args):
        """
        SetUseTranspose(MatrixFree self, bool UseTranspose) -> int

        int
        MatrixFree::SetUseTranspose(bool UseTranspose)

        If set true, transpose of this operator will be applied.

        This flag allows the transpose of the given operator to be used
        implicitly. Setting this flag affects only the Apply() and
        ApplyInverse() methods. If the implementation of this interface does
        not support transpose use, this method should return a value of -1.

        Parameters:
        -----------

        UseTranspose:  -If true, multiply by the transpose of operator,
        otherwise just use operator.

        Integer error code, set to 0 if successful. Set to -1 if this
        implementation does not support transpose. 
        """
        return ___init__.MatrixFree_SetUseTranspose(self, *args)

    def Apply(self, *args):
        """
        Apply(MatrixFree self, Epetra_MultiVector X, Epetra_MultiVector Y) -> int

        int
        MatrixFree::Apply(const Epetra_MultiVector &X, Epetra_MultiVector &Y)
        const

        Returns the result of a Epetra_Operator applied to a
        Epetra_MultiVector X in Y.

        Parameters:
        -----------

        X:  - A Epetra_MultiVector of dimension NumVectors to multiply with
        matrix.

        Y:  -A Epetra_MultiVector of dimension NumVectors containing result.

        Integer error code, set to 0 if successful. 
        """
        return ___init__.MatrixFree_Apply(self, *args)

    def ApplyInverse(self, *args):
        """
        ApplyInverse(MatrixFree self, Epetra_MultiVector X, Epetra_MultiVector Y) -> int

        int
        MatrixFree::ApplyInverse(const Epetra_MultiVector &X,
        Epetra_MultiVector &Y) const

        Returns the result of a Epetra_Operator inverse applied to an
        Epetra_MultiVector X in Y.

        Parameters:
        -----------

        X:  - A Epetra_MultiVector of dimension NumVectors to solve for.

        Y:  -A Epetra_MultiVector of dimension NumVectors containing result.

        Integer error code, set to 0 if successful.

        WARNING:  In order to work with AztecOO, any implementation of this
        method must support the case where X and Y are the same object. 
        """
        return ___init__.MatrixFree_ApplyInverse(self, *args)

    def NormInf(self, *args):
        """
        NormInf(MatrixFree self) -> double

        double
        MatrixFree::NormInf() const

        Returns the infinity norm of the global matrix. 
        """
        return ___init__.MatrixFree_NormInf(self, *args)

    def Label(self, *args):
        """
        Label(MatrixFree self) -> char const *

        const char *
        MatrixFree::Label() const

        Returns a character string describing the operator. 
        """
        return ___init__.MatrixFree_Label(self, *args)

    def UseTranspose(self, *args):
        """
        UseTranspose(MatrixFree self) -> bool

        bool
        MatrixFree::UseTranspose() const

        Returns the current UseTranspose setting. 
        """
        return ___init__.MatrixFree_UseTranspose(self, *args)

    def HasNormInf(self, *args):
        """
        HasNormInf(MatrixFree self) -> bool

        bool
        MatrixFree::HasNormInf() const

        Returns true if the this object can provide an approximate Inf-norm,
        false otherwise. 
        """
        return ___init__.MatrixFree_HasNormInf(self, *args)

    def Comm(self, *args):
        """
        Comm(MatrixFree self) -> Comm

        const
        Epetra_Comm & MatrixFree::Comm() const

        Returns a reference to the Epetra_Comm communicator associated with
        this operator. 
        """
        return ___init__.MatrixFree_Comm(self, *args)

    def OperatorDomainMap(self, *args):
        """
        OperatorDomainMap(MatrixFree self) -> Map

        const Epetra_Map & MatrixFree::OperatorDomainMap() const

        Returns the Epetra_BlockMap object associated with the domain of this
        matrix operator. 
        """
        return ___init__.MatrixFree_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        """
        OperatorRangeMap(MatrixFree self) -> Map

        const Epetra_Map & MatrixFree::OperatorRangeMap() const

        Returns the Epetra_BlockMap object associated with the range of this
        matrix operator. 
        """
        return ___init__.MatrixFree_OperatorRangeMap(self, *args)

    def computeJacobian(self, *args):
        """
        computeJacobian(MatrixFree self, Epetra_Vector x, Operator Jac) -> bool

        bool
        MatrixFree::computeJacobian(const Epetra_Vector &x, Epetra_Operator
        &Jac)

        Compute Jacobian given the specified input vector, x. Returns true if
        computation was successful. 
        """
        return ___init__.MatrixFree_computeJacobian(self, *args)

    def setDifferenceMethod(self, *args):
        """
        setDifferenceMethod(MatrixFree self, NOX::Epetra::MatrixFree::DifferenceType type)

        void MatrixFree::setDifferenceMethod(DifferenceType type)

        Set the type of perturbation method used (default is Forward) 
        """
        return ___init__.MatrixFree_setDifferenceMethod(self, *args)

    def setLambda(self, *args):
        """
        setLambda(MatrixFree self, double lambda_)

        void
        MatrixFree::setLambda(double lambda_)

        Allows the user to change the value of $ \\lambda $ in the
        perturbation calculation. 
        """
        return ___init__.MatrixFree_setLambda(self, *args)

    def setComputePerturbation(self, *args):
        """
        setComputePerturbation(MatrixFree self, bool bVal)

        void MatrixFree::setComputePerturbation(bool bVal)

        Flag that toggles whether MatrixFree should compute the perturbation
        parameter $ \\eta $ or use a value supplied by the user through
        setPerturbation(). 
        """
        return ___init__.MatrixFree_setComputePerturbation(self, *args)

    def setPerturbation(self, *args):
        """
        setPerturbation(MatrixFree self, double eta_)

        void
        MatrixFree::setPerturbation(double eta_)

        Set the perturbation parameter $ \\eta $. 
        """
        return ___init__.MatrixFree_setPerturbation(self, *args)

    def getPerturbation(self, *args):
        """
        getPerturbation(MatrixFree self) -> double

        double MatrixFree::getPerturbation() const

        Returns the most recently used value of the perturbation parameter $
        \\eta $. 
        """
        return ___init__.MatrixFree_getPerturbation(self, *args)

    def setGroupForComputeF(self, *args):
        """
        setGroupForComputeF(MatrixFree self, Group group)

        void MatrixFree::setGroupForComputeF(const NOX::Abstract::Group
        &group)

        Clone a NOX::Abstract::Group derived object and use the computeF()
        method of that group for the perturbation instead of the
        NOX::Epetra::Interface::Required::computeF() method. This is required
        for LOCA to get the operators correct during homotopy. 
        """
        return ___init__.MatrixFree_setGroupForComputeF(self, *args)

    def setSolverForComputeJacobian(self, *args):
        """
        setSolverForComputeJacobian(MatrixFree self, Teuchos::RCP< NOX::Solver::Generic > const & slvr)

        void
        MatrixFree::setSolverForComputeJacobian(const Teuchos::RCP<
        NOX::Solver::Generic > &slvr)

        Save a RCP to a solver, and use the Solver's current Group's
        computeF() in the computeJacobian call, which can save a function call
        by respecting the isValid flag. 
        """
        return ___init__.MatrixFree_setSolverForComputeJacobian(self, *args)

MatrixFree_swigregister = ___init__.MatrixFree_swigregister
MatrixFree_swigregister(MatrixFree)

class Scaling(_object):
    """
    Object to control scaling of vectors and linear systems.

    Currently this assumes a diagonal scaling only! Once epetra can do
    matrix-matrix multiplies we will expand this class.

    C++ includes: NOX_Epetra_Scaling.H 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Scaling, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Scaling, name)
    __repr__ = _swig_repr
    Scaling_None = ___init__.Scaling_Scaling_None
    RowSum = ___init__.Scaling_RowSum
    ColSum = ___init__.Scaling_ColSum
    UserDefined = ___init__.Scaling_UserDefined
    Left = ___init__.Scaling_Left
    Right = ___init__.Scaling_Right
    def __init__(self, *args): 
        """
        __init__(NOX::Epetra::Scaling self) -> Scaling

        NOX::Epetra::Scaling::Scaling()

        Constructor. 
        """
        this = ___init__.new_Scaling(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Scaling
    def addUserScaling(self, *args):
        """
        addUserScaling(Scaling self, NOX::Epetra::Scaling::ScaleType type, Teuchos::RCP< Epetra_Vector > const & D)

        void
        NOX::Epetra::Scaling::addUserScaling(ScaleType type, const
        Teuchos::RCP< Epetra_Vector > &D)

        Add a user supplied diagonal scale vector to the scaling object. 
        """
        return ___init__.Scaling_addUserScaling(self, *args)

    def addRowSumScaling(self, *args):
        """
        addRowSumScaling(Scaling self, NOX::Epetra::Scaling::ScaleType type, Teuchos::RCP< Epetra_Vector > const & D)

        void
        NOX::Epetra::Scaling::addRowSumScaling(ScaleType type, const
        Teuchos::RCP< Epetra_Vector > &D)

        Add "Row Sum" scaling to the scaling object. The supplied vector is
        used to store the current row sum vector. 
        """
        return ___init__.Scaling_addRowSumScaling(self, *args)

    def addColSumScaling(self, *args):
        """
        addColSumScaling(Scaling self, NOX::Epetra::Scaling::ScaleType type, Teuchos::RCP< Epetra_Vector > const & D)

        void
        NOX::Epetra::Scaling::addColSumScaling(ScaleType type, const
        Teuchos::RCP< Epetra_Vector > &D)

        Add "Col Sum" scaling to the scaling object. The supplied vector is
        used to store the current column sum vector. 
        """
        return ___init__.Scaling_addColSumScaling(self, *args)

    def computeScaling(self, *args):
        """
        computeScaling(Scaling self, LinearProblem problem)

        void
        NOX::Epetra::Scaling::computeScaling(const Epetra_LinearProblem
        &problem)

        Computes Row Sum scaling diagonal vectors. Only needs to be called if
        a row or column sum scaling has been requested. 
        """
        return ___init__.Scaling_computeScaling(self, *args)

    def scaleLinearSystem(self, *args):
        """
        scaleLinearSystem(Scaling self, LinearProblem problem)

        void
        NOX::Epetra::Scaling::scaleLinearSystem(Epetra_LinearProblem &problem)

        Scales the linear system. 
        """
        return ___init__.Scaling_scaleLinearSystem(self, *args)

    def unscaleLinearSystem(self, *args):
        """
        unscaleLinearSystem(Scaling self, LinearProblem problem)

        void NOX::Epetra::Scaling::unscaleLinearSystem(Epetra_LinearProblem
        &problem)

        Remove the scaling from the linear system. 
        """
        return ___init__.Scaling_unscaleLinearSystem(self, *args)

    def applyRightScaling(self, *args):
        """
        applyRightScaling(Scaling self, Epetra_Vector input, Epetra_Vector result)

        void
        NOX::Epetra::Scaling::applyRightScaling(const Epetra_Vector &input,
        Epetra_Vector &result)

        Applies any RIGHT scaling vectors to an input vector. 
        """
        return ___init__.Scaling_applyRightScaling(self, *args)

    def applyLeftScaling(self, *args):
        """
        applyLeftScaling(Scaling self, Epetra_Vector input, Epetra_Vector result)

        void
        NOX::Epetra::Scaling::applyLeftScaling(const Epetra_Vector &input,
        Epetra_Vector &result)

        Applies any LEFT scaling vectors to an input vector. 
        """
        return ___init__.Scaling_applyLeftScaling(self, *args)

Scaling_swigregister = ___init__.Scaling_swigregister
Scaling_swigregister(Scaling)

class LinearSystem(_object):
    """
    Pure virtual class interface for allowing different linear solvers to
    be used by the NOX::Epetra::Group.

    C++ includes: NOX_Epetra_LinearSystem.H 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearSystem, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LinearSystem, name)
    __repr__ = _swig_repr
    PRPT_REBUILD = ___init__.LinearSystem_PRPT_REBUILD
    PRPT_RECOMPUTE = ___init__.LinearSystem_PRPT_RECOMPUTE
    PRPT_REUSE = ___init__.LinearSystem_PRPT_REUSE
    def __init__(self, *args): 
        """
        __init__(NOX::Epetra::LinearSystem self) -> LinearSystem

        NOX::Epetra::LinearSystem::LinearSystem()

        Constructor. 
        """
        if self.__class__ == LinearSystem:
            _self = None
        else:
            _self = self
        this = ___init__.new_LinearSystem(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_LinearSystem
    def applyJacobian(self, *args):
        """
        applyJacobian(LinearSystem self, Vector input, Vector nox_result) -> bool

        virtual bool NOX::Epetra::LinearSystem::applyJacobian(const
        NOX::Epetra::Vector &input, NOX::Epetra::Vector &result) const =0

        Applies Jacobian to the given input vector and puts the answer in the
        result.

        Computes \\[ v = J u, \\] where $J$ is the Jacobian, $u$ is the
        input vector, and $v$ is the result vector. Returns true if
        successful. 
        """
        return ___init__.LinearSystem_applyJacobian(self, *args)

    def applyJacobianTranspose(self, *args):
        """
        applyJacobianTranspose(LinearSystem self, Vector input, Vector nox_result) -> bool

        virtual bool
        NOX::Epetra::LinearSystem::applyJacobianTranspose(const
        NOX::Epetra::Vector &input, NOX::Epetra::Vector &result) const =0

        Applies Jacobian-Transpose to the given input vector and puts the
        answer in the result.

        Computes \\[ v = J^T u, \\] where $J$ is the Jacobian, $u$ is the
        input vector, and $v$ is the result vector. Returns true if
        successful. 
        """
        return ___init__.LinearSystem_applyJacobianTranspose(self, *args)

    def applyJacobianInverse(self, *args):
        """
        applyJacobianInverse(LinearSystem self, ParameterList params, Vector input, Vector nox_result) -> bool

        virtual bool
        NOX::Epetra::LinearSystem::applyJacobianInverse(Teuchos::ParameterList
        &params, const NOX::Epetra::Vector &input, NOX::Epetra::Vector
        &result)=0

        Applies the inverse of the Jacobian matrix to the given input vector
        and puts the answer in result.

        Computes \\[ v = J^{-1} u, \\] where $J$ is the Jacobian, $u$ is
        the input vector, and $v$ is the result vector.

        The parameter list contains the linear solver options. 
        """
        return ___init__.LinearSystem_applyJacobianInverse(self, *args)

    def applyRightPreconditioning(self, *args):
        """
        applyRightPreconditioning(LinearSystem self, bool useTranspose, ParameterList params, Vector input, Vector nox_result) -> bool

        virtual bool
        NOX::Epetra::LinearSystem::applyRightPreconditioning(bool
        useTranspose, Teuchos::ParameterList &params, const
        NOX::Epetra::Vector &input, NOX::Epetra::Vector &result) const =0

        Apply right preconditiong to the given input vector.

        Let $M$ be a right preconditioner for the Jacobian $J$; in other
        words, $M$ is a matrix such that \\[ JM \\approx I. \\]

        Compute \\[ u = M^{-1} v, \\] where $u$ is the input vector and
        $v$ is the result vector.

        If useTranspose is true, then the transpose of the preconditioner is
        applied: \\[ u = {M^{-1}}^T v, \\] The transpose preconditioner is
        currently only required for Tensor methods.

        The parameter list contains the linear solver options. 
        """
        return ___init__.LinearSystem_applyRightPreconditioning(self, *args)

    def getScaling(self, *args):
        """
        getScaling(LinearSystem self) -> Teuchos::RCP< NOX::Epetra::Scaling >

        virtual
        Teuchos::RCP<NOX::Epetra::Scaling>
        NOX::Epetra::LinearSystem::getScaling()=0

        Get the scaling object. 
        """
        return ___init__.LinearSystem_getScaling(self, *args)

    def resetScaling(self, *args):
        """
        resetScaling(LinearSystem self, Teuchos::RCP< NOX::Epetra::Scaling > const & s)

        virtual void NOX::Epetra::LinearSystem::resetScaling(const
        Teuchos::RCP< NOX::Epetra::Scaling > &s)=0

        Sets the diagonal scaling vector(s) used in scaling the linear system.

        See NOX::Epetra::Scaling for details on how to specify scaling of the
        linear system. 
        """
        return ___init__.LinearSystem_resetScaling(self, *args)

    def computeJacobian(self, *args):
        """
        computeJacobian(LinearSystem self, Vector x) -> bool

        virtual bool NOX::Epetra::LinearSystem::computeJacobian(const
        NOX::Epetra::Vector &x)=0

        Evaluates the Jacobian based on the solution vector x. 
        """
        return ___init__.LinearSystem_computeJacobian(self, *args)

    def createPreconditioner(self, *args):
        """
        createPreconditioner(LinearSystem self, Vector x, ParameterList p, bool recomputeGraph) -> bool

        virtual bool NOX::Epetra::LinearSystem::createPreconditioner(const
        NOX::Epetra::Vector &x, Teuchos::ParameterList &p, bool
        recomputeGraph) const =0

        Explicitly constructs a preconditioner based on the solution vector x
        and the parameter list p.

        The user has the option of recomputing the graph when a new
        preconditioner is created. The NOX::Epetra::Group controls the isValid
        flag for the preconditioner and will control when to call this. 
        """
        return ___init__.LinearSystem_createPreconditioner(self, *args)

    def destroyPreconditioner(self, *args):
        """
        destroyPreconditioner(LinearSystem self) -> bool

        virtual bool
        NOX::Epetra::LinearSystem::destroyPreconditioner() const =0

        Deletes the preconditioner.

        The NOX::Epetra::Group controls the isValid flag for the
        preconditioner and will control when to call this. 
        """
        return ___init__.LinearSystem_destroyPreconditioner(self, *args)

    def recomputePreconditioner(self, *args):
        """
        recomputePreconditioner(LinearSystem self, Vector x, ParameterList linearSolverParams) -> bool

        virtual bool
        NOX::Epetra::LinearSystem::recomputePreconditioner(const
        NOX::Epetra::Vector &x, Teuchos::ParameterList &linearSolverParams)
        const =0

        Recalculates the preconditioner using an already allocated graph.

        Use this to compute a new preconditioner while using the same graph
        for the preconditioner. This avoids deleting and reallocating the
        memory required for the preconditioner and results in a big speed-up
        for large-scale jobs. 
        """
        return ___init__.LinearSystem_recomputePreconditioner(self, *args)

    def getPreconditionerPolicy(self, *args):
        """
        getPreconditionerPolicy(LinearSystem self, bool advanceReuseCounter=True) -> NOX::Epetra::LinearSystem::PreconditionerReusePolicyType

        virtual
        PreconditionerReusePolicyType
        NOX::Epetra::LinearSystem::getPreconditionerPolicy(bool
        advanceReuseCounter=true)=0

        Evaluates the preconditioner policy at the current state.

        NOTE: This can change values between nonlienar iterations. It is not a
        static value. 
        """
        return ___init__.LinearSystem_getPreconditionerPolicy(self, *args)

    def isPreconditionerConstructed(self, *args):
        """
        isPreconditionerConstructed(LinearSystem self) -> bool

        virtual bool
        NOX::Epetra::LinearSystem::isPreconditionerConstructed() const =0

        Indicates whether a preconditioner has been constructed. 
        """
        return ___init__.LinearSystem_isPreconditionerConstructed(self, *args)

    def hasPreconditioner(self, *args):
        """
        hasPreconditioner(LinearSystem self) -> bool

        virtual bool NOX::Epetra::LinearSystem::hasPreconditioner() const =0

        Indicates whether the linear system has a preconditioner. 
        """
        return ___init__.LinearSystem_hasPreconditioner(self, *args)

    def getJacobianOperator(self, *args):
        """
        getJacobianOperator(LinearSystem self) -> Teuchos::RCP< Epetra_Operator const >
        getJacobianOperator(LinearSystem self) -> Teuchos::RCP< Epetra_Operator >

        virtual Teuchos::RCP<Epetra_Operator>
        NOX::Epetra::LinearSystem::getJacobianOperator()=0

        Return Jacobian operator. 
        """
        return ___init__.LinearSystem_getJacobianOperator(self, *args)

    def getGeneratedPrecOperator(self, *args):
        """
        getGeneratedPrecOperator(LinearSystem self) -> Teuchos::RCP< Epetra_Operator const >
        getGeneratedPrecOperator(LinearSystem self) -> Teuchos::RCP< Epetra_Operator >

        virtual
        Teuchos::RCP<Epetra_Operator>
        NOX::Epetra::LinearSystem::getGeneratedPrecOperator()=0

        Return preconditioner operator. 
        """
        return ___init__.LinearSystem_getGeneratedPrecOperator(self, *args)

    def setJacobianOperatorForSolve(self, *args):
        """
        setJacobianOperatorForSolve(LinearSystem self, Teuchos::RCP< Epetra_Operator const > const & solveJacOp)

        virtual void
        NOX::Epetra::LinearSystem::setJacobianOperatorForSolve(const
        Teuchos::RCP< const Epetra_Operator > &solveJacOp)=0

        Set Jacobian operator for solve. 
        """
        return ___init__.LinearSystem_setJacobianOperatorForSolve(self, *args)

    def setPrecOperatorForSolve(self, *args):
        """
        setPrecOperatorForSolve(LinearSystem self, Teuchos::RCP< Epetra_Operator const > const & solvePrecOp)

        virtual void
        NOX::Epetra::LinearSystem::setPrecOperatorForSolve(const Teuchos::RCP<
        const Epetra_Operator > &solvePrecOp)=0

        Set preconditioner operator for solve.

        Note: This should only be called if hasPreconditioner() returns true.

        """
        return ___init__.LinearSystem_setPrecOperatorForSolve(self, *args)

    def getNumLinearSolves(self, *args):
        """
        getNumLinearSolves(LinearSystem self) -> int

        virtual int NOX::Epetra::LinearSystem::getNumLinearSolves()

        Statistics for number of times the linear solver has been called (def:
        0) 
        """
        return ___init__.LinearSystem_getNumLinearSolves(self, *args)

    def getLinearItersLastSolve(self, *args):
        """
        getLinearItersLastSolve(LinearSystem self) -> int

        virtual int
        NOX::Epetra::LinearSystem::getLinearItersLastSolve()

        Statistics for number of iterations taken in last linear solve (def:
        0) 
        """
        return ___init__.LinearSystem_getLinearItersLastSolve(self, *args)

    def getLinearItersTotal(self, *args):
        """
        getLinearItersTotal(LinearSystem self) -> int

        virtual int NOX::Epetra::LinearSystem::getLinearItersTotal()

        Statistics for cumulative number of iterations in all linear solve
        (def: 0) 
        """
        return ___init__.LinearSystem_getLinearItersTotal(self, *args)

    def getAchievedTol(self, *args):
        """
        getAchievedTol(LinearSystem self) -> double

        virtual double NOX::Epetra::LinearSystem::getAchievedTol()

        Statistics for the achieved tolerance of last linear solve (def: 0.0)

        """
        return ___init__.LinearSystem_getAchievedTol(self, *args)

    def __disown__(self):
        self.this.disown()
        ___init__.disown_LinearSystem(self)
        return weakref_proxy(self)
LinearSystem_swigregister = ___init__.LinearSystem_swigregister
LinearSystem_swigregister(LinearSystem)

class LinearSystemAztecOO(LinearSystem):
    """
    Concrete implementation of NOX::Epetra::LinearSolver for AztecOO.

    This solver provides the linear algebra services provided through the
    AztecOO parallel iterative linear solver.

    The NOX::Epetra::LinearSystemAztecOO object provides a flexible and
    efficient way to interface an Epetra based application code to the
    Aztec linear solver. This class handles construction of both the
    preconditioners and AztecOO solver. All options are determined through
    parameter lists and the basic constructors.

    Constructing a Linear System

    There are four different constructors that can be used. The difference
    between constructors is based on whether the user supplies a Jacobian,
    a preconditioner, neither or both.

    If a Jacobian is not supplied then this object can create an
    internally constructed Jacobian based on a Finite Difference or
    Matrif-Free object. The user can specify which type of object to use
    by setting the parameter "Jacobian Operator" in the parameter list.
    The choices are "Matrix-Free" or "Finite Difference".

    The user can supply their own preconditioner as an Epetra_Operator, or
    they can supply their own matrix (an Epetra_RowMatrix derived object)
    that can be used by one of the internal preconditioner libraries
    (currently aztecoo or ifpack). If they supply their own preconditioner
    the object must implement the Epetra_Operator::ApplyInverse method.
    This is the method called during the linear solve to introduce
    preconditoning into aztecoo. If the user supplies a matrix to be used
    with an internal preconditioner, it must be derived from the
    Epetra_RowMatrix class and must implement all functionality in the
    Epetra_RowMatrix. If a Preconditioner is not supplied, then this
    object can create an internal preconditioner matrix by finite
    differencing or it can use the Jacobian operator if the Jacobian
    derives from the Epetra_RowMatrix class. The user can specify which
    type of object to use by setting the parameter "Preconditioner
    Operator" in the parameter list. The choices are "Use Jacobian" or
    "Finite Difference".

    The Jacobian and preconditioner each require an interface to update
    the state of the operator with respect to the solution vector and any
    other parameters. There are three interfaces that can be implemented,
    NOX::Epetra::Interface::Required, NOX::Epetra::Interface::Jacobian,
    and NOX::Epetra::Interface::Preconditioner.

    NOX::Epetra::Interface::Required supplies the computeF() function so
    codes can tell NOX what the nonlinear equations are. This is the
    minimum requirement to run nox through the epetra interface.
    LinearSolverAztecOO requires this in some constructors so that if a
    Jacobian or preconditoner is not supplied, it will use computeF from
    the Required interface to estimate the Jacobian or preconditioner via
    finite differences or directional derivatives.

    NOX::Epetra::Interface::Jacobian is used for updating a user supplied
    Jacobian opertor with respect to the solution vector and any other
    parameters. It is required only in constructors in which a user
    supplies a Jacobian operator.

    NOX::Epetra::Interface::Preconditioner is used for updating a user
    supplied preconditioner opertor/matrix with respect to the solution
    vector and any other parameters. It is required only in constructors
    in which a user supplies a preconditioner operator.

    "Linear Solver" sublist parameters

    A Teuchos::ParameterList called linearSolverParams is required in the
    various constructors and during some method calls such as
    applyJacobianInverse() and applyRightPreconditioning(). Typically,
    this list is the "Linear Solver" sublist found in the nox parameter
    list. The following parameters can be set in the linear solver sublist
    and are vaild for the NOX::Epetra::LinearSolverAztecOO object: "Aztec
    Solver" - Determine the iterative technique used in the solve. The
    following options are valid:

    "GMRES" - Restarted generalized minimal residual (default).

    "CG" - Conjugate gradient.

    "CGS" - Conjugate gradient squared.

    "TFQMR" - Transpose-free quasi-minimal reasidual.

    "BiCGStab" - Bi-conjugate gradient with stabilization.

    "LU" - Sparse direct solve (single processor only).

    "Size of Krylov Subspace" - When using restarted GMRES this sets the
    maximum size of the Krylov subspace (defaults to 300).

    "Orthogonalization" - The orthogonalization routine used for the
    Gram-Schmidt orthogonalization procedure in Aztec. The following
    options are valid:

    "Classical" - (default).

    "Modified"

    "Convergence Test" - Algorithm used to calculate the residual that
    is used for determining the convergence of the linear solver. See the
    Aztec 2.1 manual for more information. The following options are
    valid:

    "r0" - (default)

    "rhs"

    "norm"

    "no scaling"

    "sol"

    "Tolerance" - Tolerance used by AztecOO to determine if an iterative
    linear solve has converged.

    "Ill-Conditioning Threshold" - If the upper hessenberg matrix during
    GMRES generates a condition number greater than this parameter value,
    aztec will exit the linear solve returning the it's current solution.
    The default is 1.0e11.

    "Preconditioner Iterations" - Number of iterations an
    AztecOO_Operator should take when solving the preconditioner. This is
    only used if an AztecOO preconditioner is used and the solver makes a
    call to NOX::Epetra::Group::applyRightPreconditioning(). This is NOT a
    recomended approach.

    "Max Iterations" - maximum number of iterations in the linear solve.
    Default is 400.

    "Zero Initial Guess" - boolean. Zero out the initial guess for
    linear solves performed through applyJacobianInverse calls (i.e. zero
    out the result vector before the linear solve). Defaults to false.

    "Throw Error on Prec Failure" - boolean. If set to true, an
    exception will be thrown if the preconditioner fails to initialize or
    recompute/refactor. If set to false, a warning will br printed if the
    NOX::Utils::Warning is enabled in the printing utilities (
    NOX::Utils). Defaults to true.

    "Output Frequency" - number of linear solve iterations between
    output of the linear solve residual. Takes an integer, or one of the
    AztecOO flags: AZ_none, AZ_last, or AZ_all as a value. Defaults to
    AZ_last.

    "Jacobian Operator" - When a constructor does not require a Jacobian
    operator, the linear system will create a default operator using:

    "Matrix-Free" (default)

    "Finite Difference"

    "Preconditioner" - Sets the choice of the preconditioner to use
    during linear solves. The validity of the choice of preconditioner
    will depend on the types of operators that are available for the
    Jacobian and preconditioner. NOTE: This flag will override any
    constructor details. For example, if you supply a preconditioner
    operator in the constructor, it will not be used if this flag is set
    to "None". If you supply an Epetra_Operator for the preconditioner
    but the "Preconditioner" flag is set to "AztecOO" (this requires
    an Epetra_RowMatrix for the preconditioner operator), this object will
    exit with a failure. The valid options and any requirements on the
    operator type are listed below:

    "None" - No preconditioning. (default)

    "AztecOO" - AztecOO internal preconditioner. This requires a
    preconditioner operator that derives from the Epetra_RowMatrix class.

    "Ifpack" - Ifpack internal preconditioner. This requires a
    preconditioner object that derives from the Epetra_RowMatrix class or
    it can use a Jacobian if the Jacobian derives from an
    Epetra_RowMatrix. This option is deprecated. Please use "New
    Ifpack".

    "New Ifpack" - Ifpack internal preconditioner. This requires a
    preconditioner object that derives from the Epetra_RowMatrix class or
    it can use a Jacobian if the Jacobian derives from an
    Epetra_RowMatrix.

    "User Defined" - The user supplies an Epetra_Operator derived class.
    Users must implement at a minimum the ApplyInverse() function of the
    Epetra_Operator class since preconditioning of vectors is accomplished
    through calls to this method.

    "Jacobian Operator" - If a constructor is used that does not supply
    a Jacobian operator, nox will create an internal Jacobian operator.
    This flag is ONLY valid in such cases. This will determine which
    Operator is used: "Matrix-Free" - Create a NOX::Epetra::MatrixFree
    object.

    "Finite Difference" - Create a NOX::Epetra::FiniteDifference object.

    "Preconditioner Operator" - If a constructor is used that does not
    supply a preconditioner operator, nox will create an internal
    preconditioner operator. This flag is ONLY valid in such cases. This
    will determine which Operator is used: "Use Jacobian" - Use the
    Jacobian Operator (it must be an Epetra_RowMatrix derived object).

    "Finite Difference" - Create a NOX::Epetra::FiniteDifference object.

    "Aztec Preconditioner" - If the "Preconditioner" flag is set to
    "AztecOO" then the specific AztecOO preconditioner is specified with
    this flag. Currently supported preconditioners and their corresponding
    parameters that can be set are shown below (See the Aztec 2.1 manual
    for more information):

    "ilu" - ilu preconditioning. This choice allows the following
    additional parameters to be specified: "Overlap" - defaults to 0

    "Graph Fill" - defaults to 0

    "ilut" - ilut preconditioning. This choice allows the following
    additional parameters to be specified: "Overlap" - defaults to 0

    "Fill Factor" - defaults to 1.0

    "Drop Tolerance" - defaults to 1.0e-12

    "Jacobi" - k step Jacobi where k is set by the "Steps" flag:
    "Steps" - defaults to 3.

    "Symmetric Gauss-Siedel" - Non-overlapping domain decomposition k
    step symmetric Gauss-Siedel where k is set by the "Steps" flag:

    "Steps" - defaults to 3.

    "Polynomial" - Neumann polynomial with order set by the parameter:
    "Polynomial Order" - defaults to 3.

    "Least-squares Polynomial" - Least-squares polynomial with order set
    by the parameter: "Polynomial Order" - defaults to 3.

    "Ifpack" - If the "Preconditioner" flag is set to "New Ifpack"
    then any of the options supported by the Ifpack Create factory can be
    specified using a Teuchos::ParameterList containing the Ifpack options
    and then setting this as a parameter named "Ifpack" in the "Linear
    Solver" sublist.

    "ML" - If the "Preconditioner" flag is set to "ML" then any of
    the options supported by the ML factory can be specified using a
    Teuchos::ParameterList containing the ML options and then setting this
    as a parameter named "ML" in the "Linear Solver" sublist.

    "Preconditioner Reuse Policy" - (string) Allows the user to set how
    and when the preconditioner should be computed. This flag supports
    native Aztec, Ifpack and ML preconditioners. There are three options:
    "Rebuild" - The "Rebuild" option always completely destroys and
    then rebuilds the preconditioner each time a linear solve is
    requested.

    "Reuse" - The group/linear solver will not recompute the
    preconditioner even if the group's solution vector changes. It just
    blindly reuses what has been constructed. This turns off control of
    preconditioner recalculation. This is a dangerous condition but can
    really speed up the computations if the user knows what they are
    doing. We don't recommend users trying this.

    "Recompute" - Recomputes the preconditioner, but will try to
    efficiently reuse any objects that don't need to be destroyed. How
    efficient the "Recompute" option is depends on the type of
    preconditioner. For example if we are using ILU from the Ifpack
    library, we would like to not destroy and reallocate the graph each
    solve. With this option, we tell Ifpack to reuse the graph from last
    time - e.g the sparisty pattern has not changed between applications
    of the preconditioner.

    "Max Age Of Prec" - (int) If the "Preconditioner Reuse Policy" is
    set to "Reuse", this integer tells the linear system how many times
    to reuse the preconditioner before rebuilding it. Defaults to 1.

    "RCM Reordering" - Enables RCM reordering in conjunction with domain
    decomp incomplete factorization preconditioning. The following options
    are valid:

    "Disabled" - (default).

    "Enabled"

    "Use Adaptive Linear Solve" - Enables the use of AztecOO's
    AdaptiveIterate() method instead of calling the Iterate() method. This
    causes the preconditioning matrix to be modified to make the linear
    solves easier. AztecOO will attempt to solve the linear system
    multiple times now and if the solves are failing it will modify the
    preconditioner and try again. Boolean value, defaults to false. NOTE:
    This only works for internal Aztec preconditioners! The
    "Preconditioning" parameter must be set to "AztecOO: Jacobian
    Matrix" or "AztecOO: User RowMatrix". (NOTE: This parameter is
    currently NOT supported)

    "Max Adaptive Solve Iterations" - (integer) Maximum number of
    attempts that the linear solver will make when trying to solve a
    linear system. Defaults to 5. (NOTE: This parameter is currently NOT
    supported)

    "Compute Scaling Manually" - (boolean) The linear system can be
    scaled if a NOX::Epetra::Scaling object is supplied to
    LinearSystemAztecOO. When to compute the scaling can be handled either
    manually by the user, or this object can automatically compute the
    scaling prior to a linear solve. By setting this flag to true, the
    user will call NOX::Epetra::Scaling::computeScaling() manually - on
    their own! Setting this to false means the LinearSystemAztecOO object
    will call the computeScaling function right before it applies the
    scaling to the matrix in the applyJacobianInverse function. Default is
    true (user will call compute scaling).

    "Output Solver Details" - (boolean) Write the output sublist below
    to the parameter list after each linear solve. default is true.

    "Write Linear System" - (boolean) If set to true, the linear system
    (Epetra_Map, Jacobian, LHS and RHS) is printed to a set of files in
    matrix market format. This option requires building nox with the flag
    --enable-nox-debug and building the EpetraExt library.

    "Write Linear System File Prefix" - (string) If writing of the
    linear system is enabled (see above parameter) users can change the
    name of the output file prefix. The default is "NOX_LinSys". This
    option requires building nox with the flag --enable-nox-debug and
    building the EpetraExt library.

    "Output" sublist

    The parameter list passed in during calls to ApplyJacobianInverse()
    will have an "Output" sublist created that contains the following
    parameters if the flag "Output Solver Details" is set to true:

    "Acheived Tolerance" - Actual tolerance achieved by the linear
    solver computed via the convergence test requested.

    "Number of Linear Iterations" - Number of iterations used by the
    linear solver in the last call to applyJacobianInverse

    "Total Number of Linear Iterations" - Total number of linear solve
    iterations performed by groups that have used this input list

    C++ includes: NOX_Epetra_LinearSystem_AztecOO.H 
    """
    __swig_setmethods__ = {}
    for _s in [LinearSystem]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearSystemAztecOO, name, value)
    __swig_getmethods__ = {}
    for _s in [LinearSystem]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearSystemAztecOO, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(NOX::Epetra::LinearSystemAztecOO self, ParameterList printingParams, ParameterList linearSolverParams, Teuchos::RCP< NOX::Epetra::Interface::Required > const & iReq, 
            Vector cloneVector, Teuchos::RCP< NOX::Epetra::Scaling > const scalingObject=Teuchos::null) -> LinearSystemAztecOO
        __init__(NOX::Epetra::LinearSystemAztecOO self, ParameterList printingParams, ParameterList linearSolverParams, Teuchos::RCP< NOX::Epetra::Interface::Required > const & iReq, 
            Teuchos::RCP< NOX::Epetra::Interface::Jacobian > const & iJac, 
            Teuchos::RCP< Epetra_Operator > const & J, 
            Vector cloneVector, Teuchos::RCP< NOX::Epetra::Scaling > const scalingObject=Teuchos::null) -> LinearSystemAztecOO
        __init__(NOX::Epetra::LinearSystemAztecOO self, ParameterList printingParams, ParameterList linearSolverParams, Teuchos::RCP< NOX::Epetra::Interface::Required > const & i, 
            Teuchos::RCP< NOX::Epetra::Interface::Preconditioner > const & iPrec, 
            Teuchos::RCP< Epetra_Operator > const & M, 
            Vector cloneVector, Teuchos::RCP< NOX::Epetra::Scaling > const scalingObject=Teuchos::null) -> LinearSystemAztecOO
        __init__(NOX::Epetra::LinearSystemAztecOO self, ParameterList printingParams, ParameterList linearSolverParams, Teuchos::RCP< NOX::Epetra::Interface::Jacobian > const & iJac, 
            Teuchos::RCP< Epetra_Operator > const & J, 
            Teuchos::RCP< NOX::Epetra::Interface::Preconditioner > const & iPrec, 
            Teuchos::RCP< Epetra_Operator > const & M, Vector cloneVector, Teuchos::RCP< NOX::Epetra::Scaling > const scalingObject=Teuchos::null) -> LinearSystemAztecOO

        NOX::Epetra::LinearSystemAztecOO::LinearSystemAztecOO(Teuchos::ParameterList
        &printingParams, Teuchos::ParameterList &linearSolverParams, const
        Teuchos::RCP< NOX::Epetra::Interface::Jacobian > &iJac, const
        Teuchos::RCP< Epetra_Operator > &J, const Teuchos::RCP<
        NOX::Epetra::Interface::Preconditioner > &iPrec, const Teuchos::RCP<
        Epetra_Operator > &M, const NOX::Epetra::Vector &cloneVector, const
        Teuchos::RCP< NOX::Epetra::Scaling > scalingObject=Teuchos::null)

        Constructor with user supplied separate objects for the Jacobian (J)
        and Preconditioner (M). linearSolverParams is the "Linear Solver"
        sublist of parameter list. 
        """
        this = ___init__.new_LinearSystemAztecOO(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_LinearSystemAztecOO
    def applyJacobian(self, *args):
        """
        applyJacobian(LinearSystemAztecOO self, Vector input, Vector nox_result) -> bool

        bool NOX::Epetra::LinearSystemAztecOO::applyJacobian(const
        NOX::Epetra::Vector &input, NOX::Epetra::Vector &result) const

        Applies Jacobian to the given input vector and puts the answer in the
        result.

        Computes \\[ v = J u, \\] where $J$ is the Jacobian, $u$ is the
        input vector, and $v$ is the result vector. Returns true if
        successful. 
        """
        return ___init__.LinearSystemAztecOO_applyJacobian(self, *args)

    def applyJacobianTranspose(self, *args):
        """
        applyJacobianTranspose(LinearSystemAztecOO self, Vector input, Vector nox_result) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::applyJacobianTranspose(const
        NOX::Epetra::Vector &input, NOX::Epetra::Vector &result) const

        Applies Jacobian-Transpose to the given input vector and puts the
        answer in the result.

        Computes \\[ v = J^T u, \\] where $J$ is the Jacobian, $u$ is the
        input vector, and $v$ is the result vector. Returns true if
        successful. 
        """
        return ___init__.LinearSystemAztecOO_applyJacobianTranspose(self, *args)

    def applyJacobianInverse(self, *args):
        """
        applyJacobianInverse(LinearSystemAztecOO self, ParameterList linearSolverParams, Vector input, Vector nox_result) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::applyJacobianInverse(Teuchos::ParameterList
        &linearSolverParams, const NOX::Epetra::Vector &input,
        NOX::Epetra::Vector &result)

        Applies the inverse of the Jacobian matrix to the given input vector
        and puts the answer in result.

        Computes \\[ v = J^{-1} u, \\] where $J$ is the Jacobian, $u$ is
        the input vector, and $v$ is the result vector.

        The parameter list contains the linear solver options. 
        """
        return ___init__.LinearSystemAztecOO_applyJacobianInverse(self, *args)

    def applyRightPreconditioning(self, *args):
        """
        applyRightPreconditioning(LinearSystemAztecOO self, bool useTranspose, ParameterList linearSolverParams, Vector input, Vector nox_result) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::applyRightPreconditioning(bool
        useTranspose, Teuchos::ParameterList &linearSolverParams, const
        NOX::Epetra::Vector &input, NOX::Epetra::Vector &result) const

        Apply right preconditiong to the given input vector.

        Let $M$ be a right preconditioner for the Jacobian $J$; in other
        words, $M$ is a matrix such that \\[ JM \\approx I. \\]

        Compute \\[ u = M^{-1} v, \\] where $u$ is the input vector and
        $v$ is the result vector.

        If useTranspose is true, then the transpose of the preconditioner is
        applied: \\[ u = {M^{-1}}^T v, \\] The transpose preconditioner is
        currently only required for Tensor methods.

        The parameter list contains the linear solver options. 
        """
        return ___init__.LinearSystemAztecOO_applyRightPreconditioning(self, *args)

    def createPreconditioner(self, *args):
        """
        createPreconditioner(LinearSystemAztecOO self, Vector x, ParameterList linearSolverParams, bool recomputeGraph) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::createPreconditioner(const
        NOX::Epetra::Vector &x, Teuchos::ParameterList &linearSolverParams,
        bool recomputeGraph) const

        Explicitly constructs a preconditioner based on the solution vector x
        and the parameter list p.

        The user has the option of recomputing the graph when a new
        preconditioner is created. The NOX::Epetra::Group controls the isValid
        flag for the preconditioner and will control when to call this. 
        """
        return ___init__.LinearSystemAztecOO_createPreconditioner(self, *args)

    def destroyPreconditioner(self, *args):
        """
        destroyPreconditioner(LinearSystemAztecOO self) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::destroyPreconditioner() const

        Deletes all objects associated with the chosen preconditioner. This is
        called during linear solves and when the solution vector changes to
        reset the preconditioner. 
        """
        return ___init__.LinearSystemAztecOO_destroyPreconditioner(self, *args)

    def recomputePreconditioner(self, *args):
        """
        recomputePreconditioner(LinearSystemAztecOO self, Vector x, ParameterList linearSolverParams) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::recomputePreconditioner(const
        NOX::Epetra::Vector &x, Teuchos::ParameterList &linearSolverParams)
        const

        Recalculates the preconditioner using an already allocated graph.

        Use this to compute a new preconditioner while using the same graph
        for the preconditioner. This avoids deleting and reallocating the
        memory required for the preconditioner and results in a big speed-up
        for large-scale jobs. 
        """
        return ___init__.LinearSystemAztecOO_recomputePreconditioner(self, *args)

    def getPreconditionerPolicy(self, *args):
        """
        getPreconditionerPolicy(LinearSystemAztecOO self, bool advanceReuseCounter=True) -> NOX::Epetra::LinearSystem::PreconditionerReusePolicyType

        NOX::Epetra::LinearSystem::PreconditionerReusePolicyType
        NOX::Epetra::LinearSystemAztecOO::getPreconditionerPolicy(bool
        advanceReuseCounter=true)

        Evaluates the preconditioner policy at the current state.

        NOTE: This can change values between nonlienar iterations. It is not a
        static value. 
        """
        return ___init__.LinearSystemAztecOO_getPreconditionerPolicy(self, *args)

    def reset(self, *args):
        """
        reset(LinearSystemAztecOO self, ParameterList linearSolverParams)

        void
        NOX::Epetra::LinearSystemAztecOO::reset(Teuchos::ParameterList
        &linearSolverParams)

        Reset the linear solver parameters. 
        """
        return ___init__.LinearSystemAztecOO_reset(self, *args)

    def getScaling(self, *args):
        """
        getScaling(LinearSystemAztecOO self) -> Teuchos::RCP< NOX::Epetra::Scaling >

        Teuchos::RCP< NOX::Epetra::Scaling >
        NOX::Epetra::LinearSystemAztecOO::getScaling()

        Get the scaling object. 
        """
        return ___init__.LinearSystemAztecOO_getScaling(self, *args)

    def resetScaling(self, *args):
        """
        resetScaling(LinearSystemAztecOO self, Teuchos::RCP< NOX::Epetra::Scaling > const & s)

        void NOX::Epetra::LinearSystemAztecOO::resetScaling(const
        Teuchos::RCP< NOX::Epetra::Scaling > &s)

        Sets the diagonal scaling vector(s) used in scaling the linear system.
        See NOX::Epetra::Scaling for details on how to specify scaling of the
        linear system. 
        """
        return ___init__.LinearSystemAztecOO_resetScaling(self, *args)

    def computeJacobian(self, *args):
        """
        computeJacobian(LinearSystemAztecOO self, Vector x) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::computeJacobian(const
        NOX::Epetra::Vector &x)

        Compute the Jacobian. 
        """
        return ___init__.LinearSystemAztecOO_computeJacobian(self, *args)

    def getJacobianInterface(self, *args):
        """
        getJacobianInterface(LinearSystemAztecOO self) -> Teuchos::RCP< NOX::Epetra::Interface::Jacobian const >

        Teuchos::RCP<
        const NOX::Epetra::Interface::Jacobian >
        NOX::Epetra::LinearSystemAztecOO::getJacobianInterface() const

        NOX::Interface::Jacobian accessor. 
        """
        return ___init__.LinearSystemAztecOO_getJacobianInterface(self, *args)

    def getPrecInterface(self, *args):
        """
        getPrecInterface(LinearSystemAztecOO self) -> Teuchos::RCP< NOX::Epetra::Interface::Preconditioner const >

        Teuchos::RCP<
        const NOX::Epetra::Interface::Preconditioner >
        NOX::Epetra::LinearSystemAztecOO::getPrecInterface() const

        NOX::Interface::Preconditioiner accessor. 
        """
        return ___init__.LinearSystemAztecOO_getPrecInterface(self, *args)

    def isPreconditionerConstructed(self, *args):
        """
        isPreconditionerConstructed(LinearSystemAztecOO self) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::isPreconditionerConstructed() const

        Indicates whether a preconditioner has been constructed. 
        """
        return ___init__.LinearSystemAztecOO_isPreconditionerConstructed(self, *args)

    def hasPreconditioner(self, *args):
        """
        hasPreconditioner(LinearSystemAztecOO self) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::hasPreconditioner() const

        Indicates whether the linear system has a preconditioner. 
        """
        return ___init__.LinearSystemAztecOO_hasPreconditioner(self, *args)

    def getJacobianOperator(self, *args):
        """
        getJacobianOperator(LinearSystemAztecOO self) -> Teuchos::RCP< Epetra_Operator const >
        getJacobianOperator(LinearSystemAztecOO self) -> Teuchos::RCP< Epetra_Operator >

        Teuchos::RCP<
        Epetra_Operator >
        NOX::Epetra::LinearSystemAztecOO::getJacobianOperator()

        Jacobian Epetra_Operator accessor. 
        """
        return ___init__.LinearSystemAztecOO_getJacobianOperator(self, *args)

    def getPrecOperator(self, *args):
        """
        getPrecOperator(LinearSystemAztecOO self) -> Teuchos::RCP< Epetra_Operator const >

        Teuchos::RCP<
        const Epetra_Operator >
        NOX::Epetra::LinearSystemAztecOO::getPrecOperator() const

        Preconditioner Epetra_Operator accessor (only the base matrix if using
        an internal preconditioner - aztecoo or ifpack). 
        """
        return ___init__.LinearSystemAztecOO_getPrecOperator(self, *args)

    def getGeneratedPrecOperator(self, *args):
        """
        getGeneratedPrecOperator(LinearSystemAztecOO self) -> Teuchos::RCP< Epetra_Operator const >
        getGeneratedPrecOperator(LinearSystemAztecOO self) -> Teuchos::RCP< Epetra_Operator >

        Teuchos::RCP< Epetra_Operator >
        NOX::Epetra::LinearSystemAztecOO::getGeneratedPrecOperator()

        Return preconditioner operator generated and stored in AztecOO. 
        """
        return ___init__.LinearSystemAztecOO_getGeneratedPrecOperator(self, *args)

    def getTimeCreatePreconditioner(self, *args):
        """
        getTimeCreatePreconditioner(LinearSystemAztecOO self) -> double

        double
        NOX::Epetra::LinearSystemAztecOO::getTimeCreatePreconditioner() const

        Returns the total time (sec.) spent in createPreconditioner(). 
        """
        return ___init__.LinearSystemAztecOO_getTimeCreatePreconditioner(self, *args)

    def getTimeApplyJacobianInverse(self, *args):
        """
        getTimeApplyJacobianInverse(LinearSystemAztecOO self) -> double

        double
        NOX::Epetra::LinearSystemAztecOO::getTimeApplyJacobianInverse() const

        Returns the total time (sec.) spent in applyJacobianInverse(). 
        """
        return ___init__.LinearSystemAztecOO_getTimeApplyJacobianInverse(self, *args)

    def setJacobianOperatorForSolve(self, *args):
        """
        setJacobianOperatorForSolve(LinearSystemAztecOO self, Teuchos::RCP< Epetra_Operator const > const & solveJacOp)

        void
        NOX::Epetra::LinearSystemAztecOO::setJacobianOperatorForSolve(const
        Teuchos::RCP< const Epetra_Operator > &solveJacOp)

        Set Jacobian operator for solve. 
        """
        return ___init__.LinearSystemAztecOO_setJacobianOperatorForSolve(self, *args)

    def setPrecOperatorForSolve(self, *args):
        """
        setPrecOperatorForSolve(LinearSystemAztecOO self, Teuchos::RCP< Epetra_Operator const > const & solvePrecOp)

        void
        NOX::Epetra::LinearSystemAztecOO::setPrecOperatorForSolve(const
        Teuchos::RCP< const Epetra_Operator > &solvePrecOp)

        Set preconditioner operator for solve.

        Note: This should only be called if hasPreconditioner() returns true.

        """
        return ___init__.LinearSystemAztecOO_setPrecOperatorForSolve(self, *args)

LinearSystemAztecOO_swigregister = ___init__.LinearSystemAztecOO_swigregister
LinearSystemAztecOO_swigregister(LinearSystemAztecOO)

class ModelEvaluatorInterface(Interface.Required,Interface.Jacobian,Interface.Preconditioner):
    """Proxy of C++ NOX::Epetra::ModelEvaluatorInterface class"""
    __swig_setmethods__ = {}
    for _s in [Interface.Required,Interface.Jacobian,Interface.Preconditioner]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ModelEvaluatorInterface, name, value)
    __swig_getmethods__ = {}
    for _s in [Interface.Required,Interface.Jacobian,Interface.Preconditioner]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ModelEvaluatorInterface, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_ModelEvaluatorInterface
    def computeF(self, *args):
        """
        computeF(self, Epetra.Vector x, Epetra.Vector F, FillType flag) -> bool

          Virtual method in C++ that is intended to be overridden by user.
          This method defines the nonlinear function to be solved.  Arguments
          x and F will be provided as numpy-hybrid Epetra.Vector objects.
          Return True if the computation is successful.

          It is strongly recommended that computeF() not raise any exceptions,
          accidental or otherwise.  This can be prevented by wrapping your
          algorithm in a try block:

            try:
              # Your code here...
            except Exception, e:
              print 'Python exception raised in computeF():'
              print e
              return False

          By returning False, you tell NOX that computeF() was unsuccessful.


        virtual bool NOX::Epetra::Interface::Required::computeF(const
        Epetra_Vector &x, Epetra_Vector &F, const FillType fillFlag)=0

        Compute the function, F, given the specified input vector x. Returns
        true if computation was successful. 
        """
        return ___init__.ModelEvaluatorInterface_computeF(self, *args)

    def computeJacobian(self, *args):
        """
        computeJacobian(ModelEvaluatorInterface self, Epetra_Vector x, Operator Jac) -> bool

        virtual bool
        NOX::Epetra::Interface::Jacobian::computeJacobian(const Epetra_Vector
        &x, Epetra_Operator &Jac)=0

        Compute Jacobian given the specified input vector x. Returns true if
        computation was successful. 
        """
        return ___init__.ModelEvaluatorInterface_computeJacobian(self, *args)

    def computePreconditioner(self, *args):
        """
        computePreconditioner(ModelEvaluatorInterface self, Epetra_Vector x, Operator M, ParameterList precParams=None) -> bool

        virtual bool
        NOX::Epetra::Interface::Preconditioner::computePreconditioner(const
        Epetra_Vector &x, Epetra_Operator &M, Teuchos::ParameterList
        *precParams=0)=0

        Computes a user defined preconditioner. 
        """
        return ___init__.ModelEvaluatorInterface_computePreconditioner(self, *args)

    def inargs_set_p(self, *args):
        """inargs_set_p(ModelEvaluatorInterface self, Teuchos::RCP< Epetra_Vector const > const p, int const l=0) -> bool"""
        return ___init__.ModelEvaluatorInterface_inargs_set_p(self, *args)

    def set_inargs(self, *args):
        """set_inargs(ModelEvaluatorInterface self, EpetraExt::ModelEvaluator::InArgs const & inargs_in) -> bool"""
        return ___init__.ModelEvaluatorInterface_set_inargs(self, *args)

    def __init__(self, *args): 
        """__init__(NOX::Epetra::ModelEvaluatorInterface self, ModelEvaluator eeme) -> ModelEvaluatorInterface"""
        this = ___init__.new_ModelEvaluatorInterface(*args)
        try: self.this.append(this)
        except: self.this = this
ModelEvaluatorInterface_swigregister = ___init__.ModelEvaluatorInterface_swigregister
ModelEvaluatorInterface_swigregister(ModelEvaluatorInterface)

def defaultNonlinearParameters(comm=None, verbosity=0, outputPrec=3,
                               maxIterations=800, tolerance=1.0e-4):
    """
    defaultNonlinearParameters(comm=None, verbosity=0, outputPrec=3,
                               maxIterations=800, tolerance=1.0e-4) -> dict

    Return a dictionary that can serve as a default list of parameters for a NOX
    solver.  Entries can be altered before passing to a NOX solver constructor.

    comm          - Epetra communicator object.  If not provided, the function
                    uses an Epetra.SerialComm communicator.

    verbosity     - A simple indication of verbosity level.  0: errors and test
                    details.  1: debugging, warnings, details, parameters and
                    linear solver details.  2: inner iteration, outer iteration
                    status test and outer iteration.  Default 0.

    outputPrec    - Number of significant digits to output.  Default 3.

    maxIterations - Maximum allowable linear (inner) iterations.  Default 800.

    tolerance     - Linear solver tolerance level.  Default 1.0e-4.
    """
    # Communicator
    if comm is None:
        comm = PyTrilinos.Epetra.SerialComm()
    myPID = comm.MyPID()

    # Create the printing parameter list
    Utils = PyTrilinos.NOX.Utils
    outputInfo = Utils.Error + Utils.TestDetails
    if verbosity: outputInfo += Utils.Debug      + \
                                Utils.Warning    + \
                                Utils.Details    + \
                                Utils.Parameters + \
                                Utils.LinearSolverDetails
    if verbosity > 1: outputInfo += Utils.InnerIteration           + \
                                    Utils.OuterIterationStatusTest + \
                                    Utils.OuterIteration
    printParams = {"MyPID"              : myPID,
                   "Output Precision"   : outputPrec,
                   "Output Processor"   : 0,
                   "Output Information" : outputInfo}

    # Create the linear solver parameter list
    lsParams = {"Aztec Solver"    : "GMRES",
                "Max Iterations"  : maxIterations,
                "Tolerance"       : tolerance,
                "Preconditioner"  : "Ifpack",
                "Max Age Of Prec" : 5       }

    # Create the nonlinear solver parameter list
    nlParams = {"Nonlinear Solver" : "Line Search Based",
                "Printing"         : printParams,
                "Line Search"      : {"Method" : "Full Step"},
                "Direction"        : {"Method" : "Newton"},
                "Newton"           : {"Forcing Term Method" : "Constant"},
                "Linear Solver"    : lsParams,
                "Solver Options"   : {"Status Test Check Type" : "Complete"}
                }
    
    return nlParams

def defaultGroup(nonlinearParameters, initGuess, reqInterface, jacInterface=None,
                 jacobian=None, precInterface=None, preconditioner=None):
    """
    defaultGroup(nonlinearParameters, initGuess, reqInterface, jacInterface=None,
                 jacobian=None, precInterface=None, preconditioner=None) -> Group

    Return a NOX.Epetra.Group based upon the given input arguments:

    nonlinearParameters - a dict with nonlinear parameters.  Can be obtained
                          from defaultNonlinearParameters()
    initGuess           - an initial guess Epetra.Vector.
    reqInterface        - a NOX.Epetra.Interface.Required object that defines
                          the interface to the nonlinear problem.  May be
                          None if both the Jacobian and preconditioner are
                          provided.
    jacInterface        - a NOX.Epetra.Interface.Jacobian object that defines the
                          Jacobian of the nonlinear problem.  Default None.
    jacobian            - if jacInterface is provided, this is the Epetra.Operator
                          that defines the Jacobian matrix.  Default None.
    precInterface       - a NOX.Epetra.Interface.Preconditioner object that defines
                          the preconditioner to the nonlinear problem.  Default None.
    preconditioner      - if precInterface is provided, this is the
                          Epetra.Operator that defines the preconditioner.
                          Default None.
    """

    # Sanity checks to prevent more cryptic problems down the road...
    if jacInterface is None or precInterface is None:
        assert isinstance(reqInterface, Interface.Required)
    if jacInterface is not None:
        assert isinstance(jacInterface, Interface.Jacobian        )
        assert isinstance(jacobian    , (PyTrilinos.Epetra.Operator, Operator))
    if precInterface is not None:
        assert isinstance(precInterface , Interface.Preconditioner  )
        assert isinstance(preconditioner, (PyTrilinos.Epetra.Operator, Operator))

    # Extract parameter lists
    printParams = nonlinearParameters["Printing"     ]
    lsParams    = nonlinearParameters["Linear Solver"]

    # Construct a NOX.Epetra.Vector from the Epetra.Vector
    clone = Vector(initGuess, Vector.CreateView)

    # Construct the linear system
    if jacInterface:
        if precInterface:
            linSys = LinearSystemAztecOO(printParams, lsParams,
                                         jacInterface, jacobian,
                                         precInterface, preconditioner,
                                         clone)
        else:
            linSys = LinearSystemAztecOO(printParams, lsParams,
                                         reqInterface,
                                         jacInterface, jacobian,
                                         clone)
    else:
        if precInterface:
            linSys = LinearSystemAztecOO(printParams, lsParams,
                                         reqInterface,
                                         precInterface, preconditioner,
                                         clone)
        else:
            linSys = LinearSystemAztecOO(printParams, lsParams,
                                         reqInterface,
                                         clone)

    # Construct and return the default Group
    group = Group(printParams, reqInterface, clone, linSys)
    group.linSys = linSys   ### By adding linSys as an attribute to the Group
                            ### variable, we ensure that linSys does not get
                            ### destroyed.  This is a workaround for a
                            ### Teuchos::RCP wrapper bug.
    return group

def defaultStatusTest(absTol=None, relTol=None, relGroup=None, updateTol=None,
                      wAbsTol=None, wRelTol=None, maxIters=None,
                      finiteValue=False):
    """
    defaultStatusTest(absTol=None, relTol=None, relGroup=None, updateTol=None,
                      wAbsTol=None, wRelTol=None, maxIters=None,
                      finiteValue=False) -> StatusTest

    Return a StatusTest object based upon the input arguments:

    absTol      - if specified, include an absolute residual status test, using
                  this value as the tolerance
    relTol      - if specified, along with relGroup, include a relative residual
                  status test, using this value as the tolerance
    relGroup    - if specified, along with relTol, include a relative residual
                  status test, using this Group to determine the scaling
    updateTol   - if specified, include an update status test, using this value
                  as the tolerance
    wAbsTol     - if specified, along with wRelTol, include a weighted RMS
                  status test, using this value as the absolute tolerance
    wRelTol     - if specified, along with wAbsTol, include a weighted RMS
                  status test, using this value as the relative tolerance
    maxIters    - if specified, include a maximum iterations status test, using
                  this value as the maximum allowable iterations
    finiteValue - if True, include a finite value status test.  Default False.
    """
    # Build the convergence portion of the status test
    StatusTest = PyTrilinos.NOX.StatusTest
    converged  = StatusTest.Combo(StatusTest.Combo.AND)
    converged.tests = [ ]   ### By adding this list of tests as an attribute to
                            ### the StatusTest variables, we ensure that linSys
                            ### does not get destroyed.  This is a workaround
                            ### for a Teuchos::RCP wrapper bug.

    if absTol:
        absTest = StatusTest.NormF(absTol)
        converged.addStatusTest(absTest)
        converged.tests.append(absTest)
    if relGroup and relTol:
        relTest = StatusTest.NormF(relGroup,relTol)
        converged.addStatusTest(relTest)
        converged.tests.append(relTest)
    if wAbsTol and wRelTol:
        wrmsTest = StatusTest.NormWRMS(wRelTol,wAbsTol)
        converged.addStatusTest(wrmsTest)
        converged.tests.append(wrmsTest)
    if updateTol:
        updateTest = StatusTest.NormUpdate(updateTol)
        converged.addStatusTest(updateTest)
        converged.tests.append(updateTest)

    # Return if done
    if not (maxIters or finiteValue):
        return converged

    # Add the divergence portion of the default status test
    combo = StatusTest.Combo(StatusTest.Combo.OR)
    combo.tests = [ ]
    if finiteValue:
        fvTest = StatusTest.FiniteValue()
        combo.addStatusTest(fvTest)
        combo.tests.append(fvTest)
    combo.addStatusTest(converged)
    combo.tests.append(converged)
    if maxIters:
        maxIterTest = StatusTest.MaxIters(maxIters)
        combo.addStatusTest(maxIterTest)
        combo.tests.append(maxIterTest)
    return combo

def defaultSolver(initGuess, reqInterface, jacInterface=None, jacobian=None,
                  precInterface=None, preconditioner=None, nlParams=None,
                  absTol=1.0e-8, relTol=1.0e-2, relGroup=None, updateTol=1.0e-5,
                  wAbsTol=1.0e-8, wRelTol=1.0e-2, maxIters=20, finiteValue=True):
    """
    defaultSolver(initGuess, reqInterface, jacInterface=None, jacobian=None,
                  precInterface=None, preconditioner=None, nlParams=None) -> Solver

    Return a default NOX Solver based on the given arguments:

    initGuess      - an Epetra.Vector initial guess
    reqInterface   - a NOX.Epetra.Interface.Required object that defines
                     the interface to the nonlinear problem.  May be
                     None if both the Jacobian and preconditioner are
                     provided.
    jacInterface   - a NOX.Epetra.Interface.Jacobian object that defines the
                     Jacobian of the nonlinear problem.  Default None.
    jacobian       - if jacInterface is provided, this should also be provided
                     and is the Epetra.Operator that defines the Jacobian
                     matrix.  Default None. 
    precInterface  - a NOX.Epetra.Interface.Preconditioner object that defines
                     the preconditioner to the nonlinear problem.  Default None.
    preconditioner - if precInterface is provided, this should also be provided
                     and is the Epetra.Operator that defines the preconditioner.
                     Default None.
    nlParams       - dict that contains a list of nonlinear parameters.  Default
                     None, in which case defaultNonlinearParameters() is used.
    absTol         - if not None, include an absolute residual status test,
                     using this value as the tolerance.  Default 1.0e-8.
    relTol         - if not None, include a relative residual status test, using
                     this value as the tolerance.  Default 1.0e-2.
    relGroup       - if relTol is specified, use this Group to determine the
                     scaling.  If relGroup is None, use the result of
                     defaultGroup().  Default None.
    updateTol      - if not None, include an update status test, using this
                     value as the tolerance.  Default 1.0e-5.
    wAbsTol        - if not None, along with wRelTol, include a weighted RMS
                     status test, using this value as the absolute tolerance.
                     Default 1.0e-8.
    wRelTol        - if not None, along with wAbsTol, include a weighted RMS
                     status test, using this value as the relative tolerance.
                     Default 1.0e-2.
    maxIters       - if not None, include a maximum nonlinear iterations status
                     test, using this value as the maximum allowable iterations.
                     Default 20. 
    finiteValue    - if True, include a finite value status test.  Default
                     True. 
    """

    # Sanity checks to prevent more cryptic problems down the road...
    if jacInterface is None or precInterface is None:
        assert isinstance(reqInterface, Interface.Required)
    if jacInterface is not None:
        assert isinstance(jacInterface, Interface.Jacobian        )
        assert isinstance(jacobian    , (PyTrilinos.Epetra.Operator, Operator))
    if precInterface is not None:
        assert isinstance(precInterface , Interface.Preconditioner  )
        assert isinstance(preconditioner, (PyTrilinos.Epetra.Operator, Operator))

    # Get the communicator
    comm = initGuess.Comm()

    # Get the nonlinear parameters
    if nlParams is None:
        nlParams = defaultNonlinearParameters(comm,2)

    # Build the default Group
    group = defaultGroup(nlParams, initGuess, reqInterface, jacInterface,
                         jacobian, precInterface, preconditioner)

    # Get the default StatusTest
    if relTol and (relGroup is None): relGroup = group
    statusTest = defaultStatusTest(absTol      = absTol,
                                   relTol      = relTol,
                                   relGroup    = relGroup,
                                   updateTol   = updateTol,
                                   wAbsTol     = wAbsTol,
                                   wRelTol     = wRelTol,
                                   maxIters    = maxIters,
                                   finiteValue = finiteValue)

    # Return the default Solver
    solver = PyTrilinos.NOX.Solver.buildSolver(group, statusTest, nlParams)
    #solver.group      = group        ### By adding group, statusTest and
    solver.statusTest = statusTest   ### nlParams as attributes to the Solver
    solver.nlParams   = nlParams     ### variable, we ensure that they do not
                                     ### get destroyed.  This is a workaround for
                                     ### a Teuchos::RCP wrapper bug.
    return solver

# This file is compatible with both classic and new-style classes.


